/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=fe[Y[g]];return e};define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,y){if(!L)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=g}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let l in i)g.call(i,l)&&I.push(i[l]);return I}e.values=L;function y(i,I){for(let l in i)if(g.call(i,l)&&I({key:l,value:i[l]},function(){delete i[l]})===!1)return}e.forEach=y;function _(i,I){const l=Object.create(null);for(const p of i){const h=I(p);let w=l[h];w||(w=l[h]=[]),w.push(p)}return l}e.groupBy=_;function P(i){const I=Object.create(null);return i&&i.forEach((l,p)=>{I[p]=l}),I}e.fromMap=P;function D(i,I){const l=[],p=[];for(let h of i)I.has(h)||l.push(h);for(let h of I)i.has(h)||p.push(h);return{removed:l,added:p}}e.diffSets=D;function C(i,I){const l=[],p=[];for(let[h,w]of i)I.has(h)||l.push(w);for(let[h,w]of I)i.has(h)||p.push(w);return{removed:l,added:p}}e.diffMaps=C;class k{constructor(){this.map=new Map}add(I,l){let p=this.map.get(I);p||(p=new Set,this.map.set(I,p)),p.add(l)}delete(I,l){const p=this.map.get(I);!p||(p.delete(l),p.size===0&&this.map.delete(I))}forEach(I,l){const p=this.map.get(I);!p||p.forEach(l)}}e.SetMap=k}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(P){return(D,C,k)=>{let i=null,I=null;if(typeof k.value=="function"?(i="value",I=k.value):typeof k.get=="function"&&(i="get",I=k.get),!I)throw new Error("not supported");k[i]=P(I,C)}}e.createDecorator=g;function L(P,D,C){let k=null,i=null;if(typeof C.value=="function"?(k="value",i=C.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(k="get",i=C.get),!i)throw new Error("not supported");const I=`$memoize$${D}`;C[k]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,l)}),this[I]}}e.memoize=L;function y(P,D,C){return g((k,i)=>{const I=`$debounce$${i}`,l=`$debounce$result$${i}`;return function(...p){this[l]||(this[l]=C?C():void 0),clearTimeout(this[I]),D&&(this[l]=D(this[l],...p),p=[this[l]]),this[I]=setTimeout(()=>{k.apply(this,p),this[l]=C?C():void 0},P)}})}e.debounce=y;function _(P,D,C){return g((k,i)=>{const I=`$throttle$timer$${i}`,l=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,h=`$throttle$pending$${i}`;return function(...w){if(this[l]||(this[l]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),D&&(this[l]=D(this[l],...w)),this[h])return;const S=this[p]+P;S<=Date.now()?(this[p]=Date.now(),k.apply(this,[this[l]]),this[l]=C?C():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),k.apply(this,[this[l]]),this[l]=C?C():void 0},S-Date.now()))}})}e.throttle=_}),define(fe[17],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(f=>{f(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function y(v){C(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=y;function _(v){C(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=_;function P(v){if(v instanceof Error){let{name:t,message:f}=v;const r=v.stacktrace||v.stack;return{$isError:!0,name:t,message:f,stack:r}}return v}e.transformErrorForSerialization=P;const D="Canceled";function C(v){return v instanceof Error&&v.name===D&&v.message===D}e.isPromiseCanceledError=C;class k extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=k;function i(){const v=new Error(D);return v.name=v.message,v}e.canceled=i;function I(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=I;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=l;function p(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function w(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=w;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class T extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=T;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function s(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=s;function o(v,t=Object.create(null)){const f=new Error(v);return t.actions&&(f.actions=t.actions),f}e.createErrorWithActions=o}),define(fe[18],me([0,1,17]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,X=0){return H[H.length-(1+X)]}e.tail=L;function y(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=y;function _(H,X,K=(de,_e)=>de===_e){if(H===X)return!0;if(!H||!X||H.length!==X.length)return!1;for(let de=0,_e=H.length;de<_e;de++)if(!K(H[de],X[de]))return!1;return!0}e.equals=_;function P(H,X,K){let de=0,_e=H.length-1;for(;de<=_e;){const Ce=(de+_e)/2|0,Pe=K(H[Ce],X);if(Pe<0)de=Ce+1;else if(Pe>0)_e=Ce-1;else return Ce}return-(de+1)}e.binarySearch=P;function D(H,X){let K=0,de=H.length;if(de===0)return 0;for(;K<de;){const _e=Math.floor((K+de)/2);X(H[_e])?de=_e:K=_e+1}return K}e.findFirstInSorted=D;function C(H,X,K){if(H=H|0,H>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],_e=[],Ce=[],Pe=[];for(let Be of X){const $e=K(Be,de);$e<0?_e.push(Be):$e>0?Ce.push(Be):Pe.push(Be)}return H<_e.length?C(H,_e,K):H<_e.length+Pe.length?Pe[0]:C(H-(_e.length+Pe.length),Ce,K)}e.quickSelect=C;function k(H,X){const K=[];let de;for(const _e of H.slice(0).sort(X))!de||X(de[0],_e)!==0?(de=[_e],K.push(de)):de.push(_e);return K}e.groupBy=k;function i(H,X,K){const de=[];function _e(Be,$e,He){if($e===0&&He.length===0)return;const G=de[de.length-1];G&&G.start+G.deleteCount===Be?(G.deleteCount+=$e,G.toInsert.push(...He)):de.push({start:Be,deleteCount:$e,toInsert:He})}let Ce=0,Pe=0;for(;;){if(Ce===H.length){_e(Ce,0,X.slice(Pe));break}if(Pe===X.length){_e(Ce,H.length-Ce,[]);break}const Be=H[Ce],$e=X[Pe],He=K(Be,$e);He===0?(Ce+=1,Pe+=1):He<0?(_e(Ce,1,[]),Ce+=1):He>0&&(_e(Ce,0,[$e]),Pe+=1)}return de}e.sortedDiff=i;function I(H,X,K){const de=i(H,X,K),_e=[],Ce=[];for(const Pe of de)_e.push(...H.slice(Pe.start,Pe.start+Pe.deleteCount)),Ce.push(...Pe.toInsert);return{removed:_e,added:Ce}}e.delta=I;function l(H,X,K){if(K===0)return[];const de=H.slice(0,K).sort(X);return h(H,X,de,K,H.length),de}e.top=l;function p(H,X,K,de,_e){return K===0?Promise.resolve([]):new Promise((Ce,Pe)=>{(async()=>{const Be=H.length,$e=H.slice(0,K).sort(X);for(let He=K,G=Math.min(K+de,Be);He<Be;He=G,G=Math.min(G+de,Be)){if(He>K&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();h(H,X,$e,He,G)}return $e})().then(Ce,Pe)})}e.topAsync=p;function h(H,X,K,de,_e){for(const Ce=K.length;de<_e;de++){const Pe=H[de];if(X(Pe,K[Ce-1])<0){K.pop();const Be=D(K,$e=>X(Pe,$e)<0);K.splice(Be,0,Pe)}}}function w(H){return H.filter(X=>!!X)}e.coalesce=w;function S(H){let X=0;for(let K=0;K<H.length;K++)H[K]&&(H[X]=H[K],X+=1);H.length=X}e.coalesceInPlace=S;function T(H,X,K){H.splice(K,0,H.splice(X,1)[0])}e.move=T;function b(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=b;function s(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=s;function o(H,X=K=>K){const K=new Set;return H.filter(de=>{const _e=X(de);return K.has(_e)?!1:(K.add(_e),!0)})}e.distinct=o;function v(H){const X=Object.create(null);return K=>{const de=H(K);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=v;function t(H,X){const K=f(H,X);if(K!==-1)return H[K]}e.findLast=t;function f(H,X){for(let K=H.length-1;K>=0;K--){const de=H[K];if(X(de))return K}return-1}e.lastIndex=f;function r(H,X){return H.length>0?H[0]:X}e.firstOrDefault=r;function n(H,X,K=(de,_e)=>de===_e){let de=0;for(let _e=0,Ce=Math.min(H.length,X.length);_e<Ce&&K(H[_e],X[_e]);_e++)de++;return de}e.commonPrefixLength=n;function d(H){return[].concat(...H)}e.flatten=d;function a(H,X){let K=typeof X=="number"?H:0;typeof X=="number"?K=H:(K=0,X=H);const de=[];if(K<=X)for(let _e=K;_e<X;_e++)de.push(_e);else for(let _e=K;_e>X;_e--)de.push(_e);return de}e.range=a;function c(H,X,K){return H.reduce((de,_e)=>(de[X(_e)]=K?K(_e):_e,de),Object.create(null))}e.index=c;function m(H,X){return H.push(X),()=>u(H,X)}e.insert=m;function u(H,X){const K=H.indexOf(X);if(K>-1)return H.splice(K,1),X}e.remove=u;function E(H,X,K){const de=H.slice(0,X),_e=H.slice(X);return de.concat(K,_e)}e.arrayInsert=E;function A(H,X){let K;if(typeof X=="number"){let de=X;K=()=>{const _e=Math.sin(de++)*179426549;return _e-Math.floor(_e)}}else K=Math.random;for(let de=H.length-1;de>0;de-=1){const _e=Math.floor(K()*(de+1)),Ce=H[de];H[de]=H[_e],H[_e]=Ce}}e.shuffle=A;function R(H,X){const K=H.indexOf(X);K>-1&&(H.splice(K,1),H.unshift(X))}e.pushToStart=R;function B(H,X){const K=H.indexOf(X);K>-1&&(H.splice(K,1),H.push(X))}e.pushToEnd=B;function N(H,X){return Array.isArray(H)?H.map(X):X(H)}e.mapArrayOrNot=N;function F(H){return Array.isArray(H)?H:[H]}e.asArray=F;function $(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=$;function M(H,X){for(const K of H){const de=X(K);if(de!==void 0)return de}}e.mapFind=M;function z(H,X,K){const de=x(H,X),_e=H.length,Ce=K.length;H.length=_e+Ce;for(let Pe=_e-1;Pe>=de;Pe--)H[Pe+Ce]=H[Pe];for(let Pe=0;Pe<Ce;Pe++)H[Pe+de]=K[Pe]}e.insertInto=z;function U(H,X,K,de){const _e=x(H,X),Ce=H.splice(_e,K);return z(H,_e,de),Ce}e.splice=U;function x(H,X){return X<0?Math.max(X+H.length,0):Math.min(X,H.length)}function j(H,X){let K=Number.MAX_SAFE_INTEGER,de=0;return H.forEach((_e,Ce)=>{const Pe=X(_e);Pe<K&&(K=Pe,de=Ce)}),de}e.minIndex=j;function O(H,X){let K=Number.MIN_SAFE_INTEGER,de=0;return H.forEach((_e,Ce)=>{const Pe=X(_e);Pe>K&&(K=Pe,de=Ce)}),de}e.maxIndex=O;class W{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let K=this.firstIdx;for(;K<this.items.length&&X(this.items[K]);)K++;const de=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,de}takeFromEndWhile(X){let K=this.lastIdx;for(;K>=0&&X(this.items[K]);)K--;const de=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,de}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=W}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const y=this;let _=!1,P;return function(){return _||(_=!0,P=L.apply(y,arguments)),P}}e.once=g}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function y(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=y;const _=Object.freeze([]);function P(){return _}L.empty=P;function*D(v){yield v}L.single=D;function C(v){return v||_}L.from=C;function k(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=k;function i(v){return v[Symbol.iterator]().next().value}L.first=i;function I(v,t){for(const f of v)if(t(f))return!0;return!1}L.some=I;function l(v,t){for(const f of v)if(t(f))return f}L.find=l;function*p(v,t){for(const f of v)t(f)&&(yield f)}L.filter=p;function*h(v,t){let f=0;for(const r of v)yield t(r,f++)}L.map=h;function*w(...v){for(const t of v)for(const f of t)yield f}L.concat=w;function*S(v){for(const t of v)for(const f of t)yield f}L.concatNested=S;function T(v,t,f){let r=f;for(const n of v)r=t(r,n);return r}L.reduce=T;function*b(v,t,f=v.length){for(t<0&&(t+=v.length),f<0?f+=v.length:f>v.length&&(f=v.length);t<f;t++)yield v[t]}L.slice=b;function s(v,t=Number.POSITIVE_INFINITY){const f=[];if(t===0)return[f,v];const r=v[Symbol.iterator]();for(let n=0;n<t;n++){const d=r.next();if(d.done)return[f,L.empty()];f.push(d.value)}return[f,{[Symbol.iterator](){return r}}]}L.consume=s;function o(v,t,f=(r,n)=>r===n){const r=v[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const d=r.next(),a=n.next();if(d.done!==a.done)return!1;if(d.done)return!0;if(!f(d.value,a.value))return!1}}L.equals=o})(g=e.Iterable||(e.Iterable={}))}),define(fe[61],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(t){t.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function P(t,f=!1){let r=0,n=t.length,d="",a=0,c=16,m=0;function u($){let M=0,z=0;for(;M<$;){const U=t.charCodeAt(r);if(U>=48&&U<=57)z=z*16+U-48;else if(U>=65&&U<=70)z=z*16+U-65+10;else if(U>=97&&U<=102)z=z*16+U-97+10;else break;r++,M++}return M<$&&(z=-1),z}function E($){r=$,d="",a=0,c=16,m=0}function A(){const $=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&k(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&k(t.charCodeAt(r)))for(r++;r<t.length&&k(t.charCodeAt(r));)r++;else return m=3,t.substring($,r);let M=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&k(t.charCodeAt(r))){for(r++;r<t.length&&k(t.charCodeAt(r));)r++;M=r}else m=3;return t.substring($,M)}function R(){let $="",M=r;for(;;){if(r>=n){$+=t.substring(M,r),m=2;break}const z=t.charCodeAt(r);if(z===34){$+=t.substring(M,r),r++;break}if(z===92){if($+=t.substring(M,r),r++,r>=n){m=2;break}switch(t.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const x=u(4);x>=0?$+=String.fromCharCode(x):m=4;break;default:m=5}M=r;continue}if(z>=0&&z<=31)if(C(z)){$+=t.substring(M,r),m=2;break}else m=6;r++}return $}function B(){if(d="",m=0,a=r,r>=n)return a=n,c=17;let $=t.charCodeAt(r);if(D($)){do r++,d+=String.fromCharCode($),$=t.charCodeAt(r);while(D($));return c=15}if(C($))return r++,d+=String.fromCharCode($),$===13&&t.charCodeAt(r)===10&&(r++,d+=`
`),c=14;switch($){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,d=R(),c=10;case 47:const M=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!C(t.charCodeAt(r));)r++;return d=t.substring(M,r),c=12}if(t.charCodeAt(r+1)===42){r+=2;const z=n-1;let U=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,m=1),d=t.substring(M,r),c=13}return d+=String.fromCharCode($),r++,c=16;case 45:if(d+=String.fromCharCode($),r++,r===n||!k(t.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=A(),c=11;default:for(;r<n&&N($);)r++,$=t.charCodeAt(r);if(a!==r){switch(d=t.substring(a,r),d){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return d+=String.fromCharCode($),r++,c=16}}function N($){if(D($)||C($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=B();while($>=12&&$<=15);return $}return{setPosition:E,getPosition:()=>r,scan:f?F:B,getToken:()=>c,getTokenValue:()=>d,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>m}}e.createScanner=P;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function C(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,f){const r=[],n=new Object;let d;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function m(u,E,A,R){a.value=u,a.offset=E,a.length=A,a.type=R,a.colonOffset=void 0,d=a}try{s(t,{onObjectBegin:(u,E)=>{if(f<=u)throw n;d=void 0,c=f>u,r.push("")},onObjectProperty:(u,E,A)=>{if(f<E||(m(u,E,A,"property"),r[r.length-1]=u,f<=E+A))throw n},onObjectEnd:(u,E)=>{if(f<=u)throw n;d=void 0,r.pop()},onArrayBegin:(u,E)=>{if(f<=u)throw n;d=void 0,r.push(0)},onArrayEnd:(u,E)=>{if(f<=u)throw n;d=void 0,r.pop()},onLiteralValue:(u,E,A)=>{if(f<E||(m(u,E,A,v(u)),f<=E+A))throw n},onSeparator:(u,E,A)=>{if(f<=E)throw n;if(u===":"&&d&&d.type==="property")d.colonOffset=E,c=!1,d=void 0;else if(u===","){const R=r[r.length-1];typeof R=="number"?r[r.length-1]=R+1:(c=!0,r[r.length-1]=""),d=void 0}}})}catch(u){if(u!==n)throw u}return{path:r,previousNode:d,isAtPropertyKey:c,matches:u=>{let E=0;for(let A=0;E<u.length&&A<r.length;A++)if(u[E]===r[A]||u[E]==="*")E++;else if(u[E]!=="**")return!1;return E===u.length}}}e.getLocation=I;function l(t,f=[],r=_.DEFAULT){let n=null,d=[];const a=[];function c(u){Array.isArray(d)?d.push(u):n!==null&&(d[n]=u)}return s(t,{onObjectBegin:()=>{const u={};c(u),a.push(d),d=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{d=a.pop()},onArrayBegin:()=>{const u=[];c(u),a.push(d),d=u,n=null},onArrayEnd:()=>{d=a.pop()},onLiteralValue:c,onError:(u,E,A)=>{f.push({error:u,offset:E,length:A})}},r),d[0]}e.parse=l;function p(t,f=[],r=_.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function a(u){return n.children.push(u),u}s(t,{onObjectBegin:u=>{n=a({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,E,A)=>{n=a({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:E,length:A,parent:n})},onObjectEnd:(u,E)=>{n.length=u+E-n.offset,n=n.parent,d(u+E)},onArrayBegin:(u,E)=>{n=a({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,E)=>{n.length=u+E-n.offset,n=n.parent,d(u+E)},onLiteralValue:(u,E,A)=>{a({type:v(u),offset:E,length:A,parent:n,value:u}),d(E+A)},onSeparator:(u,E,A)=>{n.type==="property"&&(u===":"?n.colonOffset=E:u===","&&d(E))},onError:(u,E,A)=>{f.push({error:u,offset:E,length:A})}},r);const m=n.children[0];return m&&delete m.parent,m}e.parseTree=p;function h(t,f){if(!t)return;let r=t;for(let n of f)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let d=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===n){r=a.children[1],d=!0;break}if(!d)return}else{const d=n;if(r.type!=="array"||d<0||!Array.isArray(r.children)||d>=r.children.length)return;r=r.children[d]}return r}e.findNodeAtLocation=h;function w(t){if(!t.parent||!t.parent.children)return[];const f=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;f.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&f.push(r)}return f}e.getNodePath=w;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const f=Object.create(null);for(let r of t.children){const n=r.children[1];n&&(f[r.children[0].value]=S(n))}return f;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function T(t,f,r=!1){return f>=t.offset&&f<t.offset+t.length||r&&f===t.offset+t.length}e.contains=T;function b(t,f,r=!1){if(T(t,f,r)){const n=t.children;if(Array.isArray(n))for(let d=0;d<n.length&&n[d].offset<=f;d++){const a=b(n[d],f,r);if(a)return a}return t}}e.findNodeAtOffset=b;function s(t,f,r=_.DEFAULT){const n=P(t,!1);function d(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(K){return K?de=>K(de,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=d(f.onObjectBegin),m=a(f.onObjectProperty),u=d(f.onObjectEnd),E=d(f.onArrayBegin),A=d(f.onArrayEnd),R=a(f.onLiteralValue),B=a(f.onSeparator),N=d(f.onComment),F=a(f.onError),$=r&&r.disallowComments,M=r&&r.allowTrailingComma;function z(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:$||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(K){case 12:case 13:$?U(10):N();break;case 16:U(1);break;case 15:case 14:break;default:return K}}}function U(K,de=[],_e=[]){if(F(K),de.length+_e.length>0){let Ce=n.getToken();for(;Ce!==17;){if(de.indexOf(Ce)!==-1){z();break}else if(_e.indexOf(Ce)!==-1)break;Ce=z()}}}function x(K){const de=n.getTokenValue();return K?R(de):m(de),z(),!0}function j(){switch(n.getToken()){case 11:let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(U(2),K=0)}catch(de){U(2)}R(K);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return z(),!0}function O(){return n.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),n.getToken()===6?(B(":"),z(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function W(){c(),z();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||U(4,[],[]),B(","),z(),n.getToken()===2&&M)break}else K&&U(6,[],[]);O()||U(4,[],[2,5]),K=!0}return u(),n.getToken()!==2?U(7,[2],[]):z(),!0}function H(){E(),z();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||U(4,[],[]),B(","),z(),n.getToken()===4&&M)break}else K&&U(6,[],[]);X()||U(4,[],[4,5]),K=!0}return A(),n.getToken()!==4?U(8,[4],[]):z(),!0}function X(){switch(n.getToken()){case 3:return H();case 1:return W();case 10:return x(!0);default:return j()}}return z(),n.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(n.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=s;function o(t,f){let r=P(t),n=[],d,a=0,c;do switch(c=r.getPosition(),d=r.scan(),d){case 12:case 13:case 17:a!==c&&n.push(t.substring(a,c)),f!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,f)),a=r.getPosition();break}while(d!==17);return n.join("")}e.stripComments=o;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(fe[139],me([0,1,61]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(C,k,i){let I,l,p,h,w;if(k){for(h=k.offset,w=h+k.length,p=h;p>0&&!D(C,p-1);)p--;let a=w;for(;a<C.length&&!D(C,a);)a++;l=C.substring(p,a),I=_(l,i)}else l=C,I=0,p=0,h=0,w=C.length;const S=P(i,C);let T=!1,b=0,s;i.insertSpaces?s=y(" ",i.tabSize||4):s="	";const o=(0,g.createScanner)(l,!1);let v=!1;function t(){return S+y(s,I+b)}function f(){let a=o.scan();for(T=!1;a===15||a===14;)T=T||a===14,a=o.scan();return v=a===16||o.getTokenError()!==0,a}const r=[];function n(a,c,m){!v&&c<w&&m>h&&C.substring(c,m)!==a&&r.push({offset:c,length:m-c,content:a})}let d=f();if(d!==17){const a=o.getTokenOffset()+p,c=y(s,I);n(c,p,a)}for(;d!==17;){let a=o.getTokenOffset()+o.getTokenLength()+p,c=f(),m="";for(;!T&&(c===12||c===13);){const E=o.getTokenOffset()+p;n(" ",a,E),a=o.getTokenOffset()+o.getTokenLength()+p,m=c===12?t():"",c=f()}if(c===2)d!==1&&(b--,m=t());else if(c===4)d!==3&&(b--,m=t());else{switch(d){case 3:case 1:b++,m=t();break;case 5:case 12:m=t();break;case 13:T?m=t():m=" ";break;case 6:m=" ";break;case 10:if(c===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:c===12||c===13?m=" ":c!==5&&c!==17&&(v=!0);break;case 16:v=!0;break}T&&(c===12||c===13)&&(m=t())}const u=o.getTokenOffset()+p;n(m,a,u),d=c}return r}e.format=L;function y(C,k){let i="";for(let I=0;I<k;I++)i+=C;return i}function _(C,k){let i=0,I=0;const l=k.tabSize||4;for(;i<C.length;){const p=C.charAt(i);if(p===" ")I++;else if(p==="	")I+=l;else break;i++}return Math.floor(I/l)}function P(C,k){for(let i=0;i<k.length;i++){const I=k.charAt(i);if(I==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=P;function D(C,k){return`\r
`.indexOf(C.charAt(k))!==-1}e.isEOL=D}),define(fe[140],me([0,1,61,139]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(k,i,I){return _(k,i,void 0,I)}e.removeProperty=y;function _(k,i,I,l,p){const h=i.slice(),w=[],S=(0,g.parseTree)(k,w);let T,b;for(;h.length>0&&(b=h.pop(),T=(0,g.findNodeAtLocation)(S,h),T===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(T)if(T.type==="object"&&typeof b=="string"&&Array.isArray(T.children)){const s=(0,g.findNodeAtLocation)(T,[b]);if(s!==void 0)if(I===void 0){if(!s.parent)throw new Error("Malformed AST");const o=T.children.indexOf(s.parent);let v,t=s.parent.offset+s.parent.length;if(o>0){const f=T.children[o-1];v=f.offset+f.length}else v=T.offset+1,T.children.length>1&&(t=T.children[1].offset);return P(k,{offset:v,length:t-v,content:""},l)}else return P(k,{offset:s.offset,length:s.length,content:JSON.stringify(I)},l);else{if(I===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,v=p?p(T.children.map(f=>f.children[0].value)):T.children.length;let t;if(v>0){const f=T.children[v-1];t={offset:f.offset+f.length,length:0,content:","+o}}else T.children.length===0?t={offset:T.offset+1,length:0,content:o}:t={offset:T.offset+1,length:0,content:o+","};return P(k,t,l)}}else if(T.type==="array"&&typeof b=="number"&&Array.isArray(T.children))if(I!==void 0){const s=`${JSON.stringify(I)}`;let o;if(T.children.length===0||b===0)o={offset:T.offset+1,length:0,content:T.children.length===0?s:s+","};else{const v=b===-1||b>T.children.length?T.children.length:b,t=T.children[v-1];o={offset:t.offset+t.length,length:0,content:","+s}}return P(k,o,l)}else{const s=b,o=T.children[s];let v;if(T.children.length===1)v={offset:T.offset+1,length:T.length-2,content:""};else if(T.children.length-1===s){const t=T.children[s-1],f=t.offset+t.length,r=T.offset+T.length;v={offset:f,length:r-2-f,content:""}}else v={offset:o.offset,length:T.children[s+1].offset-o.offset,content:""};return P(k,v,l)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${T.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return P(k,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(I)},l)}}e.setProperty=_;function P(k,i,I){let l=D(k,i),p=i.offset,h=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(l,p-1);)p--;for(;h<l.length&&!(0,L.isEOL)(l,h);)h++}const w=(0,L.format)(l,{offset:p,length:h-p},I);for(let T=w.length-1;T>=0;T--){const b=w[T];l=D(l,b),p=Math.min(p,b.offset),h=Math.max(h,b.offset+b.length),h+=b.content.length-b.length}const S=k.length-(l.length-h)-p;return[{offset:p,length:S,content:l.substring(p,h)}]}e.withFormatting=P;function D(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=D;function C(k,i){let I=i.slice(0).sort((p,h)=>{const w=p.offset-h.offset;return w===0?p.length-h.length:w}),l=k.length;for(let p=I.length-1;p>=0;p--){let h=I[p];if(h.offset+h.length<=l)k=D(k,h);else throw new Error("Overlapping edit");l=h.offset}return k}e.applyEdits=C}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new g(()=>y(this.getValue()))}}e.Lazy=g}),define(fe[6],me([0,1,76,78]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let _=null;function P(n){_=n}if(e.setDisposableTracker=P,y){const n="__is_disposable_tracked__";P(new class{trackDisposable(d){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[n]||console.log(a)},3e3)}setParent(d,a){if(d&&d!==b.None)try{d[n]=!0}catch{}}markAsDisposed(d){if(d&&d!==b.None)try{d[n]=!0}catch{}}markAsSingleton(d){}})}function D(n){return _?.trackDisposable(n),n}function C(n){_?.markAsDisposed(n)}function k(n,d){_?.setParent(n,d)}function i(n,d){if(!!_)for(const a of n)_.setParent(a,d)}function I(n){return _?.markAsSingleton(n),n}e.markAsSingleton=I;class l extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}e.MultiDisposeError=l;function p(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=p;function h(n){if(L.Iterable.is(n)){let d=[];for(const a of n)if(a)try{a.dispose()}catch(c){d.push(c)}if(d.length===1)throw d[0];if(d.length>1)throw new l(d);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=h;function w(...n){const d=S(()=>h(n));return i(n,d),d}e.combinedDisposable=w;function S(n){const d=D({dispose:(0,g.once)(()=>{C(d),n()})});return d}e.toDisposable=S;class T{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return k(d,this),this._isDisposed?T.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=T,T.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new T,D(this),k(this._store,this)}dispose(){C(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){this._isDisposed||d===this._value||(this._value?.dispose(),d&&k(d,this),this._value=d)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const d=this._value;return this._value=void 0,d&&k(d,null),d}}e.MutableDisposable=s;class o{constructor(d){this._disposable=d,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class v{constructor(){this.references=new Map}acquire(d,...a){let c=this.references.get(d);c||(c={counter:0,object:this.createReferencedObject(d,...a)},this.references.set(d,c));const{object:m}=c,u=(0,g.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(d,c.object),this.references.delete(d))});return c.counter++,{object:m,dispose:u}}}e.ReferenceCollection=v;class t{constructor(d){this.referenceCollection=d}async acquire(d,...a){const c=this.referenceCollection.acquire(d,...a);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(m){throw c.dispose(),m}}}e.AsyncReferenceCollection=t;class f{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=f;function r(n){const d=new T;try{n(d)}finally{d.dispose()}}e.disposeOnReturn=r}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(_){this.element=_,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let _=this._first;for(;_!==g.Undefined;){const P=_.next;_.prev=g.Undefined,_.next=g.Undefined,_=P}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,P){const D=new g(_);if(this._first===g.Undefined)this._first=D,this._last=D;else if(P){const k=this._last;this._last=D,D.prev=k,k.next=D}else{const k=this._first;this._first=D,D.next=k,k.prev=D}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(D))}}shift(){if(this._first!==g.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==g.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==g.Undefined&&_.next!==g.Undefined){const P=_.prev;P.next=_.next,_.next.prev=P}else _.prev===g.Undefined&&_.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):_.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):_.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==g.Undefined;)yield _.element,_=_.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,De){for(var Te=0;Te<De.length;Te++){var oe=De[Te];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Re,oe.key,oe)}}function e(Re,De,Te){return De&&Y(Re.prototype,De),Te&&Y(Re,Te),Re}function g(Re,De){if(!!Re){if(typeof Re=="string")return L(Re,De);var Te=Object.prototype.toString.call(Re).slice(8,-1);if(Te==="Object"&&Re.constructor&&(Te=Re.constructor.name),Te==="Map"||Te==="Set")return Array.from(Re);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(Re,De)}}function L(Re,De){(De==null||De>Re.length)&&(De=Re.length);for(var Te=0,oe=new Array(De);Te<De;Te++)oe[Te]=Re[Te];return oe}function y(Re,De){var Te=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Te)return(Te=Te.call(Re)).next.bind(Te);if(Array.isArray(Re)||(Te=g(Re))||De&&Re&&typeof Re.length=="number"){Te&&(Re=Te);var oe=0;return function(){return oe>=Re.length?{done:!0}:{done:!1,value:Re[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var _={exports:{}};function P(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function D(Re){_.exports.defaults=Re}_.exports={defaults:P(),getDefaults:P,changeDefaults:D};var C=/[&<>"']/,k=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(De){return l[De]};function h(Re,De){if(De){if(C.test(Re))return Re.replace(k,p)}else if(i.test(Re))return Re.replace(I,p);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function S(Re){return Re.replace(w,function(De,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var T=/(^|[^\[])\^/g;function b(Re,De){Re=Re.source||Re,De=De||"";var Te={replace:function(ue,we){return we=we.source||we,we=we.replace(T,"$1"),Re=Re.replace(ue,we),Te},getRegex:function(){return new RegExp(Re,De)}};return Te}var s=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,De,Te){if(Re){var oe;try{oe=decodeURIComponent(S(Te)).replace(s,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}De&&!o.test(Te)&&(Te=d(De,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var t={},f=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(Re,De){t[" "+Re]||(f.test(Re)?t[" "+Re]=Re+"/":t[" "+Re]=u(Re,"/",!0)),Re=t[" "+Re];var Te=Re.indexOf(":")===-1;return De.substring(0,2)==="//"?Te?De:Re.replace(r,"$1")+De:De.charAt(0)==="/"?Te?De:Re.replace(n,"$1")+De:Re+De}var a={exec:function(){}};function c(Re){for(var De=1,Te,oe;De<arguments.length;De++){Te=arguments[De];for(oe in Te)Object.prototype.hasOwnProperty.call(Te,oe)&&(Re[oe]=Te[oe])}return Re}function m(Re,De){var Te=Re.replace(/\|/g,function(we,ve,Fe){for(var Ge=!1,ze=ve;--ze>=0&&Fe[ze]==="\\";)Ge=!Ge;return Ge?"|":" |"}),oe=Te.split(/ \|/),ue=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>De)oe.splice(De);else for(;oe.length<De;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function u(Re,De,Te){var oe=Re.length;if(oe===0)return"";for(var ue=0;ue<oe;){var we=Re.charAt(oe-ue-1);if(we===De&&!Te)ue++;else if(we!==De&&Te)ue++;else break}return Re.substr(0,oe-ue)}function E(Re,De){if(Re.indexOf(De[1])===-1)return-1;for(var Te=Re.length,oe=0,ue=0;ue<Te;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===De[0])oe++;else if(Re[ue]===De[1]&&(oe--,oe<0))return ue;return-1}function A(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,De){if(De<1)return"";for(var Te="";De>1;)De&1&&(Te+=Re),De>>=1,Re+=Re;return Te+Re}var B={escape:h,unescape:S,edit:b,cleanUrl:v,resolveUrl:d,noopTest:a,merge:c,splitCells:m,rtrim:u,findClosingBracket:E,checkSanitizeDeprecation:A,repeatString:R},N=_.exports.defaults,F=B.rtrim,$=B.splitCells,M=B.escape,z=B.findClosingBracket;function U(Re,De,Te,oe){var ue=De.href,we=De.title?M(De.title):null,ve=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){oe.state.inLink=!0;var Fe={type:"link",raw:Te,href:ue,title:we,text:ve,tokens:oe.inlineTokens(ve,[])};return oe.state.inLink=!1,Fe}else return{type:"image",raw:Te,href:ue,title:we,text:M(ve)}}function x(Re,De){var Te=Re.match(/^(\s+)(?:```)/);if(Te===null)return De;var oe=Te[1];return De.split(`
`).map(function(ue){var we=ue.match(/^\s+/);if(we===null)return ue;var ve=we[0];return ve.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var j=function(){function Re(Te){this.options=Te||N}var De=Re.prototype;return De.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var we=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?we:F(we,`
`)}}},De.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var we=ue[0],ve=x(we,ue[3]||"");return{type:"code",raw:we,lang:ue[2]?ue[2].trim():ue[2],text:ve}}},De.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var we=ue[2].trim();if(/#$/.test(we)){var ve=F(we,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(we=ve.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:we,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var we=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},De.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var we,ve,Fe,Ge,ze,Ye,lt,xe,ge,be,re=ue[1].trim(),Q=re.length>1,Se={type:"list",raw:"",ordered:Q,start:Q?+re.slice(0,-1):"",loose:!1,items:[]};re=Q?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Q?re:"[*+-]");for(var Le=new RegExp("^( {0,3}"+re+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(ue=Le.exec(oe)));){ge=ue[2].split(`
`),this.options.pedantic?(Ge=2,be=ge[0].trimLeft()):(Ge=ue[2].search(/[^ ]/),Ge=ue[1].length+(Ge>4?1:Ge),be=ge[0].slice(Ge-ue[1].length)),Ye=!1,we=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(we=ue[1]+ge.slice(0,2).join(`
`)+`
`,Se.loose=!0,ge=[]);var nt=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),nt.test(xe)){we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!Ye){xe.trim()||(Ye=!0),xe.search(/[^ ]/)>=Ge?be+=`
`+xe.slice(Ge):be+=`
`+xe;continue}if(xe.search(/[^ ]/)>=Ge||!xe.trim()){be+=`
`+xe.slice(Ge);continue}else{we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Se.loose||(lt?Se.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(be),ve&&(Fe=ve[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:we,task:!!ve,checked:Fe,loose:!1,text:be}),Se.raw+=we,oe=oe.slice(we.length)}Se.items[Se.items.length-1].raw=we.trimRight(),Se.items[Se.items.length-1].text=be.trimRight(),Se.raw=Se.raw.trimRight();var qe=Se.items.length;for(ze=0;ze<qe;ze++)this.lexer.state.top=!1,Se.items[ze].tokens=this.lexer.blockTokens(Se.items[ze].text,[]),Se.items[ze].tokens.some(function(gt){return gt.type==="space"})&&(Se.loose=!0,Se.items[ze].loose=!0);return Se}},De.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue){var we={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},De.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var we=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var we={type:"table",header:$(ue[1]).map(function(lt){return{text:lt}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=ue[0];var ve=we.align.length,Fe,Ge,ze,Ye;for(Fe=0;Fe<ve;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(ve=we.rows.length,Fe=0;Fe<ve;Fe++)we.rows[Fe]=$(we.rows[Fe],we.header.length).map(function(lt){return{text:lt}});for(ve=we.header.length,Ge=0;Ge<ve;Ge++)we.header[Ge].tokens=[],this.lexer.inlineTokens(we.header[Ge].text,we.header[Ge].tokens);for(ve=we.rows.length,Ge=0;Ge<ve;Ge++)for(Ye=we.rows[Ge],ze=0;ze<Ye.length;ze++)Ye[ze].tokens=[],this.lexer.inlineTokens(Ye[ze].text,Ye[ze].tokens);return we}}},De.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue){var we={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue){var we={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue){var we={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},De.tag=function(oe){var ue=this.rules.inline.tag.exec(oe);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},De.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var we=ue[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var ve=F(we.slice(0,-1),"\\");if((we.length-ve.length)%2==0)return}else{var Fe=z(ue[2],"()");if(Fe>-1){var Ge=ue[0].indexOf("!")===0?5:4,ze=Ge+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var Ye=ue[2],lt="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);xe&&(Ye=xe[1],lt=xe[3])}else lt=ue[3]?ue[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(we)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),U(ue,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(oe,ue){var we;if((we=this.rules.inline.reflink.exec(oe))||(we=this.rules.inline.nolink.exec(oe))){var ve=(we[2]||we[1]).replace(/\s+/g," ");if(ve=ue[ve.toLowerCase()],!ve||!ve.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(we,ve,we[0],this.lexer)}},De.emStrong=function(oe,ue,we){we===void 0&&(we="");var ve=this.rules.inline.emStrong.lDelim.exec(oe);if(!!ve&&!(ve[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ve[1]||ve[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var Ge=ve[0].length-1,ze,Ye,lt=Ge,xe=0,ge=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*oe.length+Ge);(ve=ge.exec(ue))!=null;)if(ze=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!ze){if(Ye=ze.length,ve[3]||ve[4]){lt+=Ye;continue}else if((ve[5]||ve[6])&&Ge%3&&!((Ge+Ye)%3)){xe+=Ye;continue}if(lt-=Ye,!(lt>0)){if(Ye=Math.min(Ye,Ye+lt+xe),Math.min(Ge,Ye)%2){var be=oe.slice(1,Ge+ve.index+Ye);return{type:"em",raw:oe.slice(0,Ge+ve.index+Ye+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var re=oe.slice(2,Ge+ve.index+Ye-1);return{type:"strong",raw:oe.slice(0,Ge+ve.index+Ye+1),text:re,tokens:this.lexer.inlineTokens(re,[])}}}}}},De.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var we=ue[2].replace(/\n/g," "),ve=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return ve&&Fe&&(we=we.substring(1,we.length-1)),we=M(we,!0),{type:"codespan",raw:ue[0],text:we}}},De.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},De.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},De.autolink=function(oe,ue){var we=this.rules.inline.autolink.exec(oe);if(we){var ve,Fe;return we[2]==="@"?(ve=M(this.options.mangle?ue(we[1]):we[1]),Fe="mailto:"+ve):(ve=M(we[1]),Fe=ve),{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.url=function(oe,ue){var we;if(we=this.rules.inline.url.exec(oe)){var ve,Fe;if(we[2]==="@")ve=M(this.options.mangle?ue(we[0]):we[0]),Fe="mailto:"+ve;else{var Ge;do Ge=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ge!==we[0]);ve=M(we[0]),we[1]==="www."?Fe="http://"+ve:Fe=ve}return{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.inlineText=function(oe,ue){var we=this.rules.inline.text.exec(oe);if(we){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):M(we[0]):we[0]:ve=M(this.options.smartypants?ue(we[0]):we[0]),{type:"text",raw:we[0],text:ve}}},Re}(),O=B.noopTest,W=B.edit,H=B.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=W(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=W(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=W(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=W(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=W(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=W(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=H({},X),X.gfm=H({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=W(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=H({},X.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:W(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=W(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=W(X._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=W(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=W(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=W(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=W(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=W(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=W(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=W(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=W(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=H({},K),K.pedantic=H({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=H({},K.normal,{escape:W(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=W(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=H({},K.gfm,{br:W(K.br).replace("{2,}","*").getRegex(),text:W(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:K},_e=j,Ce=_.exports.defaults,Pe=de.block,Be=de.inline,$e=B.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Re){var De="",Te,oe,ue=Re.length;for(Te=0;Te<ue;Te++)oe=Re.charCodeAt(Te),Math.random()>.5&&(oe="x"+oe.toString(16)),De+="&#"+oe+";";return De}var ee=function(){function Re(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||Ce,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:Pe.normal,inline:Be.normal};this.options.pedantic?(oe.block=Pe.pedantic,oe.inline=Be.pedantic):this.options.gfm&&(oe.block=Pe.gfm,this.options.breaks?oe.inline=Be.breaks:oe.inline=Be.gfm),this.tokenizer.rules=oe}Re.lex=function(oe,ue){var we=new Re(ue);return we.lex(oe)},Re.lexInline=function(oe,ue){var we=new Re(ue);return we.inlineTokens(oe)};var De=Re.prototype;return De.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(oe,ue){var we=this;ue===void 0&&(ue=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var ve,Fe,Ge,ze;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(ve=lt.call({lexer:we},oe,ue))?(oe=oe.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.space(oe)){oe=oe.substring(ve.raw.length),ve.type&&ue.push(ve);continue}if(ve=this.tokenizer.code(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(ve=this.tokenizer.fences(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.heading(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.hr(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.blockquote(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.list(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.html(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.def(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.lheading(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(Ge=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=Infinity,xe=oe.slice(1),ge=void 0;we.options.extensions.startBlock.forEach(function(be){ge=be.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(lt=Math.min(lt,ge))}),lt<Infinity&&lt>=0&&(Ge=oe.substring(0,lt+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(Ge))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve),ze=Ge.length!==oe.length,oe=oe.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(oe){var Ye="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,ue},De.inline=function(oe,ue){this.inlineQueue.push({src:oe,tokens:ue})},De.inlineTokens=function(oe,ue){var we=this;ue===void 0&&(ue=[]);var ve,Fe,Ge,ze=oe,Ye,lt,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,Ye.index)+"["+$e("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"["+$e("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(lt||(xe=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(re){return(ve=re.call({lexer:we},oe,ue))?(oe=oe.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.tag(oe)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.link(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.emStrong(oe,ze,xe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.codespan(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.br(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.del(oe)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.autolink(oe,G)){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(oe,G))){oe=oe.substring(ve.raw.length),ue.push(ve);continue}if(Ge=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var re=Infinity,Q=oe.slice(1),Se=void 0;we.options.extensions.startInline.forEach(function(Le){Se=Le.call({lexer:this},Q),typeof Se=="number"&&Se>=0&&(re=Math.min(re,Se))}),re<Infinity&&re>=0&&(Ge=oe.substring(0,re+1))}(),ve=this.tokenizer.inlineText(Ge,He)){oe=oe.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(xe=ve.raw.slice(-1)),lt=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(oe){var be="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:Pe,inline:Be}}}]),Re}(),te=_.exports.defaults,ce=B.cleanUrl,Z=B.escape,se=function(){function Re(Te){this.options=Te||te}var De=Re.prototype;return De.code=function(oe,ue,we){var ve=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(oe,ve);Fe!=null&&Fe!==oe&&(we=!0,oe=Fe)}return oe=oe.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+Z(ve,!0)+'">'+(we?oe:Z(oe,!0))+`</code></pre>
`:"<pre><code>"+(we?oe:Z(oe,!0))+`</code></pre>
`},De.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},De.html=function(oe){return oe},De.heading=function(oe,ue,we,ve){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+ve.slug(we)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(oe,ue,we){var ve=ue?"ol":"ul",Fe=ue&&we!==1?' start="'+we+'"':"";return"<"+ve+Fe+`>
`+oe+"</"+ve+`>
`},De.listitem=function(oe){return"<li>"+oe+`</li>
`},De.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(oe){return"<p>"+oe+`</p>
`},De.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},De.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},De.tablecell=function(oe,ue){var we=ue.header?"th":"td",ve=ue.align?"<"+we+' align="'+ue.align+'">':"<"+we+">";return ve+oe+"</"+we+`>
`},De.strong=function(oe){return"<strong>"+oe+"</strong>"},De.em=function(oe){return"<em>"+oe+"</em>"},De.codespan=function(oe){return"<code>"+oe+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(oe){return"<del>"+oe+"</del>"},De.link=function(oe,ue,we){if(oe=ce(this.options.sanitize,this.options.baseUrl,oe),oe===null)return we;var ve='<a href="'+Z(oe)+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=">"+we+"</a>",ve},De.image=function(oe,ue,we){if(oe=ce(this.options.sanitize,this.options.baseUrl,oe),oe===null)return we;var ve='<img src="'+oe+'" alt="'+we+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=this.options.xhtml?"/>":">",ve},De.text=function(oe){return oe},Re}(),pe=function(){function Re(){}var De=Re.prototype;return De.strong=function(oe){return oe},De.em=function(oe){return oe},De.codespan=function(oe){return oe},De.del=function(oe){return oe},De.html=function(oe){return oe},De.text=function(oe){return oe},De.link=function(oe,ue,we){return""+we},De.image=function(oe,ue,we){return""+we},De.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var De=Re.prototype;return De.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(oe,ue){var we=oe,ve=0;if(this.seen.hasOwnProperty(we)){ve=this.seen[oe];do ve++,we=oe+"-"+ve;while(this.seen.hasOwnProperty(we))}return ue||(this.seen[oe]=ve,this.seen[we]=0),we},De.slug=function(oe,ue){ue===void 0&&(ue={});var we=this.serialize(oe);return this.getNextSafeSlug(we,ue.dryrun)},Re}(),je=se,Ke=pe,Ze=Me,rt=_.exports.defaults,ct=B.unescape,ye=function(){function Re(Te){this.options=Te||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Re.parse=function(oe,ue){var we=new Re(ue);return we.parse(oe)},Re.parseInline=function(oe,ue){var we=new Re(ue);return we.parseInline(oe)};var De=Re.prototype;return De.parse=function(oe,ue){ue===void 0&&(ue=!0);var we="",ve,Fe,Ge,ze,Ye,lt,xe,ge,be,re,Q,Se,Le,nt,qe,gt,Et,pt,vt,wt=oe.length;for(ve=0;ve<wt;ve++){if(re=oe[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(vt=this.options.extensions.renderers[re.type].call({parser:this},re),vt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(re.type))){we+=vt||"";continue}switch(re.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(re.tokens),re.depth,ct(this.parseInline(re.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(re.text,re.lang,re.escaped);continue}case"table":{for(ge="",xe="",ze=re.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(re.header[Fe].tokens),{header:!0,align:re.align[Fe]});for(ge+=this.renderer.tablerow(xe),be="",ze=re.rows.length,Fe=0;Fe<ze;Fe++){for(lt=re.rows[Fe],xe="",Ye=lt.length,Ge=0;Ge<Ye;Ge++)xe+=this.renderer.tablecell(this.parseInline(lt[Ge].tokens),{header:!1,align:re.align[Ge]});be+=this.renderer.tablerow(xe)}we+=this.renderer.table(ge,be);continue}case"blockquote":{be=this.parse(re.tokens),we+=this.renderer.blockquote(be);continue}case"list":{for(Q=re.ordered,Se=re.start,Le=re.loose,ze=re.items.length,be="",Fe=0;Fe<ze;Fe++)qe=re.items[Fe],gt=qe.checked,Et=qe.task,nt="",qe.task&&(pt=this.renderer.checkbox(gt),Le?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=pt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=pt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:pt}):nt+=pt),nt+=this.parse(qe.tokens,Le),be+=this.renderer.listitem(nt,Et,gt);we+=this.renderer.list(be,Q,Se);continue}case"html":{we+=this.renderer.html(re.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(re.tokens));continue}case"text":{for(be=re.tokens?this.parseInline(re.tokens):re.text;ve+1<wt&&oe[ve+1].type==="text";)re=oe[++ve],be+=`
`+(re.tokens?this.parseInline(re.tokens):re.text);we+=ue?this.renderer.paragraph(be):be;continue}default:{var Dt='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Dt);return}else throw new Error(Dt)}}}return we},De.parseInline=function(oe,ue){ue=ue||this.renderer;var we="",ve,Fe,Ge,ze=oe.length;for(ve=0;ve<ze;ve++){if(Fe=oe[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=Ge||"";continue}switch(Fe.type){case"escape":{we+=ue.text(Fe.text);break}case"html":{we+=ue.html(Fe.text);break}case"link":{we+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{we+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{we+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{we+=ue.codespan(Fe.text);break}case"br":{we+=ue.br();break}case"del":{we+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{we+=ue.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return we},Re}(),at=ee,J=ye,ie=j,Ee=se,Qe=pe,et=Me,le=B.merge,Ie=B.checkSanitizeDeprecation,Ue=B.escape,Xe=_.exports.getDefaults,it=_.exports.changeDefaults,ft=_.exports.defaults;function tt(Re,De,Te){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof De=="function"&&(Te=De,De=null),De=le({},tt.defaults,De||{}),Ie(De),Te){var oe=De.highlight,ue;try{ue=at.lex(Re,De)}catch(Ge){return Te(Ge)}var we=function(ze){var Ye;if(!ze)try{De.walkTokens&&tt.walkTokens(ue,De.walkTokens),Ye=J.parse(ue,De)}catch(lt){ze=lt}return De.highlight=oe,ze?Te(ze):Te(null,Ye)};if(!oe||oe.length<3||(delete De.highlight,!ue.length))return we();var ve=0;tt.walkTokens(ue,function(Ge){Ge.type==="code"&&(ve++,setTimeout(function(){oe(Ge.text,Ge.lang,function(ze,Ye){if(ze)return we(ze);Ye!=null&&Ye!==Ge.text&&(Ge.text=Ye,Ge.escaped=!0),ve--,ve===0&&we()})},0))}),ve===0&&we();return}try{var Fe=at.lex(Re,De);return De.walkTokens&&tt.walkTokens(Fe,De.walkTokens),J.parse(Fe,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ue(Ge.message+"",!0)+"</pre>";throw Ge}}tt.options=tt.setOptions=function(Re){return le(tt.defaults,Re),it(tt.defaults),tt},tt.getDefaults=Xe,tt.defaults=ft,tt.use=function(){for(var Re=this,De=arguments.length,Te=new Array(De),oe=0;oe<De;oe++)Te[oe]=arguments[oe];var ue=le.apply(void 0,[{}].concat(Te)),we=tt.defaults.extensions||{renderers:{},childTokens:{}},ve;Te.forEach(function(Fe){if(Fe.extensions&&(ve=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ye=we.renderers?we.renderers[ze.name]:null;Ye?we.renderers[ze.name]=function(){for(var lt=arguments.length,xe=new Array(lt),ge=0;ge<lt;ge++)xe[ge]=arguments[ge];var be=ze.renderer.apply(this,xe);return be===!1&&(be=Ye.apply(this,xe)),be}:we.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[ze.level]?we[ze.level].unshift(ze.tokenizer):we[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?we.startBlock?we.startBlock.push(ze.start):we.startBlock=[ze.start]:ze.level==="inline"&&(we.startInline?we.startInline.push(ze.start):we.startInline=[ze.start]))}ze.childTokens&&(we.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=tt.defaults.renderer||new Ee,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var re=arguments.length,Q=new Array(re),Se=0;Se<re;Se++)Q[Se]=arguments[Se];var Le=Fe.renderer[ge].apply(ze,Q);return Le===!1&&(Le=be.apply(ze,Q)),Le}};for(var lt in Fe.renderer)Ye(lt);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=tt.defaults.tokenizer||new ie,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var re=arguments.length,Q=new Array(re),Se=0;Se<re;Se++)Q[Se]=arguments[Se];var Le=Fe.tokenizer[ge].apply(ze,Q);return Le===!1&&(Le=be.apply(ze,Q)),Le}};for(var lt in Fe.tokenizer)Ye(lt);ue.tokenizer=ze}(),Fe.walkTokens){var Ge=tt.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),Ge&&Ge(ze)}}ve&&(ue.extensions=we),tt.setOptions(ue)})},tt.walkTokens=function(Re,De){for(var Te=function(){var ve=ue.value;switch(De(ve),ve.type){case"table":{for(var Fe=y(ve.header),Ge;!(Ge=Fe()).done;){var ze=Ge.value;tt.walkTokens(ze.tokens,De)}for(var Ye=y(ve.rows),lt;!(lt=Ye()).done;)for(var xe=lt.value,ge=y(xe),be;!(be=ge()).done;){var re=be.value;tt.walkTokens(re.tokens,De)}break}case"list":{tt.walkTokens(ve.items,De);break}default:tt.defaults.extensions&&tt.defaults.extensions.childTokens&&tt.defaults.extensions.childTokens[ve.type]?tt.defaults.extensions.childTokens[ve.type].forEach(function(Q){tt.walkTokens(ve[Q],De)}):ve.tokens&&tt.walkTokens(ve.tokens,De)}},oe=y(Re),ue;!(ue=oe()).done;)Te()},tt.parseInline=function(Re,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");De=le({},tt.defaults,De||{}),Ie(De);try{var Te=at.lexInline(Re,De);return De.walkTokens&&tt.walkTokens(Te,De.walkTokens),J.parseInline(Te,De)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ue(oe.message+"",!0)+"</pre>";throw oe}},tt.Parser=J,tt.parser=J.parse,tt.Renderer=Ee,tt.TextRenderer=Qe,tt.Lexer=at,tt.lexer=at.lex,tt.Tokenizer=ie,tt.Slugger=et,tt.parse=tt;var ut=tt;return ut}),define(fe[79],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(P,D,C){return Math.min(Math.max(P,D),C)}e.clamp=g;function L(P,D){return(D+P%D)%D}e.rot=L;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class _{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=_}),function(){function Y(y){const _=[];typeof y=="number"&&_.push("code/timeOrigin",y);function P(C){_.push(C,Date.now())}function D(){const C=[];for(let k=0;k<_.length;k+=2)C.push({name:_[k],startTime:_[k+1]});return C}return{mark:P,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const P of performance.getEntriesByType("mark"))_.push({name:P.name,startTime:Math.round(y+P.startTime)});return _}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(fe[11],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,y=!1,_=!1,P=!1,D=!1,C=!1,k=!1,i,I=g,l,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const w=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=w&&h?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,L=p.indexOf("Windows")>=0,y=p.indexOf("Macintosh")>=0,k=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=p.indexOf("Linux")>=0,C=!0,i=navigator.language,I=i;else if(typeof h=="object"){L=h.platform==="win32",y=h.platform==="darwin",_=h.platform==="linux",P=_&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,i=g,I=g;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const n=JSON.parse(r),d=n.availableLanguages["*"];i=n.locale,I=d||g,l=n._translationsConfigFile}catch(n){}D=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function T(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=T;let b=0;y?b=1:L?b=3:_&&(b=2),e.isWindows=L,e.isMacintosh=y,e.isLinux=_,e.isLinuxSnap=P,e.isNative=D,e.isWeb=C,e.isIOS=k,e.platform=b,e.userAgent=p,e.language=I;var s;(function(r){function n(){return e.language}r.value=n;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=d;function a(){return e.language==="en"}r.isDefault=a})(s=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let d=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeSetImmediateId)for(let m=0,u=d.length;m<u;m++){const E=d[m];if(E.id===c.data.vscodeSetImmediateId){d.splice(m,1),E.callback();return}}});let a=0;return c=>{const m=++a;d.push({id:m,callback:c}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const n=Promise.resolve();return d=>n.then(d)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||k?2:L?1:3;let v=!0,t=!1;function f(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,v=new Uint16Array(r.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=f}),define(fe[38],me([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const y=g.globals.vscode.process;L={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()},nextTick(_){return(0,g.setImmediate)(_)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(y){return process.nextTick(y)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(y){return(0,g.setImmediate)(y)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(fe[8],me([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,y=97,_=90,P=122,D=46,C=47,k=92,i=58,I=63;class l extends Error{constructor(o,v,t){let f;typeof v=="string"&&v.indexOf("not ")===0?(f="must not be",v=v.replace(/^not /,"")):f="must be";const r=o.indexOf(".")!==-1?"property":"argument";let n=`The "${o}" ${r} ${f} of type ${v}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function p(s,o){if(typeof s!="string")throw new l(o,"string",s)}function h(s){return s===C||s===k}function w(s){return s===C}function S(s){return s>=L&&s<=_||s>=y&&s<=P}function T(s,o,v,t){let f="",r=0,n=-1,d=0,a=0;for(let c=0;c<=s.length;++c){if(c<s.length)a=s.charCodeAt(c);else{if(t(a))break;a=C}if(t(a)){if(!(n===c-1||d===1))if(d===2){if(f.length<2||r!==2||f.charCodeAt(f.length-1)!==D||f.charCodeAt(f.length-2)!==D){if(f.length>2){const m=f.lastIndexOf(v);m===-1?(f="",r=0):(f=f.slice(0,m),r=f.length-1-f.lastIndexOf(v)),n=c,d=0;continue}else if(f.length!==0){f="",r=0,n=c,d=0;continue}}o&&(f+=f.length>0?`${v}..`:"..",r=2)}else f.length>0?f+=`${v}${s.slice(n+1,c)}`:f=s.slice(n+1,c),r=c-n-1;n=c,d=0}else a===D&&d!==-1?++d:d=-1}return f}function b(s,o){if(o===null||typeof o!="object")throw new l("pathObject","Object",o);const v=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return v?v===o.root?`${v}${t}`:`${v}${s}${t}`:t}e.win32={resolve(...s){let o="",v="",t=!1;for(let f=s.length-1;f>=-1;f--){let r;if(f>=0){if(r=s[f],p(r,"path"),r.length===0)continue}else o.length===0?r=g.cwd():(r=g.env[`=${o}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===k)&&(r=`${o}\\`));const n=r.length;let d=0,a="",c=!1;const m=r.charCodeAt(0);if(n===1)h(m)&&(d=1,c=!0);else if(h(m))if(c=!0,h(r.charCodeAt(1))){let u=2,E=u;for(;u<n&&!h(r.charCodeAt(u));)u++;if(u<n&&u!==E){const A=r.slice(E,u);for(E=u;u<n&&h(r.charCodeAt(u));)u++;if(u<n&&u!==E){for(E=u;u<n&&!h(r.charCodeAt(u));)u++;(u===n||u!==E)&&(a=`\\\\${A}\\${r.slice(E,u)}`,d=u)}}}else d=1;else S(m)&&r.charCodeAt(1)===i&&(a=r.slice(0,2),d=2,n>2&&h(r.charCodeAt(2))&&(c=!0,d=3));if(a.length>0)if(o.length>0){if(a.toLowerCase()!==o.toLowerCase())continue}else o=a;if(t){if(o.length>0)break}else if(v=`${r.slice(d)}\\${v}`,t=c,c&&o.length>0)break}return v=T(v,!t,"\\",h),t?`${o}\\${v}`:`${o}${v}`||"."},normalize(s){p(s,"path");const o=s.length;if(o===0)return".";let v=0,t,f=!1;const r=s.charCodeAt(0);if(o===1)return w(r)?"\\":s;if(h(r))if(f=!0,h(s.charCodeAt(1))){let d=2,a=d;for(;d<o&&!h(s.charCodeAt(d));)d++;if(d<o&&d!==a){const c=s.slice(a,d);for(a=d;d<o&&h(s.charCodeAt(d));)d++;if(d<o&&d!==a){for(a=d;d<o&&!h(s.charCodeAt(d));)d++;if(d===o)return`\\\\${c}\\${s.slice(a)}\\`;d!==a&&(t=`\\\\${c}\\${s.slice(a,d)}`,v=d)}}}else v=1;else S(r)&&s.charCodeAt(1)===i&&(t=s.slice(0,2),v=2,o>2&&h(s.charCodeAt(2))&&(f=!0,v=3));let n=v<o?T(s.slice(v),!f,"\\",h):"";return n.length===0&&!f&&(n="."),n.length>0&&h(s.charCodeAt(o-1))&&(n+="\\"),t===void 0?f?`\\${n}`:n:f?`${t}\\${n}`:`${t}${n}`},isAbsolute(s){p(s,"path");const o=s.length;if(o===0)return!1;const v=s.charCodeAt(0);return h(v)||o>2&&S(v)&&s.charCodeAt(1)===i&&h(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,v;for(let r=0;r<s.length;++r){const n=s[r];p(n,"path"),n.length>0&&(o===void 0?o=v=n:o+=`\\${n}`)}if(o===void 0)return".";let t=!0,f=0;if(typeof v=="string"&&h(v.charCodeAt(0))){++f;const r=v.length;r>1&&h(v.charCodeAt(1))&&(++f,r>2&&(h(v.charCodeAt(2))?++f:t=!1))}if(t){for(;f<o.length&&h(o.charCodeAt(f));)f++;f>=2&&(o=`\\${o.slice(f)}`)}return e.win32.normalize(o)},relative(s,o){if(p(s,"from"),p(o,"to"),s===o)return"";const v=e.win32.resolve(s),t=e.win32.resolve(o);if(v===t||(s=v.toLowerCase(),o=t.toLowerCase(),s===o))return"";let f=0;for(;f<s.length&&s.charCodeAt(f)===k;)f++;let r=s.length;for(;r-1>f&&s.charCodeAt(r-1)===k;)r--;const n=r-f;let d=0;for(;d<o.length&&o.charCodeAt(d)===k;)d++;let a=o.length;for(;a-1>d&&o.charCodeAt(a-1)===k;)a--;const c=a-d,m=n<c?n:c;let u=-1,E=0;for(;E<m;E++){const R=s.charCodeAt(f+E);if(R!==o.charCodeAt(d+E))break;R===k&&(u=E)}if(E!==m){if(u===-1)return t}else{if(c>m){if(o.charCodeAt(d+E)===k)return t.slice(d+E+1);if(E===2)return t.slice(d+E)}n>m&&(s.charCodeAt(f+E)===k?u=E:E===2&&(u=3)),u===-1&&(u=0)}let A="";for(E=f+u+1;E<=r;++E)(E===r||s.charCodeAt(E)===k)&&(A+=A.length===0?"..":"\\..");return d+=u,A.length>0?`${A}${t.slice(d,a)}`:(t.charCodeAt(d)===k&&++d,t.slice(d,a))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const o=e.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===k){if(o.charCodeAt(1)===k){const v=o.charCodeAt(2);if(v!==I&&v!==D)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(S(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===k)return`\\\\?\\${o}`;return s},dirname(s){p(s,"path");const o=s.length;if(o===0)return".";let v=-1,t=0;const f=s.charCodeAt(0);if(o===1)return h(f)?s:".";if(h(f)){if(v=t=1,h(s.charCodeAt(1))){let d=2,a=d;for(;d<o&&!h(s.charCodeAt(d));)d++;if(d<o&&d!==a){for(a=d;d<o&&h(s.charCodeAt(d));)d++;if(d<o&&d!==a){for(a=d;d<o&&!h(s.charCodeAt(d));)d++;if(d===o)return s;d!==a&&(v=t=d+1)}}}}else S(f)&&s.charCodeAt(1)===i&&(v=o>2&&h(s.charCodeAt(2))?3:2,t=v);let r=-1,n=!0;for(let d=o-1;d>=t;--d)if(h(s.charCodeAt(d))){if(!n){r=d;break}}else n=!1;if(r===-1){if(v===-1)return".";r=v}return s.slice(0,r)},basename(s,o){o!==void 0&&p(o,"ext"),p(s,"path");let v=0,t=-1,f=!0,r;if(s.length>=2&&S(s.charCodeAt(0))&&s.charCodeAt(1)===i&&(v=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let n=o.length-1,d=-1;for(r=s.length-1;r>=v;--r){const a=s.charCodeAt(r);if(h(a)){if(!f){v=r+1;break}}else d===-1&&(f=!1,d=r+1),n>=0&&(a===o.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=d))}return v===t?t=d:t===-1&&(t=s.length),s.slice(v,t)}for(r=s.length-1;r>=v;--r)if(h(s.charCodeAt(r))){if(!f){v=r+1;break}}else t===-1&&(f=!1,t=r+1);return t===-1?"":s.slice(v,t)},extname(s){p(s,"path");let o=0,v=-1,t=0,f=-1,r=!0,n=0;s.length>=2&&s.charCodeAt(1)===i&&S(s.charCodeAt(0))&&(o=t=2);for(let d=s.length-1;d>=o;--d){const a=s.charCodeAt(d);if(h(a)){if(!r){t=d+1;break}continue}f===-1&&(r=!1,f=d+1),a===D?v===-1?v=d:n!==1&&(n=1):v!==-1&&(n=-1)}return v===-1||f===-1||n===0||n===1&&v===f-1&&v===t+1?"":s.slice(v,f)},format:b.bind(null,"\\"),parse(s){p(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const v=s.length;let t=0,f=s.charCodeAt(0);if(v===1)return h(f)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(h(f)){if(t=1,h(s.charCodeAt(1))){let u=2,E=u;for(;u<v&&!h(s.charCodeAt(u));)u++;if(u<v&&u!==E){for(E=u;u<v&&h(s.charCodeAt(u));)u++;if(u<v&&u!==E){for(E=u;u<v&&!h(s.charCodeAt(u));)u++;u===v?t=u:u!==E&&(t=u+1)}}}}else if(S(f)&&s.charCodeAt(1)===i){if(v<=2)return o.root=o.dir=s,o;if(t=2,h(s.charCodeAt(2))){if(v===3)return o.root=o.dir=s,o;t=3}}t>0&&(o.root=s.slice(0,t));let r=-1,n=t,d=-1,a=!0,c=s.length-1,m=0;for(;c>=t;--c){if(f=s.charCodeAt(c),h(f)){if(!a){n=c+1;break}continue}d===-1&&(a=!1,d=c+1),f===D?r===-1?r=c:m!==1&&(m=1):r!==-1&&(m=-1)}return d!==-1&&(r===-1||m===0||m===1&&r===d-1&&r===n+1?o.base=o.name=s.slice(n,d):(o.name=s.slice(n,r),o.base=s.slice(n,d),o.ext=s.slice(r,d))),n>0&&n!==t?o.dir=s.slice(0,n-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let o="",v=!1;for(let t=s.length-1;t>=-1&&!v;t--){const f=t>=0?s[t]:g.cwd();p(f,"path"),f.length!==0&&(o=`${f}/${o}`,v=f.charCodeAt(0)===C)}return o=T(o,!v,"/",w),v?`/${o}`:o.length>0?o:"."},normalize(s){if(p(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===C,v=s.charCodeAt(s.length-1)===C;return s=T(s,!o,"/",w),s.length===0?o?"/":v?"./":".":(v&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return p(s,"path"),s.length>0&&s.charCodeAt(0)===C},join(...s){if(s.length===0)return".";let o;for(let v=0;v<s.length;++v){const t=s[v];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(s,o){if(p(s,"from"),p(o,"to"),s===o||(s=e.posix.resolve(s),o=e.posix.resolve(o),s===o))return"";const v=1,t=s.length,f=t-v,r=1,n=o.length-r,d=f<n?f:n;let a=-1,c=0;for(;c<d;c++){const u=s.charCodeAt(v+c);if(u!==o.charCodeAt(r+c))break;u===C&&(a=c)}if(c===d)if(n>d){if(o.charCodeAt(r+c)===C)return o.slice(r+c+1);if(c===0)return o.slice(r+c)}else f>d&&(s.charCodeAt(v+c)===C?a=c:c===0&&(a=0));let m="";for(c=v+a+1;c<=t;++c)(c===t||s.charCodeAt(c)===C)&&(m+=m.length===0?"..":"/..");return`${m}${o.slice(r+a)}`},toNamespacedPath(s){return s},dirname(s){if(p(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===C;let v=-1,t=!0;for(let f=s.length-1;f>=1;--f)if(s.charCodeAt(f)===C){if(!t){v=f;break}}else t=!1;return v===-1?o?"/":".":o&&v===1?"//":s.slice(0,v)},basename(s,o){o!==void 0&&p(o,"ext"),p(s,"path");let v=0,t=-1,f=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let n=o.length-1,d=-1;for(r=s.length-1;r>=0;--r){const a=s.charCodeAt(r);if(a===C){if(!f){v=r+1;break}}else d===-1&&(f=!1,d=r+1),n>=0&&(a===o.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=d))}return v===t?t=d:t===-1&&(t=s.length),s.slice(v,t)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===C){if(!f){v=r+1;break}}else t===-1&&(f=!1,t=r+1);return t===-1?"":s.slice(v,t)},extname(s){p(s,"path");let o=-1,v=0,t=-1,f=!0,r=0;for(let n=s.length-1;n>=0;--n){const d=s.charCodeAt(n);if(d===C){if(!f){v=n+1;break}continue}t===-1&&(f=!1,t=n+1),d===D?o===-1?o=n:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===v+1?"":s.slice(o,t)},format:b.bind(null,"/"),parse(s){p(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const v=s.charCodeAt(0)===C;let t;v?(o.root="/",t=1):t=0;let f=-1,r=0,n=-1,d=!0,a=s.length-1,c=0;for(;a>=t;--a){const m=s.charCodeAt(a);if(m===C){if(!d){r=a+1;break}continue}n===-1&&(d=!1,n=a+1),m===D?f===-1?f=a:c!==1&&(c=1):f!==-1&&(c=-1)}if(n!==-1){const m=r===0&&v?1:r;f===-1||c===0||c===1&&f===n-1&&f===r+1?o.base=o.name=s.slice(m,n):(o.name=s.slice(m,f),o.base=s.slice(m,n),o.ext=s.slice(f,n))}return r>0?o.dir=s.slice(0,r-1):v&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[96],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(_,...P){const D=P.reduce((i,I)=>(i[I]=!0,i),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(i=>!D[i]).forEach(i=>{for(let I=0;I<C.length;I++)if(i.search(C[I])!==-1){delete _[i];break}})}e.sanitizeProcessEnvironment=y}),define(fe[46],me([0,1,11]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class y{constructor(P){this._highResolution=L&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new y(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=y}),define(fe[3],me([0,1,17,76,6,95,46]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(o){o.None=()=>y.Disposable.None;function v(M){return(z,U=null,x)=>{let j=!1,O;return O=M(W=>{if(!j)return O?O.dispose():j=!0,z.call(U,W)},null,x),j&&O.dispose(),O}}o.once=v;function t(M,z){return c((U,x=null,j)=>M(O=>U.call(x,z(O)),null,j))}o.map=t;function f(M,z){return c((U,x=null,j)=>M(O=>{z(O),U.call(x,O)},null,j))}o.forEach=f;function r(M,z){return c((U,x=null,j)=>M(O=>z(O)&&U.call(x,O),null,j))}o.filter=r;function n(M){return M}o.signal=n;function d(...M){return(z,U=null,x)=>(0,y.combinedDisposable)(...M.map(j=>j(O=>z.call(U,O),null,x)))}o.any=d;function a(M,z,U){let x=U;return t(M,j=>(x=z(x,j),x))}o.reduce=a;function c(M){let z;const U=new l({onFirstListenerAdd(){z=M(U.fire,U)},onLastListenerRemove(){z.dispose()}});return U.event}function m(M,z,U=100,x=!1,j){let O,W,H,X=0;const K=new l({leakWarningThreshold:j,onFirstListenerAdd(){O=M(de=>{X++,W=z(W,de),x&&!H&&(K.fire(W),W=void 0),clearTimeout(H),H=setTimeout(()=>{const _e=W;W=void 0,H=void 0,(!x||X>1)&&K.fire(_e),X=0},U)})},onLastListenerRemove(){O.dispose()}});return K.event}o.debounce=m;function u(M,z=(U,x)=>U===x){let U=!0,x;return r(M,j=>{const O=U||!z(j,x);return U=!1,x=j,O})}o.latch=u;function E(M,z){return[o.filter(M,z),o.filter(M,U=>!z(U))]}o.split=E;function A(M,z=!1,U=[]){let x=U.slice(),j=M(H=>{x?x.push(H):W.fire(H)});const O=()=>{x&&x.forEach(H=>W.fire(H)),x=null},W=new l({onFirstListenerAdd(){j||(j=M(H=>W.fire(H)))},onFirstListenerDidAdd(){x&&(z?setTimeout(O):O())},onLastListenerRemove(){j&&j.dispose(),j=null}});return W.event}o.buffer=A;class R{constructor(z){this.event=z}map(z){return new R(t(this.event,z))}forEach(z){return new R(f(this.event,z))}filter(z){return new R(r(this.event,z))}reduce(z,U){return new R(a(this.event,z,U))}latch(){return new R(u(this.event))}debounce(z,U=100,x=!1,j){return new R(m(this.event,z,U,x,j))}on(z,U,x){return this.event(z,U,x)}once(z,U,x){return v(this.event)(z,U,x)}}function B(M){return new R(M)}o.chain=B;function N(M,z,U=x=>x){const x=(...H)=>W.fire(U(...H)),j=()=>M.on(z,x),O=()=>M.removeListener(z,x),W=new l({onFirstListenerAdd:j,onLastListenerRemove:O});return W.event}o.fromNodeEventEmitter=N;function F(M,z,U=x=>x){const x=(...H)=>W.fire(U(...H)),j=()=>M.addEventListener(z,x),O=()=>M.removeEventListener(z,x),W=new l({onFirstListenerAdd:j,onLastListenerRemove:O});return W.event}o.fromDOMEventEmitter=F;function $(M){return new Promise(z=>v(M)(z))}o.toPromise=$})(D=e.Event||(e.Event={}));class C{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${C._idPool++}`}start(v){this._stopWatch=new P.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let k=-1;function i(o){const v=k;return k=o,{dispose(){k=v}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(v,t=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let t=k;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||v<t)return;this._stacks||(this._stacks=new Map);const f=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(f)||0;if(this._stacks.set(f,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let n,d=0;for(const[a,c]of this._stacks)(!n||d<c)&&(n=a,d=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${d}):`),console.warn(n)}return()=>{const n=this._stacks.get(f)||0;this._stacks.set(f,n-1)}}}class l{constructor(v){this._disposed=!1,this._options=v,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(v,t,f)=>{this._listeners||(this._listeners=new _.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(t?[v,t]:v);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,t);const d=this._leakageMon?.check(this._listeners.size),a=(0,y.toDisposable)(()=>{d&&d(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof y.DisposableStore?f.add(a):Array.isArray(f)&&f.push(a),a}),this._event}fire(v){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,v]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,f]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,f):t[0].call(t[1],f)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class p extends l{async fireAsync(v,t,f){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,v]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,n]=this._asyncDeliveryQueue.shift(),d=[],a={...n,waitUntil:c=>{if(Object.isFrozen(d))throw new Error("waitUntil can NOT be called asynchronous");f&&(c=f(c,typeof r=="function"?r:r[0])),d.push(c)}};try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(c){(0,g.onUnexpectedError)(c);continue}Object.freeze(d),await Promise.allSettled(d).then(c=>{for(const m of c)m.status==="rejected"&&(0,g.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=p;class h extends l{constructor(v){super(v);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=v?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=h;class w extends h{constructor(v){super(v);this._delay=v.delay??100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}e.DebounceEmitter=w;class S extends l{constructor(v){super(v);this._queuedEvents=[],this._mergeFn=v?.merge}fire(v){this._queuedEvents.push(v),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=S;class T{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const t={event:v,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const f=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,y.toDisposable)((0,L.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(t=>this.emitter.fire(t))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=T;class b{constructor(){this.buffers=[]}wrapEvent(v){return(t,f,r)=>v(n=>{const d=this.buffers[this.buffers.length-1];d?d.push(()=>t.call(f,n)):t.call(f,n)},void 0,r)}bufferEvents(v){const t=[];this.buffers.push(t);const f=v();return this.buffers.pop(),t.forEach(r=>r()),f}}e.EventBufferer=b;class s{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=y.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(fe[21],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(D,C){const k=setTimeout(D.bind(C),0);return{dispose(){clearTimeout(k)}}});var y;(function(D){function C(k){return k===D.None||k===D.Cancelled||k instanceof _?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}D.isCancellationToken=C,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(y=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=y.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=P}),define(fe[47],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const y=new L;e.iconRegistry=y;function _(i,I){return new D(i,I)}e.registerCodicon=_;function P(i){return i?i.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=P;class D{constructor(I,l,p){this.id=I,this.definition=l,this.description=p,y.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function C(i,I){const l=["codicon","codicon-"+i];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=C;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function l(w){if(w instanceof D)return["codicon","codicon-"+w.id];const S=I.exec(w.id);if(!S)return l(D.error);let[,T,b]=S;const s=["codicon","codicon-"+T];return b&&s.push("codicon-modifier-"+b.substr(1)),s}i.asClassNameArray=l;function p(w){return l(w).join(" ")}i.asClassName=p;function h(w){return"."+l(w).join(".")}i.asCSSSelector=h})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"})}(D=e.Codicon||(e.Codicon={}))}),define(fe[97],me([0,1,17,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(s){const o=s;return o?[o.on,o.pause,o.resume,o.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=y;function _(s){const o=s;return o?y(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=_;function P(s,o){return new D(s,o)}e.newWriteableStream=P;class D{constructor(o,v){this.reducer=o,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(v=>v(o))}emitError(o){this.listeners.error.length===0?(0,g.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(v=>v(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,v){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(o,v){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const f=t.indexOf(v);f>=0&&t.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(s,o){const v=[];let t;for(;(t=s.read())!==null;)v.push(t);return o(v)}e.consumeReadable=C;function k(s,o,v){const t=[];let f;for(;(f=s.read())!==null&&t.length<v;)t.push(f);return f===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof f!="undefined"){const r=f;return f=void 0,r}return s.read()}}}e.peekReadable=k;function i(s,o){return new Promise((v,t)=>{const f=[];I(s,{onData:r=>{o&&f.push(r)},onError:r=>{o?t(r):v(void 0)},onEnd:()=>{v(o?o(f):void 0)}})})}e.consumeStream=i;function I(s,o){s.on("error",v=>o.onError(v)),s.on("end",()=>o.onEnd()),s.on("data",v=>o.onData(v))}e.listenStream=I;function l(s,o){return new Promise((v,t)=>{const f=new L.DisposableStore,r=[],n=c=>{if(r.push(c),r.length>o)return f.dispose(),s.pause(),v({stream:s,buffer:r,ended:!1})},d=c=>t(c),a=()=>v({stream:s,buffer:r,ended:!0});f.add((0,L.toDisposable)(()=>s.removeListener("error",d))),s.on("error",d),f.add((0,L.toDisposable)(()=>s.removeListener("end",a))),s.on("end",a),f.add((0,L.toDisposable)(()=>s.removeListener("data",n))),s.on("data",n)})}e.peekStream=l;function p(s,o){const v=P(o);return v.end(s),v}e.toStream=p;function h(){const s=P(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=h;function w(s){let o=!1;return{read:()=>o?null:(o=!0,s)}}e.toReadable=w;function S(s,o,v){const t=P(v);return I(s,{onData:f=>t.write(o.data(f)),onError:f=>t.error(o.error?o.error(f):f),onEnd:()=>t.end()}),t}e.transform=S;function T(s,o,v){let t=!1;return{read:()=>{const f=o.read();return t?f:(t=!0,f!==null?v([s,f]):s)}}}e.prefixedReadable=T;function b(s,o,v){let t=!1;const f=P(v);return I(o,{onData:r=>t?f.write(r):(t=!0,f.write(v([s,r]))),onError:r=>f.error(r),onEnd:()=>{t||(t=!0,f.write(s)),f.end()}}),f}e.prefixedStream=b}),define(fe[22],me([0,1,97]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let y,_;class P{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return L?new P(Buffer.allocUnsafe(n)):new P(new Uint8Array(n))}static wrap(n){return L&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new P(n)}static fromString(n,d){return!(d?.dontUseNodeBuffer||!1)&&L?new P(Buffer.from(n)):(y||(y=new TextEncoder),new P(y.encode(n)))}static concat(n,d){if(typeof d=="undefined"){d=0;for(let m=0,u=n.length;m<u;m++)d+=n[m].byteLength}const a=P.alloc(d);let c=0;for(let m=0,u=n.length;m<u;m++){const E=n[m];a.set(E,c),c+=E.byteLength}return a}toString(){return L?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(n,d){return new P(this.buffer.subarray(n,d))}set(n,d){n instanceof P?this.buffer.set(n.buffer,d):this.buffer.set(n,d)}readUInt32BE(n){return k(this.buffer,n)}writeUInt32BE(n,d){i(this.buffer,n,d)}readUInt32LE(n){return I(this.buffer,n)}writeUInt32LE(n,d){l(this.buffer,n,d)}readUInt8(n){return p(this.buffer,n)}writeUInt8(n,d){h(this.buffer,n,d)}}e.VSBuffer=P;function D(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0}e.readUInt16LE=D;function C(r,n,d){r[d+0]=n&255,n=n>>>8,r[d+1]=n&255}e.writeUInt16LE=C;function k(r,n){return r[n]*2**24+r[n+1]*2**16+r[n+2]*2**8+r[n+3]}e.readUInt32BE=k;function i(r,n,d){r[d+3]=n,n=n>>>8,r[d+2]=n,n=n>>>8,r[d+1]=n,n=n>>>8,r[d]=n}e.writeUInt32BE=i;function I(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0|r[n+2]<<16>>>0|r[n+3]<<24>>>0}e.readUInt32LE=I;function l(r,n,d){r[d+0]=n&255,n=n>>>8,r[d+1]=n&255,n=n>>>8,r[d+2]=n&255,n=n>>>8,r[d+3]=n&255}e.writeUInt32LE=l;function p(r,n){return r[n]}e.readUInt8=p;function h(r,n,d){r[d]=n}e.writeUInt8=h;function w(r){return g.consumeReadable(r,n=>P.concat(n))}e.readableToBuffer=w;function S(r){return g.toReadable(r)}e.bufferToReadable=S;function T(r){return g.consumeStream(r,n=>P.concat(n))}e.streamToBuffer=T;async function b(r){return r.ended?P.concat(r.buffer):P.concat([...r.buffer,await T(r.stream)])}e.bufferedStreamToBuffer=b;function s(r){return g.toStream(r,n=>P.concat(n))}e.bufferToStream=s;function o(r){return g.transform(r,{data:n=>typeof n=="string"?P.fromString(n):P.wrap(n)},n=>P.concat(n))}e.streamToBufferReadableStream=o;function v(r){return g.newWriteableStream(n=>P.concat(n),r)}e.newWriteableBufferStream=v;function t(r,n){return g.prefixedReadable(r,n,d=>P.concat(d))}e.prefixedBufferReadable=t;function f(r,n){return g.prefixedStream(r,n,d=>P.concat(d))}e.prefixedBufferStream=f}),define(fe[9],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function y(le,...Ie){return Ie.length===0?le:le.replace(L,function(Ue,Xe){const it=parseInt(Xe,10);return isNaN(it)||it<0||it>=Ie.length?Ue:Ie[it]})}e.format=y;const _=/{([^}]+)}/g;function P(le,Ie){return le.replace(_,(Ue,Xe)=>Ie[Xe]??Ue)}e.format2=P;function D(le){return le.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=D;function C(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function k(le,Ie){let Ue=0;const Xe=Ie.charCodeAt(0);for(let it=le.length-1;it>=0;it--)le.charCodeAt(it)===Xe&&Ue++;return Ue}e.count=k;function i(le,Ie,Ue="\u2026"){return le.length<=Ie?le:`${le.substr(0,Ie)}${Ue}`}e.truncate=i;function I(le,Ie=" "){const Ue=l(le,Ie);return p(Ue,Ie)}e.trim=I;function l(le,Ie){if(!le||!Ie)return le;const Ue=Ie.length;if(Ue===0||le.length===0)return le;let Xe=0;for(;le.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ue;return le.substring(Xe)}e.ltrim=l;function p(le,Ie){if(!le||!Ie)return le;const Ue=Ie.length,Xe=le.length;if(Ue===0||Xe===0)return le;let it=Xe,ft=-1;for(;ft=le.lastIndexOf(Ie,it-1),!(ft===-1||ft+Ue!==it);){if(ft===0)return"";it=ft}return le.substring(0,it)}e.rtrim=p;function h(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(le){return le.replace(/\*/g,"")}e.stripWildcards=w;function S(le,Ie,Ue={}){if(!le)throw new Error("Cannot create regex from empty string");Ie||(le=C(le)),Ue.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Xe="";return Ue.global&&(Xe+="g"),Ue.matchCase||(Xe+="i"),Ue.multiline&&(Xe+="m"),Ue.unicode&&(Xe+="u"),new RegExp(le,Xe)}e.createRegExp=S;function T(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=T;function b(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function s(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=s;function o(le){return le.split(/\r\n|\r|\n/)}e.splitLines=o;function v(le){for(let Ie=0,Ue=le.length;Ie<Ue;Ie++){const Xe=le.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=v;function t(le,Ie=0,Ue=le.length){for(let Xe=Ie;Xe<Ue;Xe++){const it=le.charCodeAt(Xe);if(it!==32&&it!==9)return le.substring(Ie,Xe)}return le.substring(Ie,Ue)}e.getLeadingWhitespace=t;function f(le,Ie=le.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Xe=le.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=f;function r(le,Ie){return le<Ie?-1:le>Ie?1:0}e.compare=r;function n(le,Ie,Ue=0,Xe=le.length,it=0,ft=Ie.length){for(;Ue<Xe&&it<ft;Ue++,it++){let Re=le.charCodeAt(Ue),De=Ie.charCodeAt(it);if(Re<De)return-1;if(Re>De)return 1}const tt=Xe-Ue,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstring=n;function d(le,Ie){return a(le,Ie,0,le.length,0,Ie.length)}e.compareIgnoreCase=d;function a(le,Ie,Ue=0,Xe=le.length,it=0,ft=Ie.length){for(;Ue<Xe&&it<ft;Ue++,it++){let Re=le.charCodeAt(Ue),De=Ie.charCodeAt(it);if(Re===De)continue;if(Re>=128||De>=128)return n(le.toLowerCase(),Ie.toLowerCase(),Ue,Xe,it,ft);c(Re)&&(Re-=32),c(De)&&(De-=32);const Te=Re-De;if(Te!==0)return Te}const tt=Xe-Ue,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstringIgnoreCase=a;function c(le){return le>=97&&le<=122}e.isLowerAsciiLetter=c;function m(le){return le>=65&&le<=90}e.isUpperAsciiLetter=m;function u(le,Ie){return le.length===Ie.length&&a(le,Ie)===0}e.equalsIgnoreCase=u;function E(le,Ie){const Ue=Ie.length;return Ie.length>le.length?!1:a(le,Ie,0,Ue)===0}e.startsWithIgnoreCase=E;function A(le,Ie){let Ue,Xe=Math.min(le.length,Ie.length);for(Ue=0;Ue<Xe;Ue++)if(le.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Xe}e.commonPrefixLength=A;function R(le,Ie){let Ue,Xe=Math.min(le.length,Ie.length);const it=le.length-1,ft=Ie.length-1;for(Ue=0;Ue<Xe;Ue++)if(le.charCodeAt(it-Ue)!==Ie.charCodeAt(ft-Ue))return Ue;return Xe}e.commonSuffixLength=R;function B(le){return 55296<=le&&le<=56319}e.isHighSurrogate=B;function N(le){return 56320<=le&&le<=57343}e.isLowSurrogate=N;function F(le,Ie){return(le-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=F;function $(le,Ie,Ue){const Xe=le.charCodeAt(Ue);if(B(Xe)&&Ue+1<Ie){const it=le.charCodeAt(Ue+1);if(N(it))return F(Xe,it)}return Xe}e.getNextCodePoint=$;function M(le,Ie){const Ue=le.charCodeAt(Ie-1);if(N(Ue)&&Ie>1){const Xe=le.charCodeAt(Ie-2);if(B(Xe))return F(Xe,Ue)}return Ue}function z(le,Ie){const Ue=ye.getInstance(),Xe=Ie,it=le.length,ft=$(le,it,Ie);Ie+=ft>=65536?2:1;let tt=Ue.getGraphemeBreakType(ft);for(;Ie<it;){const ut=$(le,it,Ie),Re=Ue.getGraphemeBreakType(ut);if(rt(tt,Re))break;Ie+=ut>=65536?2:1,tt=Re}return Ie-Xe}e.nextCharLength=z;function U(le,Ie){const Ue=ye.getInstance(),Xe=Ie,it=M(le,Ie);Ie-=it>=65536?2:1;let ft=Ue.getGraphemeBreakType(it);for(;Ie>0;){const tt=M(le,Ie),ut=Ue.getGraphemeBreakType(tt);if(rt(ut,ft))break;Ie-=tt>=65536?2:1,ft=ut}return Xe-Ie}e.prevCharLength=U;function x(le,Ie){const Ue=ye.getInstance(),Xe=le.length,it=Ie,ft=$(le,Xe,Ie),tt=Ue.getGraphemeBreakType(ft);Ie+=ft>=65536?2:1;let ut=tt;for(;Ie<Xe;){const De=$(le,Xe,Ie),Te=Ue.getGraphemeBreakType(De);if(rt(ut,Te))break;Ie+=De>=65536?2:1,ut=Te}const Re=Ie;for(Ie=it,ut=tt;Ie>0;){const De=M(le,Ie),Te=Ue.getGraphemeBreakType(De);if(rt(Te,ut))break;Ie-=De>=65536?2:1,ut=Te}return[Ie,Re]}function j(le,Ie){return Ie>0&&N(le.charCodeAt(Ie))?x(le,Ie-1):x(le,Ie)}e.getCharContainingOffset=j;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(le){return O.test(le)}e.containsRTL=W;const H=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(le){return H.test(le)}e.containsEmoji=X;const K=/^[\t\n\r\x20-\x7E]*$/;function de(le){return K.test(le)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=_e;function Ce(le){for(let Ie=0,Ue=le.length;Ie<Ue;Ie++)if(Pe(le.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=Ce;function Pe(le){return le=+le,le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Pe;function Be(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129003||le>=129280&&le<=129535||le>=129648&&le<=129750}e.isEmojiImprecise=Be;function $e(le,Ie){if(le.length<Ie)return le;const Ue=/\b/g;let Xe=0;for(;Ue.test(le)&&!(le.length-Ue.lastIndex<Ie);)Xe=Ue.lastIndex,Ue.lastIndex+=1;return le.substring(Xe).replace(/^\s/,"")}e.lcut=$e;const He=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function te(le){return le&&(le=le.replace(He,""),le=le.replace(G,""),le=le.replace(ee,"")),le}e.removeAnsiEscapeCodes=te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function Z(le){return ce(le)?le.substr(1):le}e.stripUTF8BOM=Z;function se(le,Ie){if(!le||!Ie||le.length<Ie.length)return!1;const Ue=Ie.length,Xe=le.toLowerCase();let it=0,ft=-1;for(;it<Ue;){const tt=Xe.indexOf(Ie[it],ft+1);if(tt<0)return!1;ft=tt,it++}return!0}e.fuzzyContains=se;function pe(le,Ie=!1){return le?(Ie&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=pe;function Me(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=Me;function je(le,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=le.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?le:(le[Ue-1]==="\r"&&Ue--,le.substr(0,Ue))}e.getNLines=je;function Ke(le){const Ie=90-65+1;return le=le%(2*Ie),le<Ie?String.fromCharCode(97+le):String.fromCharCode(65+le-Ie)}e.singleLetterHash=Ke;function Ze(le){return ye.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=Ze;function rt(le,Ie){return le===0?Ie!==5&&Ie!==7:le===2&&Ie===3?!1:le===4||le===2||le===3||Ie===4||Ie===2||Ie===3?!0:!(le===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(le===11||le===9)&&(Ie===9||Ie===10)||(le===12||le===10)&&Ie===10||Ie===5||Ie===13||Ie===7||le===1||le===13&&Ie===14||le===6&&Ie===6)}e.breakBetweenGraphemeBreakType=rt;var ct;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(ct=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=at()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Xe=Ue.length/3;let it=1;for(;it<=Xe;)if(Ie<Ue[3*it])it=2*it;else if(Ie>Ue[3*it+1])it=2*it+1;else return Ue[3*it+2];return 0}}ye._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function J(le,Ie){if(le===0)return 0;const Ue=ie(le,Ie);if(Ue!==void 0)return Ue;const Xe=M(Ie,le);return le-=Ee(Xe),le}e.getLeftDeleteOffset=J;function ie(le,Ie){let Ue=M(Ie,le);for(le-=Ee(Ue);Qe(Ue)||Ue===65039||Ue===8419;){if(le===0)return;Ue=M(Ie,le),le-=Ee(Ue)}if(!!Be(Ue)){if(le>=0){const Xe=M(Ie,le);Xe===8205&&(le-=Ee(Xe))}return le}}function Ee(le){return le>=65536?2:1}function Qe(le){return 127995<=le&&le<=127999}var et;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(fe[48],me([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(T){return y(T,0)}e.hash=L;function y(T,b){switch(typeof T){case"object":return T===null?_(349,b):Array.isArray(T)?C(T,b):k(T,b);case"string":return D(T,b);case"boolean":return P(T,b);case"number":return _(T,b);case"undefined":return _(937,b);default:return _(617,b)}}e.doHash=y;function _(T,b){return(b<<5)-b+T|0}e.numberHash=_;function P(T,b){return _(T?433:863,b)}function D(T,b){b=_(149417,b);for(let s=0,o=T.length;s<o;s++)b=_(T.charCodeAt(s),b);return b}e.stringHash=D;function C(T,b){return b=_(104579,b),T.reduce((s,o)=>y(o,s),b)}function k(T,b){return b=_(181387,b),Object.keys(T).sort().reduce((s,o)=>(s=D(o,s),y(T[o],s)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=y(b,this._value),this._value}}e.Hasher=i;var I;(function(T){T[T.BLOCK_SIZE=64]="BLOCK_SIZE",T[T.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(T,b,s=32){const o=s-b,v=~((1<<o)-1);return(T<<b|(v&T)>>>o)>>>0}function p(T,b=0,s=T.byteLength,o=0){for(let v=0;v<s;v++)T[b+v]=o}function h(T,b,s="0"){for(;T.length<b;)T=s+T;return T}function w(T,b=32){return T instanceof ArrayBuffer?Array.from(new Uint8Array(T)).map(s=>s.toString(16).padStart(2,"0")).join(""):h((T>>>0).toString(16),b/4)}e.toHexString=w;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const s=b.length;if(s===0)return;const o=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,f,r;for(t!==0?(f=t,r=-1,t=0):(f=b.charCodeAt(0),r=0);;){let n=f;if(g.isHighSurrogate(f))if(r+1<s){const d=b.charCodeAt(r+1);g.isLowSurrogate(d)?(r++,n=g.computeCodePoint(f,d)):n=65533}else{t=f;break}else g.isLowSurrogate(f)&&(n=65533);if(v=this._push(o,v,n),r++,r<s)f=b.charCodeAt(r);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(b,s,o){return o<128?b[s++]=o:o<2048?(b[s++]=192|(o&1984)>>>6,b[s++]=128|(o&63)>>>0):o<65536?(b[s++]=224|(o&61440)>>>12,b[s++]=128|(o&4032)>>>6,b[s++]=128|(o&63)>>>0):(b[s++]=240|(o&1835008)>>>18,b[s++]=128|(o&258048)>>>12,b[s++]=128|(o&4032)>>>6,b[s++]=128|(o&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=S._bigBlock32,s=this._buffDV;for(let c=0;c<64;c+=4)b.setUint32(c,s.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)b.setUint32(c,l(b.getUint32(c-12,!1)^b.getUint32(c-32,!1)^b.getUint32(c-56,!1)^b.getUint32(c-64,!1),1),!1);let o=this._h0,v=this._h1,t=this._h2,f=this._h3,r=this._h4,n,d,a;for(let c=0;c<80;c++)c<20?(n=v&t|~v&f,d=1518500249):c<40?(n=v^t^f,d=1859775393):c<60?(n=v&t|v&f|t&f,d=2400959708):(n=v^t^f,d=3395469782),a=l(o,5)+n+r+d+b.getUint32(c*4,!1)&4294967295,r=f,f=t,t=l(v,30),v=o,o=a;this._h0=this._h0+o&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[24],me([0,1,18,9]),function(Y,e,g,L){"use strict";var y,_,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(r,n,d){let a=r.get(n);return a===void 0&&(a=d,r.set(n,a)),a}e.getOrSet=D;function C(r){const n=[];return r.forEach((d,a)=>{n.push(`${a} => ${d}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=C;function k(r){const n=[];return r.forEach(d=>{n.push(d)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const d=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return d-a}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(n=!0,d=!0){this._splitOnBackslash=n,this._caseSensitive=d}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const d=this._value.charCodeAt(this._to);if(d===47||this._splitOnBackslash&&d===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,L.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,L.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(S||(S={}));class T{constructor(n){this._iter=n}static forUris(n=()=>!1){return new T(new h(n))}static forPaths(){return new T(new l)}static forStrings(){return new T(new i)}static forConfigKeys(){return new T(new I)}clear(){this._root=void 0}fill(n,d){if(d){const a=d.slice(0);(0,g.shuffle)(a);for(let c of a)this.set(c,n)}else{const a=n.slice(0);(0,g.shuffle)(a);for(let c of a)this.set(c[0],c[1])}}set(n,d){const a=this._iter.reset(n);let c;this._root||(this._root=new w,this._root.segment=a.value());const m=[];for(c=this._root;;){const E=a.cmp(c.segment);if(E>0)c.left||(c.left=new w,c.left.segment=a.value()),m.push([-1,c]),c=c.left;else if(E<0)c.right||(c.right=new w,c.right.segment=a.value()),m.push([1,c]),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new w,c.mid.segment=a.value()),m.push([0,c]),c=c.mid;else break}const u=c.value;c.value=d,c.key=n;for(let E=m.length-1;E>=0;E--){const A=m[E][1];A.updateHeight();const R=A.balanceFactor();if(R<-1||R>1){const B=m[E][0],N=m[E+1][0];if(B===1&&N===1)m[E][1]=A.rotateLeft();else if(B===-1&&N===-1)m[E][1]=A.rotateRight();else if(B===1&&N===-1)A.right=m[E+1][1]=m[E+1][1].rotateRight(),m[E][1]=A.rotateLeft();else if(B===-1&&N===1)A.left=m[E+1][1]=m[E+1][1].rotateLeft(),m[E][1]=A.rotateRight();else throw new Error;if(E>0)switch(m[E-1][0]){case-1:m[E-1][1].left=m[E][1];break;case 1:m[E-1][1].right=m[E][1];break;case 0:m[E-1][1].mid=m[E][1];break}else this._root=m[0][1]}}return u}get(n){return this._getNode(n)?.value}_getNode(n){const d=this._iter.reset(n);let a=this._root;for(;a;){const c=d.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(d.hasNext())d.next(),a=a.mid;else break}return a}has(n){const d=this._getNode(n);return!(d?.value===void 0&&d?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,d){const a=this._iter.reset(n),c=[];let m=this._root;for(;m;){const u=a.cmp(m.segment);if(u>0)c.push([-1,m]),m=m.left;else if(u<0)c.push([1,m]),m=m.right;else if(a.hasNext())a.next(),c.push([0,m]),m=m.mid;else break}if(!!m){if(d?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const u=this._min(m.right),{key:E,value:A,segment:R}=u;this._delete(u.key,!1),m.key=E,m.value=A,m.segment=R}else{const u=m.left??m.right;if(c.length>0){const[E,A]=c[c.length-1];switch(E){case-1:A.left=u;break;case 0:A.mid=u;break;case 1:A.right=u;break}}else this._root=u}for(let u=c.length-1;u>=0;u--){const E=c[u][1];E.updateHeight();const A=E.balanceFactor();if(A>1?(E.right.balanceFactor()>=0||(E.right=c[u+1][1]=c[u+1][1].rotateRight()),c[u][1]=E.rotateLeft()):A<-1&&(E.left.balanceFactor()<=0||(E.left=c[u+1][1]=c[u+1][1].rotateLeft()),c[u][1]=E.rotateRight()),u>0)switch(c[u-1][0]){case-1:c[u-1][1].left=c[u][1];break;case 1:c[u-1][1].right=c[u][1];break;case 0:c[u-1][1].mid=c[u][1];break}else this._root=c[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const d=this._iter.reset(n);let a=this._root,c;for(;a;){const m=d.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(d.hasNext())d.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(n){const d=this._iter.reset(n);let a=this._root;for(;a;){const c=d.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(d.hasNext())d.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[d,a]of this)n(a,d)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=d=>{if(!d)return!0;const a=d.balanceFactor();return a<-1||a>1?!1:n(d.left)&&n(d.right)};return n(this._root)}}e.TernarySearchTree=T;class b{constructor(n,d){this.uri=n,this.value=d}}class s{constructor(n,d){this[y]="ResourceMap",n instanceof s?(this.map=new Map(n.map),this.toKey=d??s.defaultToKey):(this.map=new Map,this.toKey=n??s.defaultToKey)}set(n,d){return this.map.set(this.toKey(n),new b(n,d)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,d){typeof d!="undefined"&&(n=n.bind(d));for(let[a,c]of this.map)n(c.value,c.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=s,s.defaultToKey=r=>r.toString();var o;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class v{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,d=0){const a=this._map.get(n);if(!!a)return d!==0&&this.touch(a,d),a.value}set(n,d,a=0){let c=this._map.get(n);if(c)c.value=d,a!==0&&this.touch(c,a);else{switch(c={key:n,value:d,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const d=this._map.get(n);if(!!d)return this._map.delete(n),this.removeItem(d),this._size--,d.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,d){const a=this._state;let c=this._head;for(;c;){if(d?n.bind(d)(c.value,c.key,this):n(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,d=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:a.key,done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return c}values(){const n=this,d=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:a.value,done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return c}entries(){const n=this,d=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==d)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:[a.key,a.value],done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return c}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let d=this._head,a=this.size;for(;d&&a>n;)this._map.delete(d.key),d=d.next,a--;this._head=d,this._size=a,d&&(d.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const d=n.next,a=n.previous;if(!d||!a)throw new Error("Invalid list");d.previous=a,a.next=d}n.next=void 0,n.previous=void 0,this._state++}touch(n,d){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(n===this._head)return;const a=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(d===2){if(n===this._tail)return;const a=n.next,c=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((d,a)=>{n.push([a,d])}),n}fromJSON(n){this.clear();for(const[d,a]of n)this.set(d,a)}}e.LinkedMap=v;class t extends v{constructor(n,d=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,d),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,d=2){return super.get(n,d)}peek(n){return super.get(n,0)}set(n,d){return super.set(n,d,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class f{constructor(n){P.set(this,void 0),st(this,P,n,"f")}get size(){return Ne(this,P,"f").size}forEach(n,d){Ne(this,P,"f").forEach(n,d)}get(n){return Ne(this,P,"f").get(n)}has(n){return Ne(this,P,"f").has(n)}entries(){return Ne(this,P,"f").entries()}keys(){return Ne(this,P,"f").keys()}values(){return Ne(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ne(this,P,"f").entries()}}e.ReadonlyMapView=f}),define(fe[98],me([0,1,24,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Z){return function(se,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](se,pe);if(Ke)return Ke}return null}}e.or=y,e.matchesStrictPrefix=_.bind(void 0,!1),e.matchesPrefix=_.bind(void 0,!0);function _(Z,se,pe){if(!pe||pe.length<se.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(pe,se):Me=pe.indexOf(se)===0,Me?se.length>0?[{start:0,end:se.length}]:[]:null}function P(Z,se){const pe=se.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=P;function D(Z,se){return C(Z.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=D;function C(Z,se,pe,Me){if(pe===Z.length)return[];if(Me===se.length)return null;if(Z[pe]===se[Me]){let je=null;return(je=C(Z,se,pe+1,Me+1))?T({start:Me,end:Me+1},je):null}return C(Z,se,pe,Me+1)}function k(Z){return 97<=Z&&Z<=122}function i(Z){return 65<=Z&&Z<=90}e.isUpper=i;function I(Z){return 48<=Z&&Z<=57}function l(Z){return Z===32||Z===9||Z===10||Z===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>p.add(Z.charCodeAt(0)));function h(Z){return l(Z)||p.has(Z)}function w(Z,se){return Z===se||h(Z)&&h(se)}function S(Z){return k(Z)||i(Z)||I(Z)}function T(Z,se){return se.length===0?se=[Z]:Z.end===se[0].start?se[0].start=Z.start:se.unshift(Z),se}function b(Z,se){for(let pe=se;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(i(Me)||I(Me)||pe>0&&!S(Z.charCodeAt(pe-1)))return pe}return Z.length}function s(Z,se,pe,Me){if(pe===Z.length)return[];if(Me===se.length)return null;if(Z[pe]!==se[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=s(Z,se,pe+1,Me+1);!je&&(Ke=b(se,Ke))<se.length;)je=s(Z,se,pe+1,Ke),Ke++;return je===null?null:T({start:Me,end:Me+1},je)}}function o(Z){let se=0,pe=0,Me=0,je=0,Ke=0;for(let at=0;at<Z.length;at++)Ke=Z.charCodeAt(at),i(Ke)&&se++,k(Ke)&&pe++,S(Ke)&&Me++,I(Ke)&&je++;const Ze=se/Z.length,rt=pe/Z.length,ct=Me/Z.length,ye=je/Z.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ct,numericPercent:ye}}function v(Z){const{upperPercent:se,lowerPercent:pe}=Z;return pe===0&&se>.6}function t(Z){const{upperPercent:se,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&se<.8&&Me>.6&&je<.2}function f(Z){let se=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),i(Me)&&se++,k(Me)&&pe++,l(Me)&&je++;return(se===0||pe===0)&&je===0?Z.length<=30:se<=5}function r(Z,se){if(!se||(se=se.trim(),se.length===0)||!f(Z)||se.length>60)return null;const pe=o(se);if(!t(pe)){if(!v(pe))return null;se=se.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<se.length&&(Me=s(Z,se,0,je))===null;)je=b(se,je+1);return Me}e.matchesCamelCase=r;function n(Z,se,pe=!1){if(!se||se.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),se=se.toLowerCase();je<se.length&&(Me=d(Z,se,0,je,pe))===null;)je=a(se,je+1);return Me}e.matchesWords=n;function d(Z,se,pe,Me,je){if(pe===Z.length)return[];if(Me===se.length)return null;if(w(Z.charCodeAt(pe),se.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=d(Z,se,pe+1,Me+1,je),!je)for(;!Ke&&(Ze=a(se,Ze))<se.length;)Ke=d(Z,se,pe+1,Ze,je),Ze++;return Ke===null?null:T({start:Me,end:Me+1},Ke)}else return null}function a(Z,se){for(let pe=se;pe<Z.length;pe++)if(h(Z.charCodeAt(pe))||pe>0&&h(Z.charCodeAt(pe-1)))return pe;return Z.length}const c=y(e.matchesPrefix,r,P),m=y(e.matchesPrefix,r,D),u=new g.LRUCache(1e4);function E(Z,se,pe=!1){if(typeof Z!="string"||typeof se!="string")return null;let Me=u.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),u.set(Z,Me));const je=Me.exec(se);return je?[{start:je.index,end:je.index+je[0].length}]:pe?m(Z,se):c(Z,se)}e.matchesFuzzy=E;function A(Z,se){const pe=Be(Z,Z.toLowerCase(),0,se,se.toLowerCase(),0,!0);return pe?B(pe):null}e.matchesFuzzy2=A;function R(Z,se,pe,Me,je,Ke){const Ze=Math.min(13,Z.length);for(;pe<Ze;pe++){const rt=Be(Z,se,pe,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function B(Z){if(typeof Z=="undefined")return[];const se=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=se[se.length-1];Ke&&Ke.end===je?Ke.end=je+1:se.push({start:je,end:je+1})}return se}e.createMatches=B;const N=128;function F(){const Z=[],se=[];for(let pe=0;pe<=N;pe++)se[pe]=0;for(let pe=0;pe<=N;pe++)Z.push(se.slice(0));return Z}function $(Z){const se=[];for(let pe=0;pe<=Z;pe++)se[pe]=0;return se}const M=$(2*N),z=$(2*N),U=F(),x=F(),j=F(),O=!1;function W(Z,se,pe,Me,je){function Ke(rt,ct,ye=" "){for(;rt.length<ct;)rt=ye+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Ze+=" |":Ze+=`${se[rt-1]}|`,Ze+=Z[rt].slice(0,je+1).map(ct=>Ke(ct.toString(),3)).join("|")+`
`;return Ze}function H(Z,se,pe,Me){Z=Z.substr(se),pe=pe.substr(Me),console.log(W(x,Z,Z.length,pe,pe.length)),console.log(W(j,Z,Z.length,pe,pe.length)),console.log(W(U,Z,Z.length,pe,pe.length))}function X(Z,se){if(se<0||se>=Z.length)return!1;const pe=Z.codePointAt(se);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(pe)}}function K(Z,se){if(se<0||se>=Z.length)return!1;switch(Z.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function de(Z,se,pe){return se[Z]!==pe[Z]}function _e(Z,se,pe,Me,je,Ke,Ze=!1){for(;se<pe&&je<Ke;)Z[se]===Me[je]&&(Ze&&(M[se]=je),se+=1),je+=1;return se===pe}e.isPatternInWord=_e;var Ce;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Pe;(function(Z){Z.Default=[-100,0];function se(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=se})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,se,pe,Me,je,Ke,Ze){const rt=Z.length>N?N:Z.length,ct=Me.length>N?N:Me.length;if(pe>=rt||Ke>=ct||rt-pe>ct-Ke||!_e(se,pe,rt,je,Ke,ct,!0))return;$e(rt,ct,pe,Ke,se,je);let ye=1,at=1,J=pe,ie=Ke;const Ee=[!1];for(ye=1,J=pe;J<rt;ye++,J++){const Ue=M[J],Xe=z[J],it=J+1<rt?z[J+1]:ct;for(at=Ue-Ke+1,ie=Ue;ie<it;at++,ie++){let ft=Number.MIN_SAFE_INTEGER,tt=!1;ie<=Xe&&(ft=He(Z,se,J,pe,Me,je,ie,ct,Ke,U[ye-1][at-1]===0,Ee));let ut=0;ft!==Number.MAX_SAFE_INTEGER&&(tt=!0,ut=ft+x[ye-1][at-1]);const Re=ie>Ue,De=Re?x[ye][at-1]+(U[ye][at-1]>0?-5:0):0,Te=ie>Ue+1&&U[ye][at-1]>0,oe=Te?x[ye][at-2]+(U[ye][at-2]>0?-5:0):0;if(Te&&(!Re||oe>=De)&&(!tt||oe>=ut))x[ye][at]=oe,j[ye][at]=3,U[ye][at]=0;else if(Re&&(!tt||De>=ut))x[ye][at]=De,j[ye][at]=2,U[ye][at]=0;else if(tt)x[ye][at]=ut,j[ye][at]=1,U[ye][at]=U[ye-1][at-1]+1;else throw new Error("not possible")}}if(O&&H(Z,pe,Me,Ke),!Ee[0]&&!Ze)return;ye--,at--;const Qe=[x[ye][at],Ke];let et=0,le=0;for(;ye>=1;){let Ue=at;do{const Xe=j[ye][Ue];if(Xe===3)Ue=Ue-2;else if(Xe===2)Ue=Ue-1;else break}while(Ue>=1);et>1&&se[pe+ye-1]===je[Ke+at-1]&&!de(Ue+Ke-1,Me,je)&&et+1>U[ye][Ue]&&(Ue=at),Ue===at?et++:et=1,le||(le=Ue),ye--,at=Ue-1,Qe.push(at)}ct===rt&&(Qe[0]+=2);const Ie=le-rt;return Qe[0]-=Ie,Qe}e.fuzzyScore=Be;function $e(Z,se,pe,Me,je,Ke){let Ze=Z-1,rt=se-1;for(;Ze>=pe&&rt>=Me;)je[Ze]===Ke[rt]&&(z[Ze]=rt,Ze--),rt--}function He(Z,se,pe,Me,je,Ke,Ze,rt,ct,ye,at){if(se[pe]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let J=1,ie=!1;return Ze===pe-Me?J=Z[pe]===je[Ze]?7:5:de(Ze,je,Ke)&&(Ze===0||!de(Ze-1,je,Ke))?(J=Z[pe]===je[Ze]?7:5,ie=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?J=5:(X(Ke,Ze-1)||K(Ke,Ze-1))&&(J=5,ie=!0),J>1&&pe===Me&&(at[0]=!0),ie||(ie=de(Ze,je,Ke)||X(Ke,Ze-1)||K(Ke,Ze-1)),pe===Me?Ze>ct&&(J-=ie?3:5):ye?J+=ie?2:0:J+=ie?0:1,Ze+1===rt&&(J-=ie?3:5),J}function G(Z,se,pe,Me,je,Ke,Ze){return te(Z,se,pe,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function ee(Z,se,pe,Me,je,Ke,Ze){return te(Z,se,pe,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=ee;function te(Z,se,pe,Me,je,Ke,Ze,rt){let ct=Be(Z,se,pe,Me,je,Ke,rt);if(ct&&!Ze)return ct;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let at=pe+1;at<ye;at++){const J=ce(Z,at);if(J){const ie=Be(J,J.toLowerCase(),pe,Me,je,Ke,rt);ie&&(ie[0]-=3,(!ct||ie[0]>ct[0])&&(ct=ie))}}}return ct}function ce(Z,se){if(se+1>=Z.length)return;const pe=Z[se],Me=Z[se+1];if(pe!==Me)return Z.slice(0,se)+Me+pe+Z.slice(se+2)}}),define(fe[142],me([0,1,47,98,9]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const _=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${_.source}`,"g");function D(w){return w.replace(P,(S,T)=>T?S:`\\${S}`)}e.escapeIcons=D;const C=new RegExp(`\\\\${_.source}`,"g");function k(w){return w.replace(C,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function I(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(i,(S,T,b,s)=>b?S:T||s||"")}e.stripIcons=I;function l(w){const S=w.indexOf(e.iconStartMarker);return S===-1?{text:w}:p(w,S)}e.parseLabelWithIcons=l;function p(w,S){const T=[];let b="";function s(a){if(a){b+=a;for(const c of a)T.push(t)}}let o=-1,v="",t=0,f,r,n=S;const d=w.length;for(s(w.substr(0,S));n<d;)f=w[n],r=w[n+1],f===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(o=n,s(v),v=e.iconStartMarker,n++):f===")"&&o!==-1?(t+=n-o+1,o=-1,v=""):o!==-1?/^[a-z0-9\-]$/i.test(f)?v+=f:(s(v),o=-1,v=""):s(f),n++;return s(v),{text:b,iconOffsets:T}}function h(w,S,T=!1){const{text:b,iconOffsets:s}=S;if(!s||s.length===0)return(0,L.matchesFuzzy)(w,b,T);const o=(0,y.ltrim)(b," "),v=b.length-o.length,t=(0,L.matchesFuzzy)(w,o,T);if(t)for(const f of t){const r=s[f.start+v]+v;f.start+=r,f.end+=r}return t}e.matchesFuzzyIconAware=h}),define(fe[99],me([0,1,17,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(p="",h=!1){if(this.value=p,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(p,h=0){return this.value+=k(this.supportThemeIcons?(0,L.escapeIcons)(p):p).replace(/([ \t]+)/g,(w,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,h){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=_;function P(l){return D(l)?!l.value:Array.isArray(l)?l.every(P):!0}e.isEmptyMarkdownString=P;function D(l){return l instanceof _?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function C(l,p){return l===p?!0:!l||!p?!1:l.value===p.value&&l.isTrusted===p.isTrusted&&l.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=C;function k(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function i(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(l){const p=[],h=l.split("|").map(S=>S.trim());l=h[0];const w=h[1];if(w){const S=/height=(\d+)/.exec(w),T=/width=(\d+)/.exec(w),b=S?S[1]:"",s=T?T[1]:"",o=isFinite(parseInt(s)),v=isFinite(parseInt(b));o&&p.push(`width="${s}"`),v&&p.push(`height="${b}"`)}return{href:l,dimensions:p}}e.parseHrefAndDimensions=I}),define(fe[80],me([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function y(k){return C(k,"NFC",L)}e.normalizeNFC=y;const _=new g.LRUCache(1e4);function P(k){return C(k,"NFD",_)}e.normalizeNFD=P;const D=/[^\u0000-\u0080]/;function C(k,i,I){if(!k)return k;const l=I.get(k);if(l)return l;let p;return D.test(k)?p=k.normalize(i):p=k,I.set(k,p),p}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(i){return P(i).replace(k,"")}}()}),define(fe[49],me([0,1,9]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(L||(L={})),function(y){const _="error",P="warning",D="warn",C="info",k="ignore";function i(l){return l?g.equalsIgnoreCase(_,l)?y.Error:g.equalsIgnoreCase(P,l)||g.equalsIgnoreCase(D,l)?y.Warning:g.equalsIgnoreCase(C,l)?y.Info:y.Ignore:y.Ignore}y.fromValue=i;function I(l){switch(l){case y.Error:return _;case y.Warning:return P;case y.Info:return C;default:return k}}y.toString=I}(L||(L={})),e.default=L}),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(m){return Array.isArray(m)}e.isArray=g;function L(m){return typeof m=="string"}e.isString=L;function y(m){return Array.isArray(m)&&m.every(u=>L(u))}e.isStringArray=y;function _(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=_;function P(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=P;function D(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=D;function C(m){return m===!0||m===!1}e.isBoolean=C;function k(m){return typeof m=="undefined"}e.isUndefined=k;function i(m){return!I(m)}e.isDefined=i;function I(m){return k(m)||m===null}e.isUndefinedOrNull=I;function l(m,u){if(!m)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=l;function p(m){if(I(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function h(...m){const u=[];for(let E=0;E<m.length;E++){const A=m[E];if(I(A))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);u.push(A)}return u}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function S(m){if(!_(m))return!1;for(let u in m)if(w.call(m,u))return!1;return!0}e.isEmptyObject=S;function T(m){return typeof m=="function"}e.isFunction=T;function b(...m){return m.length>0&&m.every(T)}e.areFunctions=b;function s(m,u){const E=Math.min(m.length,u.length);for(let A=0;A<E;A++)o(m[A],u[A])}e.validateConstraints=s;function o(m,u){if(L(u)){if(typeof m!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(T(u)){try{if(m instanceof u)return}catch{}if(!I(m)&&m.constructor===u||u.length===1&&u.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function v(m){let u=[],E=Object.getPrototypeOf(m);for(;Object.prototype!==E;)u=u.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return u}e.getAllPropertyNames=v;function t(m){const u=[];for(const E of v(m))typeof m[E]=="function"&&u.push(E);return u}e.getAllMethodNames=t;function f(m,u){const E=R=>function(){const B=Array.prototype.slice.call(arguments,0);return u(R,B)};let A={};for(const R of m)A[R]=E(R);return A}e.createProxyObject=f;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function d(m){return class{constructor(){return new Proxy({},{get(u,E){if(u[E])return u[E];throw new Error(`Not Implemented: ${m}->${String(E)}`)}})}}}e.NotImplementedProxy=d;function a(m,u="Unreachable"){throw new Error(u)}e.assertNever=a;function c(m){return!!m&&typeof m.then=="function"&&typeof m.catch=="function"}e.isPromise=c}),define(fe[29],me([0,1,8,11,9,12]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function D(r){return r.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=D;function C(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function k(r,n=g.posix.sep){if(!r)return"";const d=r.length,a=r.charCodeAt(0);if(P(a)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let m=3;const u=m;for(;m<d&&!P(r.charCodeAt(m));m++);if(u!==m&&!P(r.charCodeAt(m+1))){for(m+=1;m<d;m++)if(P(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,n)}}return n}else if(T(a)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let c=r.indexOf("://");if(c!==-1){for(c+=3;c<d;c++)if(P(r.charCodeAt(c)))return r.slice(0,c+1)}return""}e.getRoot=k;function i(r){if(!L.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let d=2;const a=d;for(;d<r.length&&(n=r.charCodeAt(d),n!==92);d++);return!(a===d||(n=r.charCodeAt(d+1),isNaN(n)||n===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,n=L.isWindows){const d=n?I:l;return!(!r||r.length===0||/^\s+$/.test(r)||(d.lastIndex=0,d.test(r))||n&&p.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function w(r,n,d){const a=r===n;return!d||a?a:!r||!n?!1:(0,y.equalsIgnoreCase)(r,n)}e.isEqual=w;function S(r,n,d,a=g.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(d){if(!(0,y.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let m=n.length;return n.charAt(n.length-1)===a&&m--,r.charAt(m)===a}return n.charAt(n.length-1)!==a&&(n+=a),r.indexOf(n)===0}e.isEqualOrParent=S;function T(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=T;function b(r,n){return L.isWindows&&r.endsWith(":")&&(r+=g.sep),(0,g.isAbsolute)(r)||(r=(0,g.join)(n,r)),r=(0,g.normalize)(r),L.isWindows?(r=(0,y.rtrim)(r,g.sep),r.endsWith(":")&&(r+=g.sep)):(r=(0,y.rtrim)(r,g.sep),r||(r=g.sep)),r}e.sanitizeFilePath=b;function s(r){const n=(0,g.normalize)(r);return L.isWindows?r.length>3?!1:o(n)&&(r.length===2||n.charCodeAt(2)===92):n===g.posix.sep}e.isRootOrDriveLetter=s;function o(r){return L.isWindows?T(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function v(r){return o(r)?r[0]:void 0}e.getDriveLetter=v;function t(r,n,d){return n.length>r.length?-1:r===n?0:(d&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=t;function f(r){const n=r.split(":");let d,a,c;if(n.forEach(m=>{const u=Number(m);(0,_.isNumber)(u)?a===void 0?a=u:c===void 0&&(c=u):d=d?[d,m].join(":"):m}),!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:a!==void 0?a:void 0,column:c!==void 0?c:a!==void 0?1:void 0}}e.parseLineAndColumnAware=f}),define(fe[25],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const S=Array.isArray(w)?[]:{};return Object.keys(w).forEach(T=>{w[T]&&typeof w[T]=="object"?S[T]=L(w[T]):S[T]=w[T]}),S}e.deepClone=L;function y(w){if(!w||typeof w!="object")return w;const S=[w];for(;S.length>0;){const T=S.shift();Object.freeze(T);for(const b in T)if(_.call(T,b)){const s=T[b];typeof s=="object"&&!Object.isFrozen(s)&&S.push(s)}}return w}e.deepFreeze=y;const _=Object.prototype.hasOwnProperty;function P(w,S){return D(w,S,new Set)}e.cloneAndChange=P;function D(w,S,T){if((0,g.isUndefinedOrNull)(w))return w;const b=S(w);if(typeof b!="undefined")return b;if((0,g.isArray)(w)){const s=[];for(const o of w)s.push(D(o,S,T));return s}if((0,g.isObject)(w)){if(T.has(w))throw new Error("Cannot clone recursive data-structure");T.add(w);const s={};for(let o in w)_.call(w,o)&&(s[o]=D(w[o],S,T));return T.delete(w),s}return w}function C(w,S,T=!0){return(0,g.isObject)(w)?((0,g.isObject)(S)&&Object.keys(S).forEach(b=>{b in w?T&&((0,g.isObject)(w[b])&&(0,g.isObject)(S[b])?C(w[b],S[b],T):w[b]=S[b]):w[b]=S[b]}),w):S}e.mixin=C;function k(w,S){if(w===S)return!0;if(w==null||S===null||S===void 0||typeof w!=typeof S||typeof w!="object"||Array.isArray(w)!==Array.isArray(S))return!1;let T,b;if(Array.isArray(w)){if(w.length!==S.length)return!1;for(T=0;T<w.length;T++)if(!k(w[T],S[T]))return!1}else{const s=[];for(b in w)s.push(b);s.sort();const o=[];for(b in S)o.push(b);if(o.sort(),!k(s,o))return!1;for(T=0;T<s.length;T++)if(!k(w[s[T]],S[s[T]]))return!1}return!0}e.equals=k;function i(w){const S=new Set;return JSON.stringify(w,(T,b)=>{if((0,g.isObject)(b)||Array.isArray(b)){if(S.has(b))return"[Circular]";S.add(b)}return b})}e.safeStringify=i;function I(w,S,T){const b=S(w);return typeof b=="undefined"?T:b}e.getOrDefault=I;function l(w,S){const T=Object.create(null);return!w||!S||Object.keys(S).forEach(s=>{const o=w[s],v=S[s];k(o,v)||(T[s]=v)}),T}e.distinct=l;function p(w,S){const T=S.toLowerCase(),b=Object.keys(w).find(s=>s.toLowerCase()===T);return b?w[b]:w[S]}e.getCaseInsensitive=p;function h(w,S){const T=Object.create(null);for(const b of Object.keys(w))S(b,w[b])&&(T[b]=w[b]);return T}e.filter=h}),define(fe[100],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(_){_[_.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",_[_.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",_[_.MAX_UINT_8=255]="MAX_UINT_8",_[_.MAX_UINT_16=65535]="MAX_UINT_16",_[_.MAX_UINT_32=4294967295]="MAX_UINT_32",_[_.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(_){return _<0?0:_>255?255:_|0}e.toUint8=L;function y(_){return _<0?0:_>4294967295?4294967295:_|0}e.toUint32=y}),define(fe[2],me([0,1,8,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,_=/^\//,P=/^\/\//;function D(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!y.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!_.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(r,n){return!r&&!n?"file":r}function k(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const i="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,d,a,c,m,u=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=C(n,u),this.authority=d||i,this.path=k(this.scheme,a||i),this.query=c||i,this.fragment=m||i,D(this,u))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return s(this,!1)}with(n){if(!n)return this;let{scheme:d,authority:a,path:c,query:m,fragment:u}=n;return d===void 0?d=this.scheme:d===null&&(d=i),a===void 0?a=this.authority:a===null&&(a=i),c===void 0?c=this.path:c===null&&(c=i),m===void 0?m=this.query:m===null&&(m=i),u===void 0?u=this.fragment:u===null&&(u=i),d===this.scheme&&a===this.authority&&c===this.path&&m===this.query&&u===this.fragment?this:new w(d,a,c,m,u)}static parse(n,d=!1){const a=l.exec(n);return a?new w(a[2]||i,f(a[4]||i),f(a[5]||i),f(a[7]||i),f(a[9]||i),d):new w(i,i,i,i,i)}static file(n){let d=i;if(L.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const a=n.indexOf(I,2);a===-1?(d=n.substring(2),n=I):(d=n.substring(2,a),n=n.substring(a)||I)}return new w("file",d,n,i,i)}static from(n){const d=new w(n.scheme,n.authority,n.path,n.query,n.fragment);return D(d,!0),d}static joinPath(n,...d){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return L.isWindows&&n.scheme==="file"?a=p.file(g.win32.join(s(n,!0),...d)).path:a=g.posix.join(n.path,...d),n.with({path:a})}toString(n=!1){return o(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const d=new w(n);return d._formatted=n.external,d._fsPath=n._sep===h?n.fsPath:null,d}}else return n}}e.URI=p;const h=L.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(n=!1){return n?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function T(r,n){let d,a=-1;for(let c=0;c<r.length;c++){const m=r.charCodeAt(c);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||n&&m===47)a!==-1&&(d+=encodeURIComponent(r.substring(a,c)),a=-1),d!==void 0&&(d+=r.charAt(c));else{d===void 0&&(d=r.substr(0,c));const u=S[m];u!==void 0?(a!==-1&&(d+=encodeURIComponent(r.substring(a,c)),a=-1),d+=u):a===-1&&(a=c)}}return a!==-1&&(d+=encodeURIComponent(r.substring(a))),d!==void 0?d:r}function b(r){let n;for(let d=0;d<r.length;d++){const a=r.charCodeAt(d);a===35||a===63?(n===void 0&&(n=r.substr(0,d)),n+=S[a]):n!==void 0&&(n+=r[d])}return n!==void 0?n:r}function s(r,n){let d;return r.authority&&r.path.length>1&&r.scheme==="file"?d=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?d=r.path.substr(1):d=r.path[1].toLowerCase()+r.path.substr(2):d=r.path,L.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=s;function o(r,n){const d=n?b:T;let a="",{scheme:c,authority:m,path:u,query:E,fragment:A}=r;if(c&&(a+=c,a+=":"),(m||c==="file")&&(a+=I,a+=I),m){let R=m.indexOf("@");if(R!==-1){const B=m.substr(0,R);m=m.substr(R+1),R=B.indexOf(":"),R===-1?a+=d(B,!1):(a+=d(B.substr(0,R),!1),a+=":",a+=d(B.substr(R+1),!1)),a+="@"}m=m.toLowerCase(),R=m.indexOf(":"),R===-1?a+=d(m,!1):(a+=d(m.substr(0,R),!1),a+=m.substr(R))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const R=u.charCodeAt(1);R>=65&&R<=90&&(u=`/${String.fromCharCode(R+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const R=u.charCodeAt(0);R>=65&&R<=90&&(u=`${String.fromCharCode(R+32)}:${u.substr(2)}`)}a+=d(u,!0)}return E&&(a+="?",a+=d(E,!1)),A&&(a+="#",a+=n?A:T(A,!1)),a}function v(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+v(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(r){return r.match(t)?r.replace(t,n=>v(n)):r}}),define(fe[62],me([0,1,22,9,2]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(i){return JSON.stringify(i,C)}e.stringify=_;function P(i){let I=JSON.parse(i);return I=k(I),I}e.parse=P;var D;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function C(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function k(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return y.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let l=0;l<i.length;++l)i[l]=k(i[l],I+1);else for(const l in i)Object.hasOwnProperty.call(i,l)&&(i[l]=k(i[l],I+1))}return i}e.revive=k}),define(fe[10],me([0,1,11,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(y=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,k,i){this._hosts[C]=k,this._ports[C]=i}setConnectionToken(C,k){this._connectionTokens[C]=k}rewrite(C){if(this._delegate)return this._delegate(C);const k=C.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[k],l=this._connectionTokens[k];let p=`path=${encodeURIComponent(C.path)}`;return typeof l=="string"&&(p+=`&tkn=${encodeURIComponent(l)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new _;class P{asBrowserUri(C,k){const i=this.toUri(C,k);return i.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===y.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${y.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?i.with({scheme:y.vscodeFileResource,authority:i.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(C,k){const i=this.toUri(C,k);return i.scheme===y.vscodeFileResource?i.with({scheme:y.file,authority:i.authority!==P.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(C,k){return L.URI.isUri(C)?C:L.URI.parse(k.toUrl(C))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(fe[23],me([0,1,29,10,8,11,9,2]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,D.uriToFsPath)(p,!0)}e.originalFSPath=C;class k{constructor(h){this._ignorePathCasing=h}compare(h,w,S=!1){return h===w?0:(0,P.compare)(this.getComparisonKey(h,S),this.getComparisonKey(w,S))}isEqual(h,w,S=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,S)===this.getComparisonKey(w,S)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,S=!1){if(h.scheme===w.scheme){if(h.scheme===L.Schemas.file)return g.isEqualOrParent(C(h),C(w),this._ignorePathCasing(h))&&h.query===w.query&&(S||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return g.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(S||h.fragment===w.fragment)}return!1}joinPath(h,...w){return D.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===L.Schemas.file?w=D.URI.file(y.dirname(C(h))).path:(w=y.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===L.Schemas.file?w=D.URI.file(y.normalize(C(h))).path:w=y.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===L.Schemas.file){const b=y.relative(C(h),C(w));return _.isWindows?g.toSlashes(b):b}let S=h.path||"/",T=w.path||"/";if(this._ignorePathCasing(h)){let b=0;for(const s=Math.min(S.length,T.length);b<s&&!(S.charCodeAt(b)!==T.charCodeAt(b)&&S.charAt(b).toLowerCase()!==T.charAt(b).toLowerCase());b++);S=T.substr(0,b)+S.substr(b)}return y.posix.relative(S,T)}resolvePath(h,w){if(h.scheme===L.Schemas.file){const S=D.URI.file(y.resolve(C(h),w));return h.with({authority:S.authority,path:S.path})}return w=g.toPosixPath(w),h.with({path:y.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||(0,P.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=y.sep){if(h.scheme===L.Schemas.file){const S=C(h);return S.length>g.getRoot(S).length&&S[S.length-1]===w}else{const S=h.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=y.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=y.sep){let S=!1;if(h.scheme===L.Schemas.file){const T=C(h);S=T!==void 0&&T.length===g.getRoot(T).length&&T[T.length-1]===w}else{w="/";const T=h.path;S=T.length===1&&T.charCodeAt(T.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(p=>p.scheme===L.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new k(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,h){const w=[];for(let S=0;S<p.length;S++){const T=h(p[S]);p.some((b,s)=>s===S?!1:(0,e.isEqualOrParent)(T,h(b)))||w.push(p[S])}return w}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(w){const S=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(s=>{const[o,v]=s.split(":");o&&v&&S.set(o,v)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&S.set(p.META_DATA_MIME,b),S}p.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function l(p,h,w){if(h){let S=p.path;return S&&S[0]!==y.posix.sep&&(S=y.posix.sep+S),p.with({scheme:w,authority:h,path:S})}return p.with({scheme:w})}e.toLocalResource=l}),define(fe[15],me([0,1,21,17,3,6,23]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(U){return!!U&&typeof U.then=="function"}e.isThenable=D;function C(U){const x=new g.CancellationTokenSource,j=U(x.token),O=new Promise((W,H)=>{const X=x.token.onCancellationRequested(()=>{X.dispose(),x.dispose(),H((0,L.canceled)())});Promise.resolve(j).then(K=>{X.dispose(),x.dispose(),W(K)},K=>{X.dispose(),x.dispose(),H(K)})});return new class{cancel(){x.cancel()}then(W,H){return O.then(W,H)}catch(W){return this.then(void 0,W)}finally(W){return O.finally(W)}}}e.createCancelablePromise=C;function k(U,x,j){return Promise.race([U,new Promise(O=>x.onCancellationRequested(()=>O(j)))])}e.raceCancellation=k;async function i(U){let x=-1;const j=U.map((W,H)=>W.then(X=>(x=H,X))),O=await Promise.race(j);return U.forEach((W,H)=>{H!==x&&W.cancel()}),O}e.raceCancellablePromises=i;function I(U,x,j){let O;const W=setTimeout(()=>{O?.(void 0),j?.()},x);return Promise.race([U.finally(()=>clearTimeout(W)),new Promise(H=>O=H)])}e.raceTimeout=I;function l(U){return new Promise((x,j)=>{const O=U();D(O)?O.then(x,j):x(O)})}e.asPromise=l;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(j,j).then(O)})}return new Promise((j,O)=>{this.queuedPromise.then(j,O)})}return this.activePromise=x(),new Promise((j,O)=>{this.activePromise.then(W=>{this.activePromise=null,j(W)},W=>{this.activePromise=null,O(W)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=h;class w{constructor(){this.promiseMap=new Map}queue(x,j){const W=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(x)===W&&this.promiseMap.delete(x)});return this.promiseMap.set(x,W),W}}e.SequencerByKey=w;class S{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,j=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,W)=>{this.doResolve=O,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class T{constructor(x){this.delayer=new S(x),this.throttler=new p}trigger(x,j){return this.delayer.trigger(()=>this.throttler.queue(x),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class b{constructor(){this._isOpen=!1,this._promise=new Promise((x,j)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class s extends b{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function o(U,x){return x?new Promise((j,O)=>{const W=setTimeout(()=>{H.dispose(),j()},U),H=x.onCancellationRequested(()=>{clearTimeout(W),H.dispose(),O((0,L.canceled)())})}):C(j=>o(U,j))}e.timeout=o;function v(U,x=0){const j=setTimeout(U,x);return(0,_.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=v;function t(U){const x=[];let j=0;const O=U.length;function W(){return j<O?U[j++]():null}function H(X){X!=null&&x.push(X);const K=W();return K?K.then(H):Promise.resolve(x)}return Promise.resolve(null).then(H)}e.sequence=t;function f(U,x=O=>!!O,j=null){let O=0;const W=U.length,H=()=>{if(O>=W)return Promise.resolve(j);const X=U[O++];return Promise.resolve(X()).then(de=>x(de)?Promise.resolve(de):H())};return H()}e.first=f;function r(U,x=O=>!!O,j=null){if(U.length===0)return Promise.resolve(j);let O=U.length;const W=()=>{O=-1;for(const H of U)H.cancel?.()};return new Promise((H,X)=>{for(const K of U)K.then(de=>{--O>=0&&x(de)?(W(),H(de)):O===0&&H(j)}).catch(de=>{--O>=0&&(W(),X(de))})})}e.firstParallel=r;class n{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((j,O)=>{this.outstandingPromises.push({factory:x,c:j,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const j=x.factory();j.then(x.c,x.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class d extends n{constructor(){super(1)}}e.Queue=d;class a{constructor(){this.queues=new Map}queueFor(x,j=P.extUri){const O=j.getComparisonKey(x);let W=this.queues.get(O);return W||(W=new d,y.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(O)}),this.queues.set(O,W)),W}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=a;class c{constructor(x,j){this._token=-1,typeof x=="function"&&typeof j=="number"&&this.setIfNotSet(x,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},j)}setIfNotSet(x,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},j))}}e.TimeoutTimer=c;class m{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,j){this.cancel(),this._token=setInterval(()=>{x()},j)}}e.IntervalTimer=m;class u{constructor(x,j){this.timeoutToken=-1,this.runner=x,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class E{constructor(x,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class A extends u{constructor(x,j){super(x,j);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class R extends _.Disposable{constructor(x,j,O,W){super();this.maxWorkChunkSize=x,this.maxPendingWork=j,this.throttleDelay=O,this.handler=W,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{const x=setTimeout(()=>{const O=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0,clearTimeout(x))}}}:e.runWhenIdle=(U,x)=>{const j=requestIdleCallback(U,typeof x=="number"?{timeout:x}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(j))}}}}();class B{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function N(U,x,j){let O;for(let W=0;W<j;W++)try{return await U()}catch(H){O=H,await o(x)}throw O}e.retry=N;class F{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,j,O){return this._pending={taskId:x,cancel:()=>O?.(),promise:j},j.then(()=>this.donePending(x),()=>this.donePending(x)),j}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let j,O;const W=new Promise((H,X)=>{j=H,O=X});this._next={run:x,promise:W,promiseResolve:j,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=F;class ${constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,j)=>{this.completeCallback=x,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(j=>{this.completeCallback(x),this.resolved=!0,j()})}error(x){return new Promise(j=>{this.errorCallback(x),this.rejected=!0,j()})}cancel(){new Promise(x=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=M;var z;(function(U){async function x(O){let W;const H=await Promise.all(O.map(X=>X.then(K=>K,K=>{W||(W=K)})));if(typeof W!="undefined")throw W;return H}U.settled=x;function j(O){return new Promise(async(W,H)=>{try{await O(W,H)}catch(X){H(X)}})}U.withAsyncBody=j})(z=e.Promises||(e.Promises={}))}),define(fe[101],me([0,1,15,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new g.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),_=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(u,E,A=!1){const R=u||"",B=E||"",N=y.value.collator.compare(R,B);return y.value.collatorIsNumeric&&N===0&&R!==B?R<B?-1:1:N}e.compareFileNames=D;function C(u,E){const A=_.value.collator;return u=u||"",E=E||"",v(A,u,E)}e.compareFileNamesDefault=C;function k(u,E){const A=_.value.collator;return u=u||"",E=E||"",n(u,E)||v(A,u,E)}e.compareFileNamesUpper=k;function i(u,E){const A=_.value.collator;return u=u||"",E=E||"",r(u,E)||v(A,u,E)}e.compareFileNamesLower=i;function I(u,E){return u=u||"",E=E||"",u===E?0:u<E?-1:1}e.compareFileNamesUnicode=I;function l(u,E,A=!1){A||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase());const[R,B]=s(u),[N,F]=s(E);return R!==N?R<N?-1:1:B===F?0:B<F?-1:1}e.noIntlCompareFileNames=l;function p(u,E){const[A,R]=s(u),[B,N]=s(E);let F=y.value.collator.compare(R,N);if(F===0){if(y.value.collatorIsNumeric&&R!==N)return R<N?-1:1;if(F=y.value.collator.compare(A,B),y.value.collatorIsNumeric&&F===0&&A!==B)return A<B?-1:1}return F}e.compareFileExtensions=p;function h(u,E){u=u||"",E=E||"";const A=o(u),R=o(E),B=_.value.collator,N=P.value.collator;return v(N,A,R)||v(B,u,E)}e.compareFileExtensionsDefault=h;function w(u,E){u=u||"",E=E||"";const A=o(u),R=o(E),B=_.value.collator,N=P.value.collator;return v(N,A,R)||n(u,E)||v(B,u,E)}e.compareFileExtensionsUpper=w;function S(u,E){u=u||"",E=E||"";const A=o(u),R=o(E),B=_.value.collator,N=P.value.collator;return v(N,A,R)||r(u,E)||v(B,u,E)}e.compareFileExtensionsLower=S;function T(u,E){u=u||"",E=E||"";const A=o(u).toLowerCase(),R=o(E).toLowerCase();return A!==R?A<R?-1:1:u!==E?u<E?-1:1:0}e.compareFileExtensionsUnicode=T;const b=/^(.*?)(\.([^.]*))?$/;function s(u,E=!1){const A=u?b.exec(u):[];let R=[A&&A[1]||"",A&&A[3]||""];return E&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function o(u){const E=u?b.exec(u):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function v(u,E,A){let R=u.compare(E,A);return R!==0?R:E.length!==A.length?E.length<A.length?-1:1:0}function t(u){const E=u.charAt(0);return E.toLocaleUpperCase()!==E}function f(u){const E=u.charAt(0);return E.toLocaleLowerCase()!==E}function r(u,E){return t(u)&&f(E)?-1:f(u)&&t(E)?1:0}function n(u,E){return f(u)&&t(E)?-1:t(u)&&f(E)?1:0}function d(u,E,A=!1){return A||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase()),u===E?0:u<E?-1:1}function a(u,E,A=!1){const R=u.split(L.sep),B=E.split(L.sep),N=R.length-1,F=B.length-1;let $,M;for(let z=0;;z++){if($=N===z,M=F===z,$&&M)return D(R[z],B[z],A);if($)return-1;if(M)return 1;const U=d(R[z],B[z],A);if(U!==0)return U}}e.comparePaths=a;function c(u,E,A){const R=u.toLowerCase(),B=E.toLowerCase(),N=m(u,E,A);if(N)return N;const F=R.endsWith(A),$=B.endsWith(A);if(F!==$)return F?-1:1;const M=D(R,B);return M!==0?M:R.localeCompare(B)}e.compareAnything=c;function m(u,E,A){const R=u.toLowerCase(),B=E.toLowerCase(),N=R.startsWith(A),F=B.startsWith(A);if(N!==F)return N?-1:1;if(N&&F){if(R.length<B.length)return-1;if(R.length>B.length)return 1}return 0}e.compareByPrefix=m}),define(fe[102],me([0,1,101,98,48,8,11,9]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,k=[C,[]];function i(U,x,j,O){if(!U||!x)return k;const W=U.length,H=x.length;if(W<H)return k;const X=U.toLowerCase();return I(x,j,H,U,X,W,O)}e.scoreFuzzy=i;function I(U,x,j,O,W,H,X){const K=[],de=[];for(let Be=0;Be<j;Be++){const $e=Be*H,He=$e-H,G=Be>0,ee=U[Be],te=x[Be];for(let ce=0;ce<H;ce++){const Z=ce>0,se=$e+ce,pe=se-1,Me=He+ce-1,je=Z?K[pe]:0,Ke=G&&Z?K[Me]:0,Ze=G&&Z?de[Me]:0;let rt;!Ke&&G?rt=0:rt=l(ee,te,O,W,ce,Ze),rt&&Ke+rt>=je&&(X||G||W.startsWith(x,ce))?(de[se]=Ze+1,K[se]=Ke+rt):(de[se]=C,K[se]=je)}}const _e=[];let Ce=j-1,Pe=H-1;for(;Ce>=0&&Pe>=0;){const Be=Ce*H+Pe;de[Be]===C||(_e.push(Pe),Ce--),Pe--}return[K[j*H-1],_e.reverse()]}function l(U,x,j,O,W,H){let X=0;if(!p(x,O[W]))return X;if(X+=1,H>0&&(X+=H*5),U===j[W]&&(X+=1),W===0)X+=8;else{const K=h(j.charCodeAt(W-1));K?X+=K:(0,L.isUpper)(j.charCodeAt(W))&&H===0&&(X+=2)}return X}function p(U,x){return U===x?!0:U==="/"||U==="\\"?x==="/"||x==="\\":!1}function h(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function S(U,x,j=0,O=0){const W=x;return W.values&&W.values.length>1?T(U,W.values,j,O):b(U,x,j,O)}e.scoreFuzzy2=S;function T(U,x,j,O){let W=0;const H=[];for(const X of x){const[K,de]=b(U,X,j,O);if(typeof K!="number")return w;W+=K,H.push(...de)}return[W,m(H)]}function b(U,x,j,O){const W=(0,L.fuzzyScore)(x.original,x.originalLowercase,j,U,U.toLowerCase(),O,!0);return W?[W[0],(0,L.createMatches)(W)]:w}const s=Object.freeze({score:0}),o=1<<18,v=1<<17,t=1<<16;function f(U,x,j,O){const W=O.values?O.values:[O];return(0,y.hash)({[O.normalized]:{values:W.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:U,description:x,allowNonContiguousMatches:j}})}function r(U,x,j,O,W){if(!U||!x.normalized)return s;const H=O.getItemLabel(U);if(!H)return s;const X=O.getItemDescription(U),K=f(H,X,j,x),de=W[K];if(de)return de;const _e=n(H,X,O.getItemPath(U),x,j);return W[K]=_e,_e}e.scoreItemFuzzy=r;function n(U,x,j,O,W){const H=!j||!O.containsPathSeparator;return j&&(P.isLinux?O.pathNormalized===j:(0,D.equalsIgnoreCase)(O.pathNormalized,j))?{score:o,labelMatch:[{start:0,end:U.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:O.values&&O.values.length>1?d(U,x,j,O.values,H,W):a(U,x,j,O,H,W)}function d(U,x,j,O,W,H){let X=0;const K=[],de=[];for(const _e of O){const{score:Ce,labelMatch:Pe,descriptionMatch:Be}=a(U,x,j,_e,W,H);if(Ce===C)return s;X+=Ce,Pe&&K.push(...Pe),Be&&de.push(...Be)}return{score:X,labelMatch:m(K),descriptionMatch:m(de)}}function a(U,x,j,O,W,H){if(W||!x){const[X,K]=i(U,O.normalized,O.normalizedLowercase,H&&!O.expectContiguousMatch);if(X){const de=(0,L.matchesPrefix)(O.normalized,U);let _e;return de?(_e=v,_e+=Math.round(O.normalized.length/U.length*100)):_e=t,{score:_e+X,labelMatch:de||c(K)}}}if(x){let X=x;j&&(X=`${x}${_.sep}`);const K=X.length,de=`${X}${U}`,[_e,Ce]=i(de,O.normalized,O.normalizedLowercase,H&&!O.expectContiguousMatch);if(_e){const Pe=c(Ce),Be=[],$e=[];return Pe.forEach(He=>{He.start<K&&He.end>K?(Be.push({start:0,end:He.end-K}),$e.push({start:He.start,end:K})):He.start>=K?Be.push({start:He.start-K,end:He.end-K}):$e.push(He)}),{score:_e,labelMatch:Be,descriptionMatch:$e}}}return s}function c(U){const x=[];if(!U)return x;let j;for(const O of U)j&&j.end===O?j.end+=1:(j={start:O,end:O+1},x.push(j));return x}function m(U){const x=U.sort((W,H)=>W.start-H.start),j=[];let O;for(const W of x)!O||!u(O,W)?(O=W,j.push(W)):(O.start=Math.min(O.start,W.start),O.end=Math.max(O.end,W.end));return j}function u(U,x){return!(U.end<x.start||x.end<U.start)}function E(U,x,j,O,W,H){const X=r(U,j,O,W,H),K=r(x,j,O,W,H),de=X.score,_e=K.score;if((de===o||_e===o)&&de!==_e)return de===o?-1:1;if(de>t||_e>t){if(de!==_e)return de>_e?-1:1;if(de<v&&_e<v){const ee=R(X.labelMatch,K.labelMatch);if(ee!==0)return ee}const He=W.getItemLabel(U)||"",G=W.getItemLabel(x)||"";if(He.length!==G.length)return He.length-G.length}if(de!==_e)return de>_e?-1:1;const Ce=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(K.labelMatch)&&K.labelMatch.length>0;if(Ce&&!Pe)return-1;if(Pe&&!Ce)return 1;const Be=A(U,X,W),$e=A(x,K,W);return Be&&$e&&Be!==$e?$e>Be?-1:1:B(U,x,j,W)}e.compareItemsByFuzzyScore=E;function A(U,x,j){let O=-1,W=-1;if(x.descriptionMatch&&x.descriptionMatch.length?O=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(O=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(W=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const H=j.getItemDescription(U);H&&(W+=H.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(W=x.descriptionMatch[x.descriptionMatch.length-1].end);return W-O}function R(U,x){if(!U&&!x||(!U||!U.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!U||!U.length)return 1;const j=U[0].start,W=U[U.length-1].end-j,H=x[0].start,K=x[x.length-1].end-H;return W===K?0:K<W?1:-1}function B(U,x,j,O){const W=O.getItemLabel(U)||"",H=O.getItemLabel(x)||"",X=O.getItemDescription(U),K=O.getItemDescription(x),de=W.length+(X?X.length:0),_e=H.length+(K?K.length:0);if(de!==_e)return de-_e;const Ce=O.getItemPath(U),Pe=O.getItemPath(x);return Ce&&Pe&&Ce.length!==Pe.length?Ce.length-Pe.length:W!==H?(0,g.compareAnything)(W,H,j.normalized):X&&K&&X!==K?(0,g.compareAnything)(X,K,j.normalized):Ce&&Pe&&Ce!==Pe?(0,g.compareAnything)(Ce,Pe,j.normalized):0}function N(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function $(U){typeof U!="string"&&(U="");const x=U.toLowerCase(),{pathNormalized:j,normalized:O,normalizedLowercase:W}=M(U),H=j.indexOf(_.sep)>=0,X=N(U);let K;const de=U.split(F);if(de.length>1)for(const _e of de){const Ce=N(_e),{pathNormalized:Pe,normalized:Be,normalizedLowercase:$e}=M(_e);Be&&(K||(K=[]),K.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Pe,normalized:Be,normalizedLowercase:$e,expectContiguousMatch:Ce}))}return{original:U,originalLowercase:x,pathNormalized:j,normalized:O,normalizedLowercase:W,values:K,containsPathSeparator:H,expectContiguousMatch:X}}e.prepareQuery=$;function M(U){let x;P.isWindows?x=U.replace(/\//g,_.sep):x=U.replace(/\\/g,_.sep);const j=(0,D.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:j,normalizedLowercase:j.toLowerCase()}}function z(U){return Array.isArray(U)?$(U.map(x=>x.original).join(F)):$(U.original)}e.pieceToQuery=z}),define(fe[30],me([0,1,15,29,24,8,9]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const C="**",k="/",i="[/\\\\]",I="[^/\\\\]",l=/\//g;function p(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function h(O,W){if(!O)return[];const H=[];let X=!1,K=!1,de="";for(const _e of O){switch(_e){case W:if(!X&&!K){H.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":K=!0;break;case"]":K=!1;break}de+=_e}return de&&H.push(de),H}e.splitGlobAware=h;function w(O){if(!O)return"";let W="";const H=h(O,k);if(H.every(X=>X===C))W=".*";else{let X=!1;H.forEach((K,de)=>{if(K===C){X||(W+=p(2),X=!0);return}let _e=!1,Ce="",Pe=!1,Be="";for(const $e of K){if($e!=="}"&&_e){Ce+=$e;continue}if(Pe&&($e!=="]"||!Be)){let He;$e==="-"?He=$e:($e==="^"||$e==="!")&&!Be?He="^":$e===k?He="":He=P.escapeRegExpCharacters($e),Be+=He;continue}switch($e){case"{":_e=!0;continue;case"[":Pe=!0;continue;case"}":W+=`(?:${h(Ce,",").map(ee=>w(ee)).join("|")})`,_e=!1,Ce="";break;case"]":W+="["+Be+"]",Pe=!1,Be="";break;case"?":W+=I;continue;case"*":W+=p(1);continue;default:W+=P.escapeRegExpCharacters($e)}}de<H.length-1&&(H[de+1]!==C||de+2<H.length)&&(W+=i),X=!1})}return W}const S=/^\*\*\/\*\.[\w\.-]+$/,T=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),f=function(){return!1},r=function(){return null};function n(O,W){if(!O)return r;let H;typeof O!="string"?H=O.pattern:H=O,H=H.trim();const X=`${H}_${!!W.trimForExclusions}`;let K=t.get(X);if(K)return d(K,O);let de;if(S.test(H)){const _e=H.substr(4);K=function(Ce,Pe){return typeof Ce=="string"&&Ce.endsWith(_e)?H:null}}else(de=T.exec(a(H,W)))?K=c(de[1],H):(W.trimForExclusions?s:b).test(H)?K=m(H,W):(de=o.exec(a(H,W)))?K=u(de[1].substr(1),H,!0):(de=v.exec(a(H,W)))?K=u(de[1],H,!1):K=E(H);return t.set(X,K),d(K,O)}function d(O,W){return typeof W=="string"?O:function(H,X){return L.isEqualOrParent(H,W.base)?O(_.relative(W.base,H),X):null}}function a(O,W){return W.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function c(O,W){const H=`/${O}`,X=`\\${O}`,K=function(_e,Ce){return typeof _e!="string"?null:Ce?Ce===O?W:null:_e===O||_e.endsWith(H)||_e.endsWith(X)?W:null},de=[O];return K.basenames=de,K.patterns=[W],K.allBasenames=de,K}function m(O,W){const H=j(O.slice(1,-1).split(",").map(Ce=>n(Ce,W)).filter(Ce=>Ce!==r),O),X=H.length;if(!X)return r;if(X===1)return H[0];const K=function(Ce,Pe){for(let Be=0,$e=H.length;Be<$e;Be++)if(H[Be](Ce,Pe))return O;return null},de=H.find(Ce=>!!Ce.allBasenames);de&&(K.allBasenames=de.allBasenames);const _e=H.reduce((Ce,Pe)=>Pe.allPaths?Ce.concat(Pe.allPaths):Ce,[]);return _e.length&&(K.allPaths=_e),K}function u(O,W,H){const X=_.sep===_.posix.sep,K=X?O:O.replace(l,_.sep),de=_.sep+K,_e=_.posix.sep+O,Ce=H?function(Pe,Be){return typeof Pe=="string"&&(Pe===K||Pe.endsWith(de)||!X&&(Pe===O||Pe.endsWith(_e)))?W:null}:function(Pe,Be){return typeof Pe=="string"&&(Pe===K||!X&&Pe===O)?W:null};return Ce.allPaths=[(H?"*/":"./")+O],Ce}function E(O){try{const W=new RegExp(`^${w(O)}$`);return function(H){return W.lastIndex=0,typeof H=="string"&&W.test(H)?O:null}}catch(W){return r}}function A(O,W,H){return!O||typeof W!="string"?!1:R(O)(W,void 0,H)}e.match=A;function R(O,W={}){if(!O)return f;if(typeof O=="string"||$(O)){const H=n(O,W);if(H===r)return f;const X=function(K,de){return!!H(K,de)};return H.allBasenames&&(X.allBasenames=H.allBasenames),H.allPaths&&(X.allPaths=H.allPaths),X}return U(O,W)}e.parse=R;function B(O){if(!O)return;let W;return H=>(W||(W=(O()||Promise.resolve([])).then(X=>X?F(X):{})),W.then(X=>!!X[H]))}e.hasSiblingPromiseFn=B;function N(O){if(!O)return;let W;return H=>{if(!W){const X=O();W=X?F(X):{}}return!!W[H]}}e.hasSiblingFn=N;function F(O){const W={};for(const H of O)W[H]=!0;return W}function $(O){const W=O;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=$;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function z(O){return O.allPaths||[]}e.getPathTerms=z;function U(O,W){const H=j(Object.getOwnPropertyNames(O).map(Ce=>x(Ce,O[Ce],W)).filter(Ce=>Ce!==r)),X=H.length;if(!X)return r;if(!H.some(Ce=>!!Ce.requiresSiblings)){if(X===1)return H[0];const Ce=function($e,He){for(let G=0,ee=H.length;G<ee;G++){const te=H[G]($e,He);if(te)return te}return null},Pe=H.find($e=>!!$e.allBasenames);Pe&&(Ce.allBasenames=Pe.allBasenames);const Be=H.reduce(($e,He)=>He.allPaths?$e.concat(He.allPaths):$e,[]);return Be.length&&(Ce.allPaths=Be),Ce}const K=function(Ce,Pe,Be){let $e;for(let He=0,G=H.length;He<G;He++){const ee=H[He];ee.requiresSiblings&&Be&&(Pe||(Pe=_.basename(Ce)),$e||($e=Pe.substr(0,Pe.length-_.extname(Ce).length)));const te=ee(Ce,Pe,$e,Be);if(te)return te}return null},de=H.find(Ce=>!!Ce.allBasenames);de&&(K.allBasenames=de.allBasenames);const _e=H.reduce((Ce,Pe)=>Pe.allPaths?Ce.concat(Pe.allPaths):Ce,[]);return _e.length&&(K.allPaths=_e),K}function x(O,W,H){if(W===!1)return r;const X=n(O,H);if(X===r)return r;if(typeof W=="boolean")return X;if(W){const K=W.when;if(typeof K=="string"){const de=(_e,Ce,Pe,Be)=>{if(!Be||!X(_e,Ce))return null;const $e=K.replace("$(basename)",Pe),He=Be($e);return(0,g.isThenable)(He)?He.then(G=>G?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function j(O,W){const H=O.filter(Ce=>!!Ce.basenames);if(H.length<2)return O;const X=H.reduce((Ce,Pe)=>{const Be=Pe.basenames;return Be?Ce.concat(Be):Ce},[]);let K;if(W){K=[];for(let Ce=0,Pe=X.length;Ce<Pe;Ce++)K.push(W)}else K=H.reduce((Ce,Pe)=>{const Be=Pe.patterns;return Be?Ce.concat(Be):Ce},[]);const de=function(Ce,Pe){if(typeof Ce!="string")return null;if(!Pe){let $e;for($e=Ce.length;$e>0;$e--){const He=Ce.charCodeAt($e-1);if(He===47||He===92)break}Pe=Ce.substr($e)}const Be=X.indexOf(Pe);return Be!==-1?K[Be]:null};de.basenames=X,de.patterns=K,de.allBasenames=X;const _e=O.filter(Ce=>!Ce.basenames);return _e.push(de),_e}}),define(fe[81],me([0,1,29,10,8,11,23,9,2]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(n,d,a){if(typeof n=="string"&&(n=C.URI.file(n)),a){const m=a.getWorkspaceFolder(n);if(m){const u=a.getWorkspace().folders.length>1;let E;if((0,P.isEqual)(m.uri,n)?E="":E=(0,P.relativePath)(m.uri,n),u){const A=m.name?m.name:(0,P.basename)(m.uri);E=E?A+" \u2022 "+E:A}return E}}if(n.scheme!==L.Schemas.file&&n.scheme!==L.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(n.fsPath))return(0,y.normalize)(I(n.fsPath));let c=(0,y.normalize)(n.fsPath);return!_.isWindows&&d?.userHome&&(c=p(c,d.userHome.fsPath)),c}e.getPathLabel=k;function i(n){if(!n)return;typeof n=="string"&&(n=C.URI.file(n));const d=(0,P.basename)(n)||(n.scheme===L.Schemas.file?n.fsPath:n.path);return _.isWindows&&(0,g.isRootOrDriveLetter)(d)?I(d):d}e.getBaseLabel=i;function I(n){return(0,g.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let l=Object.create(null);function p(n,d){if(_.isWindows||!n||!d)return n;let a=l.original===d?l.normalized:void 0;return a||(a=`${(0,D.rtrim)(d,y.posix.sep)}${y.posix.sep}`,l={original:d,normalized:a}),(_.isLinux?n.startsWith(a):(0,D.startsWithIgnoreCase)(n,a))&&(n=`~/${n.substr(a.length)}`),n}e.tildify=p;function h(n,d){return n.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=h;const w="\u2026",S="\\\\",T="~";function b(n,d=y.sep){const a=new Array(n.length);let c=!1;for(let m=0;m<n.length;m++){let u=n[m];if(u===""){a[m]=`.${d}`;continue}if(!u){a[m]=u;continue}c=!0;let E="";u.indexOf(S)===0?(E=u.substr(0,u.indexOf(S)+S.length),u=u.substr(u.indexOf(S)+S.length)):u.indexOf(d)===0?(E=u.substr(0,u.indexOf(d)+d.length),u=u.substr(u.indexOf(d)+d.length)):u.indexOf(T)===0&&(E=u.substr(0,u.indexOf(T)+T.length),u=u.substr(u.indexOf(T)+T.length));const A=u.split(d);for(let R=1;c&&R<=A.length;R++)for(let B=A.length-R;c&&B>=0;B--){c=!1;let N=A.slice(B,B+R).join(d);for(let F=0;!c&&F<n.length;F++)if(F!==m&&n[F]&&n[F].indexOf(N)>-1){const $=B+R===A.length,M=B>0&&n[F].indexOf(d)>-1?d+N:N,z=n[F].endsWith(M);c=!$||z}if(!c){let F="";(A[0].endsWith(":")||E!=="")&&(B===1&&(B=0,R++,N=A[0]+d+N),B>0&&(F=A[0]+d),F=E+F),B>0&&(F=F+w+d),F=F+N,B+R<A.length&&(F=F+d+w),a[m]=F}}c&&(a[m]=u)}return a}e.shorten=b;var s;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function o(n,d=Object.create(null)){const a=[];let c=!1,m="";for(const u of n)if(u==="$"||c&&u==="{")m&&a.push({value:m,type:s.TEXT}),m="",c=!0;else if(u==="}"&&c){const E=d[m];if(typeof E=="string")E.length&&a.push({value:E,type:s.VARIABLE});else if(E){const A=a[a.length-1];(!A||A.type!==s.SEPARATOR)&&a.push({value:E.label,type:s.SEPARATOR})}m="",c=!1}else m+=u;return m&&!c&&a.push({value:m,type:s.TEXT}),a.filter((u,E)=>{if(u.type===s.SEPARATOR){const A=a[E-1],R=a[E+1];return[A,R].every(B=>B&&(B.type===s.VARIABLE||B.type===s.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=o;function v(n,d){return _.isMacintosh||d?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(n,d){return _.isMacintosh||d?n.replace(/\(&&\w\)|&&/g,""):_.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function f(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=f;function r(n){const d=n.indexOf("/")!==-1?y.posix:y.win32,a=d.basename(n),c=d.dirname(n);return a.length?{name:a,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(fe[103],me([0,1,30,10,8,23,9]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown",n.latex="text/latex"})(D=e.Mimes||(e.Mimes={}));let C=[],k=[],i=[];function I(n,d=!1){const a=l(n);C.push(a),a.userConfigured?i.push(a):k.push(a),d&&!a.userConfigured&&C.forEach(c=>{c.mime===a.mime||c.userConfigured||(a.extension&&c.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&c.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&c.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&c.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=I;function l(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?(0,g.parse)(n.filepattern.toLowerCase()):void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(y.posix.sep)>=0:!1}}function p(n){n?(C=C.filter(d=>!d.userConfigured),i=[]):(C=[],k=[],i=[])}e.clearTextMimes=p;function h(n,d){let a;if(n)switch(n.scheme){case L.Schemas.file:a=n.fsPath;break;case L.Schemas.data:a=_.DataUri.parseMetaData(n).get(_.DataUri.META_DATA_LABEL);break;default:a=n.path}if(!a)return[D.unknown];a=a.toLowerCase();const c=(0,y.basename)(a),m=w(a,c,i);if(m)return[m,D.text];const u=w(a,c,k);if(u)return[u,D.text];if(d){const E=S(d);if(E)return[E,D.text]}return[D.unknown]}e.guessMimeTypes=h;function w(n,d,a){let c=null,m=null,u=null;for(let E=a.length-1;E>=0;E--){const A=a[E];if(d===A.filenameLowercase){c=A;break}if(A.filepattern&&(!m||A.filepattern.length>m.filepattern.length)){const R=A.filepatternOnPath?n:d;A.filepatternLowercase?.(R)&&(m=A)}A.extension&&(!u||A.extension.length>u.extension.length)&&d.endsWith(A.extensionLowercase)&&(u=A)}return c?c.mime:m?m.mime:u?u.mime:null}function S(n){if((0,P.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let d=C.length-1;d>=0;d--){const a=C[d];if(!a.firstline)continue;const c=n.match(a.firstline);if(c&&c.length>0)return a.mime}return null}function T(n){return n?typeof n=="string"?n===D.binary||n===D.text||n===D.unknown:n.length===1&&T(n[0]):!0}e.isUnspecific=T;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(n){const d=(0,y.extname)(n),a=b[d.toLowerCase()];return a!==void 0?a:v(n)}e.getMediaOrTextMime=o;function v(n){const d=(0,y.extname)(n);return s[d.toLowerCase()]}e.getMediaMime=v;function t(n){for(const d in s)if(s[d]===n)return d}e.getExtensionForMimeType=t;const f=/^(.+)\/(.+?)(;.+)?$/;function r(n,d){const a=f.exec(n);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:d?void 0:n}e.normalizeMimeType=r}),define(fe[104],me([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class y{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:L(g.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:L(g.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:g.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function _(i,I,l){if(!i||l>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const h=_(i[p],I,l+1);h!==null&&(i[p]=h)}}return null}function P(i,I){const l=_(i,I,0);return l===null?i:l}e.transformOutgoingURIs=P;function D(i,I,l,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return l?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const w=D(i[h],I,l,p+1);w!==null&&(i[h]=w)}}return null}function C(i,I){const l=D(i,I,!1,0);return l===null?i:l}e.transformIncomingURIs=C;function k(i,I){const l=D(i,I,!0,0);return l===null?i:l}e.transformAndReviveIncomingURIs=k}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(C){return g.test(C)}e.isUUID=L;const y=new Uint8Array(16),_=[];for(let C=0;C<256;C++)_.push(C.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(C){for(let k=0;k<C.length;k++)C[k]=Math.floor(Math.random()*256);return C};function D(){P(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let C=0,k="";return k+=_[y[C++]],k+=_[y[C++]],k+=_[y[C++]],k+=_[y[C++]],k+="-",k+=_[y[C++]],k+=_[y[C++]],k+="-",k+=_[y[C++]],k+=_[y[C++]],k+="-",k+=_[y[C++]],k+=_[y[C++]],k+="-",k+=_[y[C++]],k+=_[y[C++]],k+=_[y[C++]],k+=_[y[C++]],k+=_[y[C++]],k+=_[y[C++]],k}e.generateUuid=D}),define(fe[143],me([0,1,105]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(_="utf8"){this.stringDecoder=new g.StringDecoder(_),this.remaining=null}write(_){const P=[],D=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(D.length<1)return P;let C=0,k,i=C;for(;i<D.length;)if(k=D.charCodeAt(i),k===13||k===10){if(P.push(D.substring(C,i)),i++,i<D.length){const I=k;k=D.charCodeAt(i),(I===13&&k===10||I===10&&k===13)&&i++}C=i}else i++;return this.remaining=C<D.length?D.substr(C):null,P}end(){return this.remaining}}e.LineDecoder=L}),define(fe[26],me([0,1,50,82,291,15,29,80,8,11,23,2,32]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(M,z=p.UNLINK){if((0,P.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?S(M):w(M)}async function w(M){try{const z=(0,C.join)((0,L.tmpdir)(),(0,l.generateUuid)());try{await e.Promises.rename(M,z)}catch(U){return S(M)}S(z).catch(U=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function S(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function T(M){if((0,P.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(M,{recursive:!0})}e.rimrafSync=T;async function b(M,z){return v(await(z?s(M):(0,y.promisify)(g.readdir)(M)))}async function s(M){try{return await(0,y.promisify)(g.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const z=[],U=await b(M);for(const x of U){let j=!1,O=!1,W=!1;try{const H=await e.Promises.lstat((0,C.join)(M,x));j=H.isFile(),O=H.isDirectory(),W=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}z.push({name:x,isFile:()=>j,isDirectory:()=>O,isSymbolicLink:()=>W})}return z}function o(M){return v(g.readdirSync(M))}e.readdirSync=o;function v(M){return M.map(z=>typeof z=="string"?k.isMacintosh?(0,D.normalizeNFC)(z):z:(z.name=k.isMacintosh?(0,D.normalizeNFC)(z.name):z.name,z))}async function t(M){const z=await b(M),U=[];for(const x of z)await r.existsDirectory((0,C.join)(M,x))&&U.push(x);return U}function f(M,z=1e3){return new Promise(U=>{let x=!1;const j=setInterval(()=>{x||(x=!0,g.access(M,O=>{x=!1,O&&(clearInterval(j),U(void 0))}))},z)})}e.whenDeleted=f;var r;(function(M){async function z(j){let O;try{if(O=await e.Promises.lstat(j),!O.isSymbolicLink())return{stat:O}}catch(W){}try{return{stat:await e.Promises.stat(j),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(k.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw H}throw W}}M.stat=z;async function U(j){try{const{stat:O,symbolicLink:W}=await M.stat(j);return O.isFile()&&W?.dangling!==!0}catch(O){}return!1}M.existsFile=U;async function x(j){try{const{stat:O,symbolicLink:W}=await M.stat(j);return O.isDirectory()&&W?.dangling!==!0}catch(O){}return!1}M.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new _.ResourceQueue;function d(M,z,U){return n.queueFor(I.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const x=u(U);return new Promise((j,O)=>c(M,z,x,W=>W?O(W):j()))})}let a=!0;function c(M,z,U,x){if(!a)return g.writeFile(M,z,{mode:U.mode,flag:U.flag},x);g.open(M,U.flag,U.mode,(j,O)=>{if(j)return x(j);g.writeFile(O,z,W=>{if(W)return g.close(O,()=>x(W));g.fdatasync(O,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),a=!1),g.close(O,X=>x(X))))})})}function m(M,z,U){const x=u(U);if(!a)return g.writeFileSync(M,z,{mode:x.mode,flag:x.flag});const j=g.openSync(M,x.flag,x.mode);try{g.writeFileSync(j,z);try{g.fdatasyncSync(j)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),a=!1}}finally{g.closeSync(j)}}e.writeFileSync=m;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function E(M,z){if(M===z)return;async function U(x){try{const j=await e.Promises.lstat(x);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes(x,j.atime,new Date)}catch(j){}}try{await e.Promises.rename(M,z),await U(z)}catch(x){if(M.toLowerCase()!==z.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await A(M,z,{preserveSymlinks:!1}),await h(M,p.MOVE),await U(z);else throw x}}async function A(M,z,U){return B(M,z,{root:{source:M,target:z},options:U,handledSourcePaths:new Set})}const R=511;async function B(M,z,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:x,symbolicLink:j}=await r.stat(M);if(j){if(U.options.preserveSymlinks)try{return await $(M,z,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(j.dangling)return}return x.isDirectory()?N(M,z,x.mode&R,U):F(M,z,x.mode&R)}async function N(M,z,U,x){await e.Promises.mkdir(z,{recursive:!0,mode:U});const j=await b(M);for(const O of j)await B((0,C.join)(M,O),(0,C.join)(z,O),x)}async function F(M,z,U){await e.Promises.copyFile(M,z),await e.Promises.chmod(z,U)}async function $(M,z,U){let x=await e.Promises.readlink(M);(0,P.isEqualOrParent)(x,U.root.source,!k.isLinux)&&(x=(0,C.join)(U.root.target,x.substr(U.root.source.length+1))),await e.Promises.symlink(x,z)}e.Promises=new class{get access(){return(0,y.promisify)(g.access)}get stat(){return(0,y.promisify)(g.stat)}get lstat(){return(0,y.promisify)(g.lstat)}get utimes(){return(0,y.promisify)(g.utimes)}get read(){return(0,y.promisify)(g.read)}get readFile(){return(0,y.promisify)(g.readFile)}get write(){return(0,y.promisify)(g.write)}get appendFile(){return(0,y.promisify)(g.appendFile)}get fdatasync(){return(0,y.promisify)(g.fdatasync)}get truncate(){return(0,y.promisify)(g.truncate)}get rename(){return(0,y.promisify)(g.rename)}get copyFile(){return(0,y.promisify)(g.copyFile)}get open(){return(0,y.promisify)(g.open)}get close(){return(0,y.promisify)(g.close)}get symlink(){return(0,y.promisify)(g.symlink)}get readlink(){return(0,y.promisify)(g.readlink)}get chmod(){return(0,y.promisify)(g.chmod)}get mkdir(){return(0,y.promisify)(g.mkdir)}get unlink(){return(0,y.promisify)(g.unlink)}get rmdir(){return(0,y.promisify)(g.rmdir)}get realpath(){return(0,y.promisify)(g.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return d}get rm(){return h}get move(){return E}get copy(){return A}}}),define(fe[106],me([0,1,50,8,9,26]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(i){const I=(0,L.dirname)(i);if(i===I)return i;const l=((0,L.basename)(i)||i).toLowerCase();try{const h=(0,_.readdirSync)(I).filter(w=>w.toLowerCase()===l);if(h.length===1){const w=P(I);if(w)return(0,L.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(l);if(w>=0){const S=P(I);if(S)return(0,L.join)(S,h[w])}}}catch(p){}return null}e.realcaseSync=P;async function D(i){try{return await _.Promises.realpath(i)}catch(I){const l=k(i);return await _.Promises.access(l,g.constants.R_OK),l}}e.realpath=D;function C(i){try{return g.realpathSync(i)}catch(I){const l=k(i);return g.accessSync(l,g.constants.R_OK),l}}e.realpathSync=C;function k(i){return(0,y.rtrim)((0,L.normalize)(i),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,g,L){var y=arguments.length,_=y<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(Y,e,g,L);else for(var D=Y.length-1;D>=0;D--)(P=Y[D])&&(_=(y<3?P(_):y>3?P(e,g,_):P(e,g))||_);return y>3&&_&&Object.defineProperty(e,g,_),_};define(fe[107],me([0,1,18,15,22,21,60,17,3,6,62,9,12]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function S(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var T;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(T||(T={}));class b{constructor(O){this.buffer=O,this.pos=0}read(O){const W=this.buffer.slice(this.pos,this.pos+O);return this.pos+=W.byteLength,W}}class s{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(o||(o={}));function v(j){const O=y.VSBuffer.alloc(4);return O.writeUInt32BE(j,0),O}function t(j){return j.read(4).readUInt32BE(0)}function f(j){const O=y.VSBuffer.alloc(1);return O.writeUInt8(j,0),O}const r={Undefined:f(o.Undefined),String:f(o.String),Buffer:f(o.Buffer),VSBuffer:f(o.VSBuffer),Array:f(o.Array),Object:f(o.Object)},n=typeof Buffer!="undefined";function d(j,O){if(typeof O=="undefined")j.write(r.Undefined);else if(typeof O=="string"){const W=y.VSBuffer.fromString(O);j.write(r.String),j.write(v(W.byteLength)),j.write(W)}else if(n&&Buffer.isBuffer(O)){const W=y.VSBuffer.wrap(O);j.write(r.Buffer),j.write(v(W.byteLength)),j.write(W)}else if(O instanceof y.VSBuffer)j.write(r.VSBuffer),j.write(v(O.byteLength)),j.write(O);else if(Array.isArray(O)){j.write(r.Array),j.write(v(O.length));for(const W of O)d(j,W)}else{const W=y.VSBuffer.fromString(JSON.stringify(O));j.write(r.Object),j.write(v(W.byteLength)),j.write(W)}}function a(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(t(j)).toString();case o.Buffer:return j.read(t(j)).buffer;case o.VSBuffer:return j.read(t(j));case o.Array:{const W=t(j),H=[];for(let X=0;X<W;X++)H.push(a(j));return H}case o.Object:return JSON.parse(j.read(t(j)).toString())}}class c{constructor(O,W,H=null,X=1e3){this.protocol=O,this.ctx=W,this.logger=H,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(O,W){this.channels.set(O,W),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const W=this.send([O.type]);this.logger&&this.logger.logOutgoing(W,0,1,S(O.type));return}case 201:case 202:case 204:case 203:{const W=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(W,O.id,1,S(O.type),O.data);return}}}send(O,W=void 0){const H=new s;return d(H,O),d(H,W),this.sendBuffer(H.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onRawMessage(O){const W=new b(O),H=a(W),X=a(W),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],1,`${h(K)}: ${H[2]}.${H[3]}`,X),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],1,`${h(K)}: ${H[2]}.${H[3]}`,X),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const H=new _.CancellationTokenSource;let X;try{X=W.call(this.ctx,O.name,O.arg,H.token)}catch(_e){X=Promise.reject(_e)}const K=O.id;X.then(_e=>{this.sendResponse({id:K,data:_e,type:201}),this.activeRequests.delete(O.id)},_e=>{_e instanceof Error?this.sendResponse({id:K,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:K,data:_e,type:203}),this.activeRequests.delete(O.id)});const de=(0,k.toDisposable)(()=>H.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const H=O.id,K=W.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:H,data:de,type:204}));this.activeRequests.set(O.id,K)}disposeActiveRequest(O){const W=this.activeRequests.get(O.id);W&&(W.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let W=this.pendingRequests.get(O.channelName);W||(W=[],this.pendingRequests.set(O.channelName,W));const H=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:O,timeoutTimer:H})}flushPendingRequests(O){const W=this.pendingRequests.get(O);if(W){for(const H of W)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var m;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(O,W=null){this.protocol=O,this.isDisposed=!1,this.state=T.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=W}getChannel(O){const W=this;return{call(H,X,K){return W.isDisposed?Promise.reject(D.canceled()):W.requestPromise(O,H,X,K)},listen(H,X){return W.isDisposed?Promise.reject(D.canceled()):W.requestEvent(O,H,X)}}}requestPromise(O,W,H,X=_.CancellationToken.None){const K=this.lastRequestId++,_e={id:K,type:100,channelName:O,name:W,arg:H};if(X.isCancellationRequested)return Promise.reject(D.canceled());let Ce;return new Promise((Be,$e)=>{if(X.isCancellationRequested)return $e(D.canceled());const He=()=>{const ce=Z=>{switch(Z.type){case 201:this.handlers.delete(K),Be(Z.data);break;case 202:this.handlers.delete(K);const se=new Error(Z.data.message);se.stack=Z.data.stack,se.name=Z.data.name,$e(se);break;case 203:this.handlers.delete(K),$e(Z.data);break}};this.handlers.set(K,ce),this.sendRequest(_e)};let G=null;this.state===T.Idle?He():(G=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),G.then(()=>{G=null,He()}));const ee=()=>{G?(G.cancel(),G=null):this.sendRequest({id:K,type:101}),$e(D.canceled())},te=X.onCancellationRequested(ee);Ce=(0,k.combinedDisposable)((0,k.toDisposable)(ee),te),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(O,W,H){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:W,arg:H};let _e=null;const Ce=new C.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Ce),this.sendRequest(de)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Ce),this.sendRequest({id:X,type:103}))}}),Pe=Be=>Ce.fire(Be.data);return this.handlers.set(X,Pe),Ce.event}sendRequest(O){switch(O.type){case 100:case 102:{const W=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(W,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const W=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(W,O.id,0,h(O.type));return}}}send(O,W=void 0){const H=new s;return d(H,O),d(H,W),this.sendBuffer(H.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onBuffer(O){const W=new b(O),H=a(W),X=a(W),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,S(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],0,S(K),X),this.onResponse({type:H[0],id:H[1],data:X})}}onResponse(O){if(O.type===200){this.state=T.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(O.id);W&&W(O)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===T.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([P.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class E{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:W,onDidClientDisconnect:H})=>{C.Event.once(W.onMessage)(K=>{const de=new b(K),_e=a(de),Ce=new c(W,_e),Pe=new u(W);this.channels.forEach(($e,He)=>Ce.registerChannel(He,$e));const Be={channelServer:Ce,channelClient:Pe,ctx:_e};this._connections.add(Be),this._onDidAddConnection.fire(Be),H(()=>{Ce.dispose(),Pe.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach(W=>O.push(W)),O}getChannel(O,W){const H=this;return{call(X,K,de){let _e;if((0,l.isFunction)(W)){let Pe=(0,g.getRandomElement)(H.connections.filter(W));_e=Pe?Promise.resolve(Pe):C.Event.toPromise(C.Event.filter(H.onDidAddConnection,W))}else _e=W.routeCall(H,X,K);const Ce=_e.then(Pe=>Pe.channelClient.getChannel(O));return R(Ce).call(X,K,de)},listen(X,K){if((0,l.isFunction)(W))return H.getMulticastEvent(O,W,X,K);const de=W.routeEvent(H,X,K).then(_e=>_e.channelClient.getChannel(O));return R(de).listen(X,K)}}}getMulticastEvent(O,W,H,X){const K=this;let de=new k.DisposableStore;const _e=new C.Emitter({onFirstListenerAdd:()=>{de=new k.DisposableStore;const Ce=new C.EventMultiplexer,Pe=new Map,Be=He=>{const ee=He.channelClient.getChannel(O).listen(H,X),te=Ce.add(ee);Pe.set(He,te)},$e=He=>{const G=Pe.get(He);!G||(G.dispose(),Pe.delete(He))};K.connections.filter(W).forEach(Be),C.Event.filter(K.onDidAddConnection,W)(Be,void 0,de),K.onDidRemoveConnection($e,void 0,de),Ce.event(_e.fire,_e,de),de.add(Ce)},onLastListenerRemove:()=>{de.dispose()}});return _e.event}registerChannel(O,W){this.channels.set(O,W),this._connections.forEach(H=>{H.channelServer.registerChannel(O,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class A{constructor(O,W,H=null){const X=new s;d(X,W),O.send(X.buffer),this.channelClient=new u(O,H),this.channelServer=new c(O,W,H)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,W){this.channelServer.registerChannel(O,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function R(j){return{call(O,W,H){return j.then(X=>X.call(O,W,H))},listen(O,W){const H=new C.Relay;return j.then(X=>H.input=X.listen(O,W)),H.event}}}e.getDelayedChannel=R;function B(j){let O=!1;return{call(W,H,X){return O?j.call(W,H,X):(0,L.timeout)(0).then(()=>O=!0).then(()=>j.call(W,H,X))},listen(W,H){if(O)return j.listen(W,H);const X=new C.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>X.input=j.listen(W,H)),X.event}}}e.getNextTickChannel=B;class N{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const W of O.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await C.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=N;var F;(function(j){function O(K,de){const _e=K,Ce=de&&de.disableMarshalling,Pe=new Map;for(const Be in _e)H(Be)&&Pe.set(Be,C.Event.buffer(_e[Be],!0));return new class{listen(Be,$e,He){const G=Pe.get($e);if(G)return G;if(X($e)){const ee=_e[$e];if(typeof ee=="function")return ee.call(_e,He)}throw new Error(`Event not found: ${$e}`)}call(Be,$e,He){const G=_e[$e];if(typeof G=="function"){if(!Ce&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,i.revive)(He[ee]);return G.apply(_e,He)}throw new Error(`Method not found: ${$e}`)}}}j.fromService=O;function W(K,de){const _e=de&&de.disableMarshalling;return new Proxy({},{get(Ce,Pe){if(typeof Pe=="string")return de?.properties?.has(Pe)?de.properties.get(Pe):X(Pe)?function(Be){return K.listen(Pe,Be)}:H(Pe)?K.listen(Pe):async function(...Be){let $e;de&&!(0,l.isUndefinedOrNull)(de.context)?$e=[de.context,...Be]:$e=Be;const He=await K.call(Pe,$e);return _e?He:(0,i.revive)(He)};throw new Error(`Property not found: ${String(Pe)}`)}})}j.toService=W;function H(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}function X(K){return/^onDynamic/.test(K)&&I.isUpperAsciiLetter(K.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let O=j.toString();if(O!=="[object Object]")return O}return j}function z(j){return Array.isArray(j)?j.map(M):M(j)}function U(j,O,W,H,X,K,de){de=z(de);const _e=$[X],Ce=_e[H%_e.length];let Pe=[`%c[${j}]%c[${String(O).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(K)?(Pe=Pe.concat(de),Pe.push(")")):Pe.push(de),console.log.apply(console,Pe)}e.logWithColors=U;class x{constructor(O,W){this._outgoingPrefix=O,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,W,H,X,K){this._totalOutgoing+=O,U(this._outgoingPrefix,this._totalOutgoing,O,W,H,X,K)}logIncoming(O,W,H,X,K){this._totalIncoming+=O,U(this._incomingPrefix,this._totalIncoming,O,W,H,X,K)}}e.IPCLogger=x}),define(fe[108],me([0,1,22,3,6,11,38,107]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var C;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function i(){return k||(k=g.VSBuffer.alloc(0)),k}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,d){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const u=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=n),u}if(this._chunks[0].byteLength>n){const u=this._chunks[0].slice(0,n);return d&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),u}let a=g.VSBuffer.alloc(n),c=0,m=0;for(;n>0;){const u=this._chunks[m];if(u.byteLength>n){const E=u.slice(0,n);a.set(E,c),c+=n,d&&(this._chunks[m]=u.slice(n),this._totalLength-=n),n-=n}else a.set(u,c),c+=u.byteLength,d?(this._chunks.shift(),this._totalLength-=u.byteLength):m++,n-=u.byteLength}return a}}e.ChunkStream=I;var l;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(l||(l={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(n,d,a,c){this.type=n,this.id=d,this.ack=a,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends y.Disposable{constructor(n){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5);else{const a=this._state.messageType,c=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(a,c,m,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=g.VSBuffer.alloc(13);d.writeUInt8(n.type,0),d.writeUInt32BE(n.id,1),d.writeUInt32BE(n.ack,5),d.writeUInt32BE(n.data.byteLength,9),this._writeSoon(d,n.data)}_bufferAdd(n,d){const a=this._totalLength===0;return this._data.push(n,d),this._totalLength+=n.byteLength+d.byteLength,a}_bufferTake(){const n=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,d){this._bufferAdd(n,d)&&_.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class T extends y.Disposable{constructor(n){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new h(1,0,0,n))}}e.Protocol=T;class b extends D.IPCClient{constructor(n,d,a=null){super(n,d,a);this.protocol=n}static fromSocket(n,d){return new b(new T(n),d)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=b;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class o{constructor(n){this.data=n,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],d=0,a=this._first;for(;a;)n[d++]=a.data,a=a.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const d=new o(n);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let d=0;d<t._HISTORY_LENGTH;d++)this.lastRuns[d]=n-1e3*d;setInterval(()=>{for(let d=t._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),d=(1+t._HISTORY_LENGTH)*1e3;let a=0;for(let c=0;c<t._HISTORY_LENGTH;c++)n-this.lastRuns[c]<=d&&a++;return 1-a/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class f{constructor(n,d=null,a=t.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),d&&this._socketReader.acceptChunk(d),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new h(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const d=new h(4,0,0,i());this._socketWriter.write(d),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,d){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let d=0,a=n.length;d<a;d++)this._socketWriter.write(n[d]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new h(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const d=this._outgoingUnackMsg.toArray();for(let a=0,c=d.length;a<c;a++)this._socketWriter.write(d[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,d,this._incomingAckId,n);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(n){const d=new h(2,0,0,n);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),d=Date.now()-n.writtenTime;if(d>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-d,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new h(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=f}),define(fe[109],me([0,1,100]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(D){let C=(0,g.toUint8)(D);this._defaultValue=C,this._asciiMap=L._createAsciiMap(C),this._map=new Map}static _createAsciiMap(D){let C=new Uint8Array(256);for(let k=0;k<256;k++)C[k]=D;return C}set(D,C){let k=(0,g.toUint8)(C);D>=0&&D<256?this._asciiMap[D]=k:this._map.set(D,k)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=L;var y;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(y||(y={}));class _{constructor(){this._actual=new L(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=_}),define(fe[144],me([0,1,109]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends g.CharacterClassifier{constructor(D){super(0);for(let C=0,k=D.length;C<k;C++)this.set(D.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function _(P){let D={};return C=>(D.hasOwnProperty(C)||(D[C]=P(C)),D[C])}e.getMapForWordSeparators=_(P=>new y(P))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(y,_){this.lineNumber=y,this.column=_}with(y=this.lineNumber,_=this.column){return y===this.lineNumber&&_===this.column?this:new g(y,_)}delta(y=0,_=0){return this.with(this.lineNumber+y,this.column+_)}equals(y){return g.equals(this,y)}static equals(y,_){return!y&&!_?!0:!!y&&!!_&&y.lineNumber===_.lineNumber&&y.column===_.column}isBefore(y){return g.isBefore(this,y)}static isBefore(y,_){return y.lineNumber<_.lineNumber?!0:_.lineNumber<y.lineNumber?!1:y.column<_.column}isBeforeOrEqual(y){return g.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,_){return y.lineNumber<_.lineNumber?!0:_.lineNumber<y.lineNumber?!1:y.column<=_.column}static compare(y,_){let P=y.lineNumber|0,D=_.lineNumber|0;if(P===D){let C=y.column|0,k=_.column|0;return C-k}return P-D}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new g(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=g}),define(fe[43],me([0,1,51]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(_,P,D,C){_>D||_===D&&P>C?(this.startLineNumber=D,this.startColumn=C,this.endLineNumber=_,this.endColumn=P):(this.startLineNumber=_,this.startColumn=P,this.endLineNumber=D,this.endColumn=C)}isEmpty(){return L.isEmpty(this)}static isEmpty(_){return _.startLineNumber===_.endLineNumber&&_.startColumn===_.endColumn}containsPosition(_){return L.containsPosition(this,_)}static containsPosition(_,P){return!(P.lineNumber<_.startLineNumber||P.lineNumber>_.endLineNumber||P.lineNumber===_.startLineNumber&&P.column<_.startColumn||P.lineNumber===_.endLineNumber&&P.column>_.endColumn)}containsRange(_){return L.containsRange(this,_)}static containsRange(_,P){return!(P.startLineNumber<_.startLineNumber||P.endLineNumber<_.startLineNumber||P.startLineNumber>_.endLineNumber||P.endLineNumber>_.endLineNumber||P.startLineNumber===_.startLineNumber&&P.startColumn<_.startColumn||P.endLineNumber===_.endLineNumber&&P.endColumn>_.endColumn)}strictContainsRange(_){return L.strictContainsRange(this,_)}static strictContainsRange(_,P){return!(P.startLineNumber<_.startLineNumber||P.endLineNumber<_.startLineNumber||P.startLineNumber>_.endLineNumber||P.endLineNumber>_.endLineNumber||P.startLineNumber===_.startLineNumber&&P.startColumn<=_.startColumn||P.endLineNumber===_.endLineNumber&&P.endColumn>=_.endColumn)}plusRange(_){return L.plusRange(this,_)}static plusRange(_,P){let D,C,k,i;return P.startLineNumber<_.startLineNumber?(D=P.startLineNumber,C=P.startColumn):P.startLineNumber===_.startLineNumber?(D=P.startLineNumber,C=Math.min(P.startColumn,_.startColumn)):(D=_.startLineNumber,C=_.startColumn),P.endLineNumber>_.endLineNumber?(k=P.endLineNumber,i=P.endColumn):P.endLineNumber===_.endLineNumber?(k=P.endLineNumber,i=Math.max(P.endColumn,_.endColumn)):(k=_.endLineNumber,i=_.endColumn),new L(D,C,k,i)}intersectRanges(_){return L.intersectRanges(this,_)}static intersectRanges(_,P){let D=_.startLineNumber,C=_.startColumn,k=_.endLineNumber,i=_.endColumn,I=P.startLineNumber,l=P.startColumn,p=P.endLineNumber,h=P.endColumn;return D<I?(D=I,C=l):D===I&&(C=Math.max(C,l)),k>p?(k=p,i=h):k===p&&(i=Math.min(i,h)),D>k||D===k&&C>i?null:new L(D,C,k,i)}equalsRange(_){return L.equalsRange(this,_)}static equalsRange(_,P){return!!_&&!!P&&_.startLineNumber===P.startLineNumber&&_.startColumn===P.startColumn&&_.endLineNumber===P.endLineNumber&&_.endColumn===P.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(_){return new g.Position(_.endLineNumber,_.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(_){return new g.Position(_.startLineNumber,_.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(_,P){return new L(this.startLineNumber,this.startColumn,_,P)}setStartPosition(_,P){return new L(_,P,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(_){return new L(_.startLineNumber,_.startColumn,_.startLineNumber,_.startColumn)}static fromPositions(_,P=_){return new L(_.lineNumber,_.column,P.lineNumber,P.column)}static lift(_){return _?new L(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn):null}static isIRange(_){return _&&typeof _.startLineNumber=="number"&&typeof _.startColumn=="number"&&typeof _.endLineNumber=="number"&&typeof _.endColumn=="number"}static areIntersectingOrTouching(_,P){return!(_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<P.startColumn||P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<_.startColumn)}static areIntersecting(_,P){return!(_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<=P.startColumn||P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<=_.startColumn)}static compareRangesUsingStarts(_,P){if(_&&P){const k=_.startLineNumber|0,i=P.startLineNumber|0;if(k===i){const I=_.startColumn|0,l=P.startColumn|0;if(I===l){const p=_.endLineNumber|0,h=P.endLineNumber|0;if(p===h){const w=_.endColumn|0,S=P.endColumn|0;return w-S}return p-h}return I-l}return k-i}return(_?1:0)-(P?1:0)}static compareRangesUsingEnds(_,P){return _.endLineNumber===P.endLineNumber?_.endColumn===P.endColumn?_.startLineNumber===P.startLineNumber?_.startColumn-P.startColumn:_.startLineNumber-P.startLineNumber:_.endColumn-P.endColumn:_.endLineNumber-P.endLineNumber}static spansMultipleLines(_){return _.endLineNumber>_.startLineNumber}}e.Range=L}),define(fe[145],me([0,1,51,43]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class _ extends L.Range{constructor(D,C,k,i){super(D,C,k,i);this.selectionStartLineNumber=D,this.selectionStartColumn=C,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return _.selectionsEqual(this,D)}static selectionsEqual(D,C){return D.selectionStartLineNumber===C.selectionStartLineNumber&&D.selectionStartColumn===C.selectionStartColumn&&D.positionLineNumber===C.positionLineNumber&&D.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,C){return this.getDirection()===0?new _(this.startLineNumber,this.startColumn,D,C):new _(D,C,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,C){return this.getDirection()===0?new _(D,C,this.endLineNumber,this.endColumn):new _(this.endLineNumber,this.endColumn,D,C)}static fromPositions(D,C=D){return new _(D.lineNumber,D.column,C.lineNumber,C.column)}static liftSelection(D){return new _(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,C){if(D&&!C||!D&&C)return!1;if(!D&&!C)return!0;if(D.length!==C.length)return!1;for(let k=0,i=D.length;k<i;k++)if(!this.selectionsEqual(D[k],C[k]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,C,k,i,I){return I===0?new _(D,C,k,i):new _(k,i,D,C)}}e.Selection=_}),define(fe[110],me([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var _;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class k{constructor(s,o){this._findMatchBrand=void 0,this.range=s,this.matches=o}}e.FindMatch=k;var i;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(b){b[b.Disabled=0]="Disabled",b[b.EnabledForActive=1]="EnabledForActive",b[b.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class l{constructor(s,o,v){this.visibleColumn=s,this.className=o,this.horizontalLine=v}}e.IndentGuide=l;class p{constructor(s,o){this.top=s,this.endColumn=o}}e.IndentGuideHorizontalLine=p;var h;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class S{constructor(s,o,v,t,f,r){this.identifier=s,this.range=o,this.text=v,this.forceMoveMarkers=t,this.isAutoWhitespaceEdit=f,this._isTracked=r}}e.ValidAnnotatedEditOperation=S;class T{constructor(s,o,v){this.reverseEdits=s,this.changes=o,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=T}),define(fe[146],me([0,1,9,144,51,43,110]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class C{constructor(s,o,v,t){this.searchString=s,this.isRegex=o,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=k(this.searchString):s=this.searchString.indexOf(`
`)>=0;let o=null;try{o=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(t){return null}if(!o)return null;let v=!this.isRegex&&!s;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(o,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=C;function k(b){if(!b||b.length===0)return!1;for(let s=0,o=b.length;s<o;s++)if(b.charCodeAt(s)===92){if(s++,s>=o)break;const t=b.charCodeAt(s);if(t===110||t===114||t===87)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(s,o,v){this.regex=s,this.wordSeparators=o,this.simpleSearch=v}}e.SearchData=i;function I(b,s,o){if(!o)return new P.FindMatch(b,null);let v=[];for(let t=0,f=s.length;t<f;t++)v[t]=s[t];return new P.FindMatch(b,v)}e.createFindMatch=I;class l{constructor(s){let o=[],v=0;for(let t=0,f=s.length;t<f;t++)s.charCodeAt(t)===10&&(o[v++]=t);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(s){const o=this._lineFeedsOffsets;let v=0,t=o.length-1;if(t===-1||s<=o[0])return 0;for(;v<t;){const f=v+((t-v)/2>>0);o[f]>=s?t=f-1:o[f+1]>=s?(v=f,t=f):v=f+1}return v+1}}class p{static findMatches(s,o,v,t,f){const r=o.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(s,v,new T(r.wordSeparators,r.regex),t,f):this._doFindMatchesLineByLine(s,v,r,t,f):[]}static _getMultilineMatchRange(s,o,v,t,f,r){let n,d=0;t?(d=t.findLineFeedCountBeforeOffset(f),n=o+f+d):n=o+f;let a;if(t){let E=t.findLineFeedCountBeforeOffset(f+r.length)-d;a=n+r.length+E}else a=n+r.length;const c=s.getPositionAt(n),m=s.getPositionAt(a);return new _.Range(c.lineNumber,c.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(s,o,v,t,f){const r=s.getOffsetAt(o.getStartPosition()),n=s.getValueInRange(o,1),d=s.getEOL()===`\r
`?new l(n):null,a=[];let c=0,m;for(v.reset(0);m=v.next(n);)if(a[c++]=I(this._getMultilineMatchRange(s,r,n,d,m.index,m[0]),m,t),c>=f)return a;return a}static _doFindMatchesLineByLine(s,o,v,t,f){const r=[];let n=0;if(o.startLineNumber===o.endLineNumber){const a=s.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return n=this._findMatchesInLine(v,a,o.startLineNumber,o.startColumn-1,n,r,t,f),r}const d=s.getLineContent(o.startLineNumber).substring(o.startColumn-1);n=this._findMatchesInLine(v,d,o.startLineNumber,o.startColumn-1,n,r,t,f);for(let a=o.startLineNumber+1;a<o.endLineNumber&&n<f;a++)n=this._findMatchesInLine(v,s.getLineContent(a),a,0,n,r,t,f);if(n<f){const a=s.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);n=this._findMatchesInLine(v,a,o.endLineNumber,0,n,r,t,f)}return r}static _findMatchesInLine(s,o,v,t,f,r,n,d){const a=s.wordSeparators;if(!n&&s.simpleSearch){const u=s.simpleSearch,E=u.length,A=o.length;let R=-E;for(;(R=o.indexOf(u,R+E))!==-1;)if((!a||S(a,o,A,R,E))&&(r[f++]=new P.FindMatch(new _.Range(v,R+1+t,v,R+1+E+t),null),f>=d))return f;return f}const c=new T(s.wordSeparators,s.regex);let m;c.reset(0);do if(m=c.next(o),m&&(r[f++]=I(new _.Range(v,m.index+1+t,v,m.index+1+m[0].length+t),m,n),f>=d))return f;while(m);return f}static findNextMatch(s,o,v,t){const f=o.parseSearchRequest();if(!f)return null;const r=new T(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindNextMatchMultiline(s,v,r,t):this._doFindNextMatchLineByLine(s,v,r,t)}static _doFindNextMatchMultiline(s,o,v,t){const f=new y.Position(o.lineNumber,1),r=s.getOffsetAt(f),n=s.getLineCount(),d=s.getValueInRange(new _.Range(f.lineNumber,f.column,n,s.getLineMaxColumn(n)),1),a=s.getEOL()===`\r
`?new l(d):null;v.reset(o.column-1);let c=v.next(d);return c?I(this._getMultilineMatchRange(s,r,d,a,c.index,c[0]),c,t):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(s,new y.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(s,o,v,t){const f=s.getLineCount(),r=o.lineNumber,n=s.getLineContent(r),d=this._findFirstMatchInLine(v,n,r,o.column,t);if(d)return d;for(let a=1;a<=f;a++){const c=(r+a-1)%f,m=s.getLineContent(c+1),u=this._findFirstMatchInLine(v,m,c+1,1,t);if(u)return u}return null}static _findFirstMatchInLine(s,o,v,t,f){s.reset(t-1);const r=s.next(o);return r?I(new _.Range(v,r.index+1,v,r.index+1+r[0].length),r,f):null}static findPreviousMatch(s,o,v,t){const f=o.parseSearchRequest();if(!f)return null;const r=new T(f.wordSeparators,f.regex);return f.regex.multiline?this._doFindPreviousMatchMultiline(s,v,r,t):this._doFindPreviousMatchLineByLine(s,v,r,t)}static _doFindPreviousMatchMultiline(s,o,v,t){const f=this._doFindMatchesMultiline(s,new _.Range(1,1,o.lineNumber,o.column),v,t,10*D);if(f.length>0)return f[f.length-1];const r=s.getLineCount();return o.lineNumber!==r||o.column!==s.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(s,new y.Position(r,s.getLineMaxColumn(r)),v,t):null}static _doFindPreviousMatchLineByLine(s,o,v,t){const f=s.getLineCount(),r=o.lineNumber,n=s.getLineContent(r).substring(0,o.column-1),d=this._findLastMatchInLine(v,n,r,t);if(d)return d;for(let a=1;a<=f;a++){const c=(f+r-a-1)%f,m=s.getLineContent(c+1),u=this._findLastMatchInLine(v,m,c+1,t);if(u)return u}return null}static _findLastMatchInLine(s,o,v,t){let f=null,r;for(s.reset(0);r=s.next(o);)f=I(new _.Range(v,r.index+1,v,r.index+1+r[0].length),r,t);return f}}e.TextModelSearch=p;function h(b,s,o,v,t){if(v===0)return!0;const f=s.charCodeAt(v-1);if(b.get(f)!==0||f===13||f===10)return!0;if(t>0){const r=s.charCodeAt(v);if(b.get(r)!==0)return!0}return!1}function w(b,s,o,v,t){if(v+t===o)return!0;const f=s.charCodeAt(v+t);if(b.get(f)!==0||f===13||f===10)return!0;if(t>0){const r=s.charCodeAt(v+t-1);if(b.get(r)!==0)return!0}return!1}function S(b,s,o,v,t){return h(b,s,o,v,t)&&w(b,s,o,v,t)}e.isValidMatch=S;class T{constructor(s,o){this._wordSeparators=s,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const o=s.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(v=this._searchRegex.exec(s),!v))return null;const t=v.index,f=v[0].length;if(t===this._prevMatchStartIndex&&f===this._prevMatchLength){if(f===0){g.getNextCodePoint(s,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=f,!this._wordSeparators||S(this._wordSeparators,s,o,t,f))return v}while(v);return null}}e.Searcher=T}),define(fe[111],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(D=""){let C="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)D.indexOf(k)>=0||(C+="\\"+k);return C+="\\s]+)",new RegExp(C,"g")}e.DEFAULT_WORD_REGEXP=g();function L(D){let C=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)C=D;else{let k="g";D.ignoreCase&&(k+="i"),D.multiline&&(k+="m"),D.unicode&&(k+="u"),C=new RegExp(D.source,k)}return C.lastIndex=0,C}e.ensureValidWordDefinition=L;const y={maxLen:1e3,windowSize:15,timeBudget:150};function _(D,C,k,i,I=y){if(k.length>I.maxLen){let S=D-I.maxLen/2;return S<0?S=0:i+=S,k=k.substring(S,D+I.maxLen/2),_(D,C,k,i,I)}const l=Date.now(),p=D-1-i;let h=-1,w=null;for(let S=1;!(Date.now()-l>=I.timeBudget);S++){const T=p-I.windowSize*S;C.lastIndex=Math.max(0,T);const b=P(C,k,p,h);if(!b&&w||(w=b,T<=0))break;h=T}if(w){let S={word:w[0],startColumn:i+1+w.index,endColumn:i+1+w.index+w[0].length};return C.lastIndex=0,S}return null}e.getWordAtText=_;function P(D,C,k,i){let I;for(;I=D.exec(C);){const l=I.index||0;if(l<=k&&D.lastIndex>=k)return I;if(i>0&&l>i)return null}return null}}),define(fe[147],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(D){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let C=0,k=D.notIn.length;C<k;C++)switch(D.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=L;class y{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of D)_(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),_(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),_(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),_(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&_(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=y;function _(P,D,C){P.has(D)?P.get(D).push(C):P.set(D,[C])}}),define(fe[83],me([0,1,30,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(_,P,D,C){if(Array.isArray(_)){let k=0;for(const i of _){const I=y(i,P,D,C);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof _=="string")return C?_==="*"?5:_===D?10:0:0;if(_){const{language:k,pattern:i,scheme:I,hasAccessToAllModels:l}=_;if(!C&&!l)return 0;let p=0;if(I)if(I===P.scheme)p=10;else if(I==="*")p=5;else return 0;if(k)if(k===D)p=10;else if(k==="*")p=Math.max(p,5);else return 0;if(i){let h;if(typeof i=="string"?h=i:h={...i,base:(0,L.normalize)(i.base)},h===P.fsPath||(0,g.match)(h,P.fsPath))p=10;else return 0}return p}else return 0}}e.score=y}),define(fe[148],me([0,1,109]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class y{constructor(h,w,S){const T=new Uint8Array(h*w);for(let b=0,s=h*w;b<s;b++)T[b]=S;this._data=T,this.rows=h,this.cols=w}get(h,w){return this._data[h*this.cols+w]}set(h,w,S){this._data[h*this.cols+w]=S}}e.Uint8Matrix=y;class _{constructor(h){let w=0,S=0;for(let b=0,s=h.length;b<s;b++){let[o,v,t]=h[b];v>w&&(w=v),o>S&&(S=o),t>S&&(S=t)}w++,S++;let T=new y(S,w,0);for(let b=0,s=h.length;b<s;b++){let[o,v,t]=h[b];T.set(o,v,t)}this._states=T,this._maxCharCode=w}nextState(h,w){return w<0||w>=this._maxCharCode?0:this._states.get(h,w)}}e.StateMachine=_;let P=null;function D(){return P===null&&(P=new _([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var C;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(C||(C={}));let k=null;function i(){if(k===null){k=new g.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<p.length;w++)k.set(p.charCodeAt(w),1);const h=".,;";for(let w=0;w<h.length;w++)k.set(h.charCodeAt(w),2)}return k}class I{static _createLink(h,w,S,T,b){let s=b-1;do{const o=w.charCodeAt(s);if(h.get(o)!==2)break;s--}while(s>T);if(T>0){const o=w.charCodeAt(T-1),v=w.charCodeAt(s);(o===40&&v===41||o===91&&v===93||o===123&&v===125)&&s--}return{range:{startLineNumber:S,startColumn:T+1,endLineNumber:S,endColumn:s+2},url:w.substring(T,s+1)}}static computeLinks(h,w=D()){const S=i();let T=[];for(let b=1,s=h.getLineCount();b<=s;b++){const o=h.getLineContent(b),v=o.length;let t=0,f=0,r=0,n=1,d=!1,a=!1,c=!1,m=!1;for(;t<v;){let u=!1;const E=o.charCodeAt(t);if(n===13){let A;switch(E){case 40:d=!0,A=0;break;case 41:A=d?0:1;break;case 91:c=!0,a=!0,A=0;break;case 93:c=!1,A=a?0:1;break;case 123:m=!0,A=0;break;case 125:A=m?0:1;break;case 39:A=r===34||r===96?0:1;break;case 34:A=r===39||r===96?0:1;break;case 96:A=r===39||r===34?0:1;break;case 42:A=r===42?1:0;break;case 124:A=r===124?1:0;break;case 32:A=c?0:1;break;default:A=S.get(E)}A===1&&(T.push(I._createLink(S,o,b,f,t)),u=!0)}else if(n===12){let A;E===91?(a=!0,A=0):A=S.get(E),A===1?u=!0:n=13}else n=w.nextState(n,E),n===0&&(u=!0);u&&(n=1,d=!1,a=!1,m=!1,f=t+1,r=E),t++}n===13&&T.push(I._createLink(S,o,b,f,v))}return T}}e.LinkComputer=I;function l(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:I.computeLinks(p)}e.computeLinks=l}),define(fe[149],me([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,D){return this._map.set(P,D),this.fire([P]),(0,L.toDisposable)(()=>{this._map.get(P)===D&&(this._map.delete(P),this.fire([P]))})}registerPromise(P,D){let C=null,k=!1;return this._promises.set(P,D.then(i=>{this._promises.delete(P),!(k||!i)&&(C=this.register(P,i))})),(0,L.toDisposable)(()=>{k=!0,C&&C.dispose()})}getPromise(P){const D=this.get(P);if(D)return Promise.resolve(D);const C=this._promises.get(P);return C?C.then(k=>this.get(P)):null}get(P){return this._map.get(P)||null}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(fe[112],me([0,1,22,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(y||(y={}));function _(I){for(let l=0,p=I.length;l<p;l+=4){const h=I[l+0],w=I[l+1],S=I[l+2],T=I[l+3];I[l+0]=T,I[l+1]=S,I[l+2]=w,I[l+3]=h}}function P(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||_(l),g.VSBuffer.wrap(l)}function D(I){const l=I.buffer;if(L.isLittleEndian()||_(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function C(I){const l=new Uint32Array(k(I));let p=0;if(l[p++]=I.id,I.type==="full")l[p++]=1,l[p++]=I.data.length,l.set(I.data,p),p+=I.data.length;else{l[p++]=2,l[p++]=I.deltas.length;for(const h of I.deltas)l[p++]=h.start,l[p++]=h.deleteCount,h.data?(l[p++]=h.data.length,l.set(h.data,p),p+=h.data.length):l[p++]=0}return P(l)}e.encodeSemanticTokensDto=C;function k(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const p of I.deltas)p.data&&(l+=p.data.length)}return l}function i(I){const l=D(I);let p=0;const h=l[p++];if(l[p++]===1){const b=l[p++],s=l.subarray(p,p+b);return p+=b,{id:h,type:"full",data:s}}const S=l[p++];let T=[];for(let b=0;b<S;b++){const s=l[p++],o=l[p++],v=l[p++];let t;v>0&&(t=l.subarray(p,p+v),p+=v),T[b]={start:s,deleteCount:o,data:t}}return{id:h,type:"delta",deltas:T}}e.decodeSemanticTokensDto=i}),define(fe[113],me([0,1,100]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(P,D){this._prefixSumIndexOfResultBrand=void 0,this.index=P,this.remainder=D}}e.PrefixSumIndexOfResult=L;class y{constructor(P){this.values=P,this.prefixSum=new Uint32Array(P.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(P,D){P=(0,g.toUint32)(P);const C=this.values,k=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(C.length+i),this.values.set(C.subarray(0,P),0),this.values.set(C.subarray(P),P+i),this.values.set(D,P),P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(P,D){return P=(0,g.toUint32)(P),D=(0,g.toUint32)(D),this.values[P]===D?!1:(this.values[P]=D,P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),!0)}removeValues(P,D){P=(0,g.toUint32)(P),D=(0,g.toUint32)(D);const C=this.values,k=this.prefixSum;if(P>=C.length)return!1;let i=C.length-P;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(C.length-D),this.values.set(C.subarray(0,P),0),this.values.set(C.subarray(P+D),P),this.prefixSum=new Uint32Array(this.values.length),P-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=P-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(P){return P<0?0:(P=(0,g.toUint32)(P),this._getPrefixSum(P))}_getPrefixSum(P){if(P<=this.prefixSumValidIndex[0])return this.prefixSum[P];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),P>=this.values.length&&(P=this.values.length-1);for(let C=D;C<=P;C++)this.prefixSum[C]=this.prefixSum[C-1]+this.values[C];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],P),this.prefixSum[P]}getIndexOf(P){P=Math.floor(P),this.getTotalSum();let D=0,C=this.values.length-1,k=0,i=0,I=0;for(;D<=C;)if(k=D+(C-D)/2|0,i=this.prefixSum[k],I=i-this.values[k],P<I)C=k-1;else if(P>=i)D=k+1;else break;return new L(k,P-I)}}e.PrefixSumComputer=y}),define(fe[150],me([0,1,9,51,113]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class _{constructor(D,C,k,i){this._uri=D,this._lines=C,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const C=D.changes;for(const k of C)this._acceptDeleteRange(k.range),this._acceptInsertText(new L.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,C=this._lines.length,k=new Uint32Array(C);for(let i=0;i<C;i++)k[i]=this._lines[i].length+D;this._lineStarts=new y.PrefixSumComputer(k)}}_setLineText(D,C){this._lines[D]=C,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,C){if(C.length===0)return;let k=(0,g.splitLines)(C);if(k.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}k[k.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(D.lineNumber+I-1,0,k[I]),i[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}e.MirrorTextModel=_}),define(fe[151],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[152],me([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,y=L*60,_=y*24,P=_*7,D=_*30,C=_*365;function k(I,l){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,g.localize)(0,null,k(new Date().getTime()+p*1e3,!1));if(p<30)return(0,g.localize)(1,null);let h;return p<L?(h=p,l?h===1?(0,g.localize)(2,null,h):(0,g.localize)(3,null,h):h===1?(0,g.localize)(4,null,h):(0,g.localize)(5,null,h)):p<y?(h=Math.floor(p/L),l?h===1?(0,g.localize)(6,null,h):(0,g.localize)(7,null,h):h===1?(0,g.localize)(8,null,h):(0,g.localize)(9,null,h)):p<_?(h=Math.floor(p/y),l?h===1?(0,g.localize)(10,null,h):(0,g.localize)(11,null,h):h===1?(0,g.localize)(12,null,h):(0,g.localize)(13,null,h)):p<P?(h=Math.floor(p/_),l?h===1?(0,g.localize)(14,null,h):(0,g.localize)(15,null,h):h===1?(0,g.localize)(16,null,h):(0,g.localize)(17,null,h)):p<D?(h=Math.floor(p/P),l?h===1?(0,g.localize)(18,null,h):(0,g.localize)(19,null,h):h===1?(0,g.localize)(20,null,h):(0,g.localize)(21,null,h)):p<C?(h=Math.floor(p/D),l?h===1?(0,g.localize)(22,null,h):(0,g.localize)(23,null,h):h===1?(0,g.localize)(24,null,h):(0,g.localize)(25,null,h)):(h=Math.floor(p/C),l?h===1?(0,g.localize)(26,null,h):(0,g.localize)(27,null,h):h===1?(0,g.localize)(28,null,h):(0,g.localize)(29,null,h))}e.fromNow=k;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(fe[153],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[52],me([0,1,18,12,153]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(k,i){return i&&(k.stack||k.stacktrace)?y.localize(0,null,D(k),P(k.stack)||P(k.stacktrace)):D(k)}function P(k){return Array.isArray(k)?k.join(`
`):k}function D(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?y.localize(1,null,k.message):k.message||y.localize(2,null)}function C(k=null,i=!1){if(!k)return y.localize(3,null);if(Array.isArray(k)){const I=g.coalesce(k),l=C(I[0],i);return I.length>1?y.localize(4,null,l,I.length):l}if(L.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return _(I.error,i);if(I.exception)return _(I.exception,i)}return k.stack?_(k,i):k.message?k.message:y.localize(5,null)}e.toErrorMessage=C}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[114],me([0,1,39,29,10,25,8,11,38,96,12,143,26,154]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function h(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(t,f){if(D.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};f&&(r.cwd=f);const n=g.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],r);return new Promise(d=>{n.once("error",a=>{d({success:!1,error:a})}),n.once("exit",(a,c)=>{d(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(D.isLinux||D.isMacintosh)try{const r=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(n=>{g.execFile(r,[t.pid.toString()],{encoding:"utf8",shell:!0},(d,a,c)=>{n(d?{success:!1,error:d}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function S(t){!t||(delete t.DEBUG,D.isMacintosh&&delete t.DYLD_LIBRARY_PATH,D.isLinux&&delete t.LD_PRELOAD)}e.removeDangerousEnvVariables=S;function T(t=C.env){return t.comspec||"cmd.exe"}e.getWindowsShell=T;class b{constructor(f,r,n,d){if(r!==void 0&&n!==void 0&&d!==void 0)this.cmd=f,this.args=r,this.shell=n,this.options=d;else{const a=f;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(C.env).forEach(c=>{a[c]=C.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const r=f.lastIndexOf(P.sep);return r!==-1&&(f=f.substring(r+1)),b.WellKnowCommands[f]?f:"other"}start(f){return D.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(C.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let n,d;const a=new Promise((c,m)=>{n=c,d=m});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=g.exec(c,this.options,(m,u,E)=>{this.childProcess=null;const A=m;A&&A.killed?d({killed:this.terminateRequested,stdout:u.toString(),stderr:E.toString()}):this.handleExec(n,f,m,u,E)})}else{let c=null;const m=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,n,f,d);const E={terminated:this.terminateRequested};i.isNumber(u)&&(E.cmdCode=u),n(E)};if(this.shell&&D.isWindows){const u=_.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let E=!1,A=!1;const R=[];let B=this.ensureQuotes(this.cmd);R.push(B.value),E=B.quoted,this.args&&this.args.forEach(F=>{B=this.ensureQuotes(F),R.push(B.value),A=A&&B.quoted});const N=["/s","/c"];E?A?N.push('"'+R.join(" ")+'"'):R.length>1?N.push('"'+R[0]+'" '+R.slice(1).join(" ")):N.push('"'+R[0]+'"'):N.push(R.join(" ")),c=g.spawn(T(),N,u)}else this.cmd&&(c=g.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(i.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",u=>{this.childProcess=null,d({terminated:this.terminateRequested,error:u})}),c.pid&&(this.childProcess.on("close",m),this.handleSpawn(c,n,f,d,!0)))}return a})}handleClose(f,r,n,d){}ensureQuotes(f){return b.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,w(f,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!D.isWindows)return f(!1);const r=g.spawn(T(),["/s","/c"]);r.on("error",n=>f(!0)),r.on("exit",n=>f(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class s extends b{constructor(f,r,n,d){super(f,r,n,d);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,r,n,d,a){[d,a].forEach((c,m)=>{const u=new I.LineDecoder;u.write(c).forEach(R=>{r({line:R,source:m===0?0:1})});const A=u.end();A&&r({line:A,source:m===0?0:1})}),f({terminated:this.terminateRequested,error:n})}handleSpawn(f,r,n,d,a){const c=new I.LineDecoder,m=new I.LineDecoder;f.stdout.on("data",u=>{c.write(u).forEach(A=>n({line:A,source:0}))}),f.stderr.on("data",u=>{m.write(u).forEach(A=>n({line:A,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=m}handleClose(f,r,n,d){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&n({line:c,source:1})}}e.LineProcess=s;function o(t){let f=[],r=!1;const n=function(d){if(r){f.push(d);return}(!t.send(d,c=>{if(c&&console.error(c),r=!1,f.length>0){const m=f.slice(0);f=[],m.forEach(u=>n(u))}})||D.isWindows)&&(r=!0)};return{send:n}}e.createQueuedSender=o;var v;(function(t){async function f(r,n,d){if(P.isAbsolute(r))return r;if(n===void 0&&(n=C.cwd()),P.dirname(r)!=="."||(d===void 0&&i.isString(C.env.PATH)&&(d=C.env.PATH.split(P.delimiter)),d===void 0||d.length===0))return P.join(n,r);async function c(m){if(await l.Promises.exists(m)){let u;try{u=await l.Promises.stat(m)}catch(E){E.message.startsWith("EACCES")&&(u=await l.Promises.lstat(m))}return u?!u.isDirectory():!1}return!1}for(let m of d){let u;if(P.isAbsolute(m)?u=P.join(m,r):u=P.join(n,m,r),await c(u))return u;let E=u+".com";if(await c(E)||(E=u+".exe",await c(E)))return E}return P.join(n,r)}t.findExecutable=f})(v=e.win32||(e.win32={}))}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[115],me([0,1,155,11,111]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var _;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(_=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=P;class D{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,Ee){this._values[ie]=Ee}}e.ValidatedEditorOptions=D;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class k{constructor(ie,Ee,Qe,et){this.id=ie,this.name=Ee,this.defaultValue=Qe,this.schema=et}compute(ie,Ee,Qe){return Qe}}class i{constructor(ie,Ee=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ie){return this.defaultValue}}class I{constructor(ie,Ee,Qe,et){this.id=ie,this.name=Ee,this.defaultValue=Qe,this.schema=et}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Ee,Qe){return Qe}}function l(J,ie){return typeof J=="undefined"?ie:J==="false"?!1:Boolean(J)}e.boolean=l;class p extends I{constructor(ie,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="boolean",et.default=Qe),super(ie,Ee,Qe,et)}validate(ie){return l(ie,this.defaultValue)}}function h(J,ie,Ee,Qe){if(typeof J=="undefined")return ie;let et=parseInt(J,10);return isNaN(et)?ie:(et=Math.max(Ee,et),et=Math.min(Qe,et),et|0)}e.clampedInt=h;class w extends I{constructor(ie,Ee,Qe,et,le,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="integer",Ie.default=Qe,Ie.minimum=et,Ie.maximum=le),super(ie,Ee,Qe,Ie),this.minimum=et,this.maximum=le}static clampedInt(ie,Ee,Qe,et){return h(ie,Ee,Qe,et)}validate(ie){return w.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class S extends I{constructor(ie,Ee,Qe,et,le){typeof le!="undefined"&&(le.type="number",le.default=Qe),super(ie,Ee,Qe,le),this.validationFn=et}static clamp(ie,Ee,Qe){return ie<Ee?Ee:ie>Qe?Qe:ie}static float(ie,Ee){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Ee;const Qe=parseFloat(ie);return isNaN(Qe)?Ee:Qe}validate(ie){return this.validationFn(S.float(ie,this.defaultValue))}}class T extends I{static string(ie,Ee){return typeof ie!="string"?Ee:ie}constructor(ie,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="string",et.default=Qe),super(ie,Ee,Qe,et)}validate(ie){return T.string(ie,this.defaultValue)}}function b(J,ie,Ee){return typeof J!="string"||Ee.indexOf(J)===-1?ie:J}e.stringSet=b;class s extends I{constructor(ie,Ee,Qe,et,le=void 0){typeof le!="undefined"&&(le.type="string",le.enum=et,le.default=Qe),super(ie,Ee,Qe,le),this._allowedValues=et}validate(ie){return b(ie,this.defaultValue,this._allowedValues)}}class o extends k{constructor(ie,Ee,Qe,et,le,Ie,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=le,Ue.default=et),super(ie,Ee,Qe,Ue),this._allowedValues=le,this._convert=Ie}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function v(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Ee,Qe){return Qe===0?ie.accessibilitySupport:Qe}}class f extends k{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertSpace:l(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(J){switch(J){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function c(J){switch(J){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class m extends i{constructor(){super(126,[65,33])}compute(ie,Ee,Qe){const et=["monaco-editor"];return Ee.get(33)&&et.push(Ee.get(33)),ie.extraEditorClassName&&et.push(ie.extraEditorClassName),Ee.get(65)==="default"?et.push("mouse-default"):Ee.get(65)==="copy"&&et.push("mouse-copy"),Ee.get(99)&&et.push("showUnused"),Ee.get(124)&&et.push("showDeprecated"),et.join(" ")}}class u extends p{constructor(){super(32,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ie,Ee,Qe){return Qe&&ie.emptySelectionClipboard}}class E extends k{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:g.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{cursorMoveOnType:l(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":b(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":b(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(Ee.loop,this.defaultValue.loop)}}}class A extends k{constructor(){super(44,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?A.OFF:ie==="true"?A.ON:ie:Boolean(ie)?A.ON:A.OFF}}e.EditorFontLigatures=A,A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on';class R extends i{constructor(){super(43)}compute(ie,Ee,Qe){return ie.fontInfo}}class B extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(ie){let Ee=S.float(ie,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:S.clamp(Ee,6,100)}compute(ie,Ee,Qe){return ie.fontInfo.fontSize}}class N extends k{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:N.MINIMUM_VALUE,maximum:N.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:N.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(w.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,N.MINIMUM_VALUE,N.MAXIMUM_VALUE))}}N.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],N.MINIMUM_VALUE=1,N.MAXIMUM_VALUE=1e3;class F extends k{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Qe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Qe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Qe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Qe,description:g.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{multiple:b(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??b(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??b(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??b(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??b(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??b(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:T.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:T.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:T.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:T.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:T.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends k{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:g.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:g.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:l(Ee.enabled,this.defaultValue.enabled),delay:w.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:l(Ee.sticky,this.defaultValue.sticky),above:l(Ee.above,this.defaultValue.above)}}}var M;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class z extends i{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(ie,Ee,Qe){return z.computeLayout(Ee,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Ee=ie.height/ie.lineHeight,Qe=ie.scrollBeyondLastLine?Ee-1:0,et=(ie.viewLineCount+Qe)/(ie.pixelRatio*ie.height),le=Math.floor(ie.viewLineCount/et);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Qe,desiredRatio:et,minimapLineCount:le}}static _computeMinimapLayout(ie,Ee){const Qe=ie.outerWidth,et=ie.outerHeight,le=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(le*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const Ie=Ee.stableMinimapLayoutInput,Ue=Ie&&ie.outerHeight===Ie.outerHeight&&ie.lineHeight===Ie.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ie.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ie.pixelRatio&&ie.scrollBeyondLastLine===Ie.scrollBeyondLastLine&&ie.minimap.enabled===Ie.minimap.enabled&&ie.minimap.side===Ie.minimap.side&&ie.minimap.size===Ie.minimap.size&&ie.minimap.showSlider===Ie.minimap.showSlider&&ie.minimap.renderCharacters===Ie.minimap.renderCharacters&&ie.minimap.maxColumn===Ie.minimap.maxColumn&&ie.minimap.scale===Ie.minimap.scale&&ie.verticalScrollbarWidth===Ie.verticalScrollbarWidth&&ie.isViewportWrapping===Ie.isViewportWrapping,Xe=ie.lineHeight,it=ie.typicalHalfwidthCharacterWidth,ft=ie.scrollBeyondLastLine,tt=ie.minimap.renderCharacters;let ut=le>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const Re=ie.minimap.maxColumn,De=ie.minimap.size,Te=ie.minimap.side,oe=ie.verticalScrollbarWidth,ue=ie.viewLineCount,we=ie.remainingWidth,ve=ie.isViewportWrapping,Fe=tt?2:3;let Ge=Math.floor(le*et);const ze=Ge/le;let Ye=!1,lt=!1,xe=Fe*ut,ge=ut/le,be=1;if(De==="fill"||De==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:Et,desiredRatio:pt,minimapLineCount:vt}=z.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:ft,height:et,lineHeight:Xe,pixelRatio:le});if(ue/vt>1)Ye=!0,lt=!0,ut=1,xe=1,ge=ut/le;else{let Dt=!1,Ct=ut+1;if(De==="fit"){const Tt=Math.ceil((ue+Et)*xe);ve&&Ue&&we<=Ee.stableFitRemainingWidth?(Dt=!0,Ct=Ee.stableFitMaxMinimapScale):Dt=Tt>Ge}if(De==="fill"||Dt){Ye=!0;const Tt=ut;xe=Math.min(Xe*le,Math.max(1,Math.floor(1/pt))),ve&&Ue&&we<=Ee.stableFitRemainingWidth&&(Ct=Ee.stableFitMaxMinimapScale),ut=Math.min(Ct,Math.max(1,Math.floor(xe/Fe))),ut>Tt&&(be=Math.min(2,ut/Tt)),ge=ut/le/be,Ge=Math.ceil(Math.max(gt,ue+Et)*xe),ve?(Ee.stableMinimapLayoutInput=ie,Ee.stableFitRemainingWidth=we,Ee.stableFitMaxMinimapScale=ut):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const re=Math.floor(Re*ge),Q=Math.min(re,Math.max(0,Math.floor((we-oe-2)*ge/(it+ge)))+e.MINIMAP_GUTTER_WIDTH);let Se=Math.floor(le*Q);const Le=Se/le;Se=Math.floor(Se*be);const nt=tt?1:2,qe=Te==="left"?0:Qe-Q-oe;return{renderMinimap:nt,minimapLeft:qe,minimapWidth:Q,minimapHeightIsEditorHeight:Ye,minimapIsSampling:lt,minimapScale:ut,minimapLineHeight:xe,minimapCanvasInnerWidth:Se,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:ze}}static computeLayout(ie,Ee){const Qe=Ee.outerWidth|0,et=Ee.outerHeight|0,le=Ee.lineHeight|0,Ie=Ee.lineNumbersDigitCount|0,Ue=Ee.typicalHalfwidthCharacterWidth,Xe=Ee.maxDigitWidth,it=Ee.pixelRatio,ft=Ee.viewLineCount,tt=ie.get(121),ut=tt==="inherit"?ie.get(120):tt,Re=ut==="inherit"?ie.get(116):ut,De=ie.get(119),Te=ie.get(2),oe=Ee.isDominatedByLongLines,ue=ie.get(49),we=ie.get(59).renderType!==0,ve=ie.get(60),Fe=ie.get(93),Ge=ie.get(64),ze=ie.get(91),Ye=ze.verticalScrollbarSize,lt=ze.verticalHasArrows,xe=ze.arrowSize,ge=ze.horizontalScrollbarSize,be=ie.get(57),re=ie.get(37);let Q;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const Ut=parseFloat(be.substr(0,be.length-2));Q=w.clampedInt(Ut*Ue,0,0,1e3)}else Q=w.clampedInt(be,0,0,1e3);re&&(Q+=16);let Se=0;if(we){const Ut=Math.max(Ie,ve);Se=Math.round(Ut*Xe)}let Le=0;ue&&(Le=le);let nt=0,qe=nt+Le,gt=qe+Se,Et=gt+Q;const pt=Qe-Le-Se-Q;let vt=!1,wt=!1,Dt=-1;Te!==2&&(ut==="inherit"&&oe?(vt=!0,wt=!0):Re==="on"||Re==="bounded"?wt=!0:Re==="wordWrapColumn"&&(Dt=De));const Ct=z._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:le,typicalHalfwidthCharacterWidth:Ue,pixelRatio:it,scrollBeyondLastLine:Fe,minimap:Ge,verticalScrollbarWidth:Ye,viewLineCount:ft,remainingWidth:pt,isViewportWrapping:wt},Ee.memory||new C);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(nt+=Ct.minimapWidth,qe+=Ct.minimapWidth,gt+=Ct.minimapWidth,Et+=Ct.minimapWidth);const Tt=pt-Ct.minimapWidth,Nt=Math.max(1,Math.floor((Tt-Ye-2)/Ue)),It=lt?xe:0;return wt&&(Dt=Math.max(1,Nt),Re==="bounded"&&(Dt=Math.min(Dt,De))),{width:Qe,height:et,glyphMarginLeft:nt,glyphMarginWidth:Le,lineNumbersLeft:qe,lineNumbersWidth:Se,decorationsLeft:gt,decorationsWidth:Q,contentLeft:Et,contentWidth:Tt,minimap:Ct,viewportColumn:Nt,isWordWrapMinified:vt,isViewportWrapping:wt,wrappingColumn:Dt,verticalScrollbarWidth:Ye,horizontalScrollbarHeight:ge,overviewRuler:{top:It,width:Ye,height:et-2*It,right:0}}}}e.EditorLayoutInfoComputer=z;class U extends k{constructor(){const ie={enabled:!0};super(56,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:g.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class x extends k{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:g.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:g.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:l(Ee.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:T.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class j extends S{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>S.clamp(ie,0,150),{markdownDescription:g.localize(47,null)})}compute(ie,Ee,Qe){return ie.fontInfo.lineHeight}}class O extends k{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:g.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(49,null),g.localize(50,null),g.localize(51,null)],default:ie.size,description:g.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:g.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:g.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:g.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:g.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:l(Ee.enabled,this.defaultValue.enabled),size:b(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(Ee.side,this.defaultValue.side,["right","left"]),showSlider:b(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(Ee.scale,1,1,3),maxColumn:w.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function W(J){return J==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class H extends k{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{top:w.clampedInt(Ee.top,0,0,1e3),bottom:w.clampedInt(Ee.bottom,0,0,1e3)}}}class X extends k{constructor(){const ie={enabled:!0,cycle:!1};super(75,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:g.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:l(Ee.enabled,this.defaultValue.enabled),cycle:l(Ee.cycle,this.defaultValue.cycle)}}}class K extends i{constructor(){super(127)}compute(ie,Ee,Qe){return ie.pixelRatio}}class de extends k{constructor(){const ie={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:g.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:g.localize(63,null)},other:{type:"boolean",default:ie.other,description:g.localize(64,null)}}}],default:ie,description:g.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Ee=ie,Qe={other:l(Ee.other,this.defaultValue.other),comments:l(Ee.comments,this.defaultValue.comments),strings:l(Ee.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var _e;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ce extends k{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null),g.localize(69,null)],default:"on",description:g.localize(70,null)})}validate(ie){let Ee=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Ee=4,Qe=ie):ie==="interval"?Ee=3:ie==="relative"?Ee=2:ie==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Qe}}}function Pe(J){const ie=J.get(86);return ie==="editable"?J.get(80):ie!=="on"}e.filterValidationDecorations=Pe;class Be extends k{constructor(){const ie=[],Ee={type:"number",description:g.localize(71,null)};super(90,"rulers",ie,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:g.localize(72,null),format:"color-hex"}}}]},default:ie,description:g.localize(73,null)})}validate(ie){if(Array.isArray(ie)){let Ee=[];for(let Qe of ie)if(typeof Qe=="number")Ee.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;Ee.push({column:w.clampedInt(et.column,0,0,1e4),color:et.color})}return Ee.sort((Qe,et)=>Qe.column-et.column),Ee}return this.defaultValue}}function $e(J,ie){if(typeof J!="string")return ie;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends k{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(78,null),g.localize(79,null),g.localize(80,null)],default:"auto",description:g.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:g.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:g.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie,Qe=w.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=w.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$e(Ee.vertical,this.defaultValue.vertical),horizontal:$e(Ee.horizontal,this.defaultValue.horizontal),useShadows:l(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(Ee.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:w.clampedInt(Ee.verticalSliderSize,et,0,1e3),scrollByPage:l(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class G extends k{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:g.localize(85,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:l(Ee.enabled,this.defaultValue.enabled),mode:b(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends k{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:g.localize(86,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class te extends k{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(87,null),g.localize(88,null),g.localize(89,null)],default:ie.bracketPairs,description:g.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(91,null),g.localize(92,null),g.localize(93,null)],default:ie.bracketPairsHorizontal,description:g.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:g.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:g.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:g.localize(97,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{bracketPairs:ce(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:l(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ce(J,ie,Ee){const Qe=Ee.indexOf(J);return Qe===-1?ie:Ee[Qe]}class Z extends k{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(98,null),g.localize(99,null)],default:ie.insertMode,description:g.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:g.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:g.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:g.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:g.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:g.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:g.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:g.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:g.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(139,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertMode:b(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:l(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:l(Ee.preview,this.defaultValue.preview),previewMode:b(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(Ee.showMethods,this.defaultValue.showMethods),showFunctions:l(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:l(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:l(Ee.showFields,this.defaultValue.showFields),showVariables:l(Ee.showVariables,this.defaultValue.showVariables),showClasses:l(Ee.showClasses,this.defaultValue.showClasses),showStructs:l(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:l(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:l(Ee.showModules,this.defaultValue.showModules),showProperties:l(Ee.showProperties,this.defaultValue.showProperties),showEvents:l(Ee.showEvents,this.defaultValue.showEvents),showOperators:l(Ee.showOperators,this.defaultValue.showOperators),showUnits:l(Ee.showUnits,this.defaultValue.showUnits),showValues:l(Ee.showValues,this.defaultValue.showValues),showConstants:l(Ee.showConstants,this.defaultValue.showConstants),showEnums:l(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:l(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(Ee.showKeywords,this.defaultValue.showKeywords),showWords:l(Ee.showWords,this.defaultValue.showWords),showColors:l(Ee.showColors,this.defaultValue.showColors),showFiles:l(Ee.showFiles,this.defaultValue.showFiles),showReferences:l(Ee.showReferences,this.defaultValue.showReferences),showFolders:l(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:l(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:l(Ee.showUsers,this.defaultValue.showUsers),showIssues:l(Ee.showIssues,this.defaultValue.showIssues)}}}class se extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(140,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends i{constructor(){super(128,[80])}compute(ie,Ee,Qe){return Ee.get(80)?!0:ie.tabFocusMode}}var Me;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Me=e.WrappingIndent||(e.WrappingIndent={}));function je(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends i{constructor(){super(130,[129])}compute(ie,Ee,Qe){const et=Ee.get(129);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}const Ze="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?rt:L.isLinux?ct:Ze,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(J){return e.editorOptionsRegistry[J.id]=J,J}var at;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(141,null)})),acceptSuggestionOnEnter:ye(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(142,null),""],markdownDescription:g.localize(143,null)})),accessibilitySupport:ye(new t),accessibilityPageSize:ye(new w(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(144,null)})),ariaLabel:ye(new T(4,"ariaLabel",g.localize(145,null))),autoClosingBrackets:ye(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(146,null),g.localize(147,null),""],description:g.localize(148,null)})),autoClosingDelete:ye(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(149,null),""],description:g.localize(150,null)})),autoClosingOvertype:ye(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(151,null),""],description:g.localize(152,null)})),autoClosingQuotes:ye(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(153,null),g.localize(154,null),""],description:g.localize(155,null)})),autoIndent:ye(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[g.localize(156,null),g.localize(157,null),g.localize(158,null),g.localize(159,null),g.localize(160,null)],description:g.localize(161,null)})),automaticLayout:ye(new p(10,"automaticLayout",!1)),autoSurround:ye(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(162,null),g.localize(163,null),g.localize(164,null),""],description:g.localize(165,null)})),bracketPairColorization:ye(new ee),bracketPairGuides:ye(new te),stickyTabStops:ye(new p(103,"stickyTabStops",!1,{description:g.localize(166,null)})),codeLens:ye(new p(14,"codeLens",!0,{description:g.localize(167,null)})),codeLensFontFamily:ye(new T(15,"codeLensFontFamily","",{description:g.localize(168,null)})),codeLensFontSize:ye(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(169,null)})),colorDecorators:ye(new p(17,"colorDecorators",!0,{description:g.localize(170,null)})),columnSelection:ye(new p(18,"columnSelection",!1,{description:g.localize(171,null)})),comments:ye(new f),contextmenu:ye(new p(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new p(21,"copyWithSyntaxHighlighting",!0,{description:g.localize(172,null)})),cursorBlinking:ye(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:g.localize(173,null)})),cursorSmoothCaretAnimation:ye(new p(23,"cursorSmoothCaretAnimation",!1,{description:g.localize(174,null)})),cursorStyle:ye(new o(24,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:g.localize(175,null)})),cursorSurroundingLines:ye(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(176,null)})),cursorSurroundingLinesStyle:ye(new s(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(177,null),g.localize(178,null)],description:g.localize(179,null)})),cursorWidth:ye(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(180,null)})),disableLayerHinting:ye(new p(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new p(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new p(30,"domReadOnly",!1)),dragAndDrop:ye(new p(31,"dragAndDrop",!0,{description:g.localize(181,null)})),emptySelectionClipboard:ye(new u),extraEditorClassName:ye(new T(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new S(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:g.localize(182,null)})),find:ye(new E),fixedOverflowWidgets:ye(new p(36,"fixedOverflowWidgets",!1)),folding:ye(new p(37,"folding",!0,{description:g.localize(183,null)})),foldingStrategy:ye(new s(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(184,null),g.localize(185,null)],description:g.localize(186,null)})),foldingHighlight:ye(new p(39,"foldingHighlight",!0,{description:g.localize(187,null)})),foldingImportsByDefault:ye(new p(40,"foldingImportsByDefault",!1,{description:g.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new p(41,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(189,null)})),fontFamily:ye(new T(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(190,null)})),fontInfo:ye(new R),fontLigatures2:ye(new A),fontSize:ye(new B),fontWeight:ye(new N),formatOnPaste:ye(new p(47,"formatOnPaste",!1,{description:g.localize(191,null)})),formatOnType:ye(new p(48,"formatOnType",!1,{description:g.localize(192,null)})),glyphMargin:ye(new p(49,"glyphMargin",!0,{description:g.localize(193,null)})),gotoLocation:ye(new F),hideCursorInOverviewRuler:ye(new p(51,"hideCursorInOverviewRuler",!1,{description:g.localize(194,null)})),hover:ye(new $),inDiffEditor:ye(new p(53,"inDiffEditor",!1)),letterSpacing:ye(new S(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>S.clamp(J,-5,20),{description:g.localize(195,null)})),lightbulb:ye(new U),lineDecorationsWidth:ye(new I(57,"lineDecorationsWidth",10)),lineHeight:ye(new j),lineNumbers:ye(new Ce),lineNumbersMinChars:ye(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new p(61,"linkedEditing",!1,{description:g.localize(196,null)})),links:ye(new p(62,"links",!0,{description:g.localize(197,null)})),matchBrackets:ye(new s(63,"matchBrackets","always",["always","near","never"],{description:g.localize(198,null)})),minimap:ye(new O),mouseStyle:ye(new s(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new S(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:g.localize(199,null)})),mouseWheelZoom:ye(new p(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(200,null)})),multiCursorMergeOverlapping:ye(new p(68,"multiCursorMergeOverlapping",!0,{description:g.localize(201,null)})),multiCursorModifier:ye(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),multiCursorPaste:ye(new s(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(205,null),g.localize(206,null)],markdownDescription:g.localize(207,null)})),occurrencesHighlight:ye(new p(71,"occurrencesHighlight",!0,{description:g.localize(208,null)})),overviewRulerBorder:ye(new p(72,"overviewRulerBorder",!0,{description:g.localize(209,null)})),overviewRulerLanes:ye(new w(73,"overviewRulerLanes",3,0,3)),padding:ye(new H),parameterHints:ye(new X),peekWidgetDefaultFocus:ye(new s(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(210,null),g.localize(211,null)],description:g.localize(212,null)})),definitionLinkOpensInPeek:ye(new p(77,"definitionLinkOpensInPeek",!1,{description:g.localize(213,null)})),quickSuggestions:ye(new de),quickSuggestionsDelay:ye(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(214,null)})),readOnly:ye(new p(80,"readOnly",!1)),renameOnType:ye(new p(81,"renameOnType",!1,{description:g.localize(215,null),markdownDeprecationMessage:g.localize(216,null)})),renderControlCharacters:ye(new p(82,"renderControlCharacters",!0,{description:g.localize(217,null),restricted:!0})),renderFinalNewline:ye(new p(83,"renderFinalNewline",!0,{description:g.localize(218,null)})),renderLineHighlight:ye(new s(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(219,null)],description:g.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new p(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(221,null)})),renderValidationDecorations:ye(new s(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new s(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(222,null),g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),revealHorizontalRightPadding:ye(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new p(89,"roundedSelection",!0,{description:g.localize(226,null)})),rulers:ye(new Be),scrollbar:ye(new He),scrollBeyondLastColumn:ye(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(227,null)})),scrollBeyondLastLine:ye(new p(93,"scrollBeyondLastLine",!0,{description:g.localize(228,null)})),scrollPredominantAxis:ye(new p(94,"scrollPredominantAxis",!0,{description:g.localize(229,null)})),selectionClipboard:ye(new p(95,"selectionClipboard",!0,{description:g.localize(230,null),included:L.isLinux})),selectionHighlight:ye(new p(96,"selectionHighlight",!0,{description:g.localize(231,null)})),selectOnLineNumbers:ye(new p(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new s(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),showUnused:ye(new p(99,"showUnused",!0,{description:g.localize(235,null)})),showDeprecated:ye(new p(124,"showDeprecated",!0,{description:g.localize(236,null)})),inlayHints:ye(new x),snippetSuggestions:ye(new s(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(237,null),g.localize(238,null),g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),smartSelect:ye(new se),smoothScrolling:ye(new p(102,"smoothScrolling",!1,{description:g.localize(242,null)})),stopRenderingLineAfter:ye(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new Z),inlineSuggest:ye(new G),suggestFontSize:ye(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(243,null)})),suggestLineHeight:ye(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(244,null)})),suggestOnTriggerCharacters:ye(new p(108,"suggestOnTriggerCharacters",!0,{description:g.localize(245,null)})),suggestSelection:ye(new s(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(246,null),g.localize(247,null),g.localize(248,null)],description:g.localize(249,null)})),tabCompletion:ye(new s(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),tabIndex:ye(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new s(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null)],description:g.localize(257,null)})),useShadowDOM:ye(new p(113,"useShadowDOM",!0)),useTabStops:ye(new p(114,"useTabStops",!0,{description:g.localize(258,null)})),wordSeparators:ye(new T(115,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:g.localize(259,null)})),wordWrap:ye(new s(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new T(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new T(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(265,null)})),wordWrapOverride1:ye(new s(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new s(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new o(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[g.localize(266,null),g.localize(267,null),g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),wrappingStrategy:ye(new s(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(271,null),g.localize(272,null)],description:g.localize(273,null)})),editorClassName:ye(new m),pixelRatio:ye(new K),tabFocusMode:ye(new pe),layoutInfo:ye(new z),wrappingInfo:ye(new Ke)}}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[180],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var y;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var _;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(_=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[181],me([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function _(l){return l=l.trim(),l==="*"||L.test(l)}e.isValidVersionStr=_;function P(l){if(!_(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=l.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=P;function D(l){if(!l)return null;let p=l.majorBase,h=l.majorMustEqual,w=l.minorBase,S=l.minorMustEqual,T=l.patchBase,b=l.patchMustEqual;l.hasCaret&&(p===0||(S=!1),b=!1);let s=0;if(l.preRelease){const o=y.exec(l.preRelease);if(o){const[,v,t,f]=o;s=Date.UTC(Number(v),Number(t)-1,Number(f))}}return{majorBase:p,majorMustEqual:h,minorBase:w,minorMustEqual:S,patchBase:T,patchMustEqual:b,isMinimum:l.hasGreaterEquals,notBefore:s}}e.normalizeVersion=D;function C(l,p,h){let w;typeof l=="string"?w=D(P(l)):w=l;let S;p instanceof Date?S=p.getTime():typeof p=="string"&&(S=new Date(p).getTime());let T;if(typeof h=="string"?T=D(P(h)):T=h,!w||!T)return!1;let b=w.majorBase,s=w.minorBase,o=w.patchBase,v=T.majorBase,t=T.minorBase,f=T.patchBase,r=T.notBefore,n=T.majorMustEqual,d=T.minorMustEqual,a=T.patchMustEqual;return T.isMinimum?b>v?!0:b<v?!1:s>t?!0:s<t||S&&S<r?!1:o>=f:(b===1&&v===0&&(!n||!d||!a)&&(v=1,t=0,f=0,n=!0,d=!1,a=!1),b<v?!1:b>v?!n:s<t?!1:s>t?!d:o<f?!1:o>f?!a:!(S&&S<r))}e.isValidVersion=C;function k(l,p,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:I(l,p,h.engines.vscode,w)}e.isValidExtensionVersion=k;function i(l,p,h){return l==="*"||I(p,h,l)}e.isEngineValid=i;function I(l,p,h,w=[]){let S=D(P(h));if(!S)return w.push(g.localize(0,null,h)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return w.push(g.localize(1,null,h)),!1}else if(!S.majorMustEqual)return w.push(g.localize(2,null,h)),!1;return C(l,p,S)?!0:(w.push(g.localize(3,null,l,h)),!1)}}),define(fe[116],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(y,_=[],P=!1){this.ctor=y,this.staticArguments=_,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=g}),define(fe[84],me([0,1,116]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function y(P,D,C){D instanceof g.SyncDescriptor||(D=new g.SyncDescriptor(D,[],C)),L.push([P,D])}e.registerSingleton=y;function _(){return L}e.getSingletonServiceDescriptors=_}),define(fe[182],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=g;class L{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let P of this._nodes.values())P.outgoing.size===0&&_.push(P);return _}insertEdge(_,P){const D=this.lookupOrInsertNode(_),C=this.lookupOrInsertNode(P);D.outgoing.set(this._hashFn(P),C),C.incoming.set(this._hashFn(_),D)}removeNode(_){const P=this._hashFn(_);this._nodes.delete(P);for(let D of this._nodes.values())D.outgoing.delete(P),D.incoming.delete(P)}lookupOrInsertNode(_){const P=this._hashFn(_);let D=this._nodes.get(P);return D||(D=new g(_),this._nodes.set(P,D)),D}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[P,D]of this._nodes)_.push(`${P}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,P]of this._nodes){const D=new Set([_]),C=this._findCycle(P,D);if(C)return C}}_findCycle(_,P){for(let[D,C]of _.outgoing){if(P.has(D))return[...P,D].join(" -> ");P.add(D);const k=this._findCycle(C,P);if(k)return k;P.delete(D)}}}e.Graph=L}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function C(k){return k[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=C})(g=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function L(D,C,k,i){C[g.DI_TARGET]===C?C[g.DI_DEPENDENCIES].push({id:D,index:k,optional:i}):(C[g.DI_DEPENDENCIES]=[{id:D,index:k,optional:i}],C[g.DI_TARGET]=C)}function y(D){if(g.serviceIds.has(D))return g.serviceIds.get(D);const C=function(k,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(C,k,I,!1)};return C.toString=()=>D,g.serviceIds.set(D,C),C}e.createDecorator=y;function _(D){return D}e.refineServiceDecorator=_;function P(D){return function(C,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(D,C,i,!0)}}e.optional=P}),define(fe[183],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(fe[184],me([0,1,3,48,6,24,79,83,183]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(k):!!w.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(S,T){let b={selector:S,provider:T,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(b){let s=this._entries.indexOf(b);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(S){return this.all(S).length>0}all(S){if(!S)return[];this._updateScores(S);const T=[];for(let b of this._entries)b._score>0&&T.push(b.provider);return T}ordered(S){const T=[];return this._orderedForEach(S,b=>T.push(b.provider)),T}orderedGroups(S){const T=[];let b,s;return this._orderedForEach(S,o=>{b&&s===o._score?b.push(o.provider):(s=o._score,b=[o.provider],T.push(b))}),T}_orderedForEach(S,T){if(!!S){this._updateScores(S);for(const b of this._entries)b._score>0&&T(b)}}_updateScores(S){let T={uri:S.uri.toString(),language:S.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let b of this._entries)if(b._score=(0,D.score)(b.selector,S.uri,S.getLanguageId(),(0,C.shouldSynchronizeModel)(S)),k(b.selector)&&b._score>0){for(let s of this._entries)s._score=0;b._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(S,T){return S._score<T._score?1:S._score>T._score?-1:S._time<T._time?1:S._time>T._time?-1:0}}e.LanguageFeatureRegistry=i;const I=new WeakMap;let l=0;function p(w){let S=I.get(w);return S===void 0&&(S=++l,I.set(w,S)),S}class h{constructor(S,T,b=Number.MAX_SAFE_INTEGER){this._registry=S,this.min=T,this.max=b,this._cache=new _.LRUCache(50,.7)}_key(S){return S.id+this._registry.all(S).reduce((T,b)=>(0,L.doHash)(p(b),T),0)}_clamp(S){return S===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(S*1.3)))}get(S){const T=this._key(S),b=this._cache.get(T);return this._clamp(b?.value)}update(S,T){const b=this._key(S);let s=this._cache.get(b);return s||(s=new P.MovingAverage,this._cache.set(b,s)),s.update(T),this.get(S)}}e.LanguageFeatureRequestDelays=h}),define(fe[85],me([0,1,2,43,184,149,47]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var D;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));var C;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var k;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(k=e.ColorId||(e.ColorId={}));var i;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(i=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let A=this.getForeground(E),R="mtk"+A,B=this.getFontStyle(E);return B&1&&(R+=" mtki"),B&2&&(R+=" mtkb"),B&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(E,A){const R=this.getForeground(E),B=this.getFontStyle(E);let N=`color: ${A[R]};`;return B&1&&(N+="font-style: italic;"),B&2&&(N+="font-weight: bold;"),B&4&&(N+="text-decoration: underline;"),N}}e.TokenMetadata=l;var p;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(E){const A=u[E];let R=A&&P.iconRegistry.get(A);return R||(console.info("No codicon found for CompletionItemKind "+E),R=P.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(E,A){let R=u[E];return typeof R=="undefined"&&!A&&(R=9),R}}();var h;(function(u){u[u.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var S;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(S=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var T;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(T=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var o;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(o=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&g.URI.isUri(u.uri)&&L.Range.isIRange(u.range)&&(L.Range.isIRange(u.originSelectionRange)||L.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var t;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var f;(function(u){u[u.Deprecated=1]="Deprecated"})(f=e.SymbolTag||(e.SymbolTag={}));var r;(function(u){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function R(F){return E.get(F)}u.fromString=R;function B(F){return A.get(F)}u.toString=B;function N(F,$){const M=A.get(F);let z=M&&P.iconRegistry.get("symbol-"+M);return z||(console.info("No codicon found for SymbolKind "+F),z=P.Codicon.symbolProperty),`${$?"inline":"block"} ${z.classNames}`}u.toCssClassName=N})(r=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(E){this.value=E}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var d;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var c;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new _.TokenizationRegistryImpl;var m;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(m=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[63],me([0,1,11,9,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=g.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",g.isMacintosh),P.set("isLinux",g.isLinux),P.set("isWindows",g.isWindows),P.set("isWeb",g.isWeb),P.set("isMacNative",g.isMacintosh&&!g.isWeb),P.set("isEdge",_.indexOf("Edg/")>=0),P.set("isFirefox",_.indexOf("Firefox")>=0),P.set("isChrome",_.indexOf("Chrome")>=0),P.set("isSafari",_.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var C;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return l.INSTANCE}static true(){return p.INSTANCE}static has(F){return h.create(F)}static equals(F,$){return w.create(F,$)}static notEquals(F,$){return b.create(F,$)}static regex(F,$){return n.create(F,$)}static in(F,$){return S.create(F,$)}static not(F){return s.create(F)}static and(...F){return c.create(F,null)}static or(...F){return m.create(F,null,!0)}static greater(F,$){return v.create(F,$)}static greaterEquals(F,$){return t.create(F,$)}static smaller(F,$){return f.create(F,$)}static smallerEquals(F,$){return r.create(F,$)}static deserialize(F,$=!1){if(!!F)return this._deserializeOrExpression(F,$)}static _deserializeOrExpression(F,$){let M=F.split("||");return m.create(M.map(z=>this._deserializeAndExpression(z,$)),null,!0)}static _deserializeAndExpression(F,$){let M=F.split("&&");return c.create(M.map(z=>this._deserializeOne(z,$)),null)}static _deserializeOne(F,$){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return b.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("==")>=0){let M=F.split("==");return w.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("=~")>=0){let M=F.split("=~");return n.create(M[0].trim(),this._deserializeRegexValue(M[1],$))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return S.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return v.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return f.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,$){if((0,L.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),z=F.lastIndexOf("/");if(M===z||M<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let U=F.slice(M+1,z),x=F[z+1]==="i"?"i":"";try{return new RegExp(U,x)}catch(j){if($)throw new Error(`bad regexp-value '${F}', parse error: ${j}`);return console.warn(`bad regexp-value '${F}', parse error: ${j}`),null}}}e.ContextKeyExpr=k;function i(N,F){const $=N?N.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!$&&!M?!0:!$||!M?!1:$.equals(M)}e.expressionsAreEqualWithConstantSubstitution=i;function I(N,F){return N.cmp(F)}class l{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=l,l.INSTANCE=new l;class p{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(F,$){this.key=F,this.negated=$,this.type=2}static create(F,$=null){const M=P.get(F);return typeof M=="boolean"?M?p.INSTANCE:l.INSTANCE:new h(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?p.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=4}static create(F,$,M=null){if(typeof $=="boolean")return $?h.create(F,M):s.create(F,M);const z=P.get(F);return typeof z=="boolean"?$===(z?"true":"false")?p.INSTANCE:l.INSTANCE:new w(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?p.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class S{constructor(F,$){this.key=F,this.valueKey=$,this.type=10,this.negated=null}static create(F,$){return new S(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray($)?$.indexOf(M)>=0:typeof M=="string"&&typeof $=="object"&&$!==null?D.call($,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=T.create(this)),this.negated}}e.ContextKeyInExpr=S;class T{constructor(F){this._actual=F,this.type=11}static create(F){return new T(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new T(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=T;class b{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=5}static create(F,$,M=null){if(typeof $=="boolean")return $?s.create(F,M):h.create(F,M);const z=P.get(F);return typeof z=="boolean"?$===(z?"true":"false")?l.INSTANCE:p.INSTANCE:new b(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?l.INSTANCE:p.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class s{constructor(F,$){this.key=F,this.negated=$,this.type=3}static create(F,$=null){const M=P.get(F);return typeof M=="boolean"?M?l.INSTANCE:p.INSTANCE:new s(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?l.INSTANCE:p.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function o(N,F){if(typeof N=="string"){const $=parseFloat(N);isNaN($)||(N=$)}return typeof N=="string"||typeof N=="number"?F(N):l.INSTANCE}class v{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=12}static create(F,$,M=null){return o($,z=>new v(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=v;class t{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=13}static create(F,$,M=null){return o($,z=>new t(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=t;class f{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=14}static create(F,$,M=null){return o($,z=>new f(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=f;class r{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=15}static create(F,$,M=null){return o($,z=>new r(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class n{constructor(F,$){this.key=F,this.regexp=$,this.type=7,this.negated=null}static create(F,$){return new n(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return $<M?-1:$>M?1:0}equals(F){if(F.type===this.type){const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&$===M}return!1}substituteConstants(){return this}evaluate(F){let $=F.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class d{constructor(F){this._actual=F,this.type=8}static create(F){return new d(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new d(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=d;function a(N){let F=null;for(let $=0,M=N.length;$<M;$++){const z=N[$].substituteConstants();if(N[$]!==z&&F===null){F=[];for(let U=0;U<$;U++)F[U]=N[U]}F!==null&&(F[$]=z)}return F===null?N:F}class c{constructor(F,$){this.expr=F,this.negated=$,this.type=6}static create(F,$){return c._normalizeArr(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const z=I(this.expr[$],F.expr[$]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=a(this.expr);return F===this.expr?this:c.create(F,this.negated)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static _normalizeArr(F,$){const M=[];let z=!1;for(const U of F)if(!!U){if(U.type===1){z=!0;continue}if(U.type===0)return l.INSTANCE;if(U.type===6){M.push(...U.expr);continue}M.push(U)}if(M.length===0&&z)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let U=1;U<M.length;U++)M[U-1].equals(M[U])&&(M.splice(U,1),U--);if(M.length===1)return M[0];for(;M.length>1;){const U=M[M.length-1];if(U.type!==9)break;M.pop();const x=M.pop(),j=M.length===0,O=m.create(U.expr.map(W=>c.create([W,x],null)),null,j);O&&(M.push(O),M.sort(I))}return M.length===1?M[0]:new c(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new c(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){const F=[];for(let $ of this.expr)F.push($.negate());this.negated=m.create(F,this,!0)}return this.negated}}class m{constructor(F,$){this.expr=F,this.negated=$,this.type=9}static create(F,$,M){return m._normalizeArr(F,$,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const z=I(this.expr[$],F.expr[$]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=a(this.expr);return F===this.expr?this:m.create(F,this.negated,!1)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(this.expr[$].evaluate(F))return!0;return!1}static _normalizeArr(F,$,M){let z=[],U=!1;if(F){for(let x=0,j=F.length;x<j;x++){const O=F[x];if(!!O){if(O.type===0){U=!0;continue}if(O.type===1)return p.INSTANCE;if(O.type===9){z=z.concat(O.expr);continue}z.push(O)}}if(z.length===0&&U)return l.INSTANCE;z.sort(I)}if(z.length!==0){if(z.length===1)return z[0];for(let x=1;x<z.length;x++)z[x-1].equals(z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0];if(M){for(let x=0;x<z.length;x++)for(let j=x+1;j<z.length;j++)R(z[x],z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0]}return new m(z,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new m(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){let F=[];for(let $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),M=F.shift(),z=[];for(const x of B($))for(const j of B(M))z.push(c.create([x,j],null));const U=F.length===0;F.unshift(m.create(z,null,U))}this.negated=F[0]}return this.negated}}class u extends h{constructor(F,$,M){super(F,null);this._defaultValue=$,typeof M=="object"?u._info.push({...M,key:F}):M!==!0&&u._info.push({key:F,description:M,type:$!=null?typeof $:void 0})}static all(){return u._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return w.create(this.key,F)}notEqualsTo(F){return b.create(this.key,F)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(N,F){return N<F?-1:N>F?1:0}function A(N,F,$,M){return N<$?-1:N>$?1:F<M?-1:F>M?1:0}function R(N,F){if(F.type===6&&N.type!==9&&N.type!==6){for(const z of F.expr)if(N.equals(z))return!0}const $=N.negate(),M=B($).concat(B(F));M.sort(I);for(let z=0;z<M.length;z++){const x=M[z].negate();for(let j=z+1;j<M.length;j++){const O=M[j];if(x.equals(O))return!0}}return!1}e.implies=R;function B(N){return N.type===9?N.expr:[N]}}),define(fe[185],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[186],me([0,1,10,157,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var _;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function P(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function D(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function C(s,o){switch(s){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function k(s,o){return o==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function i(s,o,v){return k(o,v)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===v?!0:I(v).includes(s)}e.isTargetPlatformCompatible=i;function I(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function l(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=l;var p;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(s){s.Install="install",s.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var S;(function(s){s[s.None=0]="None",s[s.Install=1]="Install",s[s.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var T;(function(s){s.Unsupported="Unsupported",s.Malicious="Malicious",s.Incompatible="Incompatible",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(T=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(o,v){super(o);this.code=v,this.name=v}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(fe[187],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(fe[188],me([0,1,39,10,8,11,96,26,114,159,187]),function(Y,e,g,L,y,_,P,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=k.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends l{openTerminal(o,v){return this.spawnTerminal(g,o,C.getWindowsShell(),v)}spawnTerminal(o,v,t,f){const r=v.windowsExec||p.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const n=y.basename(r).toLowerCase();if(n==="cmder"||n==="cmder.exe")return o.spawn(r,f?[f]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return r.indexOf(" ")>=0&&d.push('""'),d.push(r),(n==="wt"||n==="wt.exe")&&d.push("-d ."),new Promise((a,c)=>{const m=S(process),u=o.spawn(t,d,{cwd:f,env:m});u.on("error",c),u.on("exit",()=>a())})}runInTerminal(o,v,t,f,r){const n="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((d,a)=>{const c=`"${v} - ${I}"`,m=`""${t.join('" "')}" & pause"`,u=["/c","start",c,"/wait",n,"/c",m],E=Object.assign({},S(process),f);Object.keys(E).filter(B=>E[B]===null).forEach(B=>delete E[B]);const A={cwd:v,env:E,windowsVerbatimArguments:!0};g.spawn(p.CMD,u,A).on("error",B=>{a(T(B))}),d(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class h extends l{openTerminal(o,v){return this.spawnTerminal(g,o,v)}runInTerminal(o,v,t,f,r){const n=r.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((d,a)=>{if(n===i.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const c=n===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,Y).fsPath,"-t",o||I,"-w",v];for(let R of t)u.push("-a"),u.push(R);if(f){const R=Object.assign({},S(process),f);for(let B in R){const N=R[B];N===null?(u.push("-u"),u.push(B)):(u.push("-e"),u.push(`${B}=${N}`))}}let E="";const A=g.spawn(h.OSASCRIPT,u);A.on("error",R=>{a(T(R))}),A.stderr.on("data",R=>{E+=R.toString()}),A.on("exit",R=>{if(R===0)d(void 0);else if(E){const B=E.split(`
`,1);a(new Error(B[0]))}else a(new Error(k.localize(1,null,c,R)))})}else a(new Error(k.localize(2,null,n)))})}spawnTerminal(o,v,t){const f=v.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{const d=["-a",f];t&&d.push(t);const a=S(process),c=o.spawn("/usr/bin/open",d,{cwd:t,env:a});c.on("error",n),c.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class w extends l{openTerminal(o,v){return this.spawnTerminal(g,o,v)}runInTerminal(o,v,t,f,r){const n=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,a)=>{let c=[];n.then(m=>{m.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const u=`${b(t)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;c.push(`''${u}''`);const E=Object.assign({},S(process),f);Object.keys(E).filter(N=>E[N]===null).forEach(N=>delete E[N]);const A={cwd:v,env:E};let R="";const B=g.spawn(m,c,A);B.on("error",N=>{a(T(N))}),B.stderr.on("data",N=>{R+=N.toString()}),B.on("exit",N=>{if(N===0)d(void 0);else if(R){const F=R.split(`
`,1);a(new Error(F[0]))}else a(new Error(k.localize(4,null,m,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!_.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const o=await D.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(v=>{o?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,v,t){const f=v.linuxExec?Promise.resolve(v.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{f.then(d=>{const a=S(process),c=o.spawn(d,[],{cwd:t,env:a});c.on("error",n),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=k.localize(3,null);function S(s){const o={...s.env};return(0,P.sanitizeProcessEnvironment)(o),o}function T(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(k.localize(5,null,s.path)):s}function b(s){let o="";for(let v of s)v.indexOf(" ")>=0?o+='"'+v+'"':o+=v,o+=" ";return o}}),define(fe[40],me([0,1,24,8,9,12,2,160,4]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function k(M){return M.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=p;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function S(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=S;var T;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(T=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,U){super(z);this.code=U}}e.FileSystemProviderError=b;function s(M,z){const U=new b(M.toString(),z);return v(U,z),U}e.createFileSystemProviderError=s;function o(M){return M||s((0,D.localize)(0,null),T.Unknown)}e.ensureFileSystemProviderError=o;function v(M,z){return M.name=z?`${z} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=v;function t(M){if(!M)return T.Unknown;if(M instanceof b)return M.code;const z=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!z)return T.Unknown;switch(z[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}e.toFileSystemProviderErrorCode=t;function f(M){if(M instanceof m)return M.fileOperationResult;switch(t(M)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=f;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(z,U,x){this.resource=z,this.operation=U,this.target=x}isOperation(z){return this.operation===z}}e.FileOperationEvent=n;var d;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class a{constructor(z,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const x=new Map;for(const j of z){const O=x.get(j.type);O?O.push([j.resource,j]):x.set(j.type,[[j.resource,j]])}for(const[j,O]of x)switch(j){case 1:this.added=g.TernarySearchTree.forUris(()=>U),this.added.fill(O);break;case 0:this.updated=g.TernarySearchTree.forUris(()=>U),this.updated.fill(O);break;case 2:this.deleted=g.TernarySearchTree.forUris(()=>U),this.deleted.fill(O);break}}contains(z,...U){return this.doContains(z,{includeChildren:!1},...U)}affects(z,...U){return this.doContains(z,{includeChildren:!0},...U)}doContains(z,U,...x){if(!z)return!1;const j=x.length>0;return!!((!j||x.includes(1))&&(this.added?.get(z)||U.includeChildren&&this.added?.findSuperstr(z))||(!j||x.includes(0))&&(this.updated?.get(z)||U.includeChildren&&this.updated?.findSuperstr(z))||(!j||x.includes(2))&&(this.deleted?.findSubstr(z)||U.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=a;function c(M,z,U){return!M||!z||M===z||z.length>M.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),U?(0,y.startsWithIgnoreCase)(M,z):M.indexOf(z)===0)}e.isParent=c;class m extends Error{constructor(z,U,x){super(z);this.fileOperationResult=U,this.options=x}}e.FileOperationError=m;class u extends m{constructor(z,U,x){super(z,2,x);this.stat=U}}e.NotModifiedSinceFileOperationError=u;var E;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function B(M,z){if(!z.hasProvider(P.URI.from({scheme:M.scheme})))return new Promise(U=>{const x=z.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===M.scheme&&j.added&&(x.dispose(),U())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(z){return(0,_.isNumber)(z)||(z=0),z<N.KB?(0,D.localize)(1,null,z.toFixed(0)):z<N.MB?(0,D.localize)(2,null,(z/N.KB).toFixed(2)):z<N.GB?(0,D.localize)(3,null,(z/N.MB).toFixed(2)):z<N.TB?(0,D.localize)(4,null,(z/N.GB).toFixed(2)):(0,D.localize)(5,null,(z/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*N.MB:16*N.GB,maxHeapSize:M===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=$}),define(fe[86],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...y){this._entries=new Map;for(let[_,P]of y)this.set(_,P)}set(y,_){const P=this._entries.get(y);return this._entries.set(y,_),P}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=g}),define(fe[189],me([0,1,15,17,116,182,4,86]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class k extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class i{constructor(h=new D.ServiceCollection,w=!1,S){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=S,this._services.set(P.IInstantiationService,this)}createChild(h){return new i(h,this._strict,this)}invokeFunction(h,...w){let S=l.traceInvocation(h),T=!1;try{return h({get:(s,o)=>{if(T)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(s,S);if(!v&&o!==P.optional)throw new Error(`[invokeFunction] unknown service '${s}'`);return v}},...w)}finally{T=!0,S.stop()}}createInstance(h,...w){let S,T;return h instanceof y.SyncDescriptor?(S=l.traceCreation(h.ctor),T=this._createInstance(h.ctor,h.staticArguments.concat(w),S)):(S=l.traceCreation(h),T=this._createInstance(h,w,S)),S.stop(),T}_createInstance(h,w=[],S){let T=P._util.getServiceDependencies(h).sort((o,v)=>o.index-v.index),b=[];for(const o of T){let v=this._getOrCreateServiceInstance(o.id,S);if(!v&&this._strict&&!o.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${o.id}.`);b.push(v)}let s=T.length>0?T[0].index:w.length;if(w.length!==s){console.warn(`[createInstance] First service dependency of ${h.name} at position ${s+1} conflicts with ${w.length} static arguments`);let o=s-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,s)}return new h(...[...w,...b])}_setServiceInstance(h,w){if(this._services.get(h)instanceof y.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let S=this._getServiceInstanceOrDescriptor(h);return S instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,S,w.branch(h,!0)):(w.branch(h,!1),S)}_safeCreateAndCacheServiceInstance(h,w,S){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,S)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,S){const T=new _.Graph(o=>o.id.toString());let b=0;const s=[{id:h,desc:w,_trace:S}];for(;s.length;){const o=s.pop();if(T.lookupOrInsertNode(o),b++>1e3)throw new k(T);for(let v of P._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${h} depends on ${v.id} which is NOT registered.`),t instanceof y.SyncDescriptor){const f={id:v.id,desc:t,_trace:o._trace.branch(v.id,!0)};T.insertEdge(o,f),s.push(f)}}}for(;;){const o=T.roots();if(o.length===0){if(!T.isEmpty())throw new k(T);break}for(const{data:v}of o){if(this._getServiceInstanceOrDescriptor(v.id)instanceof y.SyncDescriptor){const f=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,f)}T.removeNode(v)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,S=[],T,b){if(this._services.get(h)instanceof y.SyncDescriptor)return this._createServiceInstance(w,S,T,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,S,T,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],S,T){if(S){const b=new g.IdleValue(()=>this._createInstance(h,w,T));return new Proxy(Object.create(null),{get(s,o){if(o in s)return s[o];let v=b.value,t=v[o];return typeof t!="function"||(t=t.bind(v),s[o]=t),t},set(s,o,v){return b.value[o]=v,!0}})}else return this._createInstance(h,w,T)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class l{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return C?new l(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(h){return C?new l(0,h.name):l._None}branch(h,w){let S=new l(2,h.toString());return this._dep.push([h,w,S]),S}stop(){let h=Date.now()-this._start;l._totals+=h;let w=!1;function S(b,s){let o=[],v=new Array(b+1).join("	");for(const[t,f,r]of s._dep)if(f&&r){w=!0,o.push(`${v}CREATES -> ${t}`);let n=S(b+1,r);n&&o.push(n)}else o.push(`${v}uses -> ${t}`);return o.join(`
`)}let T=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(T.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(fe[13],me([0,1,52,3,6,11,4]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function D(){return new Date().toISOString()}var C;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;class k extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...f){this.checkLogLevel(C.Trace)&&this.log(C.Trace,this.format([t,...f]))}debug(t,...f){this.checkLogLevel(C.Debug)&&this.log(C.Debug,this.format([t,...f]))}info(t,...f){this.checkLogLevel(C.Info)&&this.log(C.Info,this.format([t,...f]))}warn(t,...f){this.checkLogLevel(C.Warning)&&this.log(C.Warning,this.format([t,...f]))}error(t,...f){if(this.checkLogLevel(C.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(C.Error,this.format(r))}else this.log(C.Error,this.format([t,...f]))}critical(t,...f){this.checkLogLevel(C.Critical)&&this.log(C.Critical,this.format([t,...f]))}flush(){}format(t){let f="";for(let r=0;r<t.length;r++){let n=t[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(d){}f+=(r>0?" ":"")+n}return f}}e.AbstractMessageLogger=i;class I extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!_.isWindows}trace(t,...f){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...f):console.log(`[main ${D()}]`,t,...f))}debug(t,...f){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...f):console.log(`[main ${D()}]`,t,...f))}info(t,...f){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...f):console.log(`[main ${D()}]`,t,...f))}warn(t,...f){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...f):console.warn(`[main ${D()}]`,t,...f))}error(t,...f){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...f):console.error(`[main ${D()}]`,t,...f))}critical(t,...f){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...f):console.error(`[main ${D()}]`,t,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...f){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",t,...f)}debug(t,...f){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...f)}info(t,...f){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",t,...f)}warn(t,...f){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",t,...f)}error(t,...f){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",t,...f)}critical(t,...f){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...f)}dispose(){}flush(){}}e.ConsoleLogger=l;class p extends k{constructor(t,f=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(f)}trace(t,...f){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(t),...f])}debug(t,...f){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(t),...f])}info(t,...f){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(t),...f])}warn(t,...f){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(t),...f])}error(t,...f){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(t),...f])}critical(t,...f){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(t),...f])}extractMessage(t){return typeof t=="string"?t:(0,g.toErrorMessage)(t,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class h extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const f of this.logServices)f.setLevel(t);super.setLevel(t)}trace(t,...f){for(const r of this.logServices)r.trace(t,...f)}debug(t,...f){for(const r of this.logServices)r.debug(t,...f)}info(t,...f){for(const r of this.logServices)r.info(t,...f)}warn(t,...f){for(const r of this.logServices)r.warn(t,...f)}error(t,...f){for(const r of this.logServices)r.error(t,...f)}critical(t,...f){for(const r of this.logServices)r.critical(t,...f)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class w extends y.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...f){this.logger.trace(t,...f)}debug(t,...f){this.logger.debug(t,...f)}info(t,...f){this.logger.info(t,...f)}warn(t,...f){this.logger.warn(t,...f)}error(t,...f){this.logger.error(t,...f)}critical(t,...f){this.logger.critical(t,...f)}flush(){this.logger.flush()}}e.LogService=w;class S extends y.Disposable{constructor(t,f){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(f(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,f){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,f?.always?C.Trace:this.logLevel,f),this.loggers.set(t.toString(),r),f?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class T{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return C.Info}trace(t,...f){}debug(t,...f){}info(t,...f){}warn(t,...f){}error(t,...f){}critical(t,...f){}dispose(){}flush(){}}e.NullLogService=T;function b(v){if(v.verbose)return C.Trace;if(typeof v.logLevel=="string"){const t=s(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function s(v){switch(v){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=s;function o(v){switch(v){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=o}),define(fe[117],me([0,1,40,13]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function y(C,k,i,I){try{const l=await new Promise((p,h)=>{Y(["spdlog"],p,h)});return l.setFlushOn(L.LogLevel.Trace),l.createAsyncRotatingLogger(C,k,i,I)}catch(l){console.error(l)}return null}function _(C,k,i,I){const l=Y.__$__nodeRequire("spdlog");return l.setFlushOn(L.LogLevel.Trace),l.createRotatingLogger(C,k,i,I)}e.createRotatingLogger=_;function P(C,k,i){switch(k){case L.LogLevel.Trace:C.trace(i);break;case L.LogLevel.Debug:C.debug(i);break;case L.LogLevel.Info:C.info(i);break;case L.LogLevel.Warning:C.warn(i);break;case L.LogLevel.Error:C.error(i);break;case L.LogLevel.Critical:C.critical(i);break;default:throw new Error("Invalid log level")}}class D extends L.AbstractMessageLogger{constructor(k,i,I,l){super();this.name=k,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const k=this.rotating?6:1,i=30/k*g.ByteSize.MB;return y(this.name,this.filepath,i,k).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:l,message:p}of this.buffer)P(this._logger,l,p);this.buffer=[]}})}log(k,i){this._logger?P(this._logger,k,i):this.getLevel()<=k&&this.buffer.push({level:k,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(fe[118],me([0,1,49,161,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var _;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(_=e.MarkerTag||(e.MarkerTag={}));var P;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function k(h,w){return w-h}C.compare=k;const i=Object.create(null);i[C.Error]=(0,L.localize)(0,null),i[C.Warning]=(0,L.localize)(1,null),i[C.Info]=(0,L.localize)(2,null);function I(h){return i[h]||""}C.toString=I;function l(h){switch(h){case g.default.Error:return C.Error;case g.default.Warning:return C.Warning;case g.default.Info:return C.Info;case g.default.Ignore:return C.Hint}}C.fromSeverity=l;function p(h){switch(h){case C.Error:return g.default.Error;case C.Warning:return g.default.Warning;case C.Info:return g.default.Info;case C.Hint:return g.default.Ignore}}C.toSeverity=p}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(C){const k="";function i(l){return I(l,!0)}C.makeKey=i;function I(l,p){let h=[k];return l.source?h.push(l.source.replace("\xA6","\\\xA6")):h.push(k),l.code?typeof l.code=="string"?h.push(l.code.replace("\xA6","\\\xA6")):h.push(l.code.value.replace("\xA6","\\\xA6")):h.push(k),l.severity!==void 0&&l.severity!==null?h.push(P.toString(l.severity)):h.push(k),l.message&&p?h.push(l.message.replace("\xA6","\\\xA6")):h.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?h.push(l.startLineNumber.toString()):h.push(k),l.startColumn!==void 0&&l.startColumn!==null?h.push(l.startColumn.toString()):h.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?h.push(l.endLineNumber.toString()):h.push(k),l.endColumn!==void 0&&l.endColumn!==null?h.push(l.endColumn.toString()):h.push(k),h.push(k),h.join("\xA6")}C.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(fe[190],me([0,1,3,49,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,y.createDecorator)("notificationService");var _;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(_=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new C,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class C{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=C}),define(fe[191],me([0,1,6,9,2,4]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,_.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function P(D,C){return y.URI.isUri(D)?(0,L.equalsIgnoreCase)(D.scheme,C):(0,L.startsWithIgnoreCase)(D,C+":")}e.matchesScheme=P}),define(fe[192],me([0,1,10,11,38,23]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const D=L.globals.vscode.context.configuration();if(D)P=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const D=(0,_.dirname)(g.FileAccess.asFileUri("",Y));P=Y.__$__nodeRequire((0,_.joinPath)(D,"product.json").fsPath);const C=Y.__$__nodeRequire((0,_.joinPath)(D,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:C.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.62.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P});var We=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(fe[119],me([0,1,15,21,6,4]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var P;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let C=class extends y.Disposable{constructor(I,l){super();this.deferred=new g.DeferredPromise,l.withProgress(I,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};C=Ve([We(1,e.IProgressService)],C),e.UnmanagedProgress=C;class k extends y.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,p=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:p.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,58,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(P,D){g.ok(L.isString(P)),g.ok(L.isObject(D)),g.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,D)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new y}),define(fe[120],me([0,1,3,34]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class _{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,k){this.schemasById[y(C)]=k,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new _;L.Registry.add(e.Extensions.JSONContribution,P)}),define(fe[87],me([0,1,18,3,12,156,120,34]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=D.Registry.as(P.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const v=this.doRegisterConfigurations(s,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(s){const o=this.doDeregisterConfigurations(s);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:s,remove:o}){const v=[];v.push(...this.doDeregisterConfigurations(o)),v.push(...this.doRegisterConfigurations(s,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,g.distinct)(v))}registerDefaultConfigurations(s){const o=[],v=[];for(const t of s)for(const f in t)if(o.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]={...this.defaultValues[f]||{},...t[f]};const r={type:"object",default:this.defaultValues[f],description:_.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};v.push(p(f)),this.configurationProperties[f]=r,this.defaultLanguageConfigurationOverridesNode.properties[f]=r}else{this.defaultValues[f]=t[f];const r=this.configurationProperties[f];r&&(this.updatePropertyDefaultValue(f,r),this.updateSchema(f,r))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(s){const o=[];for(const v of s)for(const t in v)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const f=this.configurationProperties[t];f&&(this.updatePropertyDefaultValue(t,f),this.updateSchema(t,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const o of s)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,o){const v=[];return s.forEach(t=>{v.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),v}doDeregisterConfigurations(s){const o=[],v=t=>{if(t.properties)for(const f in t.properties)o.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,t.properties[f]);t.allOf&&t.allOf.forEach(f=>v(f))};for(const t of s){v(t);const f=this.configurationContributors.indexOf(t);f!==-1&&this.configurationContributors.splice(f,1)}return o}validateAndRegisterProperties(s,o=!0,v,t=3){t=y.isUndefinedOrNull(s.scope)?t:s.scope;let f=[],r=s.properties;if(r)for(let d in r){if(o&&S(d)){delete r[d];continue}const a=r[d];if(this.updatePropertyDefaultValue(d,a),e.OVERRIDE_PROPERTY_PATTERN.test(d)?a.scope=void 0:(a.scope=y.isUndefinedOrNull(a.scope)?t:a.scope,a.restricted=y.isUndefinedOrNull(a.restricted)?!!v?.restrictedConfigurations?.includes(d):a.restricted),r[d].hasOwnProperty("included")&&!r[d].included){this.excludedConfigurationProperties[d]=r[d],delete r[d];continue}else this.configurationProperties[d]=r[d];!r[d].deprecationMessage&&r[d].markdownDeprecationMessage&&(r[d].deprecationMessage=r[d].markdownDeprecationMessage),f.push(d)}let n=s.allOf;if(n)for(let d of n)f.push(...this.validateAndRegisterProperties(d,o,v,t));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(s){const o=v=>{let t=v.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let f=v.allOf;f&&f.forEach(o)};o(s)}updateSchema(s,o){switch(e.allSettings.properties[s]=o,o.scope){case 1:e.applicationSettings.properties[s]=o;break;case 2:e.machineSettings.properties[s]=o;break;case 6:e.machineOverridableSettings.properties[s]=o;break;case 3:e.windowSettings.properties[s]=o;break;case 4:e.resourceSettings.properties[s]=o;break;case 5:e.resourceSettings.properties[s]=o,this.resourceLanguageSettingsSchema.properties[s]=o;break}}removeFromSchema(s,o){switch(delete e.allSettings.properties[s],o.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const o=`[${s}]`,v={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,v),e.allSettings.properties[o]=v,e.applicationSettings.properties[o]=v,e.machineSettings.properties[o]=v,e.machineOverridableSettings.properties[o]=v,e.windowSettings.properties[o]=v,e.resourceSettings.properties[o]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,o){let v=this.defaultValues[s];y.isUndefined(v)&&(v=o.default),y.isUndefined(v)&&(v=h(o.type)),o.default=v}}const l="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(l);function p(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=p;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const w=new I;D.Registry.add(e.Extensions.Configuration,w);function S(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?_.localize(5,null,b):w.getConfigurationProperties()[b]!==void 0?_.localize(6,null,b):null:_.localize(4,null)}e.validateProperty=S;function T(){const b=[],s=w.getConfigurationProperties();for(const o of Object.keys(s))b.push([o,s[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=T}),define(fe[121],me([0,1,25,12,2,87,4,34]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function C(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof y.URI)}e.isConfigurationOverrides=C;var k;(function(f){f[f.USER=1]="USER",f[f.USER_LOCAL=2]="USER_LOCAL",f[f.USER_REMOTE=3]="USER_REMOTE",f[f.WORKSPACE=4]="WORKSPACE",f[f.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",f[f.DEFAULT=6]="DEFAULT",f[f.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(f){switch(f){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(f,r){const n=r?f?r.keys.filter(A=>f.keys.indexOf(A)===-1):[...r.keys]:[],d=f?r?f.keys.filter(A=>r.keys.indexOf(A)===-1):[...f.keys]:[],a=[];if(r&&f){for(const A of f.keys)if(r.keys.indexOf(A)!==-1){const R=T(f.contents,A),B=T(r.contents,A);g.equals(R,B)||a.push(A)}}const c=[],m=A=>{const R={};for(const B of A)for(const N of B.identifiers)R[v(N)]=B;return R},u=r?m(r.overrides):{},E=f?m(f.overrides):{};if(Object.keys(u).length)for(const A of n){const R=u[A];R&&c.push([(0,_.overrideIdentifierFromKey)(A),R.keys])}if(Object.keys(E).length)for(const A of d){const R=E[A];R&&c.push([(0,_.overrideIdentifierFromKey)(A),R.keys])}if(Object.keys(u).length&&Object.keys(E).length)for(const A of a){const R=E[A],B=u[A];if(R&&B){const N=I({contents:R.contents,keys:R.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});c.push([(0,_.overrideIdentifierFromKey)(A),[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:d,updated:a,overrides:c}}e.compare=I;function l(f,r){const n=[];for(const d of Object.keys(f))if(_.OVERRIDE_PROPERTY_PATTERN.test(d)){const a={};for(const c in f[d])a[c]=f[d][c];n.push({identifiers:[(0,_.overrideIdentifierFromKey)(d).trim()],keys:Object.keys(a),contents:p(a,r)})}return n}e.toOverrides=l;function p(f,r){const n=Object.create(null);for(let d in f)h(n,d,f[d],r);return n}e.toValuesTree=p;function h(f,r,n,d){const a=r.split("."),c=a.pop();let m=f;for(let u=0;u<a.length;u++){let E=a[u],A=m[E];switch(typeof A){case"undefined":A=m[E]=Object.create(null);break;case"object":break;default:d(`Ignoring ${r} as ${a.slice(0,u+1).join(".")} is ${JSON.stringify(A)}`);return}m=A}if(typeof m=="object"&&m!==null)try{m[c]=n}catch(u){d(`Ignoring ${r} as ${a.join(".")} is ${JSON.stringify(m)}`)}else d(`Ignoring ${r} as ${a.join(".")} is ${JSON.stringify(m)}`)}e.addToValueTree=h;function w(f,r){const n=r.split(".");S(f,n)}e.removeFromValueTree=w;function S(f,r){const n=r.shift();if(r.length===0){delete f[n];return}if(Object.keys(f).indexOf(n)!==-1){const d=f[n];typeof d=="object"&&!Array.isArray(d)&&(S(d,r),Object.keys(d).length===0&&delete f[n])}}function T(f,r,n){function d(m,u){let E=m;for(const A of u){if(typeof E!="object"||E===null)return;E=E[A]}return E}const a=r.split("."),c=d(f,a);return typeof c=="undefined"?n:c}e.getConfigurationValue=T;function b(f,r,n){Object.keys(r).forEach(d=>{d!=="__proto__"&&(d in f?L.isObject(f[d])&&L.isObject(r[d])?b(f[d],r[d],n):n&&(f[d]=r[d]):f[d]=r[d])})}e.merge=b;function s(){const f=D.Registry.as(_.Extensions.Configuration).getConfigurationProperties();return Object.keys(f)}e.getConfigurationKeys=s;function o(){const f=Object.create(null),r=D.Registry.as(_.Extensions.Configuration).getConfigurationProperties();for(let n in r){let d=r[n].default;h(f,n,d,a=>console.error(`Conflict in default settings: ${a}`))}return f}e.getDefaultValues=o;function v(f){return`[${f}]`}e.keyFromOverrideIdentifier=v;function t(f,r,n){const d=f.inspect(r),a=f.inspect(n);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:d.defaultValue}e.getMigratedSettingValue=t}),define(fe[193],me([0,1,18,3,61,6,24,25,12,2,121,87,34]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},f=[],r=[]){this._contents=t,this._keys=f,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,f){const r=this.getContentsForOverrideIdentifer(f);return r?t?(0,i.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const f of this.overrides)if(f.identifiers.indexOf(t)!==-1)return f.keys;return[]}override(t){let f=this.overrideConfigurations.get(t);return f||(f=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,f)),f}merge(...t){const f=D.deepClone(this.contents),r=D.deepClone(this.overrides),n=[...this.keys];for(const d of t){this.mergeContents(f,d.contents);for(const a of d.overrides){const[c]=r.filter(m=>g.equals(m.identifiers,a.identifiers));c?this.mergeContents(c.contents,a.contents):r.push(D.deepClone(a))}for(const a of d.keys)n.indexOf(a)===-1&&n.push(a)}return new p(f,n,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const f=this.getContentsForOverrideIdentifer(t);if(!f||typeof f!="object"||!Object.keys(f).length)return this;let r={};for(const n of g.distinct([...Object.keys(this.contents),...Object.keys(f)])){let d=this.contents[n],a=f[n];a&&(typeof d=="object"&&typeof a=="object"?(d=D.deepClone(d),this.mergeContents(d,a)):d=a),r[n]=d}return new p(r,this.keys,this.overrides)}mergeContents(t,f){for(const r of Object.keys(f)){if(r in t&&C.isObject(t[r])&&C.isObject(f[r])){this.mergeContents(t[r],f[r]);continue}t[r]=D.deepClone(f[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const f of this.overrides)if(f.identifiers.indexOf(t)!==-1)return f.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,f){this.addKey(t),(0,i.addToValueTree)(this.contents,t,f,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let f=this.keys.length;for(let r=0;r<f;r++)t.indexOf(this.keys[r])===0&&(f=r);this.keys.splice(f,1,t)}removeKey(t){let f=this.keys.indexOf(t);return f!==-1?(this.keys.splice(f,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const t=(0,i.getDefaultValues)(),f=(0,i.getConfigurationKeys)(),r=[];for(const n of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,i.toValuesTree)(t[n],d=>console.error(`Conflict in default settings file: ${d}`))});super(t,f,r)}}e.DefaultConfigurationModel=h;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,f){if(!C.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,f)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,f){this._raw=t;const{contents:r,keys:n,overrides:d,restricted:a}=this.doParseRaw(t,f);this._configurationModel=new p(r,n,d),this._restrictedConfigurations=a||[]}doParseContent(t){let f={},r=null,n=[],d=[],a=[];function c(u){Array.isArray(n)?n.push(u):r!==null&&(n[r]=u)}let m={onObjectBegin:()=>{let u={};c(u),d.push(n),n=u,r=null},onObjectProperty:u=>{r=u},onObjectEnd:()=>{n=d.pop()},onArrayBegin:()=>{let u=[];c(u),d.push(n),n=u,r=null},onArrayEnd:()=>{n=d.pop()},onLiteralValue:c,onError:(u,E,A)=>{a.push({error:u,offset:E,length:A})}};if(t)try{y.visit(t,m),f=n[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return f}doParseRaw(t,f){const r=l.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,r,!0,f);t=n.raw;const d=(0,i.toValuesTree)(t,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),a=Object.keys(t),c=(0,i.toOverrides)(t,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:d,keys:a,overrides:c,restricted:n.restricted}}filter(t,f,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const d={},a=[];for(let c in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(c)&&r){const m=this.filter(t[c],f,!1,n);d[c]=m.raw,a.push(...m.restricted)}else{const m=f[c],u=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&a.push(c),(u===void 0||n.scopes===void 0||n.scopes.includes(u))&&(n.skipRestricted&&m?.restricted||(d[c]=t[c]))}return{raw:d,restricted:a}}}e.ConfigurationModelParser=w;class S extends _.Disposable{constructor(t,f,r,n){super();this.userSettingsResource=t,this.scopes=f,this.fileService=n,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class T{constructor(t,f,r=new p,n=new p,d=new P.ResourceMap,a=new p,c=new P.ResourceMap,m=!0){this._defaultConfiguration=t,this._localUserConfiguration=f,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=d,this._memoryConfiguration=a,this._memoryConfigurationByResource=c,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,f,r){return this.getConsolidateConfigurationModel(f,r).getValue(t)}updateValue(t,f,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new p,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,f===void 0?n.removeValue(t):n.setValue(t,f),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,f,r){const n=this.getConsolidateConfigurationModel(f,r),d=this.getFolderConfigurationModelForResource(f.resource,r),a=f.resource?this._memoryConfigurationByResource.get(f.resource)||this._memoryConfiguration:this._memoryConfiguration,c=f.overrideIdentifier?this._defaultConfiguration.freeze().override(f.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),m=f.overrideIdentifier?this.userConfiguration.freeze().override(f.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),u=f.overrideIdentifier?this.localUserConfiguration.freeze().override(f.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),E=f.overrideIdentifier?this.remoteUserConfiguration.freeze().override(f.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=r?f.overrideIdentifier?this._workspaceConfiguration.freeze().override(f.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,R=d?f.overrideIdentifier?d.freeze().override(f.overrideIdentifier).getValue(t):d.freeze().getValue(t):void 0,B=f.overrideIdentifier?a.override(f.overrideIdentifier).getValue(t):a.getValue(t),N=n.getValue(t),F=g.distinct(g.flatten(n.overrides.map($=>$.identifiers))).filter($=>n.getOverrideValue(t,$)!==void 0);return{defaultValue:c,userValue:m,userLocalValue:u,userRemoteValue:E,workspaceValue:A,workspaceFolderValue:R,memoryValue:B,value:N,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:f.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,f.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:f.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,f.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:f.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,f.overrideIdentifier):void 0}:void 0,userRemote:E!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:f.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,f.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:f.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,f.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:d?.freeze().getValue(t),override:f.overrideIdentifier?d?.freeze().getOverrideValue(t,f.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:a.getValue(t),override:f.overrideIdentifier?a.getOverrideValue(t,f.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(t){const f=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:f?f.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,f){this._folderConfigurations.set(t,f),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,f){const r=f.filter(n=>I.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const d=(0,I.overrideIdentifierFromKey)(n),a=this._defaultConfiguration.getKeysForOverrideIdentifier(d),c=t.getKeysForOverrideIdentifier(d),m=[...c.filter(u=>a.indexOf(u)===-1),...a.filter(u=>c.indexOf(u)===-1),...a.filter(u=>!D.equals(this._defaultConfiguration.override(d).getValue(u),t.override(d).getValue(u)))];return[d,m]});return this.updateDefaultConfiguration(t),{keys:f,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:f,updated:r,removed:n,overrides:d}=(0,i.compare)(this.localUserConfiguration,t),a=[...f,...r,...n];return a.length&&this.updateLocalUserConfiguration(t),{keys:a,overrides:d}}compareAndUpdateRemoteUserConfiguration(t){const{added:f,updated:r,removed:n,overrides:d}=(0,i.compare)(this.remoteUserConfiguration,t);let a=[...f,...r,...n];return a.length&&this.updateRemoteUserConfiguration(t),{keys:a,overrides:d}}compareAndUpdateWorkspaceConfiguration(t){const{added:f,updated:r,removed:n,overrides:d}=(0,i.compare)(this.workspaceConfiguration,t);let a=[...f,...r,...n];return a.length&&this.updateWorkspaceConfiguration(t),{keys:a,overrides:d}}compareAndUpdateFolderConfiguration(t,f){const r=this.folderConfigurations.get(t),{added:n,updated:d,removed:a,overrides:c}=(0,i.compare)(r,f);let m=[...n,...d,...a];return(m.length||!r)&&this.updateFolderConfiguration(t,f),{keys:m,overrides:c}}compareAndDeleteFolderConfiguration(t){const f=this.folderConfigurations.get(t);if(!f)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:n,removed:d,overrides:a}=(0,i.compare)(f,void 0);return{keys:[...r,...n,...d],overrides:a}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,f){let r=this.getConsolidatedConfigurationModelForResource(t,f);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},f){let r=this.getWorkspaceConsolidatedConfiguration();if(f&&t){const n=f.getFolder(t);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const d=this._memoryConfigurationByResource.get(t);d&&(r=r.merge(d))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let f=this._foldersConsolidatedConfigurations.get(t);if(!f){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(f=r.merge(n),this._freeze&&(f=f.freeze()),this._foldersConsolidatedConfigurations.set(t,f)):f=r}return f}getFolderConfigurationModelForResource(t,f){if(f&&t){const r=f.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,f)=>{const{contents:r,overrides:n,keys:d}=this._folderConfigurations.get(f);return t.push([f,{contents:r,overrides:n,keys:d}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(f=>t.add(f)),this.userConfiguration.freeze().keys.forEach(f=>t.add(f)),this._workspaceConfiguration.freeze().keys.forEach(f=>t.add(f)),this._folderConfigurations.forEach(f=>f.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const f=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>f.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>f.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>f.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(n=>f.add(n))),[...f.values()]}static parse(t){const f=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),d=t.folders.reduce((a,c)=>(a.set(k.URI.revive(c[0]),this.parseConfigurationModel(c[1])),a),new P.ResourceMap);return new T(f,r,new p,n,d,new p,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=T;function b(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,f=new Map;for(const n of v)n.keys.forEach(d=>t.add(d)),n.overrides.forEach(([d,a])=>{const c=(0,P.getOrSet)(f,d,new Set);a.forEach(m=>c.add(m))});const r=[];return f.forEach((n,d)=>r.push([d,[...n.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=b;class s{constructor(t,f,r,n){this.change=t,this.previous=f,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const d=new Set;t.keys.forEach(c=>d.add(c)),t.overrides.forEach(([,c])=>c.forEach(m=>d.add(m))),this.affectedKeys=[...d.values()];const a=new p;this.affectedKeys.forEach(c=>a.setValue(c,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=T.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,f){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(f){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,f,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,f,this.currentWorkspace);return!D.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(t,f){let r=(0,i.toValuesTree)({[f]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(t=t[n],!t)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=s;class o extends s{constructor(t,f,r,n){super({keys:t.allKeys(),overrides:[]},void 0,t,f);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=o}),define(fe[122],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(P,D=L.Unknown,C){super(P);this._message=P,this._code=D,this._detail=C,this.isHandled=D===L.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(P){return P instanceof y&&P._code===L.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof y&&P._code===L.NoResolverFound}static isHandled(P){return P instanceof y&&P.isHandled}}e.RemoteAuthorityResolverError=y}),define(fe[64],me([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(k){return k.scheme===g.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=L;function y(k){if(!k)return;const i=k.indexOf("+");return i<0?k:k.substr(0,i)}e.getRemoteName=y;function _(k){return k.scheme!==g.Schemas.file&&k.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=_;function P(k){if(k.folders.length)return k.folders.every(i=>_(i.uri))?k.folders[0].uri:void 0;if(k.configuration&&_(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=P;function D(k){return P(k)?.scheme}e.getVirtualWorkspaceScheme=D;function C(k){return P(k)!==void 0}e.isVirtualWorkspace=C}),define(fe[27],me([0,1,9,4,64]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=_;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let w=typeof p=="string"?p:p.value,S=typeof h=="string"?h:h.value;return g.equalsIgnoreCase(w,S)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=C;function k(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function i(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(l,p){if(p&&l.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,y.getRemoteName)(p)}`;return l.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[194],me([0,1,9,27]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,g.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=y;class _{constructor(w,S){this.version=S,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof _?y(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=_;function P(h,w){return`${h}.${w}`}e.getExtensionId=P;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function C(h,w){return D(P(h,w))}e.getGalleryExtensionId=C;function k(h,w){const S=[],T=b=>{for(const s of S)if(s.some(o=>y(w(o),w(b))))return s;return null};for(const b of h){const s=T(b);s?s.push(b):S.push([b])}return S}e.groupByExtension=k;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function l(h){const w=new Set;for(const S of h)S.malicious&&w.add(S.id.id);return w}e.getMaliciousExtensionsSet=l;function p(h,w){const S=[],T=w.manifest.extensionDependencies?.slice(0)??[];for(;T.length;){const b=T.shift();if(b&&S.every(s=>!y(s.identifier,{id:b}))){const s=h.filter(o=>y(o.identifier,{id:b}));s.length===1&&(S.push(s[0]),T.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=p}),define(fe[123],me([0,1,3,11,4,13]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var P;(function(h){h.Http="http",h.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function l(h,w){return w?w!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=l;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,S){return this._tunnelProvider=w,w?(this._canElevate=S.elevation,this._privacyOptions=S.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],S=Array.from(this._tunnels.values());for(let T of S){const b=Array.from(T.values());for(let s of b){const o=await s.value;o&&w.push(o)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:S}of w.values())await S.then(T=>T?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,S,T,b,s=!1,o=D.Private,v){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${S}:${T} on local port ${b}.`),!w)return;S||(S="localhost");const t=this.retainOrCreateTunnel(w,S,T,b,s,o,v);return t?t.then(f=>{if(!f){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(S,T);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(f);return(f.tunnelRemoteHost!==S||f.tunnelRemotePort!==T)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const S=this._tunnels.get(w.tunnelRemoteHost);if(S){const T=S.get(w.tunnelRemotePort);T&&(T.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,T))}}}}async tryDisposeTunnel(w,S,T){if(T.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${S}.`);const b=T.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(S),b}}async closeTunnel(w,S){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${S} `);const T=this._tunnels.get(w);if(T&&T.has(S)){const b=T.get(S);b.refcount=0,await this.tryDisposeTunnel(w,S,b)}}addTunnelToMap(w,S,T){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(S,{refcount:1,value:T})}async removeEmptyTunnelFromMap(w,S){const T=this._tunnels.get(w);T&&(await T.get(S)||T.delete(S),T.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,S){let T=[w];i(w)?(T.push(...e.LOCALHOST_ADDRESSES),T.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&T.push(...e.ALL_INTERFACES_ADDRESSES);const b=T.map(s=>this._tunnels.get(s));for(const s of b){const o=s?.get(S);if(o)return o}}canTunnel(w){return!!k(w)}createWithProvider(w,S,T,b,s,o,v){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${S}:${T} on local port ${b}.`);const f={elevationRequired:s?l(b===void 0?T:b):!1},r={remoteAddress:{host:S,port:T},localAddressPort:b,privacy:o,public:o!==D.Private,protocol:v},n=w.forwardPort(r,f);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(S,T,n),n}};p=Ve([We(0,_.ILogService)],p),e.AbstractTunnelService=p}),define(fe[195],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{constructor(){this.validators=new Map}vsda(){return new Promise((y,_)=>Y(["vsda"],y,_))}async createNewMessage(y){try{const _=await this.vsda(),P=new _.validator;if(P){const D=String(g._nextId++);return this.validators.set(D,P),{id:D,data:P.createNewMessage(y)}}}catch(_){}return{id:"",data:y}}async validate(y,_){if(!y.id)return!0;const P=this.validators.get(y.id);if(!P)return!1;this.validators.delete(y.id);try{return P.validate(_)==="ok"}catch(D){return!1}}async sign(y){try{const _=await this.vsda(),P=new _.signer;if(P)return P.sign(y)}catch(_){}return y}}e.SignService=g,g._nextId=1}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,_,P=5){let D;return D=_(C=>{const k=typeof C=="string"?C:C.data;let i=this._terminalBufferMap.get(y);if(i){i.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(y),P);i={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(y),D.dispose()}},this._terminalBufferMap.set(y,i)}),D}stopBuffering(y){const _=this._terminalBufferMap.get(y);_&&_.dispose()}flushBuffer(y){const _=this._terminalBufferMap.get(y);_&&(this._terminalBufferMap.delete(y),this._callback(y,_.data.join("")))}}e.TerminalDataBufferer=g}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(fe[65],me([0,1,47,3,6,4,34,197]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var C;(function(S){function T(b){return b&&typeof b=="object"&&typeof b.id=="string"}S.isThemeColor=T})(C=e.ThemeColor||(e.ThemeColor={}));function k(S){return{id:S}}e.themeColorFromId=k;var i;(function(S){function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color=="undefined"||C.isThemeColor(f.color))}S.isThemeIcon=T;const b=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function s(f){const r=b.exec(f);if(!r)return;let[,n]=r;return{id:n}}S.fromString=s;function o(f,r){let n=f.id;const d=n.lastIndexOf("~");return d!==-1&&(n=n.substring(0,d)),r&&(n=`${n}~${r}`),{id:n}}S.modify=o;function v(f,r){return f.id===r.id&&f.color?.id===r.color?.id}S.isEqual=v;function t(f,r){return{id:f.id,color:r?k(r):void 0}}S.asThemeIcon=t,S.asClassNameArray=g.CSSIcon.asClassNameArray,S.asClassName=g.CSSIcon.asClassName,S.asCSSSelector=g.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(S){switch(S){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(T){return this.themingParticipants.push(T),this.onThemingParticipantAddedEmitter.fire(T),(0,y.toDisposable)(()=>{const b=this.themingParticipants.indexOf(T);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new l;P.Registry.add(e.Extensions.ThemingContribution,p);function h(S){return p.onColorThemeChange(S)}e.registerThemingParticipant=h;class w extends y.Disposable{constructor(T){super();this.themeService=T,this.theme=T.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(T){this.theme=T,this.updateStyles()}updateStyles(){}getColor(T,b){let s=this.theme.getColor(T);return s&&b&&(s=b(s,this.theme)),s?s.toString():null}}e.Themable=w}),define(fe[198],me([0,1,15,47,3,162,120,34,65]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(T,b,s,o){const v=this.iconsById[T];if(v){if(s&&!v.description){v.description=s,this.iconSchema.properties[T].markdownDescription=`${s} $(${T})`;const r=this.iconReferenceSchema.enum.indexOf(T);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=s),this._onDidChange.fire()}return v}let t={id:T,description:s,defaults:b,deprecationMessage:o};this.iconsById[T]=t;let f={$ref:"#/definitions/icons"};return o&&(f.deprecationMessage=o),s&&(f.markdownDescription=`${s}: $(${T})`),this.iconSchema.properties[T]=f,this.iconReferenceSchema.enum.push(T),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:T}}deregisterIcon(T){delete this.iconsById[T],delete this.iconSchema.properties[T];const b=this.iconReferenceSchema.enum.indexOf(T);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(T=>this.iconsById[T])}getIcon(T){return this.iconsById[T]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(T,b){const s=this.iconFontsById[T];if(s)return s;let o={id:T,definition:b};return this.iconFontsById[T]=o,this._onDidChange.fire(),o}deregisterIconFont(T){delete this.iconFontsById[T]}getIconFonts(){return Object.keys(this.iconFontsById).map(T=>this.iconFontsById[T])}getIconFont(T){return this.iconFontsById[T]}toString(){const T=(v,t)=>v.id.localeCompare(t.id),b=v=>{for(;C.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of o.filter(t=>!!t.description).sort(T))s.push(`|<i class="${b(v)}"></i>|${v.id}|${C.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const v of o.filter(t=>!C.ThemeIcon.isThemeIcon(t.defaults)).sort(T))s.push(`|<i class="${b(v)}"></i>|${v.id}|`);return s.join(`
`)}}const i=new k;D.Registry.add(e.Extensions.IconContribution,i);function I(S,T,b,s){return i.registerIcon(S,T,b,s)}e.registerIcon=I;function l(){return i}e.getIconRegistry=l;function p(){for(const S of L.iconRegistry.all)i.registerIcon(S.id,S.definition,S.description);L.iconRegistry.onDidRegister(S=>i.registerIcon(S.id,S.definition,S.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let h=D.Registry.as(P.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,i.getIconSchema());const w=new g.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=C.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,_.createDecorator)("contextService");var P;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function D(l){const p=l;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=D;function C(l){const p=l;return!!(p&&typeof p=="object"&&y.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=C;class k{constructor(p,h,w,S,T){this._id=p,this._transient=w,this._configuration=S,this._ignorePathCasing=T,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=k;class i{constructor(p,h){this.raw=h,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(l){return new i({uri:l,index:0,name:(0,L.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(fe[199],me([0,1,29,61,140,81,10,8,11,23,2,163,4,64,44]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(M){return(typeof M=="string"?(0,D.extname)(M):(0,k.extname)(M))===w}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function T(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=T;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function o(M){const z=M;return typeof z?.id=="string"&&i.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=o;function v(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(M){const z=M;return typeof z?.id=="string"&&i.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function f(M){const z=M;if(z?.uri)return{id:z.id,uri:i.URI.revive(z.uri)};const U=M;if(U?.configPath)return{id:U.id,configPath:i.URI.revive(U.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=f;function r(M,z){return k.extUriBiasedIgnorePathCase.isEqualOrParent(M,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function n(M){return d(M)||a(M)}e.isStoredWorkspaceFolder=n;function d(M){const z=M;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=d;function a(M){const z=M;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=a;function c(M,z,U,x,j=!C.isWindows,O){if(M.scheme!==x.scheme)return{name:U,uri:M.toString(!0)};let W=z?void 0:O.relativePath(x,M);if(W!==void 0)W.length===0?W=".":C.isWindows&&M.scheme===P.Schemas.file&&!j&&(W=W.replace(/\//g,"\\"));else if(M.scheme===P.Schemas.file)W=M.fsPath,C.isWindows&&(W=(0,_.normalizeDriveLetter)(W),j&&(W=(0,g.toSlashes)(W)));else{if(!O.isEqualAuthority(M.authority,x.authority))return{name:U,uri:M.toString(!0)};W=M.path}return{name:U,path:W}}e.getStoredWorkspaceFolder=c;function m(M,z,U){let x=[],j=new Set;const O=U.dirname(z);for(let W of M){let H;if(d(W))W.path&&(H=U.resolvePath(O,W.path));else if(a(W))try{H=i.URI.parse(W.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(X){console.warn(X)}if(H){let X=U.getComparisonKey(H);if(!j.has(X)){j.add(X);const K=W.name||U.basenameOrAuthority(H);x.push(new h.WorkspaceFolder({uri:H,name:K,index:x.length},W))}}}return x}e.toWorkspaceFolders=m;function u(M,z,U,x,j){let O=E(z,M);const W=j.dirname(z),H=j.dirname(x),X=[],K=A(O.folders);for(const Pe of O.folders){const Be=d(Pe)?j.resolvePath(W,Pe.path):i.URI.parse(Pe.uri);let $e;U?$e=!1:$e=!d(Pe)||(0,D.isAbsolute)(Pe.path),X.push(c(Be,$e,Pe.name,H,K,j))}const de={insertSpaces:!1,tabSize:4,eol:C.isLinux||C.isMacintosh?`
`:`\r
`},_e=y.setProperty(M,["folders"],X,de);let Ce=y.applyEdits(M,_e);return O.remoteAuthority===(0,p.getRemoteAuthority)(x)&&(Ce=y.applyEdits(Ce,y.removeProperty(Ce,["remoteAuthority"],de))),Ce}e.rewriteWorkspaceFileForNewLocation=u;function E(M,z){let U=L.parse(z);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>n(x));else throw new Error(`${M} looks like an invalid workspace file.`);return U}function A(M){return C.isWindows?M.some(z=>d(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function B(M){return typeof M.folderUri=="string"}function N(M){return typeof M.fileUri=="string"}function F(M,z){const U={workspaces:[],files:[]};if(M){const x=function(O,W){for(let H=0;H<O.length;H++)try{W(O[H],H)}catch(X){z.warn(`Error restoring recent entry ${JSON.stringify(O[H])}: ${X.toString()}. Skip entry.`)}},j=M;if(Array.isArray(j.entries))x(j.entries,O=>{const W=O.label,H=O.remoteAuthority;R(O)?U.workspaces.push({label:W,remoteAuthority:H,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):B(O)?U.workspaces.push({label:W,remoteAuthority:H,folderUri:i.URI.parse(O.folderUri)}):N(O)&&U.files.push({label:W,remoteAuthority:H,fileUri:i.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&x(O.workspaces3,(W,H)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[H]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:W.id,configPath:i.URI.parse(W.configURIPath)}}):typeof W=="string"&&U.workspaces.push({label:X,folderUri:i.URI.parse(W)})}),Array.isArray(O.files2)&&x(O.files2,(W,H)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[H]||void 0;typeof W=="string"&&U.files.push({label:X,fileUri:i.URI.parse(W)})})}}return U}e.restoreRecentlyOpened=F;function $(M){const z={entries:[]};for(const U of M.workspaces)b(U)?z.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):z.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of M.files)z.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return z}e.toStoreData=$}),define(fe[88],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const _=this._idPool++;return this._data.set(_,y),this.logDebugInfo(),_}get(y,_){return this._data.has(y)?this._data.get(y)[_]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(fe[53],me([0,1,10,23,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class _{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(D=>{const C=this._providerInfo.get(D.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(D,C){C===null?this._providerInfo.delete(D):this._providerInfo.set(D,C)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=_,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(fe[28],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(fe[200],me([0,1,15]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(P,D,C){this._deferredPromises=new Map,this._id=P,this._shared=D,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const I of k.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(P,D){let C=this._value[P];return typeof C=="undefined"&&(C=D),C}update(P,D){this._value[P]=D;let C=this._deferredPromises.get(P);if(C!==void 0)return C.p;const k=new g.DeferredPromise;return this._deferredPromises.set(P,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class y extends L{constructor(P,D){super(P.identifier.value,!0,D);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=y}),define(fe[201],me([0,1,3,2,13]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let _=class{constructor(D,C){this._logService=D,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,C,k){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(D)).acceptModelChanged(C.value,k)}$acceptDirtyStateChanged(D,C){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(D)).acceptDirty(C)}$acceptModelSaved(D){const C=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(D));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(D,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,C);const k=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(D));k.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};_=Ve([We(0,y.ILogService)],_),e.ExtHostNotebookDocuments=_}),define(fe[14],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(_){this.getProxy=_.getProxy.bind(_),this.set=_.set.bind(_),this.assertRegistered=_.assertRegistered.bind(_),this.drain=_.drain.bind(_)}}e.ExtHostRpcService=L});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[202],me([0,1,27,3]),function(Y,e,g,L){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class _{constructor(D,C){y.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(D.identifier),st(this,y,C,"f"),Ne(this,y,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(D){return Ne(this,y,"f").get(this._id,D)}store(D,C){return Ne(this,y,"f").store(this._id,D,C)}delete(D){return Ne(this,y,"f").delete(this._id,D)}}e.ExtensionSecrets=_,y=new WeakMap}),define(fe[124],me([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(P){this._enabled=P}$onDidChangeTelemetryEnabled(P){this._enabled=P,this._onDidChangeTelemetryEnabled.fire(P)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(fe[66],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,y=(b,s)=>{const o={controllerId:s};return L.set(b,o),o};e.createPrivateApiFor=y;const _=b=>L.get(b);e.getPrivateApiFor=_;const P=(b,s,o,v)=>{let t=o;return{enumerable:!0,configurable:!1,get(){return t},set(f){if(!v(t,f)){const r=t;t=f,b.listener?.({op:3,key:s,value:f,previous:r})}}}},D=(b,s)=>b===s,C={range:(b,s)=>b===s?!0:!b||!s?!1:b.isEqual(s),label:D,description:D,busy:D,error:D,canResolveChildren:D,tags:(b,s)=>!(b.length!==s.length||b.some(o=>!s.find(v=>o.id===v.id)))},k=Object.keys(C),i=(b,s)=>({range:P(b,"range",void 0,C.range),label:P(b,"label",s,C.label),description:P(b,"description",void 0,C.description),canResolveChildren:P(b,"canResolveChildren",!1,C.canResolveChildren),busy:P(b,"busy",!1,C.busy),error:P(b,"error",void 0,C.error),tags:P(b,"tags",[],C.tags)}),I=(b,s)=>{const o=new Map;for(const v of k)C[v](b[v],s[v])||o.set(v,s[v]);return o};e.diffTestItems=I;class l extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=l;class p extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class h extends Error{constructor(s,o,v){super(`TestItem with ID "${s}" is from controller "${o}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=h;const w=b=>{const s=(0,e.getPrivateApiFor)(b);let o=new Map;return{get size(){return o.size},forEach(v,t){for(const f of o.values())v.call(t,f,this)},replace(v){const t=new Map,f=new Set(o.keys()),r={op:4,ops:[]};for(const n of v){if(!(n instanceof S))throw new p(n.id);const d=(0,e.getPrivateApiFor)(n).controllerId;if(d!==s.controllerId)throw new h(n.id,d,s.controllerId);if(t.has(n.id))throw new l(n.id);t.set(n.id,n),f.delete(n.id),r.ops.push({op:0,item:n})}for(const n of f.keys())r.ops.push({op:1,id:n});s.listener?.(r),o=t},add(v){if(!(v instanceof S))throw new p(v.id);o.set(v.id,v),s.listener?.({op:0,item:v})},delete(v){o.delete(v)&&s.listener?.({op:1,id:v})},get(v){return o.get(v)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class S{constructor(s,o,v,t){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const f=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof T?void 0:f.parent}},children:{value:w(this),enumerable:!0,writable:!1},...i(f,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=S;class T extends S{constructor(s,o){super(s,s,o,void 0)}}e.TestItemRootImpl=T}),define(fe[54],me([0,1,4,123,3,14]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(C){function k(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}C.fromApiTunnel=k;function i(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}C.fromServiceTunnel=i})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let D=class{constructor(k){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,i){return{dispose:()=>{}}}async $providePortAttributes(k,i,I,l,p){return[]}async $forwardPort(k,i){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=Ve([We(0,_.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[7],me([0,1,18,17,99,24,103,9,12,2,32,40,122]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l){"use strict";var p,h,w,S,T,b,s,o,v,t,f,r,n,d,a,c,m,u,E,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function V(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(V,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(V,q),Object.setPrototypeOf(V.prototype,q.prototype),V}let B=T=class{constructor(V){p.set(this,void 0),st(this,p,V,"f")}static from(...V){let ae=V;return new T(function(){if(ae){for(const ke of ae)ke&&typeof ke.dispose=="function"&&ke.dispose();ae=void 0}})}dispose(){typeof Ne(this,p,"f")=="function"&&(Ne(this,p,"f").call(this),st(this,p,void 0,"f"))}};p=new WeakMap,B=T=Ve([R],B),e.Disposable=B;let N=b=class{constructor(V,ae){if(V<0)throw(0,L.illegalArgument)("line must be non-negative");if(ae<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=V,this._character=ae}static Min(...V){if(V.length===0)throw new TypeError;let ae=V[0];for(let ke=1;ke<V.length;ke++){const Je=V[ke];Je.isBefore(ae)&&(ae=Je)}return ae}static Max(...V){if(V.length===0)throw new TypeError;let ae=V[0];for(let ke=1;ke<V.length;ke++){const Je=V[ke];Je.isAfter(ae)&&(ae=Je)}return ae}static isPosition(V){if(!V)return!1;if(V instanceof b)return!0;let{line:ae,character:ke}=V;return typeof ae=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,ae=0){if(V===null||ae===null)throw(0,L.illegalArgument)();let ke;return typeof V=="undefined"?ke=0:typeof V=="number"?ke=V:(ke=typeof V.lineDelta=="number"?V.lineDelta:0,ae=typeof V.characterDelta=="number"?V.characterDelta:0),ke===0&&ae===0?this:new b(this.line+ke,this.character+ae)}with(V,ae=this.character){if(V===null||ae===null)throw(0,L.illegalArgument)();let ke;return typeof V=="undefined"?ke=this.line:typeof V=="number"?ke=V:(ke=typeof V.line=="number"?V.line:this.line,ae=typeof V.character=="number"?V.character:this.character),ke===this.line&&ae===this.character?this:new b(ke,ae)}toJSON(){return{line:this.line,character:this.character}}};N=b=Ve([R],N),e.Position=N;let F=s=class{constructor(V,ae,ke,Je){let ot,dt;if(typeof V=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new N(V,ae),dt=new N(ke,Je)):V instanceof N&&ae instanceof N&&(ot=V,dt=ae),!ot||!dt)throw new Error("Invalid arguments");ot.isBefore(dt)?(this._start=ot,this._end=dt):(this._start=dt,this._end=ot)}static isRange(V){return V instanceof s?!0:V?N.isPosition(V.start)&&N.isPosition(V.end):!1}get start(){return this._start}get end(){return this._end}contains(V){return V instanceof s?this.contains(V._start)&&this.contains(V._end):V instanceof N?!(V.isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const ae=N.Max(V.start,this._start),ke=N.Min(V.end,this._end);if(!ae.isAfter(ke))return new s(ae,ke)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ae=N.Min(V.start,this._start),ke=N.Max(V.end,this.end);return new s(ae,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,ae=this.end){if(V===null||ae===null)throw(0,L.illegalArgument)();let ke;return V?N.isPosition(V)?ke=V:(ke=V.start||this.start,ae=V.end||this.end):ke=this.start,ke.isEqual(this._start)&&ae.isEqual(this.end)?this:new s(ke,ae)}toJSON(){return[this.start,this.end]}};F=s=Ve([R],F),e.Range=F;let $=o=class extends F{constructor(V,ae,ke,Je){let ot,dt;if(typeof V=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new N(V,ae),dt=new N(ke,Je)):V instanceof N&&ae instanceof N&&(ot=V,dt=ae),!ot||!dt)throw new Error("Invalid arguments");super(ot,dt);this._anchor=ot,this._active=dt}static isSelection(V){return V instanceof o?!0:V?F.isRange(V)&&N.isPosition(V.anchor)&&N.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=o=Ve([R],$),e.Selection=$;class M{constructor(V,ae,ke){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,L.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,L.illegalArgument)("connectionToken");this.host=V,this.port=Math.round(ae),this.connectionToken=ke}}e.ResolvedAuthority=M;class z extends Error{constructor(V,ae=l.RemoteAuthorityResolverErrorCode.Unknown,ke){super(V);this._message=V,this._code=ae,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(V,ae){return new z(V,l.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(V){return new z(V,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var U;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var x;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=v=class{constructor(V,ae){this._range=V,this._newText=ae}static isTextEdit(V){return V instanceof v?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ae){return new v(V,ae)}static insert(V,ae){return v.replace(new F(V,V),ae)}static delete(V){return v.replace(V,"")}static setEndOfLine(V){const ae=new v(new F(new N(0,0),new N(0,0)),"");return ae.newEol=V,ae}get range(){return this._range}set range(V){if(V&&!F.isRange(V))throw(0,L.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,L.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,L.illegalArgument)("newEol");this._newEol=V}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=v=Ve([R],j),e.TextEdit=j;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let W=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,ae,ke,Je){this._edits.push({_type:1,from:V,to:ae,options:ke,metadata:Je})}createFile(V,ae,ke){this._edits.push({_type:1,from:void 0,to:V,options:ae,metadata:ke})}deleteFile(V,ae,ke){this._edits.push({_type:1,from:V,to:void 0,options:ae,metadata:ke})}replaceNotebookMetadata(V,ae,ke){this._edits.push({_type:3,metadata:ke,uri:V,edit:{editType:5,metadata:ae},notebookMetadata:ae})}replaceNotebookCells(V,ae,ke,Je,ot){let dt,mt,kt=[],Rt;if(Ht.isNotebookRange(ae)&&Oe.isNotebookCellDataArray(ke)&&!Oe.isNotebookCellDataArray(Je)?(dt=ae.start,mt=ae.end,kt=ke,Rt=Je):typeof ae=="number"&&typeof ke=="number"&&Oe.isNotebookCellDataArray(Je)&&(dt=ae,mt=ke,kt=Je,Rt=ot),dt===void 0||mt===void 0)throw new Error("Invalid arguments");(dt!==mt||kt.length>0)&&this._edits.push({_type:5,uri:V,index:dt,count:mt-dt,cells:kt,metadata:Rt})}replaceNotebookCellMetadata(V,ae,ke,Je){this._edits.push({_type:3,metadata:Je,uri:V,edit:{editType:8,index:ae,metadata:ke}})}replace(V,ae,ke,Je){this._edits.push({_type:2,uri:V,edit:new j(ae,ke),metadata:Je})}insert(V,ae,ke,Je){this.replace(V,new F(ae,ae),ke,Je)}delete(V,ae,ke){this.replace(V,ae,"",ke)}has(V){return this._edits.some(ae=>ae._type===2&&ae.uri.toString()===V.toString())}set(V,ae){if(ae)for(const ke of ae)ke&&this._edits.push({_type:2,uri:V,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===V.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(V){const ae=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===V.toString()&&ae.push(ke.edit);return ae}entries(){const V=new _.ResourceMap;for(let ae of this._edits)if(ae._type===2){let ke=V.get(ae.uri);ke||(ke=[ae.uri,[]],V.set(ae.uri,ke)),ke[1].push(ae.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};W=Ve([R],W),e.WorkspaceEdit=W;let H=t=class{constructor(V){this._tabstop=1,this.value=V||""}static isSnippetString(V){return V instanceof t?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}appendText(V){return this.value+=t._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ae=this._tabstop++){if(typeof V=="function"){const ke=new t;ke._tabstop=this._tabstop,V(ke),this._tabstop=ke._tabstop,V=ke.value}else V=t._escape(V);return this.value+="${",this.value+=ae,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ae=this._tabstop++){const ke=V.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(V,ae){if(typeof ae=="function"){const ke=new t;ke._tabstop=this._tabstop,ae(ke),this._tabstop=ke._tabstop,ae=ke.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};H=t=Ve([R],H),e.SnippetString=H;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=f=class{constructor(V,ae){if(this.uri=V,ae)if(ae instanceof F)this.range=ae;else if(ae instanceof N)this.range=new F(ae,ae);else throw new Error("Illegal argument")}static isLocation(V){return V instanceof f?!0:V?F.isRange(V.range)&&k.URI.isUri(V.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=f=Ve([R],de),e.Location=de;let _e=class{constructor(V,ae){this.location=V,this.message=ae}static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&k.URI.isUri(V.location.uri):!1}static isEqual(V,ae){return V===ae?!0:!V||!ae?!1:V.message===ae.message&&V.location.range.isEqual(ae.location.range)&&V.location.uri.toString()===ae.location.uri.toString()}};_e=Ve([R],_e),e.DiagnosticRelatedInformation=_e;let Ce=class{constructor(V,ae,ke=K.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=V,this.message=ae,this.severity=ke}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ae){return V===ae?!0:!V||!ae?!1:V.message===ae.message&&V.severity===ae.severity&&V.code===ae.code&&V.severity===ae.severity&&V.source===ae.source&&V.range.isEqual(ae.range)&&(0,g.equals)(V.tags,ae.tags)&&(0,g.equals)(V.relatedInformation,ae.relatedInformation,_e.isEqual)}};Ce=Ve([R],Ce),e.Diagnostic=Ce;let Pe=class{constructor(V,ae){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ae}};Pe=Ve([R],Pe),e.Hover=Pe;var Be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $e=class{constructor(V,ae=Be.Text){this.range=V,this.kind=ae}toJSON(){return{range:this.range,kind:Be[this.kind]}}};$e=Ve([R],$e),e.DocumentHighlight=$e;var He;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=r=class{constructor(V,ae,ke,Je,ot){this.name=V,this.kind=ae,this.containerName=ot,typeof ke=="string"&&(this.containerName=ke),Je instanceof de?this.location=Je:ke instanceof F&&(this.location=new de(Je,ke)),r.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ee=r=Ve([R],ee),e.SymbolInformation=ee;let te=n=class{constructor(V,ae,ke,Je,ot){this.name=V,this.detail=ae,this.kind=ke,this.range=Je,this.selectionRange=ot,this.children=[],n.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children&&V.children.forEach(n.validate)}};te=n=Ve([R],te),e.DocumentSymbol=te;var ce;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ce=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(V,ae){this.title=V,this.kind=ae}};Z=Ve([R],Z),e.CodeAction=Z;let se=d=class{constructor(V){this.value=V}append(V){return new d(this.value?this.value+d.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+d.sep)}};se.sep=".",se=d=Ve([R],se),e.CodeActionKind=se,se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll");let pe=class{constructor(V,ae){if(this.range=V,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};pe=Ve([R],pe),e.SelectionRange=pe;class Me{constructor(V,ae,ke,Je,ot,dt){this.kind=V,this.name=ae,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.CallHierarchyItem=Me;class je{constructor(V,ae){this.fromRanges=ae,this.from=V}}e.CallHierarchyIncomingCall=je;class Ke{constructor(V,ae){this.fromRanges=ae,this.to=V}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(V,ae){this.range=V,this.command=ae}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let ct=a=class{constructor(V,ae=!1){h.set(this,void 0),st(this,h,new y.MarkdownString(V,{supportThemeIcons:ae}),"f")}static isMarkdownString(V){return V instanceof a?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}get value(){return Ne(this,h,"f").value}set value(V){Ne(this,h,"f").value=V}get isTrusted(){return Ne(this,h,"f").isTrusted}set isTrusted(V){Ne(this,h,"f").isTrusted=V}get supportThemeIcons(){return Ne(this,h,"f").supportThemeIcons}set supportThemeIcons(V){Ne(this,h,"f").supportThemeIcons=V}get supportHtml(){return Ne(this,h,"f").supportHtml}set supportHtml(V){Ne(this,h,"f").supportHtml=V}appendText(V){return Ne(this,h,"f").appendText(V),this}appendMarkdown(V){return Ne(this,h,"f").appendMarkdown(V),this}appendCodeblock(V,ae){return Ne(this,h,"f").appendCodeblock(ae??"",V),this}};h=new WeakMap,ct=a=Ve([R],ct),e.MarkdownString=ct;let ye=class{constructor(V,ae){this.label=V,this.documentation=ae}};ye=Ve([R],ye),e.ParameterInformation=ye;let at=class{constructor(V,ae){this.label=V,this.documentation=ae,this.parameters=[]}};at=Ve([R],at),e.SignatureInformation=at;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([R],J),e.SignatureHelp=J;var ie;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(V,ae,ke){this.text=V,this.position=ae,this.kind=ke}};Qe=Ve([R],Qe),e.InlayHint=Qe;var et;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(le=e.CompletionItemKind||(e.CompletionItemKind={}));var Ie;(function(q){q[q.Deprecated=1]="Deprecated"})(Ie=e.CompletionItemTag||(e.CompletionItemTag={}));let Ue=class{constructor(V,ae){this.label=V,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ue=Ve([R],Ue),e.CompletionItem=Ue;let Xe=class{constructor(V=[],ae=!1){this.items=V,this.isIncomplete=ae}};Xe=Ve([R],Xe),e.CompletionList=Xe;let it=class{constructor(V,ae,ke){this.text=V,this.range=ae,this.command=ke}};it=Ve([R],it),e.InlineSuggestion=it;let ft=class{constructor(V){this.items=V}};ft=Ve([R],ft),e.InlineSuggestions=ft;var tt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var we;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(we=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function V(ae){switch(ae){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=V}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor(V,ae){if(ae&&!k.URI.isUri(ae))throw(0,L.illegalArgument)("target");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.target=ae}};ve=Ve([R],ve),e.DocumentLink=ve;let Fe=class{constructor(V,ae,ke,Je){this.red=V,this.green=ae,this.blue=ke,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let Ge=class{constructor(V,ae){if(ae&&!(ae instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.color=ae}};Ge=Ve([R],Ge),e.ColorInformation=Ge;let ze=class{constructor(V){if(!V||typeof V!="string")throw(0,L.illegalArgument)("label");this.label=V}};ze=Ve([R],ze),e.ColorPresentation=ze;var Ye;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ye=e.ColorFormat||(e.ColorFormat={}));var lt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(V,ae,ke){if(this.startIndex=V,this.length=ae,this.tooltip=ke,typeof V!="number"||V<0)throw(0,L.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,L.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class be{constructor(V){this.options=V,typeof V!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=be;var re;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var Q;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Q=e.TaskPanelKind||(e.TaskPanelKind={}));let Se=c=class{constructor(V,ae){if(this.label=ae,typeof V!="string"||typeof ae!="string")throw(0,L.illegalArgument)("name");this._id=V}static from(V){switch(V){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Se.Clean=new c("clean","Clean"),Se.Build=new c("build","Build"),Se.Rebuild=new c("rebuild","Rebuild"),Se.Test=new c("test","Test"),Se=c=Ve([R],Se),e.TaskGroup=Se;function Le(q){let V="";for(let ae=0;ae<q.length;ae++)V+=q[ae].replace(/,/g,",,")+",";return V}let nt=class{constructor(V,ae,ke){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=V,ae!==void 0&&(Array.isArray(ae)?(this._args=ae,this._options=ke):this._options=ae)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(let ae of this._args)V.push(ae);return Le(V)}};nt=Ve([R],nt),e.ProcessExecution=nt;let qe=class{constructor(V,ae,ke){if(this._args=[],Array.isArray(ae)){if(!V)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V,this._args=ae,this._options=ke}else{if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V,this._options=ae}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ae of this._args)V.push(typeof ae=="string"?ae:ae.value);return Le(V)}};qe=Ve([R],qe),e.ShellExecution=qe;var gt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(gt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class pt{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,i.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=pt;let vt=m=class{constructor(V,ae,ke,Je,ot,dt){this.__deprecated=!1,this._definition=this.definition=V;let mt;typeof ae=="string"?(this._name=this.name=ae,this._source=this.source=ke,this.execution=Je,mt=ot,this.__deprecated=!0):ae===Et.Global||ae===Et.Workspace?(this.target=ae,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,mt=dt):(this.target=ae,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof nt?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,i.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const ae=this._definition.type;(m.EmptyType===ae||m.ProcessType===ae||m.ShellType===ae||m.ExtensionCallbackType===ae)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=m=Ve([R],vt),e.Task=vt;var wt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let Dt=class{constructor(V,ae=Ct.None){this.collapsibleState=ae,k.URI.isUri(V)?this.resourceUri=V:this.label=V}};Dt=Ve([R],Dt),e.TreeItem=Dt;var Ct;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor(V,ae){this.id=V,this.color=ae}};Tt=Ve([R],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let Nt=class{constructor(V){this.id=V}};Nt=Ve([R],Nt),e.ThemeColor=Nt;var It;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(It=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ut=class{constructor(V,ae){if(typeof V!="string"&&(!V||!k.URI.isUri(V)&&!k.URI.isUri(V.uri)))throw(0,L.illegalArgument)("base");if(typeof ae!="string")throw(0,L.illegalArgument)("pattern");typeof V=="string"?(this.baseFolder=k.URI.file(V),this.base=V):k.URI.isUri(V)?(this.baseFolder=V,this.base=V.fsPath):(this.baseFolder=V.uri,this.base=V.uri.fsPath),this.pattern=ae}};Ut=Ve([R],Ut),e.RelativePattern=Ut;let $t=class{constructor(V,ae,ke,Je){this.enabled=typeof V=="boolean"?V:!0,typeof ae=="string"&&(this.condition=ae),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,i.generateUuid)()),this._id}};$t=Ve([R],$t),e.Breakpoint=$t;let St=class extends $t{constructor(V,ae,ke,Je,ot){super(ae,ke,Je,ot);if(V===null)throw(0,L.illegalArgument)("location");this.location=V}};St=Ve([R],St),e.SourceBreakpoint=St;let Qt=class extends $t{constructor(V,ae,ke,Je,ot){super(ae,ke,Je,ot);this.functionName=V}};Qt=Ve([R],Qt),e.FunctionBreakpoint=Qt;let zt=class extends $t{constructor(V,ae,ke,Je,ot,dt,mt){super(Je,ot,dt,mt);if(!ae)throw(0,L.illegalArgument)("dataId");this.label=V,this.dataId=ae,this.canPersist=ke}};zt=Ve([R],zt),e.DataBreakpoint=zt;let nn=class{constructor(V,ae,ke){this.command=V,this.args=ae||[],this.options=ke}};nn=Ve([R],nn),e.DebugAdapterExecutable=nn;let rn=class{constructor(V,ae){this.port=V,this.host=ae}};rn=Ve([R],rn),e.DebugAdapterServer=rn;let At=class{constructor(V){this.path=V}};At=Ve([R],At),e.DebugAdapterNamedPipeServer=At;let Xt=class{constructor(V){this.implementation=V}};Xt=Ve([R],Xt),e.DebugAdapterInlineImplementation=Xt;let sn=class{constructor(V,ae){this.range=V,this.expression=ae}};sn=Ve([R],sn),e.EvaluatableExpression=sn;var Yt;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(V,ae){this.range=V,this.text=ae}};Wt=Ve([R],Wt),e.InlineValueText=Wt;let bt=class{constructor(V,ae,ke=!0){this.range=V,this.variableName=ae,this.caseSensitiveLookup=ke}};bt=Ve([R],bt),e.InlineValueVariableLookup=bt;let on=class{constructor(V,ae){this.range=V,this.expression=ae}};on=Ve([R],on),e.InlineValueEvaluatableExpression=on;let Ft=class{constructor(V,ae){this.frameId=V,this.stoppedLocation=ae}};Ft=Ve([R],Ft),e.InlineValueContext=Ft;var Vt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Jt=u=class extends Error{constructor(V,ae=I.FileSystemProviderErrorCode.Unknown,ke){super(k.URI.isUri(V)?V.toString(!0):V);this.code=ke?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,ae),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(V){return new u(V,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(V){return new u(V,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(V){return new u(V,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(V){return new u(V,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Jt=u=Ve([R],Jt),e.FileSystemError=Jt;let an=class{constructor(V,ae,ke){this.start=V,this.end=ae,this.kind=ke}};an=Ve([R],an),e.FoldingRange=an;var hn;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(hn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(bn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var fn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(fn=e.CommentMode||(e.CommentMode={}));class Zt{constructor(V,ae=[]){this.tokenTypes=V,this.tokenModifiers=ae}}e.SemanticTokensLegend=Zt;function En(q){return typeof q=="undefined"||(0,C.isStringArray)(q)}class jt{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let ae=0,ke=V.tokenTypes.length;ae<ke;ae++)this._tokenTypeStrToInt.set(V.tokenTypes[ae],ae);for(let ae=0,ke=V.tokenModifiers.length;ae<ke;ae++)this._tokenModifierStrToInt.set(V.tokenModifiers[ae],ae)}}push(V,ae,ke,Je,ot){if(typeof V=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(V,ae,ke,Je,ot);if(F.isRange(V)&&typeof ae=="string"&&En(ke))return this._push(V,ae,ke);throw(0,L.illegalArgument)()}_push(V,ae,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ae))throw new Error("`tokenType` is not in the provided legend");const Je=V.start.line,ot=V.start.character,dt=V.end.character-V.start.character,mt=this._tokenTypeStrToInt.get(ae);let kt=0;if(ke)for(const Rt of ke){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(Rt);kt|=1<<Mt>>>0}this._pushEncoded(Je,ot,dt,mt,kt)}_pushEncoded(V,ae,ke,Je,ot){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&ae<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Rt=0,Mt=0;for(let Ot=0;Ot<kt;Ot++){let xt=this._data[5*Ot],un=this._data[5*Ot+1];xt===0?(xt=Rt,un+=Mt):xt+=Rt,this._data[5*Ot]=xt,this._data[5*Ot+1]=un,Rt=xt,Mt=un}}let dt=V,mt=ae;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ot,this._prevLine=V,this._prevChar=ae}static _sortAndDeltaEncode(V){let ae=[];const ke=V.length/5|0;for(let mt=0;mt<ke;mt++)ae[mt]=mt;ae.sort((mt,kt)=>{const Rt=V[5*mt],Mt=V[5*kt];if(Rt===Mt){const Ot=V[5*mt+1],xt=V[5*kt+1];return Ot-xt}return Rt-Mt});const Je=new Uint32Array(V.length);let ot=0,dt=0;for(let mt=0;mt<ke;mt++){const kt=5*ae[mt],Rt=V[kt+0],Mt=V[kt+1],Ot=V[kt+2],xt=V[kt+3],un=V[kt+4],Bn=Rt-ot,Kn=Bn===0?Mt-dt:Mt,dn=5*mt;Je[dn+0]=Bn,Je[dn+1]=Kn,Je[dn+2]=Ot,Je[dn+3]=xt,Je[dn+4]=un,ot=Rt,dt=Mt}return Je}build(V){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),V):new qt(jt._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=jt;class qt{constructor(V,ae){this.resultId=ae,this.data=V}}e.SemanticTokens=qt;class _n{constructor(V,ae,ke){this.start=V,this.deleteCount=ae,this.data=ke}}e.SemanticTokensEdit=_n;class Sn{constructor(V,ae){this.resultId=ae,this.edits=V}}e.SemanticTokensEdits=Sn;var Gt;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yn;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(yn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let en=class{constructor(){}};en.Back={iconPath:new Tt("arrow-left")},en=Ve([R],en),e.QuickInputButtons=en;var Dn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(V,ae,ke){this.badge=V,this.tooltip=ae,this.color=ke}static validate(V){if(V.badge){let ae=(0,D.nextCharLength)(V.badge,0);if(ae<V.badge.length&&(ae+=(0,D.nextCharLength)(V.badge,ae)),V.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Cn;let Kt=class{constructor(V){this.kind=V}};Kt=Ve([R],Kt),e.ColorTheme=Kt;var mn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(mn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(V,ae){if(V<0)throw(0,L.illegalArgument)("start must be positive");if(ae<0)throw(0,L.illegalArgument)("end must be positive");V<=ae?(this._start=V,this._end=ae):(this._start=ae,this._end=V)}static isNotebookRange(V){return V instanceof Ht?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(V){let ae=this._start,ke=this._end;return V.start!==void 0&&(ae=V.start),V.end!==void 0&&(ke=V.end),ae===this._start&&ke===this._end?this:new Ht(ae,ke)}}e.NotebookRange=Ht;class Oe{constructor(V,ae,ke,Je,ot,dt,mt){this.kind=V,this.value=ae,this.languageId=ke,this.mime=Je,this.outputs=ot??[],this.metadata=dt,this.executionSummary=mt,Oe.validate(this)}static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ae=>Oe.isNotebookCellData(ae))}static isNotebookCellData(V){return!0}}e.NotebookCellData=Oe;class ln{constructor(V){this.cells=V}}e.NotebookData=ln;class Lt{constructor(V,ae){this.data=V,this.mime=ae;const ke=(0,P.normalizeMimeType)(ae,!0);if(!ke)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem(V){return V instanceof Lt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ae={name:V.name,message:V.message,stack:V.stack};return Lt.json(ae,"application/vnd.code.notebook.error")}static stdout(V){return Lt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Lt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ae="application/octet-stream"){return new Lt(V,ae)}static text(V,ae=P.Mimes.text){const ke=Ne(Lt,w,"f",S).encode(String(V));return new Lt(ke,ae)}static json(V,ae="application/json"){const ke=JSON.stringify(V,void 0,"	");return Lt.text(ke,ae)}}e.NotebookCellOutputItem=Lt,w=Lt,S={value:new TextEncoder};class _t{constructor(V,ae,ke){this.items=_t.ensureUniqueMimeTypes(V,!0),typeof ae=="string"?(this.id=ae,this.metadata=ke):(this.id=(0,i.generateUuid)(),this.metadata=ae??ke)}static isNotebookCellOutput(V){return V instanceof _t?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&(0,C.isArray)(V.items)}static ensureUniqueMimeTypes(V,ae=!1){const ke=new Set,Je=new Set;for(let ot=0;ot<V.length;ot++){const dt=V[ot],mt=(0,P.normalizeMimeType)(dt.mime);if(!ke.has(mt)){ke.add(mt);continue}Je.add(ot),ae&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?V:V.filter((ot,dt)=>!Je.has(dt))}}e.NotebookCellOutput=_t;var kn;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(kn=e.NotebookCellKind||(e.NotebookCellKind={}));var In;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(In=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var pn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pn{constructor(V,ae){this.text=V,this.alignment=ae}}e.NotebookCellStatusBarItem=Pn;var Tn;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(V,ae=[]){this.uri=V,this.provides=(0,g.asArray)(ae)}}e.NotebookRendererScript=An;let cn=class{constructor(V,ae){this.label=V,this.timestamp=ae}};cn=Ve([R],cn),e.TimelineItem=cn;var vn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(V,ae){this.ranges=V,this.wordPattern=ae}}e.LinkedEditingRanges=Fn;class Mn{constructor(V,ae){this._port=V,this._autoForwardAction=ae}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var On;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(On=e.TestResultState||(e.TestResultState={}));var ne;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(ne=e.TestRunProfileKind||(e.TestRunProfileKind={}));let he=class{constructor(V=void 0,ae=void 0,ke=void 0){this.include=V,this.exclude=ae,this.profile=ke}};he=Ve([R],he),e.TestRunRequest=he;let Ae=E=class{constructor(V){this.message=V}static diff(V,ae,ke){const Je=new E(V);return Je.expectedOutput=ae,Je.actualOutput=ke,Je}};Ae=E=Ve([R],Ae),e.TestMessage=Ae;let ht=class{constructor(V){this.id=V}};ht=Ve([R],ht),e.TestTag=ht;let yt=class{constructor(V,ae){this.covered=V,this.total=ae}};yt=Ve([R],yt),e.CoveredCount=yt;let Pt=A=class{constructor(V,ae,ke,Je){this.uri=V,this.statementCoverage=ae,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(V,ae){const ke=new yt(0,0),Je=new yt(0,0),ot=new yt(0,0);for(const mt of ae)if("branches"in mt){ke.total+=1,ke.covered+=mt.executionCount>0?1:0;for(const kt of mt.branches)Je.total+=1,Je.covered+=kt.executionCount>0?1:0}else ot.total+=1,ot.covered+=mt.executionCount>0?1:0;const dt=new A(V,ke,Je.total>0?Je:void 0,ot.total>0?ot:void 0);return dt.detailedCoverage=ae,dt}};Pt=A=Ve([R],Pt),e.FileCoverage=Pt;let Nn=class{constructor(V,ae,ke=[]){this.executionCount=V,this.location=ae,this.branches=ke}};Nn=Ve([R],Nn),e.StatementCoverage=Nn;let Un=class{constructor(V,ae){this.executionCount=V,this.location=ae}};Un=Ve([R],Un),e.BranchCoverage=Un;let xn=class{constructor(V,ae){this.executionCount=V,this.location=ae}};xn=Ve([R],xn),e.FunctionCoverage=xn;var Vn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var jn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(jn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Gn{constructor(V,ae,ke,Je,ot,dt){this.kind=V,this.name=ae,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.TypeHierarchyItem=Gn}),define(fe[125],me([0,1,58,10,9,150,111,7,18]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(h,w){w?k.set(h,w):k.delete(h)}e.setWordDefinitionFor=i;function I(h){return k.get(h)}e.getWordDefinitionFor=I;class l extends _.MirrorTextModel{constructor(w,S,T,b,s,o,v,t){super(S,T,b,s);this._proxy=w,this._languageId=o,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,C.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===L.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(S){return S?w._getTextInRange(S):w.getText()},get eol(){return w._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(S){return w._lineAt(S)},offsetAt(S){return w._offsetAt(S)},positionAt(S){return w._positionAt(S)},validateRange(S){return w._validateRange(S)},validatePosition(S){return w._validatePosition(S)},getWordRangeAtPosition(S,T){return w._getWordRangeAtPosition(S,T)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,g.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,g.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const S=this._validateRange(w);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const T=this._eol,b=S.start.line,s=S.end.line,o=[];o.push(this._lines[b].substring(S.start.character));for(let v=b+1;v<s;v++)o.push(this._lines[v]);return o.push(this._lines[s].substring(0,S.end.character)),o.join(T)}_lineAt(w){let S;if(w instanceof D.Position?S=w.line:typeof w=="number"&&(S=w),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new p(S,this._lines[S],S===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(w),T=this._lines[S.index].length;return new D.Position(S.index,Math.min(S.remainder,T))}_validateRange(w){if(!(w instanceof D.Range))throw new Error("Invalid argument");const S=this._validatePosition(w.start),T=this._validatePosition(w.end);return S===w.start&&T===w.end?w:new D.Range(S.line,S.character,T.line,T.character)}_validatePosition(w){if(!(w instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:S,character:T}=w,b=!1;if(S<0)S=0,T=0,b=!0;else if(S>=this._lines.length)S=this._lines.length-1,T=this._lines[S].length,b=!0;else{const s=this._lines[S].length;T<0?(T=0,b=!0):T>s&&(T=s,b=!0)}return b?new D.Position(S,T):w}_getWordRangeAtPosition(w,S){const T=this._validatePosition(w);if(!S)S=I(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const b=(0,P.getWordAtText)(T.character+1,(0,P.ensureValidWordDefinition)(S),this._lines[T.line],0);if(b)return new D.Range(T.line,b.startColumn-1,T.line,b.endColumn-1)}}e.ExtHostDocumentData=l;class p{constructor(w,S,T){this._line=w,this._text=S,this._isLastLine=T}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(fe[203],me([0,1,7,3,113,6,83,24,2,32]),function(Y,e,g,L,y,_,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(l,p,h,w){this._notebook=h,this._selector=w,this._disposables=new _.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(T=>{const b=this._cellUris.get(T.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=T=>{T===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(T=>S(T.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const l=[],p=[];for(const h of this._notebook.getCells())h.kind===g.NotebookCellKind.Code&&(!this._selector||(0,P.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),l.push(h.document.getText().length+1),p.push(h.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(l){if(!l){let b="";for(const s of this._cells)b+=s.document.getText()+`
`;return b=b.slice(0,-1),b}if(l.isEmpty)return"";const p=this.locationAt(l.start),h=this.locationAt(l.end),w=this._cellUris.get(p.uri),S=this._cellUris.get(h.uri);if(w===void 0||S===void 0)return"";if(w===S)return this._cells[w].document.getText(new g.Range(p.range.start,h.range.end));const T=[this._cells[w].document.getText(new g.Range(p.range.start,new g.Position(this._cells[w].document.lineCount,0)))];for(let b=w+1;b<S;b++)T.push(this._cells[b].document.getText());return T.push(this._cells[S].document.getText(new g.Range(new g.Position(0,0),h.range.end))),T.join(`
`)}offsetAt(l){const p=this._cellLines.getIndexOf(l.line),h=this._cellLengths.getPrefixSum(p.index-1),w=this._cells[p.index].document.offsetAt(l.with(p.remainder));return h+w}positionAt(l){if(typeof l=="number"){const h=this._cellLengths.getIndexOf(l),w=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(w)}const p=this._cellUris.get(l.uri);if(p!==void 0){const h=this._cellLines.getPrefixSum(p-1);return new g.Position(h+l.range.start.line,l.range.start.character)}return new g.Position(0,0)}locationAt(l){g.Range.isRange(l)||(l=new g.Range(l,l));const p=this._cellLines.getIndexOf(l.start.line);let h=p;l.isEmpty||(h=this._cellLines.getIndexOf(l.end.line));const w=new g.Position(p.remainder,l.start.character),S=new g.Position(h.remainder,l.end.character),T=new g.Range(w,S),b=this._cells[p.index];return new g.Location(b.document.uri,b.document.validateRange(T))}contains(l){return this._cellUris.has(l)}validateRange(l){const p=this.validatePosition(l.start),h=this.validatePosition(l.end);return l.with(p,h)}validatePosition(l){const p=this._cellLines.getIndexOf(l.line),h=new g.Position(p.remainder,l.character),w=this._cells[p.index].document.validatePosition(h),S=this._cellLines.getPrefixSum(p.index-1);return new g.Position(S+w.line,w.character)}}e.ExtHostNotebookConcatDocument=i}),define(fe[204],me([0,1,7,14,3]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let _=class{constructor(D){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let C=D==="light"?g.ColorThemeKind.Light:D==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};_=Ve([We(0,L.IExtHostRpcService)],_),e.ExtHostTheming=_}),define(fe[67],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(_){_?(this.transformIncoming=_.transformIncoming.bind(_),this.transformOutgoing=_.transformOutgoing.bind(_),this.transformOutgoingURI=_.transformOutgoingURI.bind(_),this.transformOutgoingScheme=_.transformOutgoingScheme.bind(_)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=L}),define(fe[205],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(C){let k=this.buffers.indexOf(C);return k<0&&(k=this.buffers.length,this.buffers.push(C)),k}}function y(D,C){if(C.serializeBuffersForPostMessage){const k=new L,i=(p,h)=>{if(h instanceof ArrayBuffer){const w=k.add(h);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(h)){const w=_(h);if(w){const S=k.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:w,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(D,i),l=k.buffers.map(p=>{const h=new Uint8Array(p);return g.VSBuffer.wrap(h)});return{message:I,buffers:l}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=y;function _(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(D,C){const k=C.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),i=C.length?(l,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const h=p,{index:w}=h,S=k[w];if(h.view)switch(h.view.type){case 1:return new Int8Array(S,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return p}:void 0;return{message:JSON.parse(D,i),arrayBuffers:k}}e.deserializeWebviewMessage=P}),define(fe[206],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function y(P){const D={items:new Map};return P.types.forEach((C,k)=>{D.items.set(C,{asString:async()=>P.items[k].asString})}),D}L.toITreeDataTransfer=y;async function _(P){const D={types:[],items:[]},C=Array.from(P.items.entries());for(const k of C)D.types.push(k[0]),D.items.push({asString:await k[1].asString()});return D}L.toTreeDataTransferDTO=_})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[89],me([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(D,C){return D.scheme===g.Schemas.http||D.scheme===g.Schemas.https?D:(C&&C.authority&&C.isRemote&&D.scheme===g.Schemas.file&&(D=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:C.authority,path:D.path})),L.URI.from({scheme:g.Schemas.https,authority:`${D.scheme}+${_(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=y;function _(D){return D.replace(/./g,C=>{const k=C.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?C:"-"+k.toString(16).padStart(4,"0")})}function P(D){return D.replace(/-([0-9a-f]{4})/g,(C,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=P}),define(fe[207],me([0,1,3,6,89]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class _{constructor(D,C,k){this._proxy=D,this._editors=C,this._initData=k,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const i=C.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,C,k,i,I){let l;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===D){l=s;break}if(!l)throw new Error("not a visible editor");const p=this,h=this._handlePool++,w=new g.Emitter,S=new g.Emitter,T=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,y.asWebviewUri)(s,p._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(s){this._options=s,p._proxy.$setOptions(h,s)}get options(){return this._options}set html(s){this._html=s,p._proxy.$setHtml(h,s)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(s){return p._proxy.$postMessage(h,s)}},b=new class{constructor(){this.editor=D,this.line=C,this.height=k,this.webview=T,this.onDidDispose=S.event}dispose(){p._insets.has(h)&&(p._insets.delete(h),p._proxy.$disposeEditorInset(h),S.fire(),S.dispose(),w.dispose())}};return this._proxy.$createEditorInset(h,l.id,l.value.document.uri,C+1,k,i||{},I.identifier,I.extensionLocation),this._insets.set(h,{editor:D,inset:b,onDidReceiveMessage:w}),b}$onDidDispose(D){const C=this._insets.get(D);C&&C.inset.dispose()}$onDidReceiveMessage(D,C){const k=this._insets.get(D);k&&k.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=_}),define(fe[208],me([0,1,173,12,2,6,4,63,34,40,18,10]),function(Y,e,g,L,y,_,P,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new D.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new D.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new D.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new D.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new D.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new D.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new D.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new D.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new D.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new D.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new D.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new D.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new D.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new D.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new D.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new D.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new D.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new D.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new D.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new D.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new D.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new D.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(N,F,$){for(const M of $.visibleEditorPanes)if(M.group.id===F&&N.matches(M.input))return M.getViewState()}e.findViewStateForEditor=l;function p(N){if(v(N))return!1;const F=N;return y.URI.isUri(F?.resource)}e.isResourceEditorInput=p;function h(N){if(v(N))return!1;const F=N;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=h;function w(N){if(v(N)||h(N))return!1;const F=N;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function S(N){if(v(N))return!1;const F=N;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;var T;(function(N){N[N.SHORT=0]="SHORT",N[N.MEDIUM=1]="MEDIUM",N[N.LONG=2]="LONG"})(T=e.Verbosity||(e.Verbosity={}));var b;(function(N){N[N.EXPLICIT=1]="EXPLICIT",N[N.AUTO=2]="AUTO",N[N.FOCUS_CHANGE=3]="FOCUS_CHANGE",N[N.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var s;(function(N){N[N.None=0]="None",N[N.Readonly=2]="Readonly",N[N.Untitled=4]="Untitled",N[N.Singleton=8]="Singleton",N[N.RequiresTrust=16]="RequiresTrust",N[N.CanSplitInGroup=32]="CanSplitInGroup",N[N.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends _.Disposable{}e.AbstractEditorInput=o;function v(N){return N instanceof o}e.isEditorInput=v;function t(N){const F=N;return y.URI.isUri(F?.preferredResource)}function f(N){const F=N;return v(F?.primary)&&v(F?.secondary)}e.isSideBySideEditorInput=f;function r(N){const F=N;return v(F?.modified)&&v(F?.original)}e.isDiffEditorInput=r;function n(N){return v(N?.editor)}e.isEditorInputWithOptions=n;function d(N){const F=N;return n(N)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=d;function a(N){const F=N;return typeof F?.groupId=="number"&&v(F.editor)}e.isEditorIdentifier=a;var c;(function(N){N[N.UNKNOWN=0]="UNKNOWN",N[N.REPLACE=1]="REPLACE",N[N.MOVE=2]="MOVE",N[N.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(N){N[N.PRIMARY=1]="PRIMARY",N[N.SECONDARY=2]="SECONDARY",N[N.BOTH=3]="BOTH",N[N.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:z,secondary:U}=this.getSideEditors(F);if(z&&U){if($?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===m.ANY)return this.getOriginalUri(z,{filterByScheme:$.filterByScheme})??this.getOriginalUri(U,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===m.PRIMARY?z:U}}if(h(F)||w(F))return;const M=t(F)?F.preferredResource:F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}getSideEditors(F){return f(F)||w(F)?{primary:F.primary,secondary:F.secondary}:r(F)||h(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:z,secondary:U}=this.getSideEditors(F);if(z&&U){if($?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===m.ANY)return this.getCanonicalUri(z,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===m.PRIMARY?z:U}}if(h(F)||w(F))return;const M=F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}filterUri(F,$){if(Array.isArray($)){if($.some(M=>F.scheme===M))return F}else if($===F.scheme)return F}}e.EditorResourceAccessor=new u;var E;(function(N){N[N.LEFT=0]="LEFT",N[N.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const $=this.instantiationService=F.get(P.IInstantiationService);for(const[M,z]of this.editorSerializerConstructors)this.createEditorSerializer(M,z,$);this.editorSerializerConstructors.clear()}createEditorSerializer(F,$,M){const z=M.createInstance($);this.editorSerializerInstances.set(F,z)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,$){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,$,this.instantiationService):this.editorSerializerConstructors.set(F,$),(0,_.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new A);async function R(N,F){if(!N||!N.length)return[];const $=await Promise.all(N.map(async M=>{const z=y.URI.revive(M.fileUri);if(!z||!await F.canHandleResource(z))return;let x=M.exists,j=M.type;if(typeof x!="boolean"||typeof j!="number")try{j=(await F.resolve(z)).isFile?k.FileType.File:k.FileType.Unknown,x=!0}catch{x=!1}if(!x&&M.openOnlyIfExists||j!==k.FileType.File)return;const O={selection:x?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let W;return x?W={resource:z,options:O}:W={resource:z,options:O,forceUntitled:!0},W}));return(0,i.coalesce)($)}e.pathsToEditors=R;var B;(function(N){N[N.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",N[N.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[209],me([0,1,3,63,174,4,6,24,34,18,59,25,47,198]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",l.Codicon.window,(0,y.localize)(0,null));var h;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(h=e.Extensions||(e.Extensions={}));var w;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function S(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=S;function T(d){return`viewContainer.${d}.enabled`}e.getEnabledViewContainerContextKey=T;class b extends P.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(a,c,m){const u=this.get(a.id);if(u)return u;const E=a;return E.openCommandActionDescriptor=m?.donotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,D.getOrSet)(this.viewContainers,c,[]).push(E),m?.isDefault&&this.defaultViewContainers.push(E),this._onDidRegister.fire({viewContainer:E,viewContainerLocation:c}),E}deregisterViewContainer(a){for(const c of this.viewContainers.keys()){const m=this.viewContainers.get(c),u=m?.indexOf(a);if(u!==-1){m?.splice(u,1),m.length===0&&this.viewContainers.delete(c),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:c});return}}}get(a){return this.all.filter(c=>c.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(c=>this.getViewContainers(c).filter(m=>m?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(c=>this.getViewContainerLocation(c)===a)}}C.Registry.add(h.ViewContainersRegistry,new b);var s;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(s=e.ViewContentGroups||(e.ViewContentGroups={}));function o(d,a){const c=d.group??s.More,m=a.group??s.More;return c!==m?c.localeCompare(m):(d.order??5)-(a.order??5)}class v extends P.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(a,c){this.registerViews2([{views:a,viewContainer:c}])}registerViews2(a){a.forEach(({views:c,viewContainer:m})=>this.addViews(c,m)),this._onViewsRegistered.fire(a)}deregisterViews(a,c){const m=this.removeViews(a,c);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:c})}moveViews(a,c){for(const m of this._views.keys())if(m!==c){const u=this.removeViews(a,m);u.length&&(this.addViews(u,c),this._onDidChangeContainer.fire({views:u,from:m,to:c}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const c of this._viewContainers){const m=(this._views.get(c)||[]).filter(u=>u.id===a)[0];if(m)return m}return null}getViewContainer(a){for(const c of this._viewContainers)if((this._views.get(c)||[]).filter(u=>u.id===a)[0])return c;return null}registerViewWelcomeContent(a,c){return this._viewWelcomeContents.add(a,c),this._onDidChangeViewWelcomeContent.fire(a),(0,P.toDisposable)(()=>{this._viewWelcomeContents.delete(a,c),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,c){const m=new Map;for(const[u,E]of c)this._viewWelcomeContents.add(a,E),m.set(u,(0,P.toDisposable)(()=>{this._viewWelcomeContents.delete(a,E),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),m}getViewWelcomeContent(a){const c=[];return this._viewWelcomeContents.forEach(a,m=>c.push(m)),c.sort(o)}addViews(a,c){let m=this._views.get(c);m||(m=[],this._views.set(c,m),this._viewContainers.push(c));for(const u of a){if(this.getView(u.id)!==null)throw new Error((0,y.localize)(1,null,u.id));m.push(u)}}removeViews(a,c){const m=this._views.get(c);if(!m)return[];const u=[],E=[];for(const A of m)a.includes(A)?u.push(A):E.push(A);return u.length&&(E.length?this._views.set(c,E):(this._views.delete(c),this._viewContainers.splice(this._viewContainers.indexOf(c),1))),u}}C.Registry.add(h.ViewsRegistry,new v),e.IViewsService=(0,_.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,y.localize)(2,null));function t(d){return`view.${d}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,_.createDecorator)("viewDescriptorService");var f;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(f=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(a,c){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,a),this._hasResolve=!!c,this.resolve=async m=>{if(c&&!this.resolved){const u=await c(m);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[126],me([0,1,3,15,175]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class _{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,C,k,i){const I={command:D};if(C&&Object.keys(C).length>0&&(I.arguments=C),this.internalSend("request",I),typeof i=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.pendingRequests.get(I.seq);if(p){this.pendingRequests.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:(0,y.localize)(0,null,i,D)};p(h)}},i)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,C){return D.type!=="event"||C.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,L.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const C=D,k=this.pendingRequests.get(C.request_seq);k&&(this.pendingRequests.delete(C.request_seq),k(C));break}}}internalSend(D,C){C.type=D,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((C,k)=>D.set(k,C)),await(0,L.timeout)(500),D.forEach((C,k)=>{C({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=_}),define(fe[210],me([0,1,9,2,8,25,10]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function C(r,n,d){return r.replace(D,function(a,c){return n&&c.length>0&&c[0]!=="_"?a:d&&d.hasOwnProperty(c)?d[c]:a})}e.formatPII=C;function k(r){const n={};for(const d of Object.keys(r))d.startsWith("!")||(n[d]=r[d]);return n}e.filterExceptionsFromTelemetry=k;function i(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||i(r.parentSession))}e.isSessionAttach=i;function I(r){let n=r.configuration.type;if(!!n)return n==="vslsShare"&&(n=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(n,"extensionhost")||(0,g.equalsIgnoreCase)(n,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function p(r,n,d){let a,c=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=m.exec(r);){let E=u.index+1,A=E+u[0].length;if(E<=n&&A>=d){a=u[0],c=E;break}}if(a){let E=/\w+/g,A=null;for(;(A=E.exec(a))&&!(A.index+1+c+A[0].length>=d););A&&(a=a.substring(0,E.lastIndex))}return a?{start:c,end:c+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(r){return!!(r&&r.match(h))}e.isUri=w;function S(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(w(r.path))return L.URI.parse(r.path);if((0,y.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function T(r){if(typeof r.path=="object"){const n=L.URI.revive(r.path);if(n)return n.scheme===P.Schemas.file?n.fsPath:n.toString()}return r.path}function b(r,n){const d=n?S:T,a=(0,_.deepClone)(r);return o(a,(c,m)=>{c&&m&&(m.path=d(m))}),a}e.convertToDAPaths=b;function s(r,n){const d=n?S:T,a=(0,_.deepClone)(r);return o(a,(c,m)=>{!c&&m&&(m.path=d(m))}),a}e.convertToVSCPaths=s;function o(r,n){switch(r.type){case"event":const d=r;switch(d.event){case"output":n(!1,d.body.source);break;case"loadedSource":n(!1,d.body.source);break;case"breakpoint":n(!1,d.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":n(!0,a.arguments.source);break;case"breakpointLocations":n(!0,a.arguments.source);break;case"source":n(!0,a.arguments.source);break;case"gotoTargets":n(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(m=>n(!1,m));break;default:break}break;case"response":const c=r;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(m=>n(!1,m.source));break;case"loadedSources":c.body.sources.forEach(m=>n(!1,m));break;case"scopes":c.body.scopes.forEach(m=>n(!1,m.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(m=>n(!1,m.source));break;case"setBreakpoints":c.body.breakpoints.forEach(m=>n(!1,m.source));break;default:break}break}}function v(r){return r.filter(n=>!n.presentation?.hidden).sort((n,d)=>n.presentation?d.presentation?n.presentation.group?d.presentation.group?n.presentation.group!==d.presentation.group?n.presentation.group.localeCompare(d.presentation.group):t(n.presentation.order,d.presentation.order):-1:d.presentation.group?1:t(n.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.getVisibleAndSorted=v;function t(r,n){return typeof r!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:r-n}async function f(r,n){const d=r.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorMode});if(d!=="none"&&(await n.saveAll(),d==="allEditorsInActiveGroup")){const a=n.activeEditorPane;a&&await n.save({editor:a.input,groupId:a.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=f}),define(fe[211],me([0,1,26,39,176,127,8,9,25,11,186,126]),function(Y,e,g,L,y,_,P,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",o=>this.handleData(o))}sendMessage(b){if(this.outputStream){const s=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${l.TWO_CRLF}${s}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+s))}continue}}else{const s=this.rawData.indexOf(l.TWO_CRLF);if(s!==-1){const v=this.rawData.toString("utf8",0,s).split(l.HEADER_LINESEPARATOR);for(const t of v){const f=t.split(l.HEADER_FIELDSEPARATOR);f[0]==="Content-Length"&&(this.contentLength=Number(f[1]))}this.rawData=this.rawData.slice(s+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class p extends l{startSession(){return new Promise((b,s)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",v=>{o?this._onError.fire(v):s(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class h extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return _.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=h;class w extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return _.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=w;class S extends l{constructor(b,s,o){super();this.adapterExecutable=b,this.debugType=s,this.outputService=o}async startSession(){const b=this.adapterExecutable.command,s=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(b)if(P.isAbsolute(b)){if(!await g.Promises.exists(b))throw new Error(y.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let v=process.env;if(o.env&&Object.keys(o.env).length>0&&(v=C.mixin(C.deepClone(process.env),o.env)),b==="node")if(Array.isArray(s)&&s.length>0){const f=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:v,execArgv:f?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(r.cwd=o.cwd);const n=L.fork(s[0],s.slice(1),r);if(!n.pid)throw new Error(y.localize(2,null,s[0]));this.serverProcess=n}else throw new Error(y.localize(3,null));else{const f={env:v};o.cwd&&(f.cwd=o.cwd),this.serverProcess=L.spawn(b,s,f)}this.serverProcess.on("error",f=>{this._onError.fire(f)}),this.serverProcess.on("exit",(f,r)=>{this._onExit.fire(f)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",f=>{this._onError.fire(f)}),this.serverProcess.stdin.on("error",f=>{this._onError.fire(f)});const t=this.outputService;if(t){const f=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(f(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),k.isWindows?new Promise((b,s)=>{const o=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,f){if(v)return s(v)});o.on("exit",b),o.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,s){if(!b)return;const o=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?o.runtime=P.join(s,b.runtime):o.runtime=b.runtime),b.runtimeArgs&&(o.runtimeArgs=b.runtimeArgs),b.program&&(P.isAbsolute(b.program)?o.program=b.program:o.program=P.join(s,b.program)),b.args&&(o.args=b.args);const v=b;return v.win&&(o.win=S.extract(v.win,s)),v.winx86&&(o.winx86=S.extract(v.winx86,s)),v.windows&&(o.windows=S.extract(v.windows,s)),v.osx&&(o.osx=S.extract(v.osx,s)),v.linux&&(o.linux=S.extract(v.linux,s)),o}static platformAdapterExecutable(b,s){let o=Object.create(null);s=s.toLowerCase();for(const d of b)if(d.contributes){const a=d.contributes.debuggers;a&&a.length>0&&a.filter(c=>typeof c.type=="string"&&D.equalsIgnoreCase(c.type,s)).forEach(c=>{const m=S.extract(c,d.extensionLocation.fsPath);o=C.mixin(o,m,d.isBuiltin)})}let v;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=o.winx86||o.win||o.windows:k.isWindows?v=o.win||o.windows:k.isMacintosh?v=o.osx:k.isLinux&&(v=o.linux),v=v||o;let t=v.program||o.program;const f=v.args||o.args;let r=v.runtime||o.runtime;const n=v.runtimeArgs||o.runtimeArgs;if(r)return{type:"executable",command:r,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(f||[])};if(t)return{type:"executable",command:t,args:f||[]}}}e.ExecutableDebugAdapter=S}),define(fe[212],me([0,1,39,11,29,188]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function P(l,p){return new Promise((h,w)=>{let S="";const T=g.spawn(l,p);T.pid&&T.stdout.on("data",b=>{S+=b.toString()}),T.on("error",b=>{w(b)}),T.on("close",b=>{h(S)})})}let D;function C(l,p){if(!D)if(L.isWindows)D=new _.WindowsExternalTerminalService;else if(L.isMacintosh)D=new _.MacExternalTerminalService;else if(L.isLinux)D=new _.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=p.getConfiguration("terminal");return D.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}e.runInExternalTerminal=C;async function k(l){if(l)if(L.isWindows){const p=await new Promise((h,w)=>{Y(["windows-process-tree"],h,w)});return new Promise(h=>{p.getProcessTree(l,w=>{h(w.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(l)]).then(p=>{const h=p.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},p=>!0);return Promise.resolve(!0)}e.hasChildProcesses=k;var i;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(i||(i={}));function I(l,p,h,w){l=l.trim().toLowerCase();let S;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?S=1:l.indexOf("cmd.exe")>=0?S=0:l.indexOf("bash")>=0?S=2:L.isWindows?S=0:S=2;let T,b=" ";switch(S){case 1:if(T=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),h){const o=(0,y.getDriveLetter)(h);o&&(b+=`${o}:; `),b+=`cd ${T(h)}; `}if(w)for(let o in w){const v=w[o];v===null?b+=`Remove-Item env:${o}; `:b+=`\${env:${o}}='${v}'; `}if(p.length>0){const o=T(p.shift());b+=o[0]==="'"?`& ${o} `:`${o} `;for(let v of p)b+=`${T(v)} `}break;case 0:if(T=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),h){const o=(0,y.getDriveLetter)(h);o&&(b+=`${o}: && `),b+=`cd ${T(h)} && `}if(w){b+='cmd /C "';for(let o in w){let v=w[o];v===null?b+=`set "${o}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${o}=${v}" && `)}}for(let o of p)b+=`${T(o)} `;w&&(b+='"');break;case 2:T=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const s=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(h&&(b+=`cd ${T(h)} ; `),w){b+="/usr/bin/env";for(let o in w){const v=w[o];v===null?b+=` -u ${s(o)}`:b+=` ${s(`${o}=${v}`)}`}b+=" "}for(let o of p)b+=`${T(o)} `;break}return b}e.prepareCommand=I}),define(fe[128],me([0,1,30,78,103,10,8,11,63]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var i;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(i=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var S;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(S=e.CellEditType||(e.CellEditType={}));var T;(function(E){E.scheme=_.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function R(M,z){return M.with({scheme:E.scheme,fragment:`ch${z.toString().padStart(7,"0")}${M.scheme!==_.Schemas.file?M.scheme:""}`})}E.generate=R;function B(M){if(M.scheme!==E.scheme)return;const z=A.exec(M.fragment);return z?{handle:Number(z[1]),notebook:M.with({scheme:M.fragment.substr(z[0].length)||_.Schemas.file,fragment:null})}:void 0}E.parse=B;function N(M){if(M.scheme!==_.Schemas.vscodeNotebookCellMetadata)return;const z=A.exec(M.fragment);return z?{handle:Number(z[1]),notebook:M.with({scheme:M.fragment.substr(z[0].length)||_.Schemas.file,fragment:null})}:void 0}E.parseCellMetadataUri=N;function F(M,z,U){return M.with({scheme:U,fragment:`ch${z.toString().padStart(7,"0")}${M.scheme!==_.Schemas.file?M.scheme:""}`})}E.generateCellUri=F;function $(M,z){if(M.scheme!==z)return;const U=A.exec(M.fragment);return U?{handle:Number(U[1]),notebook:M.with({scheme:M.fragment.substr(U[0].length)||_.Schemas.file,fragment:null})}:void 0}E.parseCellUri=$})(T=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(E){return b.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function o(E){return b.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=o;function v(E){return b.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=v;const t=E=>D.isWindows?E.replace(/\//g,"\\"):E;class f{constructor(A=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(A)].map(B=>({pattern:B,matches:g.parse(t(B))}))}sort(A){const R=new Map(L.Iterable.map(A,N=>[N,t(N)]));let B=[];for(const{matches:N}of this.order)for(const[F,$]of R)if(N($)){B.push(F),R.delete(F);break}return R.size&&(B=B.concat([...R.keys()].sort((N,F)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(F)))),B}prioritize(A,R){const B=this.findIndex(A);if(B===-1){this.order.unshift({pattern:A,matches:g.parse(t(A))});return}const N=new Set(R.map($=>this.findIndex($,B)));N.delete(-1);const F=Array.from(N).sort();this.order.splice(B+1,0,...F.map($=>this.order[$]));for(let $=F.length-1;$>=0;$--)this.order.splice(F[$],1)}toArray(){return this.order.map(A=>A.pattern)}findIndex(A,R=this.order.length){const B=t(A);for(let N=0;N<R;N++)if(this.order[N].matches(B))return N;return-1}}e.MimeTypeDisplayOrder=f;function r(E,A,R,B=(N,F)=>N===F){const N=[];function F(z,U,x){if(U===0&&x.length===0)return;const j=N[N.length-1];j&&j.start+j.deleteCount===z?(j.deleteCount+=U,j.toInsert.push(...x)):N.push({start:z,deleteCount:U,toInsert:x})}let $=0,M=0;for(;;){if($===E.length){F($,0,A.slice(M));break}if(M===A.length){F($,E.length-$,[]);break}const z=E[$],U=A[M];if(B(z,U)){$+=1,M+=1;continue}R(U)?(F($,1,[]),$+=1):(F($,0,[U]),M+=1)}return N}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(E){E.default="default",E.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(E){const A=E;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=d;function a(E,A,R){if(Array.isArray(E.viewType)&&E.viewType.indexOf(A)>=0||E.viewType===A)return!0;if(E.filenamePattern){let B=d(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,N=d(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(g.match(B,(0,P.basename)(R.fsPath).toLowerCase()))return!(N&&g.match(N,(0,P.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class c{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)A[R]=this.textModel.cells[R].getHashValue();return A}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var m;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(A){return`${u._prefix}${A}`}static parse(A){if(A.startsWith(u._prefix))return A.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(fe[213],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(fe[214],me([0,1,178,4,63]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[215],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=g;function L(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=L}),define(fe[129],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var _;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(I,l)=>{l.expand!==void 0&&(I.expand=l.expand),l.item!==void 0&&(I.item=I.item?Object.assign(I.item,l.item):l.item)};e.applyTestItemUpdate=P;var D;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(D=e.DetailType||(e.DetailType={}));var C;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(l){}update(l){}remove(l,p){}complete(){}}e.IncrementalChangeCollector=k;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const p=this.createChangeCollector();for(const h of l)switch(h[0]){case 0:{const w=h[1];if(w.parent){if(this.items.has(w.parent)){const S=this.items.get(w.parent);S.children.add(w.item.extId);const T=this.createItem(w,S);this.items.set(w.item.extId,T),p.add(T)}}else{const S=this.createItem(w);this.roots.add(S),this.items.set(w.item.extId,S),p.add(S)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=h[1],S=this.items.get(w.extId);if(!S)break;w.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,w),p.update(S);break}case 2:{const w=this.items.get(h[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const S=[[h[1]]];for(;S.length;)for(const T of S.pop()){const b=this.items.get(T);b&&(S.push(b.children),this.items.delete(T),p.remove(b,b!==w),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}p.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=i}),define(fe[90],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(_){_.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(_){_[_.IsSame=0]="IsSame",_[_.Disconnected=1]="Disconnected",_[_.IsChild=2]="IsChild",_[_.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class y{constructor(P,D=P.length){if(this.path=P,this.viewEnd=D,P.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(P,D,C=P.parent){if(P.id===D)return new y([D]);let k=[P.id];for(let i=C;i&&i.id!==D;i=i.parent)k.push(i.id);return k.push(D),new y(k.reverse())}static isRoot(P){return!P.includes("\0")}static fromString(P){return new y(P.split("\0"))}static join(P,D){return new y([...P.path,D])}static joinToString(P,D){return P.toString()+"\0"+D}static compare(P,D){return P===D?0:D.startsWith(P+"\0")?2:P.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new y(this.path,P)}compare(P){if(typeof P=="string")return y.compare(this.toString(),P);for(let D=0;D<P.viewEnd&&D<this.viewEnd;D++)if(P.path[D]!==this.path[D])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=y}),define(fe[216],me([0,1,8,38,12,25,11,81,179]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,l,p){this._contributedVariables=new Map,this._context=I,this._labelService=l,p&&(this._envVariablesPromise=p.then(h=>this.prepareEnv(h)))}prepareEnv(I){if(P.isWindows){const l=Object.create(null);return Object.keys(I).forEach(p=>{l[p.toLowerCase()]=I[p]}),l}return I}resolveWithEnvironment(I,l,p){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,p)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,p,h){const w=_.deepClone(l);return P.isWindows&&w.windows?Object.keys(w.windows).forEach(S=>w[S]=w.windows[S]):P.isMacintosh&&w.osx?Object.keys(w.osx).forEach(S=>w[S]=w.osx[S]):P.isLinux&&w.linux&&Object.keys(w.linux).forEach(S=>w[S]=w.linux[S]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,w,p,h)}async resolveAnyAsync(I,l,p){return this.resolveAnyBase(I,l,p)}async resolveAnyMap(I,l,p){const h=new Map;return{newConfig:await this.resolveAnyBase(I,l,p,h),resolvedVariables:h}}resolveWithInteractionReplace(I,l,p,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,p,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,p,h,w){if(y.isString(p))return this.resolveString(I,l,p,h,w);if(y.isArray(p))return p.map(S=>this.recursiveResolve(I,l,S,h,w));if(y.isObject(p)){let S=Object.create(null);return Object.keys(p).forEach(T=>{const b=this.resolveString(I,l,T,h,w);S[b]=this.recursiveResolve(I,l,p[T],h,w)}),S}return p}resolveString(I,l,p,h,w){return p.replace(k.VARIABLE_REGEXP,(T,b)=>{if(b.includes(k.VARIABLE_LHS))return T;let s=this.evaluateSingleVariable(I,T,b,l,h);return w&&w.set(b,s),s!==T&&y.isString(s)&&s.match(k.VARIABLE_REGEXP)&&(s=this.resolveString(I,l,s,h,w)),s})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,p,h,w){let S;const T=p.split(":");T.length>1&&(p=T[0],S=T[1]);const b=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,C.localize)(0,null,l))},s=()=>{const v=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,C.localize)(1,null,l,g.basename(v)))},o=()=>{if(S){const v=this._context.getFolderUri(S);if(v)return v;throw new Error((0,C.localize)(2,null,l,S))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,l)):new Error((0,C.localize)(4,null,l))};switch(p){case"env":if(S){if(I){const v=I[P.isWindows?S.toLowerCase():S];if(y.isString(v))return v}return""}throw new Error((0,C.localize)(5,null,l));case"config":if(S){const v=this._context.getConfigurationValue(h,S);if(y.isUndefinedOrNull(v))throw new Error((0,C.localize)(6,null,l,S));if(y.isObject(v))throw new Error((0,C.localize)(7,null,l,S));return v}throw new Error((0,C.localize)(8,null,l));case"command":return this.resolveFromMap(l,S,w,"command");case"input":return this.resolveFromMap(l,S,w,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return h||S?(0,D.normalizeDriveLetter)(this.fsPath(o())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(o()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,C.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,C.localize)(10,null,l));case"file":return b();case"fileWorkspaceFolder":return s();case"relativeFile":return h||S?g.relative(this.fsPath(o()),b()):b();case"relativeFileDirname":const f=g.dirname(b());if(h||S){const a=g.relative(this.fsPath(o()),f);return a.length===0?".":a}return f;case"fileDirname":return g.dirname(b());case"fileExtname":return g.extname(b());case"fileBasename":return g.basename(b());case"fileBasenameNoExtension":const r=g.basename(b());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(b()));case"execPath":const n=this._context.getExecPath();return n||l;case"execInstallFolder":const d=this._context.getAppRoot();return d||l;case"pathSeparator":return g.sep;default:try{const a=S?`${p}:${S}`:p;return this.resolveFromMap(l,a,w,void 0)}catch(a){return l}}}}resolveFromMap(I,l,p,h){if(l&&p){const w=h===void 0?p[l]:p[h+":"+l];if(typeof w=="string")return w;throw new Error((0,C.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[130],me([0,1,4,208]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var y;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var _;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(_=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var D;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function k(w){const S=w;return(0,L.isEditorInput)(S?.editor)&&(0,L.isEditorInput)(S?.replacement)}e.isEditorReplacement=k;var i;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function p(w){const S=w;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=p;function h(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(fe[217],me([0,1,4,130]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(_){const P=_;return typeof _=="number"||(0,L.isEditorGroup)(P)}e.isPreferredGroup=y}),define(fe[16],me([0,1,18,22,99,292,62,25,12,2,43,85,180,118,66,128,90,217,7]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ge){function be(Q){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:qe}=Q,gt=new b.Position(Se-1,Le-1),Et=new b.Position(nt-1,qe-1);return new b.Selection(gt,Et)}ge.to=be;function re(Q){const{anchor:Se,active:Le}=Q;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=re})(s=e.Selection||(e.Selection={}));var o;(function(ge){function be(Q){if(!Q)return;const{start:Se,end:Le}=Q;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=be;function re(Q){if(!Q)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:nt,endColumn:qe}=Q;return new b.Range(Se-1,Le-1,nt-1,qe-1)}ge.to=re})(o=e.Range||(e.Range={}));var v;(function(ge){function be(re){switch(re){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ge.to=be})(v=e.TokenType||(e.TokenType={}));var t;(function(ge){function be(Q){return new b.Position(Q.lineNumber-1,Q.column-1)}ge.to=be;function re(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ge.from=re})(t=e.Position||(e.Position={}));var f;(function(ge){function be(Se,Le){return(0,g.coalesce)((0,g.asArray)(Se).map(nt=>re(nt,Le)))}ge.from=be;function re(Se,Le){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:Q(Se.scheme,Le),pattern:typeof Se.pattern=="undefined"?void 0:le.from(Se.pattern),exclusive:Se.exclusive}}function Q(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(f=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ge){function be(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ge.from=be;function re(Q){switch(Q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ge.to=re})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ge){function be(Q){let Se;return Q.code&&((0,C.isString)(Q.code)||(0,C.isNumber)(Q.code)?Se=String(Q.code):Se={value:String(Q.code.value),target:Q.code.target}),{...o.from(Q.range),message:Q.message,source:Q.source,code:Se,severity:a.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(d.from),tags:Array.isArray(Q.tags)?(0,g.coalesce)(Q.tags.map(r.from)):void 0}}ge.from=be;function re(Q){const Se=new b.Diagnostic(o.to(Q),Q.message,a.to(Q.severity));return Se.source=Q.source,Se.code=(0,C.isString)(Q.code)?Q.code:Q.code?.value,Se.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(d.to),Se.tags=Q.tags&&(0,g.coalesce)(Q.tags.map(r.to)),Se}ge.to=re})(n=e.Diagnostic||(e.Diagnostic={}));var d;(function(ge){function be(Q){return{...o.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ge.from=be;function re(Q){return new b.DiagnosticRelatedInformation(new b.Location(Q.resource,o.to(Q)),Q.message)}ge.to=re})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(ge){function be(Q){switch(Q){case b.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}ge.from=be;function re(Q){switch(Q){case p.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ge.to=re})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ge){function be(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?T.SIDE_GROUP:T.ACTIVE_GROUP}ge.from=be;function re(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=re})(c=e.ViewColumn||(e.ViewColumn={}));function m(ge){return typeof ge.range!="undefined"}function u(ge){return ge.length===0?!0:!!m(ge[0])}e.isDecorationOptionsArr=u;var E;(function(ge){function be(qe){return qe.map(ge.from)}ge.fromMany=be;function re(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Q(qe){let gt;if(re(qe)){const{language:wt,value:Dt}=qe;gt={value:"```"+wt+`
`+Dt+"\n```\n"}}else b.MarkdownString.isMarkdownString(qe)?gt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?gt={value:qe}:gt={value:""};const Et=Object.create(null);gt.uris=Et;const pt=wt=>{try{let Dt=k.URI.parse(wt,!0);Dt=Dt.with({query:Se(Dt.query,Et)}),Et[wt]=Dt}catch(Dt){}return""},vt=new _.Renderer;return vt.link=pt,vt.image=wt=>pt(y.parseHrefAndDimensions(wt).href),_(gt.value,{renderer:vt}),gt}ge.from=Q;function Se(qe,gt){if(!qe)return qe;let Et;try{Et=(0,P.parse)(qe)}catch(vt){}if(!Et)return qe;let pt=!1;return Et=(0,D.cloneAndChange)(Et,vt=>{if(k.URI.isUri(vt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[wt]=vt,pt=!0,wt}else return}),pt?JSON.stringify(Et):qe}function Le(qe){const gt=new b.MarkdownString(qe.value,qe.supportThemeIcons);return gt.isTrusted=qe.isTrusted,gt.supportHtml=qe.supportHtml,gt}ge.to=Le;function nt(qe){if(!!qe)return typeof qe=="string"?qe:ge.from(qe)}ge.fromStrict=nt})(E=e.MarkdownString||(e.MarkdownString={}));function A(ge){return u(ge)?ge.map(be=>({range:o.from(be.range),hoverMessage:Array.isArray(be.hoverMessage)?E.fromMany(be.hoverMessage):be.hoverMessage?E.from(be.hoverMessage):void 0,renderOptions:be.renderOptions})):ge.map(be=>({range:o.from(be)}))}e.fromRangeOrRangeWithMessage=A;function R(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?k.URI.file(ge):ge}e.pathOrURIToURI=R;var B;(function(ge){function be(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?R(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ge.from=be})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(ge){function be(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?R(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?B.from(re.before):void 0,after:re.after?B.from(re.after):void 0}}ge.from=be})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ge){function be(re){if(typeof re=="undefined")return re;switch(re){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=be})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(ge){function be(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?F.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?N.from(re.light):void 0,dark:re.dark?N.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?R(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?B.from(re.before):void 0,after:re.after?B.from(re.after):void 0}}ge.from=be})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(ge){function be(Q){return{text:Q.newText,eol:Q.newEol&&J.from(Q.newEol),range:o.from(Q.range)}}ge.from=be;function re(Q){const Se=new b.TextEdit(o.to(Q.range),Q.text);return Se.newEol=typeof Q.eol=="undefined"?void 0:J.to(Q.eol),Se}ge.to=re})(M=e.TextEdit||(e.TextEdit={}));var z;(function(ge){function be(Q,Se,Le){const nt={edits:[]};if(Q instanceof b.WorkspaceEdit)for(let qe of Q._allEntries())if(qe._type===1)nt.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const gt=Se?.getDocument(qe.uri);nt.edits.push({_type:2,resource:qe.uri,edit:M.from(qe.edit),modelVersionId:gt?.version,metadata:qe.metadata})}else qe._type===3?nt.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&nt.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(tt.from)}});return nt}ge.from=be;function re(Q){const Se=new b.WorkspaceEdit;for(const Le of Q.edits)Le.edit?Se.replace(k.URI.revive(Le.resource),o.to(Le.edit.range),Le.edit.text):Se.renameFile(k.URI.revive(Le.oldUri),k.URI.revive(Le.newUri),Le.options);return Se}ge.to=re})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(ge){const be=Object.create(null);be[b.SymbolKind.File]=0,be[b.SymbolKind.Module]=1,be[b.SymbolKind.Namespace]=2,be[b.SymbolKind.Package]=3,be[b.SymbolKind.Class]=4,be[b.SymbolKind.Method]=5,be[b.SymbolKind.Property]=6,be[b.SymbolKind.Field]=7,be[b.SymbolKind.Constructor]=8,be[b.SymbolKind.Enum]=9,be[b.SymbolKind.Interface]=10,be[b.SymbolKind.Function]=11,be[b.SymbolKind.Variable]=12,be[b.SymbolKind.Constant]=13,be[b.SymbolKind.String]=14,be[b.SymbolKind.Number]=15,be[b.SymbolKind.Boolean]=16,be[b.SymbolKind.Array]=17,be[b.SymbolKind.Object]=18,be[b.SymbolKind.Key]=19,be[b.SymbolKind.Null]=20,be[b.SymbolKind.EnumMember]=21,be[b.SymbolKind.Struct]=22,be[b.SymbolKind.Event]=23,be[b.SymbolKind.Operator]=24,be[b.SymbolKind.TypeParameter]=25;function re(Se){return typeof be[Se]=="number"?be[Se]:6}ge.from=re;function Q(Se){for(const Le in be)if(be[Le]===Se)return Number(Le);return b.SymbolKind.Property}ge.to=Q})(U=e.SymbolKind||(e.SymbolKind={}));var x;(function(ge){function be(Q){switch(Q){case b.SymbolTag.Deprecated:return 1}}ge.from=be;function re(Q){switch(Q){case 1:return b.SymbolTag.Deprecated}}ge.to=re})(x=e.SymbolTag||(e.SymbolTag={}));var j;(function(ge){function be(Q){return{name:Q.name,kind:U.from(Q.kind),tags:Q.tags&&Q.tags.map(x.from),containerName:Q.containerName,location:K.from(Q.location)}}ge.from=be;function re(Q){const Se=new b.SymbolInformation(Q.name,U.to(Q.kind),Q.containerName,K.to(Q.location));return Se.tags=Q.tags&&Q.tags.map(x.to),Se}ge.to=re})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function be(Q){const Se={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),kind:U.from(Q.kind),tags:Q.tags?.map(x.from)??[]};return Q.children&&(Se.children=Q.children.map(be)),Se}ge.from=be;function re(Q){const Se=new b.DocumentSymbol(Q.name,Q.detail,U.to(Q.kind),o.to(Q.range),o.to(Q.selectionRange));return(0,g.isNonEmptyArray)(Q.tags)&&(Se.tags=Q.tags.map(x.to)),Q.children&&(Se.children=Q.children.map(re)),Se}ge.to=re})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(ge){function be(Q){const Se=new b.CallHierarchyItem(U.to(Q.kind),Q.name,Q.detail||"",k.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Se._sessionId=Q._sessionId,Se._itemId=Q._itemId,Se}ge.to=be;function re(Q,Se,Le){if(Se=Se??Q._sessionId,Le=Le??Q._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:Q.name,detail:Q.detail,kind:U.from(Q.kind),uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}ge.from=re})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(ge){function be(re){return new b.CallHierarchyIncomingCall(W.to(re.from),re.fromRanges.map(Q=>o.to(Q)))}ge.to=be})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function be(re){return new b.CallHierarchyOutgoingCall(W.to(re.to),re.fromRanges.map(Q=>o.to(Q)))}ge.to=be})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var K;(function(ge){function be(Q){return{range:Q.range&&o.from(Q.range),uri:Q.uri}}ge.from=be;function re(Q){return new b.Location(k.URI.revive(Q.uri),o.to(Q.range))}ge.to=re})(K=e.location||(e.location={}));var de;(function(ge){function be(Q){const Se=Q,Le=Q;return{originSelectionRange:Se.originSelectionRange?o.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:o.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?o.from(Se.targetSelectionRange):void 0}}ge.from=be;function re(Q){return{targetUri:k.URI.revive(Q.uri),targetRange:o.to(Q.range),targetSelectionRange:Q.targetSelectionRange?o.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?o.to(Q.originSelectionRange):void 0}}ge.to=re})(de=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(ge){function be(Q){return{range:o.from(Q.range),contents:E.fromMany(Q.contents)}}ge.from=be;function re(Q){return new b.Hover(Q.contents.map(E.to),o.to(Q.range))}ge.to=re})(_e=e.Hover||(e.Hover={}));var Ce;(function(ge){function be(Q){return{range:o.from(Q.range),expression:Q.expression}}ge.from=be;function re(Q){return new b.EvaluatableExpression(o.to(Q.range),Q.expression)}ge.to=re})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ge){function be(Q){if(Q instanceof b.InlineValueText)return{type:"text",range:o.from(Q.range),text:Q.text};if(Q instanceof b.InlineValueVariableLookup)return{type:"variable",range:o.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=be;function re(Q){switch(Q.type){case"text":return{range:o.to(Q.range),text:Q.text};case"variable":return{range:o.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:o.to(Q.range),expression:Q.expression}}}ge.to=re})(Pe=e.InlineValue||(e.InlineValue={}));var Be;(function(ge){function be(Q){return{frameId:Q.frameId,stoppedLocation:o.from(Q.stoppedLocation)}}ge.from=be;function re(Q){return new b.InlineValueContext(Q.frameId,o.to(Q.stoppedLocation))}ge.to=re})(Be=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(ge){function be(Q){return{range:o.from(Q.range),kind:Q.kind}}ge.from=be;function re(Q){return new b.DocumentHighlight(o.to(Q.range),Q.kind)}ge.to=re})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function be(re){switch(re){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ge.to=be})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(ge){function be(re){return{triggerKind:He.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ge.to=be})(G=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function be(Q){switch(Q){case b.CompletionItemTag.Deprecated:return 1}}ge.from=be;function re(Q){switch(Q){case 1:return b.CompletionItemTag.Deprecated}}ge.to=re})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var te;(function(ge){const be=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function re(Le){return be.get(Le)??9}ge.from=re;const Q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Se(Le){return Q.get(Le)??b.CompletionItemKind.Property}ge.to=Se})(te=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(ge){function be(re,Q){const Se=new b.CompletionItem(re.label);return Se.insertText=re.insertText,Se.kind=te.to(re.kind),Se.tags=re.tags?.map(ee.to),Se.detail=re.detail,Se.documentation=y.isMarkdownString(re.documentation)?E.to(re.documentation):re.documentation,Se.sortText=re.sortText,Se.filterText=re.filterText,Se.preselect=re.preselect,Se.commitCharacters=re.commitCharacters,i.Range.isIRange(re.range)?Se.range=o.to(re.range):typeof re.range=="object"&&(Se.range={inserting:o.to(re.range.insert),replacing:o.to(re.range.replace)}),Se.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Se.insertText=new b.SnippetString(re.insertText):(Se.insertText=re.insertText,Se.textEdit=Se.range instanceof b.Range?new b.TextEdit(Se.range,Se.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Se.additionalTextEdits=re.additionalTextEdits.map(Le=>M.to(Le))),Se.command=Q&&re.command?Q.fromInternal(re.command):void 0,Se}ge.to=be})(ce=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function be(Q){return{label:Q.label,documentation:Q.documentation?E.fromStrict(Q.documentation):void 0}}ge.from=be;function re(Q){return{label:Q.label,documentation:y.isMarkdownString(Q.documentation)?E.to(Q.documentation):Q.documentation}}ge.to=re})(Z=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(ge){function be(Q){return{label:Q.label,documentation:Q.documentation?E.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.from):[],activeParameter:Q.activeParameter}}ge.from=be;function re(Q){return{label:Q.label,documentation:y.isMarkdownString(Q.documentation)?E.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.to):[],activeParameter:Q.activeParameter}}ge.to=re})(se=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function be(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(se.from):[]}}ge.from=be;function re(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(se.to):[]}}ge.to=re})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function be(Q){return{text:Q.text,position:t.from(Q.position),kind:je.from(Q.kind??b.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}ge.from=be;function re(Q){const Se=new b.InlayHint(Q.text,t.to(Q.position),je.to(Q.kind));return Se.whitespaceAfter=Q.whitespaceAfter,Se.whitespaceBefore=Q.whitespaceBefore,Se}ge.to=re})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function be(Q){return Q}ge.from=be;function re(Q){return Q}ge.to=re})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function be(Q){return{range:o.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ge.from=be;function re(Q){let Se;if(Q.url)try{Se=typeof Q.url=="string"?k.URI.parse(Q.url,!0):k.URI.revive(Q.url)}catch(Le){}return new b.DocumentLink(o.to(Q.range),Se)}ge.to=re})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ge){function be(Q){const Se=new b.ColorPresentation(Q.label);return Q.textEdit&&(Se.textEdit=M.to(Q.textEdit)),Q.additionalTextEdits&&(Se.additionalTextEdits=Q.additionalTextEdits.map(Le=>M.to(Le))),Se}ge.to=be;function re(Q){return{label:Q.label,textEdit:Q.textEdit?M.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Se=>M.from(Se)):void 0}}ge.from=re})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function be(Q){return new b.Color(Q[0],Q[1],Q[2],Q[3])}ge.to=be;function re(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ge.from=re})(rt=e.Color||(e.Color={}));var ct;(function(ge){function be(Q){return{range:o.from(Q.range)}}ge.from=be;function re(Q){return new b.SelectionRange(o.to(Q.range))}ge.to=re})(ct=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ge){function be(re){switch(re){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ge.to=be})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(ge){function be(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=be;function re(Q){switch(Q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ge.to=re})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ge){function be(Q){if(Q===b.EndOfLine.CRLF)return 1;if(Q===b.EndOfLine.LF)return 0}ge.from=be;function re(Q){if(Q===1)return b.EndOfLine.CRLF;if(Q===0)return b.EndOfLine.LF}ge.to=re})(J=e.EndOfLine||(e.EndOfLine={}));var ie;(function(ge){function be(re){if(typeof re=="object")return re.viewId;switch(re){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=be})(ie=e.ProgressLocation||(e.ProgressLocation={}));var Ee;(function(ge){function be(re){const Q={start:re.start+1,end:re.end+1};return re.kind&&(Q.kind=Qe.from(re.kind)),Q}ge.from=be})(Ee=e.FoldingRange||(e.FoldingRange={}));var Qe;(function(ge){function be(re){if(re)switch(re){case b.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ge.from=be})(Qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ge){function be(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?o.from(re.selection):void 0,override:typeof re.override=="boolean"?l.EditorResolution.DISABLED:void 0}}ge.from=be})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(ge){function be(Q){return Q instanceof b.RelativePattern||typeof Q=="string"?Q:re(Q)?new b.RelativePattern(Q.base,Q.pattern):Q}ge.from=be;function re(Q){const Se=Q;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(le=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function be(re){if(re){if(Array.isArray(re))return re.map(be);if(typeof re=="string")return re;{const Q=re;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:le.from(Q.pattern),exclusive:Q.exclusive}}}else return}ge.from=be})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(ge){function be(Q){return{start:Q.start,end:Q.end}}ge.from=be;function re(Q){return new b.NotebookRange(Q.start,Q.end)}ge.to=re})(Ue=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function be(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ge.to=be;function re(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ge.from=re})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var it;(function(ge){function be(Q){switch(Q){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=be;function re(Q){switch(Q){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ge.to=re})(it=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ge){function be(Q){const Se={metadata:Q.metadata??Object.create(null),cells:[]};for(let Le of Q.cells)b.NotebookCellData.validate(Le),Se.cells.push(tt.from(Le));return Se}ge.from=be;function re(Q){const Se=new b.NotebookData(Q.cells.map(tt.to));return(0,C.isEmptyObject)(Q.metadata)||(Se.metadata=Q.metadata),Se}ge.to=re})(ft=e.NotebookData||(e.NotebookData={}));var tt;(function(ge){function be(Q){return{cellKind:it.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Xe.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Re.from):[]}}ge.from=be;function re(Q){return new b.NotebookCellData(it.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Re.to):void 0,Q.metadata,Q.internalMetadata?Xe.to(Q.internalMetadata):void 0)}ge.to=re})(tt=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(ge){function be(Q){return{mime:Q.mime,valueBytes:L.VSBuffer.wrap(Q.data)}}ge.from=be;function re(Q){return new b.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}ge.to=re})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function be(Q){return{outputId:Q.id,items:Q.items.map(ut.from),metadata:Q.metadata}}ge.from=be;function re(Q){const Se=Q.items.map(ut.to);return new b.NotebookCellOutput(Se,Q.outputId,Q.metadata)}ge.to=re})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ge){function be(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(Se(Le))return new b.RelativePattern(Le.base,Le.pattern);if(Q(Le))return{include:le.from(Le.include)||void 0,exclude:le.from(Le.exclude)||void 0}}}ge.from=be;function re(Le){return typeof Le=="string"?Le:Se(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=re;function Q(Le){const nt=Le,qe=le.from(nt.include);if(!(qe&&qe instanceof b.RelativePattern||typeof qe=="string"))return!1;const gt=le.from(nt.exclude);return!!(gt&&gt instanceof b.RelativePattern||typeof gt=="string")}function Se(Le){const nt=Le;return nt&&typeof nt.base=="string"&&typeof nt.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(ge){function be(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?B.from(re.top):void 0}}ge.from=be})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(ge){function be(re,Q,Se){const Le=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Le,Se),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ge.from=be})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function be(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ge.from=be})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var we;(function(ge){function be(Q){return{uri:Q.uri,provides:Q.provides}}ge.from=be;function re(Q){return new b.NotebookRendererScript(k.URI.revive(Q.uri),Q.provides)}ge.to=re})(we=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ve;(function(ge){function be(Q){return{message:E.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location?K.from(Q.location):void 0}}ge.from=be;function re(Q){const Se=new b.TestMessage(typeof Q.message=="string"?Q.message:E.to(Q.message));return Se.actualOutput=Q.actual,Se.expectedOutput=Q.expected,Se.location=Q.location?K.to(Q.location):void 0,Se}ge.to=re})(ve=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let be;(function(re){re.Delimiter="\0"})(be||(be={})),ge.namespace=(re,Q)=>re+"\0"+Q,ge.denamespace=re=>{const Q=re.indexOf("\0");return{ctrlId:re.slice(0,Q),tagId:re.slice(Q+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Ge;(function(ge){function be(Le){const nt=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:S.TestId.fromExtHostTestItem(Le,nt).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Fe.namespace(nt,qe.id)),range:o.from(Le.range)||null,description:Le.description||null,error:Le.error&&E.fromStrict(Le.error)||null}}ge.from=be;function re(Le){return{parent:void 0,error:void 0,id:S.TestId.fromString(Le.extId).localId,label:Le.label,uri:k.URI.revive(Le.uri),tags:(Le.tags||[]).map(nt=>{const{tagId:qe}=Fe.denamespace(nt);return new b.TestTag(qe)}),range:o.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=re;function Q(Le){const nt=S.TestId.fromString(Le.extId),qe=new h.TestItemImpl(nt.controllerId,nt.localId,Le.label,k.URI.revive(Le.uri));return qe.range=o.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function Se(Le){let nt;for(const qe of Le.tests){const gt=Q(qe.item);(0,h.getPrivateApiFor)(gt).parent=nt,nt=gt}return nt}ge.toItemFromContext=Se})(Ge=e.TestItem||(e.TestItem={})),function(ge){function be(Q){return{id:Q.id}}ge.from=be;function re(Q){return new b.TestTag(Q.id)}ge.to=re}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const be=(Q,Se)=>{const Le={...Ge.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(nt=>({state:nt.state,duration:nt.duration,messages:nt.messages.filter(qe=>qe.type===0).map(ve.to)})),children:Q.children.map(nt=>Se.get(nt)).filter(C.isDefined).map(nt=>be(nt,Se))};for(const nt of Le.children)nt.parent=Le;return Le};function re(Q){const Se=[],Le=new Map;for(const nt of Q.items)Le.set(nt.item.extId,nt),Q.request.targets.some(qe=>qe.controllerId===nt.controllerId&&qe.testIds.includes(nt.item.extId))&&Se.push(nt);return{completedAt:Q.completedAt,results:Se.map(nt=>be(nt,Le))}}ge.to=re})(ze=e.TestResults||(e.TestResults={}));var Ye;(function(ge){function be(Le){return{covered:Le.covered,total:Le.covered}}function re(Le){return"line"in Le?t.from(Le):o.from(Le)}function Q(Le){return"branches"in Le?{count:Le.executionCount,location:re(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&re(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:re(Le.location)}}ge.fromDetailed=Q;function Se(Le){return{uri:Le.uri,statement:be(Le.statementCoverage),branch:Le.branchCoverage&&be(Le.branchCoverage),function:Le.functionCoverage&&be(Le.functionCoverage),details:Le.detailedCoverage?.map(Q)}}ge.fromFile=Se})(Ye=e.TestCoverage||(e.TestCoverage={}));var lt;(function(ge){function be(re){switch(re){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ge.to=be})(lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function be(Q){const Se=new b.TypeHierarchyItem(U.to(Q.kind),Q.name,Q.detail||"",k.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return Se._sessionId=Q._sessionId,Se._itemId=Q._itemId,Se}ge.to=be;function re(Q,Se,Le){if(Se=Se??Q._sessionId,Le=Le??Q._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:U.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(x.from)}}ge.from=re})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[218],me([0,1,2,17,7,16,95]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(k,i,I,l={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,I,l)=>{const h={dispose:this._callbacks.push([i,I,k])};return Array.isArray(l)&&l.push(h),h}}async $participateInSave(k,i){const I=g.URI.revive(k);let l=!1;const p=setTimeout(()=>l=!0,this._thresholds.timeout),h=[];try{for(let w of[...this._callbacks]){if(l)break;const S=this._documents.getDocument(I),T=await this._deliverEventAsyncAndBlameBadListeners(w,{document:S,reason:_.TextDocumentSaveReason.to(i)});h.push(T)}}finally{clearTimeout(p)}return h}_deliverEventAsyncAndBlameBadListeners([k,i,I],l){const p=this._badListeners.get(k);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,i,l).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const w=this._badListeners.get(k);this._badListeners.set(k,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,I,l){const p=[],h=Date.now(),{document:w,reason:S}=l,{version:T}=w,b=Object.freeze({document:w,reason:S,waitUntil(s){if(Object.isFrozen(p))throw(0,L.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(s))}});try{i.apply(I,[b])}catch(s){return Promise.reject(s)}return Object.freeze(p),new Promise((s,o)=>{const v=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(v),s(t)}).catch(t=>{clearTimeout(v),o(t)})}).then(s=>{const o={edits:[]};for(const v of s)if(Array.isArray(v)&&v.every(t=>t instanceof y.TextEdit))for(const{newText:t,newEol:f,range:r}of v)o.edits.push({_type:2,resource:w.uri,edit:{range:r&&_.Range.from(r),text:t,eol:f&&_.EndOfLine.from(f)}});if(o.edits.length!==0)return T===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(fe[219],me([0,1,3,30,2,16,7]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(i,I,l,p,h){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,l&&(this._config+=1),p&&(this._config+=2),h&&(this._config+=4);const w=(0,L.parse)(I),S=i(T=>{if(!l)for(let b of T.created){const s=y.URI.revive(b);w(s.fsPath)&&this._onDidCreate.fire(s)}if(!p)for(let b of T.changed){const s=y.URI.revive(b);w(s.fsPath)&&this._onDidChange.fire(s)}if(!h)for(let b of T.deleted){const s=y.URI.revive(b);w(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,S)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(i,I,l){this._logService=I,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,l,p){return new D(this._onFileSystemEvent.event,i,I,l,p)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(l=>({oldUri:y.URI.revive(l.source),newUri:y.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(l=>y.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(l=>y.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(l,p,h)=>{const w=function(T){l.call(p,T)};return w.extension=i,I.event(w,void 0,h)}}async $onWillRunFileOperation(i,I,l,p){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},l,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>y.URI.revive(h.target))},l,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>y.URI.revive(h.target))},l,p)}}async _fireWillEvent(i,I,l,p){const h=new Set,w=[];if(await i.fireAsync(I,p,async(T,b)=>{const s=Date.now(),o=await Promise.resolve(T);o instanceof P.WorkspaceEdit&&(w.push(o),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-s>l&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),p.isCancellationRequested||w.length===0)return;const S={edits:[]};for(let T of w){let{edits:b}=_.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);S.edits=S.edits.concat(b)}return{edit:S,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=C}),define(fe[220],me([0,1,10,25,2,16,7,128]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(l,p,h,w){this.start=l,this.deletedCount=p,this.deletedItems=h,this.items=w}static asApiEvents(l){return l.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(h=>h.apiCell)}))}}class k{constructor(l,p,h){this.notebook=l,this._extHostDocument=p,this._cellData=h,this.handle=h.handle,this.uri=y.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(_.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(l,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:_.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return l._mime},set mime(h){l._mime=h},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(_.NotebookCellOutput.to)}setOutputItems(l,p,h){const w=h.map(_.NotebookCellOutputItem.to),S=this._outputs.find(T=>T.id===l);S&&(p||(S.items.length=0),S.items.push(...w))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(_.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=k;class i{constructor(l,p,h,w,S,T){this._proxy=l,this._textDocumentsAndEditors=p,this._textDocuments=h,this._emitter=w,this.uri=S,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=T.viewType,this._metadata=Object.freeze(T.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,T.cells]],!0),this._versionId=T.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===g.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(p){return p=l._validateIndex(p),l._cells[p].apiCell},getCells(p){return(p?l._getCells(p):l._cells).map(w=>w.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,p){this._versionId=l.versionId,this._isDirty=p;for(const h of l.rawEvents)h.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===D.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let p=l.start|0,h=l.end|0;return p<0&&(p=0),h>this._cells.length&&(h=this._cells.length),l.with({start:p,end:h})}_getCells(l){l=this._validateRange(l);const p=[];for(let h=l.start;h<l.end;h++)p.push(this._cells[h]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,p){if(this._disposed)return;const h=[],w=[],S=[];l.reverse().forEach(T=>{const s=T[2].map(t=>{const f=new k(this,this._textDocumentsAndEditors,t);return p||w.push(k.asModelAddData(this.apiNotebook,t)),f}),o=new C(T[0],T[1],[],s),v=this._cells.splice(T[0],T[1],...s);for(const t of v)S.push(t.uri),o.deletedItems.push(t.apiCell);h.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:S}),p||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(h)}))}_moveCell(l,p){const h=this._cells.splice(l,1);this._cells.splice(p,0,...h);const w=[new C(l,1,h.map(S=>S.apiCell),[]),new C(p,0,[],h)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(w)}))}_setCellOutputs(l,p){const h=this._cells[l];h.setOutputs(p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(l,p,h,w){const S=this._cells[l];S.setOutputItems(p,h,w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(l,p){const h=this._cells[l];h.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(h.uri,p)}_changeCellMime(l,p){const h=this._cells[l];h.apiCell.mime=p}_changeCellMetadata(l,p){const h=this._cells[l],w=h.apiCell.metadata;h.setMetadata(p);const S=h.apiCell.metadata;(0,L.equals)(w,S)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(l,p){const h=this._cells[l],w=h.internalMetadata;if(h.setInternalMetadata(p),w.runState!==p.runState){const S=p.runState??P.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:S}))}}getCellFromApiCell(l){return this._cells.find(p=>p.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(p=>p.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(fe[131],me([0,1,7,16,17]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class _{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:k})}replaceCells(C,k,i){this._throwIfFinalized(),!(C===k&&i.length===0)&&this._collectedEdits.push({editType:1,index:C,count:k-C,cells:i.map(L.NotebookCellData.from)})}}class P{constructor(C,k,i,I,l,p){this.id=C,this._proxy=k,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=I,this._viewColumn=p}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(k){if(!Array.isArray(k)||!k.every(g.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");C._selections=k,C._trySetSelections(k)},get visibleRanges(){return C._visibleRanges},revealRange(k,i){C._proxy.$tryRevealRange(C.id,L.NotebookRange.from(k),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(k){const i=new _(this.document.version);return k(i),C._applyEdit(i.finalize())},setDecorations(k,i){return C.setDecorations(k,i)}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(L.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const k=[];let i=-1;for(let I=0;I<C.cellEdits.length;I++){if(i<0){k.push(C.cellEdits[I]),i++;continue}const p=k[i],h=C.cellEdits[I];if(p.editType===1&&h.editType===1&&p.index===h.index){p.cells.push(...C.cellEdits[I].cells),p.count+=C.cellEdits[I].count;continue}k.push(C.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,k)}setDecorations(C,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return k.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(k),C.key)}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(fe[221],me([0,1,16,119,166,21,60,17]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,p,h){const w=this._handles++,{title:S,location:T,cancellable:b}=p,s={label:(0,y.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(w,{location:g.ProgressLocation.from(T),title:S,source:s,cancellable:b},l).catch(D.onUnexpectedExternalError),this._withProgress(w,h,!!b)}_withProgress(l,p,h){let w;h&&(w=new _.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,w));const S=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),w&&w.dispose()};let T;try{T=p(new i(this._proxy,l),h&&w?w.token:_.CancellationToken.None)}catch(b){throw S(l),b}return T.then(b=>S(l),b=>S(l)),T}$acceptProgressCanceled(l){const p=this._mapHandleToCancellationSource.get(l);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=C;function k(I,l){return I.message=l.message,typeof l.increment=="number"&&(typeof I.increment=="number"?I.increment+=l.increment:I.increment=l.increment),I}class i extends L.Progress{constructor(l,p){super(h=>this.throttledReport(h));this._proxy=l,this._handle=p}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}Ve([(0,P.throttle)(100,(I,l)=>k(I,l),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(fe[132],me([0,1,58,17,77,16,7]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(l,p,h){const w=D._Keys.nextId();l.$registerTextEditorDecorationType(p.identifier,w,_.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:w,dispose(){l.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=D,D._Keys=new y.IdGenerator("TextEditorDecorationType");class C{constructor(l,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,p){this._throwIfFinalized();let h=null;if(l instanceof P.Position)h=new P.Range(l,l);else if(l instanceof P.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,p,!1)}insert(l,p){this._throwIfFinalized(),this._pushEdit(new P.Range(l,l),p,!0)}delete(l){this._throwIfFinalized();let p=null;if(l instanceof P.Range)p=l;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(l,p,h){const w=this._document.validateRange(l);this._collectedEdits.push({range:w,text:p,forceMoveMarkers:h})}setEndOfLine(l){if(this._throwIfFinalized(),l!==P.EndOfLine.LF&&l!==P.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=C;class k{constructor(l,p,h,w){this._proxy=l,this._id=p,this._accept(h),this._logService=w;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(T){S._setTabSize(T)},get insertSpaces(){return S._insertSpaces},set insertSpaces(T){S._setInsertSpaces(T)},get cursorStyle(){return S._cursorStyle},set cursorStyle(T){S._setCursorStyle(T)},get lineNumbers(){return S._lineNumbers},set lineNumbers(T){S._setLineNumbers(T)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=_.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(l){const p=this._validateTabSize(l);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const p=this._validateInsertSpaces(l);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:_.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let h=!1;if(typeof l.tabSize!="undefined"){const w=this._validateTabSize(l.tabSize);w==="auto"?(h=!0,p.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,h=!0,p.tabSize=w)}if(typeof l.insertSpaces!="undefined"){const w=this._validateInsertSpaces(l.insertSpaces);w==="auto"?(h=!0,p.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,h=!0,p.insertSpaces=w)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,h=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,h=!0,p.lineNumbers=_.TextEditorLineNumbersStyle.from(l.lineNumbers)),h&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(l){l.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=k;class i{constructor(l,p,h,w,S,T,b,s){this.id=l,this._proxy=p,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new k(this._proxy,this.id,T,h),this._visibleRanges=b,this._viewColumn=s;const o=this;this.value=Object.freeze({get document(){return w.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(v){if(!(v instanceof P.Selection))throw(0,L.illegalArgument)("selection");o._selections=[v],o._trySetSelection()},get selections(){return o._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof P.Selection)))throw(0,L.illegalArgument)("selections");o._selections=v,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return o._options.value},set options(v){o._disposed||o._options.assign(v)},get viewColumn(){return o._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new C(w.getValue(),t);return v(f),o._applyEdit(f)},insertSnippet(v,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=o._selections.map(n=>_.Range.from(n));else if(t instanceof P.Position){const{lineNumber:n,column:d}=_.Position.from(t);r=[{startLineNumber:n,startColumn:d,endLineNumber:n,endColumn:d}]}else if(t instanceof P.Range)r=[_.Range.from(t)];else{r=[];for(const n of t)if(n instanceof P.Range)r.push(_.Range.from(n));else{const{lineNumber:d,column:a}=_.Position.from(n);r.push({startLineNumber:d,startColumn:a,endLineNumber:d,endColumn:a})}}return p.$tryInsertSnippet(l,v.value,r,f)},setDecorations(v,t){const f=t.length===0;f&&!o._hasDecorationsForKey.has(v.key)||(f?o._hasDecorationsForKey.delete(v.key):o._hasDecorationsForKey.add(v.key),o._runOnProxy(()=>{if(_.isDecorationOptionsArr(t))return p.$trySetDecorations(l,v.key,_.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let n=0,d=t.length;n<d;n++){const a=t[n];r[4*n]=a.start.line+1,r[4*n+1]=a.start.character+1,r[4*n+2]=a.end.line+1,r[4*n+3]=a.end.character+1}return p.$trySetDecorationsFast(l,v.key,r)}}))},revealRange(v,t){o._runOnProxy(()=>p.$tryRevealRange(l,_.Range.from(v),t||P.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(l,_.ViewColumn.from(v))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,g.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,g.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,g.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,g.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(_.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const h=p.edits.map(S=>S.range);h.sort((S,T)=>S.end.line===T.end.line?S.end.character===T.end.character?S.start.line===T.start.line?S.start.character-T.start.character:S.start.line-T.start.line:S.end.character-T.end.character:S.end.line-T.end.line);for(let S=0,T=h.length-1;S<T;S++){const b=h[S].end;if(h[S+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=p.edits.map(S=>({range:_.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,w,{setEndOfLine:typeof p.setEndOfLine=="number"?_.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(fe[222],me([0,1,169,23,2,3,6,209,15,7,12,18,16,21,206]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(b,s){if((0,i.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let o;return Array.isArray(b.highlights)&&(o=b.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),o=o.length?o:void 0),{label:b.label,highlights:o}}}class S{constructor(s,o,v){this._proxy=s,this.commands=o,this.logService=v,this.treeViews=new Map;function t(f){return f&&f.$treeViewId&&f.$treeItemHandle}o.registerArgumentProcessor({processArgument:f=>t(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(r=>t(r)?this.convertArgument(r):r):f})}registerTreeDataProvider(s,o,v){const t=this.createTreeView(s,{treeDataProvider:o},v);return{dispose:()=>t.dispose()}}createTreeView(s,o,v){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=o.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,canDragAndDrop:t}),r=this.createExtHostTreeView(s,o,v);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(n){r.message=n},get title(){return r.title},set title(n){r.title=n},get description(){return r.description},set description(n){r.description=n},reveal:(n,d)=>r.reveal(n,d),dispose:async()=>{await f,this.treeViews.delete(s),r.dispose()}}}$getChildren(s,o){const v=this.treeViews.get(s);return v?v.getChildren(o):Promise.reject(new Error((0,g.localize)(0,null,s)))}async $onDrop(s,o,v){const t=this.treeViews.get(s);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,s)));const f=h.TreeDataTransferConverter.toITreeDataTransfer(o);if(f.items.has(D.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await f.items.get(D.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(d=>t.getExtensionElement(d)).filter(d=>!!d);n.length>0?f.items.set(D.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):f.items.delete(D.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(f,v)}async $hasResolve(s){const o=this.treeViews.get(s);if(!o)throw new Error((0,g.localize)(2,null,s));return o.hasResolve}$resolve(s,o,v){const t=this.treeViews.get(s);if(!t)throw new Error((0,g.localize)(3,null,s));return t.resolveTreeItem(o,v)}$setExpanded(s,o,v){const t=this.treeViews.get(s);if(!t)throw new Error((0,g.localize)(4,null,s));t.setExpanded(o,v)}$setSelection(s,o){const v=this.treeViews.get(s);if(!v)throw new Error((0,g.localize)(5,null,s));v.setSelection(o)}$setVisible(s,o){const v=this.treeViews.get(s);if(!v)throw new Error((0,g.localize)(6,null,s));v.setVisible(o)}createExtHostTreeView(s,o,v){const t=new T(s,o,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(s,t),t}convertArgument(s){const o=this.treeViews.get(s.$treeViewId);return o?o.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=S;class T extends P.Disposable{constructor(s,o,v,t,f,r){super();if(this.viewId=s,this.proxy=v,this.commands=t,this.logService=f,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,r.contributes&&r.contributes.views)for(const a in r.contributes.views)for(const c of r.contributes.views[a])c.id===s&&(this._title=c.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(a=>this._onDidChangeData.fire({message:!1,element:a}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let n,d;this._register(_.Event.debounce(this._onDidChangeData.event,(a,c)=>(a||(a={message:!1,elements:[]}),c.element!==!1&&(n||(n=new Promise(m=>d=m),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(c.element)?a.elements.push(...c.element):a.elements.push(c.element)),c.message&&(a.message=!0),a),200,!0)(({message:a,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=d;return n=null,this.refresh(c).then(()=>m())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,i.isUndefinedOrNull)(s))}async getChildren(s){const o=s?this.getExtensionElement(s):void 0;if(s&&!o)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(s);return v||(v=await this.fetchChildrenNodes(o)),v?v.map(t=>t.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,o){o=o||{select:!0,focus:!1};const v=(0,i.isUndefinedOrNull)(o.select)?!0:o.select,t=(0,i.isUndefinedOrNull)(o.focus)?!1:o.focus,f=(0,i.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(r=>this.resolveTreeNode(s,r[r.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:r.map(d=>d.item)},{select:v,focus:t,expand:f})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:f})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,o){const v=this.getExtensionElement(s);v&&(o?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(s){(0,I.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(s,o){const v=this.getExtensionElement(o);if(!!v)return(0,C.asPromise)(()=>this.dndController?.onDrop(s,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,o){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(s);if(v){const t=this.nodes.get(v);if(t){const f=await this.dataProvider.resolveTreeItem(t.extensionItem,v,o)??t.extensionItem;return t.item.tooltip=this.getTooltip(f.tooltip),t.item.command=this.getCommand(t.disposableStore,f.command),t.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(o=>o?this.resolveUnknownParentChain(o).then(v=>this.resolveTreeNode(o,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(s){const o=this.nodes.get(s);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,o){const v=this.nodes.get(s);return v?Promise.resolve(v):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(t=>this.createHandle(s,t,o,!0)).then(t=>this.getChildren(o?o.item.handle:void 0).then(()=>{const f=this.getExtensionElement(t);if(f){const r=this.nodes.get(f);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(s){if(s){let o;if(typeof s=="string"){const v=this.getExtensionElement(s);o=v?this.nodes.get(v):void 0}else o=s;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const o=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=s?this.nodes.get(s):void 0,t=await this.dataProvider.getChildren(s);if(o.token.isCancellationRequested)return;const f=await Promise.all((0,I.coalesce)(t||[]).map(async r=>{const n=await this.dataProvider.getTreeItem(r);return n&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(r,n,v):null}));return o.token.isCancellationRequested?void 0:(0,I.coalesce)(f)}finally{o.dispose()}}refresh(s){if(s.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(s);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const o=new Set,v=s.map(f=>this.nodes.get(f));for(const f of v)if(f&&!o.has(f.item.handle)){let r=f;for(;r&&r.parent&&v.findIndex(n=>r&&r.parent&&n&&n.item.handle===r.parent.item.handle)===-1;){const n=this.elements.get(r.parent.item.handle);r=n?this.nodes.get(n):void 0}r&&!r.parent&&o.add(f.item.handle)}const t=[];return o.forEach(f=>{const r=this.elements.get(f);if(r){const n=this.nodes.get(r);n&&(!n.parent||!o.has(n.parent.item.handle))&&t.push(f)}}),t}refreshHandles(s){const o={};return Promise.all(s.map(v=>this.refreshNode(v).then(t=>{t&&(o[v]=t.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(s){const o=this.getExtensionElement(s);if(o){const v=this.nodes.get(o);if(v)return this.clearChildren(o),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>{if(t){const f=this.createTreeNode(o,t,v.parent);return this.updateNodeCache(o,f,v,v.parent),v.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,o,v){const t=this.createTreeNode(s,o,v);if(o.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,o.id));return this.addNodeToCache(s,t),this.addNodeToParentCache(t,v),t}getTooltip(s){return k.MarkdownString.isMarkdownString(s)?l.MarkdownString.from(s):s}getCommand(s,o){return o?this.commands.toInternal(o,s):void 0}createTreeNode(s,o,v){const t=new P.DisposableStore,f=this.createHandle(s,o,v),r=this.getLightIconPath(o);return{item:{handle:f,parentHandle:v?v.item.handle:void 0,label:w(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(t,o.command),contextValue:o.contextValue,icon:r,iconDark:this.getDarkIconPath(o)||r,themeIcon:this.getThemeIcon(o),collapsibleState:(0,i.isUndefinedOrNull)(o.collapsibleState)?k.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(s){return s.iconPath instanceof k.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:o,label:v,resourceUri:t},f,r){if(o)return`${T.ID_HANDLE_PREFIX}/${o}`;const n=w(v,this.extension),d=f?f.item.handle:T.LABEL_HANDLE_PREFIX;let a=n?n.label:t?(0,L.basename)(t):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const c=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,m=this.getChildrenNodes(f)||[];let u,E=0;do{if(u=`${d}/${E}:${a}`,r||!this.elements.has(u)||c===u)break;E++}while(E<=m.length);return u}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof k.ThemeIcon))return typeof s.iconPath=="string"||y.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof k.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return y.URI.isUri(s)?s:y.URI.file(s)}addNodeToCache(s,o){this.elements.set(o.item.handle,s),this.nodes.set(s,o)}updateNodeCache(s,o,v,t){this.elements.delete(o.item.handle),this.nodes.delete(s),o.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(s,o);const f=this.getChildrenNodes(t)||[],r=f.filter(n=>n.item.handle===v.item.handle)[0];r&&f.splice(f.indexOf(r),1,o)}addNodeToParentCache(s,o){o?(o.children||(o.children=[]),o.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const o=this.nodes.get(s);if(o){if(o.children)for(const v of o.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}o.children=void 0}}else this.clearAll()}clear(s){const o=this.nodes.get(s);if(o){if(o.children)for(const v of o.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(s),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}T.LABEL_HANDLE_PREFIX="0",T.ID_HANDLE_PREFIX="1"}),define(fe[223],me([0,1,15,3,6,12,66,16,129,90]),function(Y,e,g,L,y,_,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends y.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new P.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const p=this.diff[this.diff.length-1];if(p&&l[0]===1){if(p[0]===1&&p[1].extId===l[1].extId){(0,C.applyTestItemUpdate)(p[1],l[1]);return}if(p[0]===0&&p[1].item.extId===l[1].extId){(0,C.applyTestItemUpdate)(p[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,p){const h=this.tree.get(l);if(!!h){if((h.expandLevels===void 0||p>h.expandLevels)&&(h.expandLevels=p),h.expand===1){const w=this.resolveChildren(h);return w.isOpen()?this.expandChildren(h,p-1):w.wait().then(()=>this.expandChildren(h,p-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,p-1)):this.expandChildren(h,p-1)}}dispose(){for(const l of this.tree.values())(0,P.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,p){switch(p.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(l.fullId,p.id));break;case 0:this.upsertItem(p.item,l);break;case 4:for(const b of p.ops)this.onTestItemEvent(l,b);break;case 3:const{key:h,value:w,previous:S}=p,T=l.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(w,S,T);break;case"range":this.pushDiff([1,{extId:T,item:{range:D.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:T,item:{error:D.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:T,item:{[h]:w??null}}]);break}break;default:(0,_.assertNever)(p)}}upsertItem(l,p){if(!(l instanceof P.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const h=k.TestId.fromExtHostTestItem(l,this.root.id,p?.actual),w=(0,P.getPrivateApiFor)(l);w.parent&&w.parent!==p?.actual&&w.parent.children.delete(l.id);let S=this.tree.get(h.toString());if(!S){S={fullId:h,actual:l,parent:p?h.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(S.fullId.toString(),S),this.setItemParent(l,p),this.pushDiff([0,{parent:S.parent&&S.parent.toString(),controllerId:this.controllerId,expand:S.expand,item:D.TestItem.from(l)}]),this.connectItemAndChildren(l,S,p);return}if(S.actual===l){this.connectItem(l,S,p);return}const T=S.actual.children,b=S.actual,s=(0,P.diffTestItems)(b,l);(0,P.getPrivateApiFor)(b).listener=void 0,S.actual=l,S.expand=0;for(const[o,v]of s)this.onTestItemEvent(S,{op:3,key:o,value:v,previous:b[o]});this.connectItemAndChildren(l,S,p);for(const o of T)l.children.get(o.id)||this.removeItem(k.TestId.joinToString(h,o.id))}diffTagRefs(l,p,h){const w=new Set(p.map(S=>S.id));for(const S of l)w.delete(S.id)||this.incrementTagRefs(S);this.pushDiff([1,{extId:h,item:{tags:l.map(S=>D.TestTag.namespace(this.controllerId,S.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const p=this.tags.get(l.id);p?p.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:D.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const p=this.tags.get(l);p&&!--p.refCount&&(this.tags.delete(l),this.pushDiff([6,D.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,p){(0,P.getPrivateApiFor)(l).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(l,p,h){this.setItemParent(l,h);const w=(0,P.getPrivateApiFor)(l);w.parent=h?.actual,w.listener=S=>this.onTestItemEvent(p,S),this.updateExpandability(p)}connectItemAndChildren(l,p,h){this.connectItem(l,p,h);for(const w of l.children)this.upsertItem(w,p)}updateExpandability(l){let p;this._resolveHandler?l.resolveBarrier?p=l.resolveBarrier.isOpen()?3:2:p=l.actual.canResolveChildren?1:0:p=0,p!==l.expand&&(l.expand=p,this.pushDiff([1,{extId:l.fullId.toString(),expand:p}]),p===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,p){if(p<0)return;const h=[];for(const w of l.actual.children){const S=this.expand(k.TestId.joinToString(l.fullId,w.id),p);(0,g.isThenable)(S)&&h.push(S)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const S=new g.Barrier;return S.open(),S}l.expand=2,this.pushExpandStateUpdate(l);const p=l.resolveBarrier=new g.Barrier,h=S=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=S.stack||S.message||String(S))};let w;try{w=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(S){h(S)}return(0,g.isThenable)(w)?w.catch(h).then(()=>{p.open(),this.updateExpandability(l)}):(p.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const p=this.tree.get(l);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const h=[p];for(;h.length;){const w=h.pop();if(!!w){(0,P.getPrivateApiFor)(w.actual).listener=void 0;for(const S of w.actual.tags)this.decrementTagRefs(S.id);this.tree.delete(w.fullId.toString());for(const S of w.actual.children)h.push(this.tree.get(k.TestId.joinToString(w.fullId,S.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=i}),define(fe[224],me([0,1,4,185]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(fe[225],me([0,1,27,3,8]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class _{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=_;class P{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(l=>I.add(g.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(g.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const l=P._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(p=>p.identifier)),I.length>0){const p=new Set;I.forEach(h=>p.add(g.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!p.has(g.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new _(l)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,T){this.addNode(S),this.addNode(T),this._arcs.has(S)?this._arcs.get(S).push(T):this._arcs.set(S,[T])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,T){const b=I.getArcs(S);for(let s=0;s<b.length;s++)if(!T.has(b[s]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let S of i){const T=g.ExtensionIdentifier.toKey(S.identifier);if(l.set(T,S),S.extensionDependencies)for(let b of S.extensionDependencies){const s=g.ExtensionIdentifier.toKey(b);I.addArc(T,s)}}let p=new Set;I.getNodes().filter(S=>I.getArcs(S).length===0).forEach(S=>p.add(S));let h=I.getNodes().filter(S=>!p.has(S)),w;do{w=!1;for(let S=0;S<h.length;S++){const T=h[S];I.hasOnlyGoodArcs(T,p)&&(h.splice(S,1),S--,p.add(T),w=!0)}}while(w);return h.map(S=>l.get(S))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=P;var D;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(D||(D={}));function C(k,i){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,l=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==l)return I-l;const p=y.posix.basename(k.extensionLocation.path),h=y.posix.basename(i.extensionLocation.path);return p<h?-1:p>h?1:0}}),define(fe[226],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function _(D){const C=g.VSBuffer.alloc(1);switch(D){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=_;function P(D,C){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=P}),define(fe[35],me([0,1,3,2,4,27,194]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new _.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var D;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(D=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class k{constructor(v){this.dependency=v}}e.MissingExtensionDependency=k;var i;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(i=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;class l{constructor(v,t,f,r){this.codeLoadingTime=v,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=r}}e.ActivationTimes=l;class p{constructor(v,t){this.description=v,this.value=t}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var h;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function w(o){o.enableProposedApi||S(o)}e.checkProposedApiEnabled=w;function S(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=S;function T(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=T;function b(o,v){return{identifier:new _.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!v,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=b;class s{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(v){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(v){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(v,t){return Promise.resolve()}_onWillActivateExtension(v){}_onDidActivateExtension(v,t,f,r,n){}_onDidActivateExtensionError(v,t){}_onExtensionRuntimeError(v,t){}_onExtensionHostExit(v){}}e.NullExtensionService=s}),define(fe[227],me([0,1,27,35,13]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const _=Promise.resolve(void 0);class P{constructor(h,w,S,T){this.startup=h,this.codeLoadingTime=w,this.activateCallTime=S,this.activateResolvedTime=T}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class D{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,w){return h===-1||w===-1?-1:w-h}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class C{constructor(h,w,S,T,b,s){this.activationFailed=h,this.activationFailedError=w,this.activationTimes=S,this.module=T,this.exports=b,this.subscriptions=s}}e.ActivatedExtension=C;class k extends C{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends C{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends C{constructor(h){super(!0,h,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(h,w,S,T,b){this._logService=b,this._registry=h,this._resolvedExtensionsSet=new Set,w.forEach(s=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,S.forEach(s=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(s),s)),this._host=T,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const w=g.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(w)}getActivatedExtension(h){const w=g.ExtensionIdentifier.toKey(h),S=this._activatedExtensions.get(w);if(!S)throw new Error("Extension `"+h.value+"` is not known or not activated");return S}activateByEvent(h,w){if(this._alreadyActivatedEvents[h])return _;const S=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(S.map(T=>({id:T.identifier,reason:{startup:w,extensionId:T.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,w){const S=this._registry.getExtensionDescription(h);if(!S)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:S.identifier,reason:w}])}_handleActivateRequest(h,w,S){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(h.id))){w[g.ExtensionIdentifier.toKey(h.id)]=h;return}const T=this._registry.getExtensionDescription(h.id);if(!T){const o=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,o,new L.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(h.id),new I(o));return}const b=typeof T.extensionDependencies=="undefined"?[]:T.extensionDependencies;let s=!0;for(let o=0,v=b.length;o<v;o++){const t=b[o];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const f=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(f&&!f.activationFailed)continue;if(f&&f.activationFailed){const a=T.displayName||T.identifier.value,c=this._registry.getExtensionDescription(t),m=c&&c.displayName||t,u=new Error(`Cannot activate the '${a}' extension because its dependency '${m}' failed to activate`);u.detail=f.activationFailedError,this._host.onExtensionActivationError(T.identifier,u,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(T.identifier),new I(u));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){s=!1,w[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:h.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){if(!r.main&&!r.browser)continue;s=!1,w[g.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:h.reason};continue}const n=T.displayName||T.identifier.value,d=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(T.identifier,d,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(T.identifier),new I(d));return}s?w[g.ExtensionIdentifier.toKey(T.identifier)]=h:S.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(b=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(b.id))),h.length===0))return Promise.resolve(void 0);const w=Object.create(null),S=[];for(let b=0,s=h.length;b<s;b++)this._handleActivateRequest(h[b],w,S);for(let b=0,s=S.length;b<s;b++){const o=g.ExtensionIdentifier.toKey(S[b].id);w[o]&&delete w[o]}const T=Object.keys(w).map(b=>w[b]);return S.length===0?Promise.all(T.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(T).then(b=>this._activateExtensions(S))}_activateExtension(h,w){const S=g.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const T=this._activatingExtensions.get(S);if(T)return T;const b=this._host.actualActivateExtension(h,w).then(void 0,s=>{const o=new Error;return s&&s.name&&(o.name=s.name),s&&s.message?o.message=`Activating extension '${h.value}' failed: ${s.message}.`:o.message=`Activating extension '${h.value}' failed: ${s}.`,s&&s.stack&&(o.stack=s.stack),this._host.onExtensionActivationError(h,o,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(s),new I(s)}).then(s=>{this._activatedExtensions.set(S,s),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,b),b}};l=Ve([We(4,y.ILogService)],l),e.ExtensionsActivator=l}),define(fe[228],me([0,1,13,35,28,10,117]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends g.LogService{constructor(k){if(k.logFile.scheme!==_.Schemas.file)throw new Error("Only file-logging supported");super(new P.SpdLogLogger(L.ExtensionHostLogFileName,k.logFile.fsPath,!0,k.logLevel))}$setLevel(k){this.setLevel(k)}};D=Ve([We(0,y.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(fe[229],me([0,1,17]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,P)=>{this._actualOk=_,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,g.onUnexpectedError)(_))}then(_,P){return this._ensureActual().then(_,P)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=L}),define(fe[55],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(k,i){this._proxyIdentifierBrand=void 0,this.isMain=k,this.sid=i,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function y(C){const k=new g(!0,C);return L[k.nid]=k,k}e.createMainContextProxyIdentifier=y;function _(C){const k=new g(!1,C);return L[k.nid]=k,k}e.createExtHostContextProxyIdentifier=_;function P(C){return L[C].sid}e.getStringIdentifierForProxy=P;class D{constructor(k){this.value=k}}e.SerializableObjectWithBuffers=D}),define(fe[5],me([0,1,62,2,55]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var _;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(_=e.UIKind||(e.UIKind={}));var P;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(s){s.name="$ident";function o(t,f){return Object.defineProperty(t,s.name,{value:f,enumerable:!0}),t}s.mixin=o;function v(t){return t[s.name]}s.of=v})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(o){return o._id=p._n++,o}}e.IdObject=p,p._n=0;var h;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function T(s){if(s&&s.edits)for(const o of s.edits)typeof o.resource=="object"?o.resource=L.URI.revive(o.resource):(o.newUri=L.URI.revive(o.newUri),o.oldUri=L.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,g.revive)(o.metadata));return s}e.reviveWorkspaceEditDto=T;var b;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,y.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[91],me([0,1,5,3,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class _{constructor(D){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,C){return this._proxy.$getPassword(D,C)}store(D,C,k){return this._proxy.$setPassword(D,C,k)}delete(D,C){return this._proxy.$deletePassword(D,C)}}e.ExtHostSecretState=_,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(fe[68],me([0,1,4,13,5,14]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(C,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(y.MainContext.MainThreadTelemetry)}report(C,k,i){const I=this.getUsageKey(C,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:C}))}getUsageKey(C,k){return`${C}-${k.identifier.value}`}};P=Ve([We(0,_.IExtHostRpcService),We(1,L.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(D,C,k){}})}),define(fe[230],me([0,1,3,5,7,27]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,k,i,I={}){const l=_.ExtensionIdentifier.toKey(C.identifier),p=this._inFlightRequests.get(l)||[],h=[...i].sort().join(" ");let w=p.find(S=>S.scopes===h);if(w)return w.result;{const S=this._getSession(C,l,k,i,I);w={scopes:h,result:S},p.push(w),this._inFlightRequests.set(l,p);try{await S}finally{const T=p.findIndex(b=>b.scopes===h);T>-1&&(p.splice(T),this._inFlightRequests.set(l,p))}return S}}async _getSession(C,k,i,I,l={}){await this._proxy.$ensureProvider(i);const p=C.displayName||C.name;return this._proxy.$getSession(i,I,k,p,l)}async removeSession(C,k){const i=this._authenticationProviders.get(C);return i?i.provider.removeSession(k):this._proxy.$removeSession(C,k)}registerAuthenticationProvider(C,k,i,I){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:k,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===C)||this._providers.push({id:C,label:k});const l=i.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(C,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,k,I?.supportsMultipleAccounts??!1),new y.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(C);const p=this._providers.findIndex(h=>h.id===C);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,k){const i=this._authenticationProviders.get(C);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,k){const i=this._authenticationProviders.get(C);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,k){const i=this._authenticationProviders.get(C);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,k){return this._onDidChangeSessions.fire({provider:{id:C,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(fe[231],me([0,1,5,14,16]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(D,C){this._extHostDocumentsAndEditors=C,this._proxy=D.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const C=y.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};_=Ve([We(0,L.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(fe[232],me([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(_){const P=_.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(D){return P.$writeText(D)}})}}e.ExtHostClipboard=L}),define(fe[41],me([0,1,12,7,16,25,5,18,13,62,43,51,2,6,4,14,66,22,55,52]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(d,a){this._commands=new Map,this._apiCommands=new Map,this._proxy=d.getProxy(P.MainContext.MainThreadCommands),this._logService=a,this.converter=new v(this,c=>{const m=this._apiCommands.get(c);return m?.result===f.Void?m:void 0},a),this._argumentProcessors=[{processArgument(c){return(0,k.revive)(c)}},{processArgument(c){return(0,_.cloneAndChange)(c,function(m){if(i.Range.isIRange(m))return y.Range.to(m);if(I.Position.isIPosition(m))return y.Position.to(m);if(i.Range.isIRange(m.range)&&l.URI.isUri(m.uri))return y.location.to(m);if(m instanceof T.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(d){this._argumentProcessors.push(d)}registerApiCommand(d){const a=this.registerCommand(!1,d.id,async(...c)=>{const m=d.args.map((E,A)=>{if(!E.validate(c[A]))throw new Error(`Invalid argument '${E.name}' when running '${d.id}', received: ${c[A]}`);return E.convert(c[A])}),u=await this.executeCommand(d.internalId,...m);return d.result.convert(u,c,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this._apiCommands.set(d.id,d),new L.Disposable(()=>{a.dispose(),this._apiCommands.delete(d.id)})}registerCommand(d,a,c,m,u,E){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:c,thisArg:m,description:u,extension:E}),d&&this._proxy.$registerCommand(a),new L.Disposable(()=>{this._commands.delete(a)&&d&&this._proxy.$unregisterCommand(a)})}executeCommand(d,...a){return this._logService.trace("ExtHostCommands#executeCommand",d),this._doExecuteCommand(d,a,!0)}async _doExecuteCommand(d,a,c){if(this._commands.has(d))return this._executeContributedCommand(d,a,!1);{let m=!1;const u=(0,_.cloneAndChange)(a,function(E){if(E instanceof L.Position)return y.Position.from(E);if(E instanceof L.Range)return y.Range.from(E);if(E instanceof L.Location)return y.location.from(E);if(L.NotebookRange.isNotebookRange(E))return y.NotebookRange.from(E);if(E instanceof ArrayBuffer)return m=!0,T.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return m=!0,T.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(d,m?new b.SerializableObjectWithBuffers(u):u,c);return(0,k.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(d,a,!1);throw E}}}async _executeContributedCommand(d,a,c){const m=this._commands.get(d);if(!m)throw new Error("Unknown command");let{callback:u,thisArg:E,description:A}=m;if(A)for(let R=0;R<A.args.length;R++)try{(0,g.validateConstraint)(a[R],A.args[R].constraint)}catch(B){throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${A.args[R].name}' - ${A.args[R].description}`)}try{return await u.apply(E,a)}catch(R){if(d===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...a);B&&(d=B.command)}throw this._logService.error(R,d,m.extension?.identifier),c?new class extends Error{constructor(){super((0,s.toErrorMessage)(R));this.id=d,this.source=m.extension?.displayName??m.extension?.name}}:R}}$executeContributedCommand(d,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",d),this._commands.has(d)?(a=a.map(c=>this._argumentProcessors.reduce((m,u)=>u.processArgument(m),c)),this._executeContributedCommand(d,a,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this._logService.trace("ExtHostCommands#getCommands",d),this._proxy.$getCommands().then(a=>(d&&(a=a.filter(c=>c[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(let[a,c]of this._commands){let{description:m}=c;m&&(d[a]=m)}return Promise.resolve(d)}};o=Ve([We(0,w.IExtHostRpcService),We(1,C.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class v{constructor(d,a,c){this._commands=d,this._lookupApiCommand=a,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(d,a){if(!d)return;const c={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return c;const m=this._lookupApiCommand(d.command);if(m)c.id=m.internalId,c.arguments=m.args.map((u,E)=>u.convert(d.arguments&&d.arguments[E]));else if((0,D.isNonEmptyArray)(d.arguments)){const u=++this._cachIdPool;this._cache.set(u,d),a.add((0,p.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),c.$ident=u,c.id=this.delegatingCommandId,c.arguments=[u],this._logService.trace("CommandsConverter#CREATE",d.command,u)}return c}fromInternal(d){const a=P.ObjectIdentifier.of(d);return typeof a=="number"?this._cache.get(a):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this._cache.get(d[0])}_executeConvertedCommand(...d){const a=this.getActualCommand(...d);return this._logService.trace("CommandsConverter#EXECUTE",d[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class t{constructor(d,a,c,m){this.name=d,this.description=a,this.validate=c,this.convert=m}optional(){return new t(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,a){return new t(d??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=t,t.Uri=new t("uri","Uri of a text document",n=>l.URI.isUri(n),n=>n),t.Position=new t("position","A position in a text document",n=>L.Position.isPosition(n),y.Position.from),t.Range=new t("range","A range in a text document",n=>L.Range.isRange(n),y.Range.from),t.Selection=new t("selection","A selection in a text document",n=>L.Selection.isSelection(n),y.Selection.from),t.Number=new t("number","",n=>typeof n=="number",n=>n),t.String=new t("string","",n=>typeof n=="string",n=>n),t.CallHierarchyItem=new t("item","A call hierarchy item",n=>n instanceof L.CallHierarchyItem,y.CallHierarchyItem.from),t.TypeHierarchyItem=new t("item","A type hierarchy item",n=>n instanceof L.TypeHierarchyItem,y.TypeHierarchyItem.from),t.TestItem=new t("testItem","A VS Code TestItem",n=>n instanceof S.TestItemImpl,y.TestItem.from);class f{constructor(d,a){this.description=d,this.convert=a}}e.ApiCommandResult=f,f.Void=new f("no result",n=>n);class r{constructor(d,a,c,m,u){this.id=d,this.internalId=a,this.description=c,this.args=m,this.result=u}}e.ApiCommand=r}),define(fe[233],me([0,1,16,7,85,41,18,112]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,p)=>{if((0,P.isFalsyOrEmpty)(l))return;class h extends L.SymbolInformation{static to(S){const T=new h(S.name,g.SymbolKind.to(S.kind),S.containerName||"",new L.Location(p[0],g.Range.to(S.range)));return T.detail=S.detail,T.range=T.location.range,T.selectionRange=g.Range.to(S.selectionRange),T.children=S.children?S.children.map(h.to):[],T}}return l.map(h.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new _.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(p=>L.Position.isPosition(p)),l=>l.map(g.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(p=>{let h;for(const w of p.reverse())h=new L.SelectionRange(g.Range.to(w),h);return h}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const p=[];if(Array.isArray(l))for(let h of l)p.push(...h[1].map(g.WorkspaceSymbol.to));return p})),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:g.Range.to(l.range),placeholder:l.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return g.WorkspaceEdit.to(l)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(g.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const p=(0,D.decodeSemanticTokensDto)(l);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const p=(0,D.decodeSemanticTokensDto)(l);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,p,h)=>{if(!l)return new L.CompletionList([]);const w=l.suggestions.map(S=>g.CompletionItem.to(S,h));return new L.CompletionList(w,l.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return g.SignatureHelp.to(l)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,p,h)=>i(w=>new L.CodeLens(g.Range.to(w.range),w.command&&h.fromInternal(w.command)))(l))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>L.Range.isRange(l),l=>L.Selection.isSelection(l)?g.Selection.from(l):g.Range.from(l)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,p,h)=>i(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const S=new L.CodeAction(w.title,w.kind?new L.CodeActionKind(w.kind):void 0);return w.edit&&(S.edit=g.WorkspaceEdit.to(w.edit)),w.command&&(S.command=h.fromInternal(w.command)),S.isPreferred=w.isPreferred,S}})(l))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(p=>new L.ColorInformation(g.Range.to(p.range),g.Color.to(p.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",l=>l instanceof L.Color,g.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:g.Range.from(l.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(g.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(g.InlayHint.to))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(p=>g.NotebookExclusiveDocumentPattern.to(p))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(g.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void)];class k{static register(p){C.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=k;function i(l){return p=>{if(Array.isArray(p))return p.map(l)}}function I(l){if(!Array.isArray(l))return;const p=[];for(const h of l)y.isLocationLink(h)?p.push(g.DefinitionLink.to(h)):p.push(g.location.to(h));return p}}),define(fe[234],me([0,1,15,60,3,6,2,85,27,16,7,5]),function(Y,e,g,L,y,_,P,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(p,h,w){const S=p.getProxy(I.MainContext.MainThreadComments);class T{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const d=this._commentControllers.get(n.handle);return d||n}else if(n&&n.$mid===7){const d=this._commentControllers.get(n.commentControlHandle);if(!d)return n;const a=d.getCommentThread(n.commentThreadHandle);return a||n}else if(n&&n.$mid===8){const d=this._commentControllers.get(n.thread.commentControlHandle);if(!d)return n;const a=d.getCommentThread(n.thread.commentThreadHandle);return a?{thread:a,text:n.text}:n}else if(n&&n.$mid===9){const d=this._commentControllers.get(n.thread.commentControlHandle);if(!d)return n;const a=d.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let c=n.commentUniqueId,m=a.getCommentByUniqueId(c);return m||n}else if(n&&n.$mid===10){const d=this._commentControllers.get(n.thread.commentControlHandle);if(!d)return n;const a=d.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let c=n.text,m=n.commentUniqueId,u=a.getCommentByUniqueId(m);return u?(u.body=c,u):n}return n}})}createCommentController(n,d,a){const c=T.handlePool++,m=new s(n,c,d,a);this._commentControllers.set(m.handle,m);const u=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(n.identifier))||[];return u.push(m),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(n.identifier),u),m.value}$createCommentThreadTemplate(n,d,a){const c=this._commentControllers.get(n);!c||c.$createCommentThreadTemplate(d,a)}async $updateCommentThreadTemplate(n,d,a){const c=this._commentControllers.get(n);!c||c.$updateCommentThreadTemplate(d,a)}$deleteCommentThread(n,d){const a=this._commentControllers.get(n);a&&a.$deleteCommentThread(d)}$provideCommentingRanges(n,d,a){const c=this._commentControllers.get(n);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const m=w.getDocument(P.URI.revive(d));return(0,g.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(m,a)).then(u=>u?u.map(E=>k.Range.from(E)):void 0)}$toggleReaction(n,d,a,c,m){const u=this._commentControllers.get(n);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const E=u.getCommentThread(d);if(E){const A=E.getCommentByUniqueId(c.uniqueIdInThread);if(u!==void 0&&A&&u.reactionHandler)return u.reactionHandler(A,t(m))}return Promise.resolve(void 0)})}dispose(){}}T.handlePool=0;class b{constructor(n,d,a,c,m,u,E){this._commentControllerHandle=d,this._id=a,this._uri=c,this._range=m,this._comments=u,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputDisposables.value=new _.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),S.$createCommentThread(d,this.handle,this._id,this._uri,k.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(d,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(R){A.range=R},get comments(){return A.comments},set comments(R){A.comments=R},get collapsibleState(){return A.collapsibleState},set collapsibleState(R){A.collapsibleState=R},get canReply(){return A.canReply},set canReply(R){A.canReply=R},get contextValue(){return A.contextValue},set contextValue(R){A.contextValue=R},get label(){return A.label},set label(R){A.label=R},dispose:()=>{A.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new _.DisposableStore);const n=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),d={};n("range")&&(d.range=k.Range.from(this._range)),n("label")&&(d.label=this.label),n("contextValue")&&(d.contextValue=this.contextValue),n("comments")&&(d.comments=this._comments.map(a=>o(this,a,this._commentsMap))),n("collapsibleState")&&(d.collapseState=f(this._collapseState)),n("canReply")&&(d.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,d)}getCommentByUniqueId(n){for(let d of this._commentsMap){let a=d[0],c=d[1];if(n===c)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}b._handlePool=0,Ve([(0,L.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(n,d,a,c){this._extension=n,this._handle=d,this._id=a,this._label=c,this._threads=new Map,S.$registerCommentController(this.handle,a,c);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(u){m.options=u},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(u){m.commentingRangeProvider=u},get reactionHandler(){return m.reactionHandler},set reactionHandler(u){m.reactionHandler=u},createCommentThread(u,E,A){return m.createCommentThread(u,E,A).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,S.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,d,a,c){if(typeof n=="string"){const m=new b(this.id,this.handle,n,d,a,c,this._extension.identifier);return this._threads.set(m.handle,m),m}else{const m=new b(this.id,this.handle,void 0,n,d,a,this._extension.identifier);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(n,d){const a=new b(this.id,this.handle,void 0,P.URI.revive(n),k.Range.to(d),[],this._extension.identifier);return a.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(n,d){let a=this._threads.get(n);a&&(a.range=k.Range.to(d))}$deleteCommentThread(n){let d=this._threads.get(n);d&&d.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function o(r,n,d){let a=d.get(n);a||(a=++r.commentHandle,d.set(n,a));const c=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:a,body:k.MarkdownString.from(n.body),userName:n.author.name,userIconPath:c,label:n.label,commentReactions:n.reactions?n.reactions.map(m=>v(m)):void 0}}function v(r){return{label:r.label,iconPath:r.iconPath?k.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?P.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function f(r){if(r!==void 0)switch(r){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}return new T}e.createExtHostComments=l}),define(fe[133],me([0,1,2,5,7,4,14,13,18,9,8]),function(Y,e,g,L,y,_,P,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(p,h){this._logService=h,this._provider=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,h){const w=wn._handlePool++;this._provider.set(w,{provider:p,extensionId:h}),this._proxy.$registerDecorationProvider(w,h.value);const S=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(T=>{if(!T){this._proxy.$onDidChange(w,null);return}let b=(0,C.asArray)(T);if(b.length<=wn._maxEventSize){this._proxy.$onDidChange(w,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,b.length);const s=b.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),o=(0,C.groupBy)(s,(t,f)=>t.rank-f.rank||(0,k.compare)(t.uri.path,f.uri.path));let v=[];e:for(let t of o){let f;for(let r of t){let n=(0,i.dirname)(r.uri.path);if(f!==n&&(f=n,v.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(w,v)});return new y.Disposable(()=>{S?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(p,h,w){if(!this._provider.has(p))return Object.create(null);const S=Object.create(null),{provider:T,extensionId:b}=this._provider.get(p);return await Promise.all(h.map(async s=>{try{const{uri:o,id:v}=s,t=await Promise.resolve(T.provideFileDecoration(g.URI.revive(o),w));if(!t)return;try{y.FileDecoration.validate(t),S[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(f){this._logService.warn(`INVALID decoration from extension '${b.value}': ${f}`)}}catch(o){this._logService.error(o)}})),S}};I._handlePool=0,I._maxEventSize=250,I=Ve([We(0,P.IExtHostRpcService),We(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,_.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[235],me([0,1,164,118,2,5,7,16,3,13,24,53]),function(Y,e,g,L,y,_,P,D,C,k,i,I){"use strict";var l,p,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(b,s,o,v,t,f){this._name=b,this._owner=s,this._maxDiagnosticsPerFile=o,l.set(this,void 0),p.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,st(this,h,new i.ResourceMap(r=>v.getComparisonKey(r)),"f"),st(this,l,t,"f"),st(this,p,f,"f")}dispose(){this._isDisposed||(Ne(this,p,"f").fire([...Ne(this,h,"f").keys()]),Ne(this,l,"f")&&Ne(this,l,"f").$clear(this._owner),Ne(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,s){if(!b){this.clear();return}this._checkDisposed();let o=[];if(y.URI.isUri(b)){if(!s){this.delete(b);return}Ne(this,h,"f").set(b,s.slice()),o=[b]}else if(Array.isArray(b)){o=[];let t;b=[...b].sort(w._compareIndexedTuplesByUri);for(const f of b){const[r,n]=f;if((!t||r.toString()!==t.toString())&&(t&&Ne(this,h,"f").get(t).length===0&&Ne(this,h,"f").delete(t),t=r,o.push(r),Ne(this,h,"f").set(r,[])),n){const d=Ne(this,h,"f").get(r);d&&d.push(...n)}else{const d=Ne(this,h,"f").get(r);d&&(d.length=0)}}}if(Ne(this,p,"f").fire(o),!Ne(this,l,"f"))return;const v=[];for(let t of o){let f=[];const r=Ne(this,h,"f").get(t);if(r)if(r.length>this._maxDiagnosticsPerFile){f=[];const n=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(let a of r)if(a.severity===n[d]&&f.push(D.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;f.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=r.map(n=>D.Diagnostic.from(n));v.push([t,f])}Ne(this,l,"f").$changeMany(this._owner,v)}delete(b){this._checkDisposed(),Ne(this,p,"f").fire([b]),Ne(this,h,"f").delete(b),Ne(this,l,"f")&&Ne(this,l,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Ne(this,p,"f").fire([...Ne(this,h,"f").keys()]),Ne(this,h,"f").clear(),Ne(this,l,"f")&&Ne(this,l,"f").$clear(this._owner)}forEach(b,s){this._checkDisposed();for(let o of Ne(this,h,"f").keys())b.apply(s,[o,this.get(o),this])}get(b){this._checkDisposed();const s=Ne(this,h,"f").get(b);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Ne(this,h,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,s){return b[0].toString()<s[0].toString()?-1:b[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=w,l=new WeakMap,p=new WeakMap,h=new WeakMap;let S=class tn{constructor(b,s,o){this._logService=s,this._fileSystemInfoService=o,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:v=>v.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,tn._mapper),this._proxy=b.getProxy(_.MainContext.MainThreadDiagnostics)}static _mapper(b){const s=new i.ResourceMap;for(const o of b)s.set(o,o);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(b,s){const{_collections:o,_proxy:v,_onDidChangeDiagnostics:t,_logService:f,_fileSystemInfoService:r}=this,n=new class{$changeMany(c,m){v.$changeMany(c,m),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,c,m.length===0?"CLEARING":m)}$clear(c){v.$clear(c),f.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,c)}dispose(){v.dispose()}};let d;if(!s)s="_generated_diagnostic_collection_name_#"+tn._idPool++,d=s;else if(!o.has(s))d=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do d=s+tn._idPool++;while(o.has(d))}return new class extends w{constructor(){super(s,d,tn._maxDiagnosticsPerFile,r.extUri,n,t);o.set(d,this)}dispose(){super.dispose(),o.delete(d)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const s=new Map,o=[];for(const v of this._collections.values())v.forEach((t,f)=>{let r=s.get(t.toString());typeof r=="undefined"&&(r=o.length,s.set(t.toString(),r),o.push([t,[]])),o[r][1]=o[r][1].concat(...f)});return o}}_getDiagnostics(b){let s=[];for(let o of this._collections.values())o.has(b)&&(s=s.concat(o.get(b)));return s}$acceptMarkersChange(b){if(!this._mirrorCollection){const s="_generated_mirror",o=new w(s,s,tn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,o),this._mirrorCollection=o}for(const[s,o]of b)this._mirrorCollection.set(y.URI.revive(s),o.map(D.Diagnostic.to))}};S._idPool=0,S._maxDiagnosticsPerFile=1e3,S=Ve([We(1,k.ILogService),We(2,I.IExtHostFileSystemInfo)],S),e.ExtHostDiagnostics=S}),define(fe[236],me([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(P){this._proxy=P.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(D=>D?D.map(C=>g.URI.revive(C)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(D=>D?g.URI.revive(D):void 0)}}e.ExtHostDialogs=y}),define(fe[237],me([0,1,17,2,7,5,10,21,9]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,l,p){this._documentsAndEditors=l,this._logService=p,this._documentContentProviders=new Map,this._proxy=I.getProxy(_.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(P.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const p=k._handlePool++;this._documentContentProviders.set(p,l),this._proxy.$registerTextContentProvider(p,I);let h;return typeof l.onDidChange=="function"&&(h=l.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(p,w).then(S=>{if(!S&&typeof S!="string")return;const T=this._documentsAndEditors.getDocument(w);if(!T)return;const b=(0,C.splitLines)(S);if(!T.equalLines(b))return this._proxy.$onVirtualDocumentChange(w,S)},g.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,l){const p=this._documentContentProviders.get(I);return p?Promise.resolve(p.provideTextDocumentContent(L.URI.revive(l),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(fe[238],me([0,1,3,6,2,5,125,16,12,25,7]),function(Y,e,g,L,y,_,P,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(p,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(_.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const S of w)this._onDidRemoveDocument.fire(S.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const S of w)this._onDidAddDocument.fire(S.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const h=this._documentsAndEditors.getDocument(p);if(h)return h}getDocument(p){const h=this.getDocumentData(p);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return h.document}ensureDocumentData(p){const h=this._documentsAndEditors.getDocument(p);if(h)return Promise.resolve(h);let w=this._documentLoader.get(p.toString());return w||(w=this._proxy.$tryOpenDocument(p).then(S=>{this._documentLoader.delete(p.toString());const T=y.URI.revive(S);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(T))},S=>(this._documentLoader.delete(p.toString()),Promise.reject(S))),this._documentLoader.set(p.toString(),w)),w}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(h=>y.URI.revive(h))}$acceptModelModeChanged(p,h){const w=y.URI.revive(p),S=this._documentsAndEditors.getDocument(w);if(!S)throw new Error("unknown document");this._onDidRemoveDocument.fire(S.document),S._acceptLanguageId(h),this._onDidAddDocument.fire(S.document)}$acceptModelSaved(p){const h=y.URI.revive(p),w=this._documentsAndEditors.getDocument(h);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(p,h){const w=y.URI.revive(p),S=this._documentsAndEditors.getDocument(w);if(!S)throw new Error("unknown document");S._acceptIsDirty(h),this._onDidChangeDocument.fire({document:S.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,h,w){const S=y.URI.revive(p),T=this._documentsAndEditors.getDocument(S);if(!T)throw new Error("unknown document");T._acceptIsDirty(w),T.onEvents(h);let b;h.isUndoing?b=i.TextDocumentChangeReason.Undo:h.isRedoing&&(b=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:T.document,contentChanges:h.changes.map(s=>({range:D.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:b}))}setWordDefinitionFor(p,h){(0,P.setWordDefinitionFor)(p,h)}}e.ExtHostDocuments=I}),define(fe[45],me([0,1,58,3,6,2,4,5,125,14,132,16,13,24,10,78,141]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class T{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(o,v){this._extHostRpc=o,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const v=[],t=[],f=[];if(o.removedDocuments)for(const r of o.removedDocuments){const n=_.URI.revive(r),d=this._documents.get(n);d?.unref()&&(this._documents.delete(n),v.push(d.value))}if(o.addedDocuments)for(const r of o.addedDocuments){const n=_.URI.revive(r.uri);let d=this._documents.get(n);if(d&&n.scheme!==h.Schemas.vscodeNotebookCell&&n.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);d||(d=new T(new C.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(n,d),t.push(d.value)),d.ref()}if(o.removedEditors)for(const r of o.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&f.push(n)}if(o.addedEditors)for(const r of o.addedEditors){const n=_.URI.revive(r.documentUri);g.ok(this._documents.has(n),`document '${n}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const d=this._documents.get(n).value,a=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>d.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(c=>I.Range.to(c)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,a)}o.newActiveEditor!==void 0&&(g.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,y.dispose)(v),(0,y.dispose)(f),o.removedDocuments&&this._onDidRemoveDocuments.fire(v),o.addedDocuments&&this._onDidAddDocuments.fire(t),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return o?v:v?.value}allEditors(){return[...this._editors.values()]}};b=Ve([We(0,k.IExtHostRpcService),We(1,l.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[56],me([0,1,16,5,2,3,4,14,15]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");let k=class{constructor(I){this._onDidChangeTabs=new _.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new _.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let l=-1;this._tabs=I.map((h,w)=>(h.isActive&&(l=w),Object.freeze({label:h.label,viewColumn:g.ViewColumn.to(h.viewColumn),index:w,resource:y.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:S,viewId:T})=>({resource:y.URI.revive(S),viewId:T})),viewId:h.editorId,isActive:h.isActive,move:async(S,T)=>{this._proxy.$moveTab(h,S,g.ViewColumn.from(T)),await(0,C.raceTimeout)(_.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,C.raceTimeout)(_.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,w)=>h.viewColumn===w.viewColumn?h.index-w.index:h.viewColumn-w.viewColumn);const p=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};k=Ve([We(0,D.IExtHostRpcService)],k),e.ExtHostEditorTabs=k}),define(fe[239],me([0,1,2,5,6,7,16,148,9,22]),function(Y,e,g,L,y,_,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const h=this._schemes.indexOf(p);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),h=[];let w,S,T=14,b=14;for(const s of p){let o=w?(0,C.commonPrefixLength)(w,s):0;for(o===0?S=1:S=b;o<s.length;o++)o+1===s.length?(T=b,b=9):b+=1,h.push([S,s.toUpperCase().charCodeAt(o),b]),h.push([S,s.toLowerCase().charCodeAt(o),b]),S=b;w=s,b=T}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new D.StateMachine(h)}}provideDocumentLinks(p){this._initStateMachine();const h=[],w=D.LinkComputer.computeLinks({getLineContent(S){return p.lineAt(S-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const S of w){const T=P.DocumentLink.to(S);T.target&&h.push(T)}return h}}class I{constructor(p,h){this._extHostLanguageFeatures=h,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,h,w,S={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const T=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(T,w);let b=2;S.isCaseSensitive&&(b+=1024),S.isReadonly&&(b+=2048),typeof w.copy=="function"&&(b+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(T,h,b).catch(o=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${h}`),console.error(o)});const s=w.onDidChangeFile(o=>{const v=[];for(const t of o){let{uri:f,type:r}=t;if(f.scheme!==h)continue;let n;switch(r){case _.FileChangeType.Changed:n=0;break;case _.FileChangeType.Created:n=1;break;case _.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:f,type:n})}this._proxy.$onFileSystemChange(T,v)});return(0,y.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(T),this._proxy.$unregisterProvider(T)})}static _asIStat(p){const{type:h,ctime:w,mtime:S,size:T,permissions:b}=p;return{type:h,ctime:w,mtime:S,size:T,permissions:b}}$stat(p,h){return Promise.resolve(this._getFsProvider(p).stat(g.URI.revive(h))).then(w=>I._asIStat(w))}$readdir(p,h){return Promise.resolve(this._getFsProvider(p).readDirectory(g.URI.revive(h)))}$readFile(p,h){return Promise.resolve(this._getFsProvider(p).readFile(g.URI.revive(h))).then(w=>k.VSBuffer.wrap(w))}$writeFile(p,h,w,S){return Promise.resolve(this._getFsProvider(p).writeFile(g.URI.revive(h),w.buffer,S))}$delete(p,h,w){return Promise.resolve(this._getFsProvider(p).delete(g.URI.revive(h),w))}$rename(p,h,w,S){return Promise.resolve(this._getFsProvider(p).rename(g.URI.revive(h),g.URI.revive(w),S))}$copy(p,h,w,S){const T=this._getFsProvider(p);if(!T.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(T.copy(g.URI.revive(h),g.URI.revive(w),S))}$mkdir(p,h){return Promise.resolve(this._getFsProvider(p).createDirectory(g.URI.revive(h)))}$watch(p,h,w,S){const T=this._getFsProvider(p).watch(g.URI.revive(w),S);this._watches.set(h,T)}$unwatch(p,h){const w=this._watches.get(h);w&&(w.dispose(),this._watches.delete(h))}$open(p,h,w){const S=this._getFsProvider(p);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(g.URI.revive(h),w))}$close(p,h){const w=this._getFsProvider(p);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(h))}$read(p,h,w,S){const T=this._getFsProvider(p);if(!T.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(S);return Promise.resolve(T.read(h,w,b.buffer,0,S)).then(s=>b.slice(0,s))}$write(p,h,w,S){const T=this._getFsProvider(p);if(!T.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(T.write(h,w,S.buffer,0,S.byteLength))}_getFsProvider(p){const h=this._fsProvider.get(p);if(!h){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return h}}e.ExtHostFileSystem=I}),define(fe[92],me([0,1,5,40,7,22,4,14,53]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Bt{constructor(I,l){const p=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(h){return p.$stat(h).catch(Bt._handleError)},readDirectory(h){return p.$readdir(h).catch(Bt._handleError)},createDirectory(h){return p.$mkdir(h).catch(Bt._handleError)},async readFile(h){return p.$readFile(h).then(w=>w.buffer).catch(Bt._handleError)},writeFile(h,w){return p.$writeFile(h,_.VSBuffer.wrap(w)).catch(Bt._handleError)},delete(h,w){return p.$delete(h,{recursive:!1,useTrash:!1,...w}).catch(Bt._handleError)},rename(h,w,S){return p.$rename(h,w,{overwrite:!1,...S}).catch(Bt._handleError)},copy(h,w,S){return p.$copy(h,w,{overwrite:!1,...S}).catch(Bt._handleError)},isWritableFileSystem(h){const w=l.getCapabilities(h);if(typeof w=="number")return!(w&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new y.FileSystemError(String(I));if(I.name==="ENOPRO")throw y.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(I.message);default:throw new y.FileSystemError(I.message,I.name)}}};k=Ve([We(0,D.IExtHostRpcService),We(1,C.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[240],me([0,1,2,41]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(P,D,C,k){this._extHostNotebooks=D,this._textDocumentsAndEditors=C,this._commands=k;const i=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(P,D,C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:C,uri:P,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=y}),define(fe[241],me([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(P){this._handlePool=0,this._proxy=P.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,P),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=y}),define(fe[242],me([0,1,2,25,16,7,5,9,43,18,12,145,6,112,77,88,46,17,3]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentSymbols(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentSymbols(te,ee);if(!(0,k.isFalsyOrEmpty)(ce))return ce[0]instanceof _.DocumentSymbol?ce.map(y.DocumentSymbol.from):s._asDocumentSymbolTree(ce)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((ce,Z)=>{let se=ce.location.range.start.compareTo(Z.location.range.start);return se===0&&(se=Z.location.range.end.compareTo(ce.location.range.end)),se});const ee=[],te=[];for(const ce of G){const Z={name:ce.name||"!!MISSING: name!!",kind:y.SymbolKind.from(ce.kind),tags:ce.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:ce.containerName,range:y.Range.from(ce.location.range),selectionRange:y.Range.from(ce.location.range),children:[]};for(;;){if(te.length===0){te.push(Z),ee.push(Z);break}const se=te[te.length-1];if(C.Range.containsRange(se.range,Z.range)&&!C.Range.equalsRange(se.range,Z.range)){se.children&&se.children.push(Z),te.push(Z);break}te.pop()}}return ee}}class o{constructor(G,ee,te){this._documents=G,this._commands=ee,this._provider=te,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideCodeLenses(te,ee);if(!ce||ee.isCancellationRequested)return;const Z=this._cache.add(ce),se=new l.DisposableStore;this._disposables.set(Z,se);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<ce.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:y.Range.from(ce[Me].range),command:this._commands.toInternal(ce[Me].command,se)});return pe}async resolveCodeLens(G,ee){const te=G.cacheId&&this._cache.get(...G.cacheId);if(!te)return;let ce;if(typeof this._provider.resolveCodeLens!="function"||te.isResolved?ce=te:ce=await this._provider.resolveCodeLens(te,ee),ce||(ce=te),ee.isCancellationRequested)return;const Z=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!Z)return G.command=this._commands.toInternal(ce.command??o._badCmd,Z),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(He){return Array.isArray(He)?He.map(y.DefinitionLink.from):He?[y.DefinitionLink.from(He)]:[]}class t{constructor(G,ee){this._documents=G,this._provider=ee}async provideDefinition(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.provideDefinition(ce,Z,te);return v(se)}}class f{constructor(G,ee){this._documents=G,this._provider=ee}async provideDeclaration(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.provideDeclaration(ce,Z,te);return v(se)}}class r{constructor(G,ee){this._documents=G,this._provider=ee}async provideImplementation(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.provideImplementation(ce,Z,te);return v(se)}}class n{constructor(G,ee){this._documents=G,this._provider=ee}async provideTypeDefinition(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.provideTypeDefinition(ce,Z,te);return v(se)}}class d{constructor(G,ee){this._documents=G,this._provider=ee}async provideHover(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.provideHover(ce,Z,te);if(!(!se||(0,k.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ce.getWordRangeAtPosition(Z)),se.range||(se.range=new _.Range(Z,Z)),y.Hover.from(se)}}class a{constructor(G,ee){this._documents=G,this._provider=ee}async provideEvaluatableExpression(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.provideEvaluatableExpression(ce,Z,te);if(se)return y.EvaluatableExpression.from(se)}}class c{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlineValues(G,ee,te,ce){const Z=this._documents.getDocument(G),se=await this._provider.provideInlineValues(Z,y.Range.to(ee),y.InlineValueContext.to(te),ce);if(Array.isArray(se))return se.map(pe=>y.InlineValue.from(pe))}}class m{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentHighlights(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.provideDocumentHighlights(ce,Z,te);if(Array.isArray(se))return se.map(y.DocumentHighlight.from)}}class u{constructor(G,ee){this._documents=G,this._provider=ee}async provideLinkedEditingRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.provideLinkedEditingRanges(ce,Z,te);if(se&&Array.isArray(se.ranges))return{ranges:(0,k.coalesce)(se.ranges.map(y.Range.from)),wordPattern:se.wordPattern}}}class E{constructor(G,ee){this._documents=G,this._provider=ee}async provideReferences(G,ee,te,ce){const Z=this._documents.getDocument(G),se=y.Position.to(ee),pe=await this._provider.provideReferences(Z,se,te,ce);if(Array.isArray(pe))return pe.map(y.location.from)}}class A{constructor(G,ee,te,ce,Z,se,pe){this._documents=G,this._commands=ee,this._diagnostics=te,this._provider=ce,this._logService=Z,this._extension=se,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,ee,te,ce){const Z=this._documents.getDocument(G),se=I.Selection.isISelection(ee)?y.Selection.to(ee):y.Range.to(ee),pe=[];for(const ct of this._diagnostics.getDiagnostics(G))if(se.intersection(ct.range)&&pe.push(ct)>A._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:te.only?new _.CodeActionKind(te.only):void 0,triggerKind:y.CodeActionTriggerKind.to(te.trigger)},je=await this._provider.provideCodeActions(Z,se,Me,ce);if(!(0,k.isNonEmptyArray)(je)||ce.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new l.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ct=0;ct<je.length;ct++){const ye=je[ct];!ye||(A._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ze)})):(Me.only&&(ye.kind?Me.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ct],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ze),diagnostics:ye.diagnostics&&ye.diagnostics.map(y.Diagnostic.from),edit:ye.edit&&y.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,ee){const[te,ce]=G,Z=this._cache.get(te,ce);if(!Z||A._isCommand(Z)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(Z,ee)??Z;return se?.edit?y.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}A._maxCodeActionsPerFile=1e3;class R{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentFormattingEdits(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentFormattingEdits(ce,ee,te);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class B{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeFormattingEdits(G,ee,te,ce){const Z=this._documents.getDocument(G),se=y.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,se,te,ce);if(Array.isArray(pe))return pe.map(y.TextEdit.from)}}class N{constructor(G,ee){this._documents=G,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,ee,te,ce,Z){const se=this._documents.getDocument(G),pe=y.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(se,pe,te,ce,Z);if(Array.isArray(Me))return Me.map(y.TextEdit.from)}}class F{constructor(G,ee){this._provider=G,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,ee){const te=P.IdObject.mixin({symbols:[]}),ce=await this._provider.provideWorkspaceSymbols(G,ee);if((0,k.isNonEmptyArray)(ce))for(const Z of ce){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const se=P.IdObject.mixin(y.WorkspaceSymbol.from(Z));this._symbolCache.set(se._id,Z),te.symbols.push(se)}return te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te}async resolveWorkspaceSymbol(G,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const te=this._symbolCache.get(G._id);if(te){const ce=await this._provider.resolveWorkspaceSymbol(te,ee);return ce&&(0,L.mixin)(G,y.WorkspaceSymbol.from(ce),!0)}}releaseWorkspaceSymbols(G){const ee=this._resultCache.get(G);if(ee){for(let[te,ce]=ee;te<=ce;te++)this._symbolCache.delete(te);this._resultCache.delete(G)}}}class ${constructor(G,ee,te){this._documents=G,this._provider=ee,this._logService=te}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,ee,te,ce){const Z=this._documents.getDocument(G),se=y.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,se,te,ce);return pe?y.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=$._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(G,ee,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ce=this._documents.getDocument(G),Z=y.Position.to(ee);try{const se=await this._provider.prepareRename(ce,Z,te);let pe,Me;if(_.Range.isRange(se)?(pe=se,Me=ce.getText(se)):(0,i.isObject)(se)&&(pe=se.range,Me=se.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(pe),text:Me}}catch(se){const pe=$._asMessage(se);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class M{constructor(G,ee){this.resultId=G,this.tokens=ee}}class z{constructor(G,ee){this._documents=G,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,ee,te){const ce=this._documents.getDocument(G),Z=ee!==0?this._previousResults.get(ee):null;let se=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ce,Z.resultId,te):await this._provider.provideDocumentSemanticTokens(ce,te);return Z&&this._previousResults.delete(ee),se?(se=z._fixProvidedSemanticTokens(se),this._send(z._convertToEdits(Z,se),se)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return z._isSemanticTokens(G)?z._isCorrectSemanticTokens(G)?G:new _.SemanticTokens(new Uint32Array(G.data),G.resultId):z._isSemanticTokensEdits(G)?z._isCorrectSemanticTokensEdits(G)?G:new _.SemanticTokensEdits(G.edits.map(ee=>new _.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const ee of G.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,ee){if(!z._isSemanticTokens(ee)||!G||!G.tokens)return ee;const te=G.tokens,ce=te.length,Z=ee.data,se=Z.length;let pe=0;const Me=Math.min(ce,se);for(;pe<Me&&te[pe]===Z[pe];)pe++;if(pe===ce&&pe===se)return new _.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&te[ce-je-1]===Z[se-je-1];)je++;return new _.SemanticTokensEdits([{start:pe,deleteCount:ce-pe-je,data:Z.subarray(pe,se-je)}],ee.resultId)}_send(G,ee){if(z._isSemanticTokens(G)){const te=this._nextResultId++;return this._previousResults.set(te,new M(G.resultId,G.data)),(0,p.encodeSemanticTokensDto)({id:te,type:"full",data:G.data})}if(z._isSemanticTokensEdits(G)){const te=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(te,new M(ee.resultId,ee.data)):this._previousResults.set(te,new M(G.resultId)),(0,p.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(G.edits||[]).map(ce=>({start:ce.start,deleteCount:ce.deleteCount,data:ce.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class U{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeSemanticTokens(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentRangeSemanticTokens(ce,y.Range.to(ee),te);return Z?this._send(Z):null}_send(G){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(G,ee,te,ce,Z){this._documents=G,this._commands=ee,this._provider=te,this._apiDeprecation=ce,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,ee,te,ce){const Z=this._documents.getDocument(G),se=y.Position.to(ee),pe=Z.getWordRangeAtPosition(se)||new _.Range(se,se),Me=pe.with({end:se}),je=new S.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,se,ce,y.CompletionContext.to(te));if(!Ke||ce.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new _.CompletionList(Ke):Ke,rt=x.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ct=new l.DisposableStore;this._disposables.set(rt,ct);const ye=[],at={x:rt,b:ye,a:{replace:y.Range.from(pe),insert:y.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let J=0;J<Ze.items.length;J++){const ie=Ze.items[J],Ee=this._convertCompletionItem(ie,[rt,J],Me,pe);ye.push(Ee)}return at}async resolveCompletionItem(G,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...G);if(!te)return;const ce=await this._provider.resolveCompletionItem(te,ee);if(!!ce)return this._convertCompletionItem(ce,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,ee,te,ce){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const se={x:ee,a:G.label,b:G.kind!==void 0?y.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(y.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(G.command,Z)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=G.textEdit.newText):typeof G.insertText=="string"?se.h=G.insertText:G.insertText instanceof _.SnippetString&&(se.h=G.insertText.value,se.i|=4);let pe;return G.textEdit?pe=G.textEdit.range:G.range&&(pe=G.range),_.Range.isRange(pe)?se.j=y.Range.from(pe):pe&&(!te?.isEqual(pe.inserting)||!ce?.isEqual(pe.replacing))&&(se.j={insert:y.Range.from(pe.inserting),replace:y.Range.from(pe.replacing)}),se}}class j{constructor(G,ee,te){this._documents=G,this._provider=ee,this._commands=te,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,ee,te,ce){const Z=this._documents.getDocument(G),se=y.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,se,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:y.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:te.triggerKind},ce);if(!pe||ce.isCancellationRequested)return;const Me=(0,i.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ct;return Ze.command&&(Ke||(Ke=new l.DisposableStore,this._disposables.set(je,Ke)),ct=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?y.Range.from(Ze.range):void 0,command:ct,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const ee=this._disposables.get(G);ee&&ee.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,ee){const te=this._cache.get(G,ee);te&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let ee=O.map.get(G);return ee||(ee=new O,O.map.set(G,ee)),ee}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class W{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(G,ee,te,ce){const Z=this._documents.getDocument(G),se=y.Position.to(ee),pe=this.reviveContext(te),Me=await this._provider.provideSignatureHelp(Z,se,ce,pe);if(Me){const je=this._cache.add([Me]);return{...y.SignatureHelp.from(Me),id:je}}}reviveContext(G){let ee;if(G.activeSignatureHelp){const te=y.SignatureHelp.to(G.activeSignatureHelp),ce=this._cache.get(G.activeSignatureHelp.id,0);ce?(ee=ce,ee.activeSignature=te.activeSignature,ee.activeParameter=te.activeParameter):ee=te}return{...G,activeSignatureHelp:ee}}releaseSignatureHelp(G){this._cache.delete(G)}}class H{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlayHints(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideInlayHints(ce,y.Range.to(ee),te);return Z?{hints:Z.map(y.InlayHint.from)}:void 0}}class X{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentLinks(te,ee);if(!(!Array.isArray(ce)||ce.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ce.filter(X._validateLink).map(y.DocumentLink.from)};{const Z=this._cache.add(ce),se={links:[],id:Z};for(let pe=0;pe<ce.length;pe++){if(!X._validateLink(ce[pe]))continue;const Me=y.DocumentLink.from(ce[pe]);Me.cacheId=[Z,pe],se.links.push(Me)}return se}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...G);if(!te)return;const ce=await this._provider.resolveDocumentLink(te,ee);if(!(!ce||!X._validateLink(ce)))return y.DocumentLink.from(ce)}releaseLinks(G){this._cache.delete(G)}}class K{constructor(G,ee){this._documents=G,this._provider=ee}async provideColors(G,ee){const te=this._documents.getDocument(G),ce=await this._provider.provideDocumentColors(te,ee);return Array.isArray(ce)?ce.map(se=>({color:y.Color.from(se.color),range:y.Range.from(se.range)})):[]}async provideColorPresentations(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Range.to(ee.range),se=y.Color.to(ee.color),pe=await this._provider.provideColorPresentations(se,{document:ce,range:Z},te);if(!!Array.isArray(pe))return pe.map(y.ColorPresentation.from)}}class de{constructor(G,ee){this._documents=G,this._provider=ee}async provideFoldingRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=await this._provider.provideFoldingRanges(ce,ee,te);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class _e{constructor(G,ee,te){this._documents=G,this._provider=ee,this._logService=te}async provideSelectionRanges(G,ee,te){const ce=this._documents.getDocument(G),Z=ee.map(y.Position.to),se=await this._provider.provideSelectionRanges(ce,Z,te);if(!(0,k.isNonEmptyArray)(se))return[];if(se.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Ze=se[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(y.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return pe}}class Ce{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.prepareCallHierarchy(ce,Z,te);if(!se)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(se)?se.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,se)]}async provideCallsTo(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(ce,te);if(!!Z)return Z.map(se=>({from:this._cacheAndConvertItem(G,se.from),fromRanges:se.fromRanges.map(pe=>y.Range.from(pe))}))}async provideCallsFrom(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(ce,te);if(!!Z)return Z.map(se=>({to:this._cacheAndConvertItem(G,se.to),fromRanges:se.fromRanges.map(pe=>y.Range.from(pe))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const te=this._cache.get(G),ce=y.CallHierarchyItem.from(ee,G,te.size.toString(36));return te.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Pe{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,te){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),se=await this._provider.prepareTypeHierarchy(ce,Z,te);if(!se)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(se)?se.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,se)]}async provideSupertypes(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(ce,te);if(!!Z)return Z.map(se=>this._cacheAndConvertItem(G,se))}async provideSubtypes(G,ee,te){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(ce,te);if(!!Z)return Z.map(se=>this._cacheAndConvertItem(G,se))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const te=this._cache.get(G),ce=y.TypeHierarchyItem.from(ee,G,te.size.toString(36));return te.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Be{constructor(G,ee){this.adapter=G,this.extension=ee}}class $e{constructor(G,ee,te,ce,Z,se,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=G.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=ce,this._diagnostics=Z,this._logService=se,this._apiDeprecation=pe}_transformDocumentSelector(G){return y.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new _.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return $e._handlePool++}_withAdapter(G,ee,te,ce,Z=!1){const se=this._adapter.get(G);if(!se)return Promise.resolve(ce);if(se.adapter instanceof ee){let pe;se.extension&&(pe=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=te(se.adapter,se.extension),je=se.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof T.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,ee){const te=this._nextHandle();return this._adapter.set(te,new Be(G,ee)),te}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,ee,te,ce){const Z=this._addNewAdapter(new s(this._documents,te),G),se=ce&&ce.label||$e._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),se),this._createDisposable(Z)}$provideDocumentSymbols(G,ee,te){return this._withAdapter(G,s,ce=>ce.provideDocumentSymbols(g.URI.revive(ee),te),void 0)}registerCodeLensProvider(G,ee,te){const ce=this._nextHandle(),Z=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new o(this._documents,this._commands.converter,te),G)),this._proxy.$registerCodeLensSupport(ce,this._transformDocumentSelector(ee),Z);let se=this._createDisposable(ce);if(Z!==void 0){const pe=te.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));se=_.Disposable.from(se,pe)}return se}$provideCodeLenses(G,ee,te){return this._withAdapter(G,o,ce=>ce.provideCodeLenses(g.URI.revive(ee),te),void 0)}$resolveCodeLens(G,ee,te){return this._withAdapter(G,o,ce=>ce.resolveCodeLens(ee,te),void 0)}$releaseCodeLenses(G,ee){this._withAdapter(G,o,te=>Promise.resolve(te.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(G,ee,te){const ce=this._addNewAdapter(new t(this._documents,te),G);return this._proxy.$registerDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDefinition(G,ee,te,ce){return this._withAdapter(G,t,Z=>Z.provideDefinition(g.URI.revive(ee),te,ce),[])}registerDeclarationProvider(G,ee,te){const ce=this._addNewAdapter(new f(this._documents,te),G);return this._proxy.$registerDeclarationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDeclaration(G,ee,te,ce){return this._withAdapter(G,f,Z=>Z.provideDeclaration(g.URI.revive(ee),te,ce),[])}registerImplementationProvider(G,ee,te){const ce=this._addNewAdapter(new r(this._documents,te),G);return this._proxy.$registerImplementationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideImplementation(G,ee,te,ce){return this._withAdapter(G,r,Z=>Z.provideImplementation(g.URI.revive(ee),te,ce),[])}registerTypeDefinitionProvider(G,ee,te){const ce=this._addNewAdapter(new n(this._documents,te),G);return this._proxy.$registerTypeDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideTypeDefinition(G,ee,te,ce){return this._withAdapter(G,n,Z=>Z.provideTypeDefinition(g.URI.revive(ee),te,ce),[])}registerHoverProvider(G,ee,te,ce){const Z=this._addNewAdapter(new d(this._documents,te),G);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(G,ee,te,ce){return this._withAdapter(G,d,Z=>Z.provideHover(g.URI.revive(ee),te,ce),void 0)}registerEvaluatableExpressionProvider(G,ee,te,ce){const Z=this._addNewAdapter(new a(this._documents,te),G);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(G,ee,te,ce){return this._withAdapter(G,a,Z=>Z.provideEvaluatableExpression(g.URI.revive(ee),te,ce),void 0)}registerInlineValuesProvider(G,ee,te,ce){const Z=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new c(this._documents,te),G);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(se);if(Z!==void 0){const Me=te.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=_.Disposable.from(pe,Me)}return pe}$provideInlineValues(G,ee,te,ce,Z){return this._withAdapter(G,c,se=>se.provideInlineValues(g.URI.revive(ee),te,ce,Z),void 0)}registerDocumentHighlightProvider(G,ee,te){const ce=this._addNewAdapter(new m(this._documents,te),G);return this._proxy.$registerDocumentHighlightProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentHighlights(G,ee,te,ce){return this._withAdapter(G,m,Z=>Z.provideDocumentHighlights(g.URI.revive(ee),te,ce),void 0)}registerLinkedEditingRangeProvider(G,ee,te){const ce=this._addNewAdapter(new u(this._documents,te),G);return this._proxy.$registerLinkedEditingRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideLinkedEditingRanges(G,ee,te,ce){return this._withAdapter(G,u,async Z=>{const se=await Z.provideLinkedEditingRanges(g.URI.revive(ee),te,ce);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?$e._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(G,ee,te){const ce=this._addNewAdapter(new E(this._documents,te),G);return this._proxy.$registerReferenceSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideReferences(G,ee,te,ce,Z){return this._withAdapter(G,E,se=>se.provideReferences(g.URI.revive(ee),te,ce,Z),void 0)}registerCodeActionProvider(G,ee,te,ce){const Z=new l.DisposableStore,se=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,te,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(ee),{providedKinds:ce?.providedCodeActionKinds?.map(pe=>pe.value),documentation:ce?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},$e._extLabel(G),Boolean(te.resolveCodeAction)),Z.add(this._createDisposable(se)),Z}$provideCodeActions(G,ee,te,ce,Z){return this._withAdapter(G,A,se=>se.provideCodeActions(g.URI.revive(ee),te,ce,Z),void 0)}$resolveCodeAction(G,ee,te){return this._withAdapter(G,A,ce=>ce.resolveCodeAction(ee,te),void 0)}$releaseCodeActions(G,ee){this._withAdapter(G,A,te=>Promise.resolve(te.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(G,ee,te){const ce=this._addNewAdapter(new R(this._documents,te),G);return this._proxy.$registerDocumentFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentFormattingEdits(G,ee,te,ce){return this._withAdapter(G,R,Z=>Z.provideDocumentFormattingEdits(g.URI.revive(ee),te,ce),void 0)}registerDocumentRangeFormattingEditProvider(G,ee,te){const ce=this._addNewAdapter(new B(this._documents,te),G);return this._proxy.$registerRangeFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentRangeFormattingEdits(G,ee,te,ce,Z){return this._withAdapter(G,B,se=>se.provideDocumentRangeFormattingEdits(g.URI.revive(ee),te,ce,Z),void 0)}registerOnTypeFormattingEditProvider(G,ee,te,ce){const Z=this._addNewAdapter(new N(this._documents,te),G);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),ce,G.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(G,ee,te,ce,Z,se){return this._withAdapter(G,N,pe=>pe.provideOnTypeFormattingEdits(g.URI.revive(ee),te,ce,Z,se),void 0)}registerWorkspaceSymbolProvider(G,ee){const te=this._addNewAdapter(new F(ee,this._logService),G);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(G,ee,te){return this._withAdapter(G,F,ce=>ce.provideWorkspaceSymbols(ee,te),{symbols:[]})}$resolveWorkspaceSymbol(G,ee,te){return this._withAdapter(G,F,ce=>ce.resolveWorkspaceSymbol(ee,te),void 0)}$releaseWorkspaceSymbols(G,ee){this._withAdapter(G,F,te=>te.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(G,ee,te){const ce=this._addNewAdapter(new $(this._documents,te,this._logService),G);return this._proxy.$registerRenameSupport(ce,this._transformDocumentSelector(ee),$.supportsResolving(te)),this._createDisposable(ce)}$provideRenameEdits(G,ee,te,ce,Z){return this._withAdapter(G,$,se=>se.provideRenameEdits(g.URI.revive(ee),te,ce,Z),void 0)}$resolveRenameLocation(G,ee,te,ce){return this._withAdapter(G,$,Z=>Z.resolveRenameLocation(g.URI.revive(ee),te,ce),void 0)}registerDocumentSemanticTokensProvider(G,ee,te,ce){const Z=this._nextHandle(),se=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new z(this._documents,te),G)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce,se);let pe=this._createDisposable(Z);if(se){const Me=te.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(se));pe=_.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(G,ee,te,ce){return this._withAdapter(G,z,Z=>Z.provideDocumentSemanticTokens(g.URI.revive(ee),te,ce),null,!0)}$releaseDocumentSemanticTokens(G,ee){this._withAdapter(G,z,te=>te.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(G,ee,te,ce){const Z=this._addNewAdapter(new U(this._documents,te),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(G,ee,te,ce){return this._withAdapter(G,U,Z=>Z.provideDocumentRangeSemanticTokens(g.URI.revive(ee),te,ce),null,!0)}registerCompletionItemProvider(G,ee,te,ce){const Z=this._addNewAdapter(new x(this._documents,this._commands.converter,te,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),ce,x.supportsResolving(te),`${G.identifier.value}(${ce.join("")})`),this._createDisposable(Z)}$provideCompletionItems(G,ee,te,ce,Z){return this._withAdapter(G,x,se=>se.provideCompletionItems(g.URI.revive(ee),te,ce,Z),void 0)}$resolveCompletionItem(G,ee,te){return this._withAdapter(G,x,ce=>ce.resolveCompletionItem(ee,te),void 0)}$releaseCompletionItems(G,ee){this._withAdapter(G,x,te=>te.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(G,ee,te){const ce=this._addNewAdapter(new j(this._documents,te,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideInlineCompletions(G,ee,te,ce,Z){return this._withAdapter(G,j,se=>se.provideInlineCompletions(g.URI.revive(ee),te,ce,Z),void 0)}$handleInlineCompletionDidShow(G,ee,te){this._withAdapter(G,j,async ce=>{ce.handleDidShowCompletionItem(ee,te)},void 0)}$freeInlineCompletionsList(G,ee){this._withAdapter(G,j,async te=>{te.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(G,ee,te,ce){const Z=Array.isArray(ce)?{triggerCharacters:ce,retriggerCharacters:[]}:ce,se=this._addNewAdapter(new W(this._documents,te),G);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(ee),Z),this._createDisposable(se)}$provideSignatureHelp(G,ee,te,ce,Z){return this._withAdapter(G,W,se=>se.provideSignatureHelp(g.URI.revive(ee),te,ce,Z),void 0)}$releaseSignatureHelp(G,ee){this._withAdapter(G,W,te=>te.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(G,ee,te){const ce=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new H(this._documents,te),G);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),ce);let se=this._createDisposable(Z);if(ce!==void 0){const pe=te.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ce));se=_.Disposable.from(se,pe)}return se}$provideInlayHints(G,ee,te,ce){return this._withAdapter(G,H,Z=>Z.provideInlayHints(g.URI.revive(ee),te,ce),void 0)}registerDocumentLinkProvider(G,ee,te){const ce=this._addNewAdapter(new X(this._documents,te),G);return this._proxy.$registerDocumentLinkProvider(ce,this._transformDocumentSelector(ee),typeof te.resolveDocumentLink=="function"),this._createDisposable(ce)}$provideDocumentLinks(G,ee,te){return this._withAdapter(G,X,ce=>ce.provideLinks(g.URI.revive(ee),te),void 0)}$resolveDocumentLink(G,ee,te){return this._withAdapter(G,X,ce=>ce.resolveLink(ee,te),void 0)}$releaseDocumentLinks(G,ee){this._withAdapter(G,X,te=>te.releaseLinks(ee),void 0)}registerColorProvider(G,ee,te){const ce=this._addNewAdapter(new K(this._documents,te),G);return this._proxy.$registerDocumentColorProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentColors(G,ee,te){return this._withAdapter(G,K,ce=>ce.provideColors(g.URI.revive(ee),te),[])}$provideColorPresentations(G,ee,te,ce){return this._withAdapter(G,K,Z=>Z.provideColorPresentations(g.URI.revive(ee),te,ce),void 0)}registerFoldingRangeProvider(G,ee,te){const ce=this._nextHandle(),Z=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new de(this._documents,te),G)),this._proxy.$registerFoldingRangeProvider(ce,this._transformDocumentSelector(ee),Z);let se=this._createDisposable(ce);if(Z!==void 0){const pe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));se=_.Disposable.from(se,pe)}return se}$provideFoldingRanges(G,ee,te,ce){return this._withAdapter(G,de,Z=>Z.provideFoldingRanges(g.URI.revive(ee),te,ce),void 0)}registerSelectionRangeProvider(G,ee,te){const ce=this._addNewAdapter(new _e(this._documents,te,this._logService),G);return this._proxy.$registerSelectionRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideSelectionRanges(G,ee,te,ce){return this._withAdapter(G,_e,Z=>Z.provideSelectionRanges(g.URI.revive(ee),te,ce),[])}registerCallHierarchyProvider(G,ee,te){const ce=this._addNewAdapter(new Ce(this._documents,te),G);return this._proxy.$registerCallHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareCallHierarchy(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),te,ce)),void 0)}$provideCallHierarchyIncomingCalls(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Z.provideCallsTo(ee,te,ce),void 0)}$provideCallHierarchyOutgoingCalls(G,ee,te,ce){return this._withAdapter(G,Ce,Z=>Z.provideCallsFrom(ee,te,ce),void 0)}$releaseCallHierarchy(G,ee){this._withAdapter(G,Ce,te=>Promise.resolve(te.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(G,ee,te){const ce=this._addNewAdapter(new Pe(this._documents,te),G);return this._proxy.$registerTypeHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareTypeHierarchy(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),te,ce)),void 0)}$provideTypeHierarchySupertypes(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Z.provideSupertypes(ee,te,ce),void 0)}$provideTypeHierarchySubtypes(G,ee,te,ce){return this._withAdapter(G,Pe,Z=>Z.provideSubtypes(ee,te,ce),void 0)}$releaseTypeHierarchy(G,ee){this._withAdapter(G,Pe,te=>Promise.resolve(te.releaseSession(ee)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,D.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:$e._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:$e._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?$e._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?$e._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:$e._serializeRegExp(G.beforeText),afterText:G.afterText?$e._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?$e._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map($e._serializeOnEnterRule)}setLanguageConfiguration(G,ee,te){let{wordPattern:ce}=te;if(ce&&(0,D.regExpLeadsToEndlessLoop)(ce))throw new Error(`Invalid language configuration: wordPattern '${ce}' is not allowed to match the empty string.`);ce?this._documents.setWordDefinitionFor(ee,ce):this._documents.setWordDefinitionFor(ee,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const Z=this._nextHandle(),se={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?$e._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?$e._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?$e._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,se),this._createDisposable(Z)}$setWordDefinitions(G){for(const ee of G)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=$e,$e._handlePool=0}),define(fe[243],me([0,1,5,16,7,49,15,6]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(i,I,l,p){this._documents=I,this._commands=l,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=i.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(i){this._languageIds=i}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(i,I){await this._proxy.$changeLanguage(i,I);const l=this._documents.getDocumentData(i);if(!l)throw new Error(`document '${i.toString}' NOT found`);return l.document}async tokenAtPosition(i,I){const l=i.version,p=L.Position.from(I),h=await this._proxy.$tokensAtPosition(i.uri,p),w={type:y.StandardTokenType.Other,range:i.getWordRangeAtPosition(I)??new y.Range(I.line,I.character,I.line,I.character)};if(!h)return w;const S={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!S.range.contains(I)||l!==i.version?w:S}createLanguageStatusItem(i,I,l){const p=this._handlePool++,h=this._proxy,w=this._ids,S=`${i.identifier.value}/${I}`;if(w.has(S))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(S);const T={selector:l,id:I,name:i.displayName??i.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,s=new D.DisposableStore;const o=()=>{b?.dispose(),b=(0,P.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(p,{id:S,name:T.name??i.displayName??i.name,source:i.displayName??i.name,selector:L.DocumentSelector.from(T.selector,this._uriTransformer),label:T.text,detail:T.detail??"",severity:T.severity===y.LanguageStatusSeverity.Error?_.default.Error:T.severity===y.LanguageStatusSeverity.Warning?_.default.Warning:_.default.Info,command:T.command&&this._commands.toInternal(T.command,s),accessibilityInfo:T.accessibilityInformation})},0)},v={dispose(){s.dispose(),b?.dispose(),h.$removeLanguageStatus(p),w.delete(S)},get id(){return T.id},get name(){return T.name},set name(t){T.name=t,o()},get selector(){return T.selector},set selector(t){T.selector=t,o()},get text(){return T.text},set text(t){T.text=t,o()},get detail(){return T.detail},set detail(t){T.detail=t,o()},get severity(){return T.severity},set severity(t){T.severity=t,o()},get accessibilityInformation(){return T.accessibilityInformation},set accessibilityInformation(t){T.accessibilityInformation=t,o()},get command(){return T.command},set command(t){T.command=t,o()}};return o(),v}}e.ExtHostLanguages=C}),define(fe[244],me([0,1,5,13,35]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function _(D){return D&&D.title}let P=class{constructor(C,k){this._logService=k,this._proxy=C.getProxy(g.MainContext.MainThreadMessageService)}showMessage(C,k,i,I,l){const p={extension:C};let h;typeof I=="string"||_(I)?h=[I,...l]:(p.modal=I?.modal,p.useCustom=I?.useCustom,p.detail=I?.detail,h=l),p.useCustom&&(0,y.checkProposedApiEnabled)(C);const w=[];for(let S=0;S<h.length;S++){const T=h[S];if(typeof T=="string")w.push({title:T,handle:S,isCloseAffordance:!1});else if(typeof T=="object"){let{title:b,isCloseAffordance:s}=T;w.push({title:b,isCloseAffordance:!!s,handle:S})}else this._logService.warn("Invalid message item:",T)}return this._proxy.$showMessage(k,i,p,w).then(S=>{if(typeof S=="number")return h[S]})}};P=Ve([We(1,L.ILogService)],P),e.ExtHostMessageService=P}),define(fe[245],me([0,1,22,3,48,6,24,9,12,2,88,5,16,7,55,220,131]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class T{constructor(s,o,v,t,f){this._textDocumentsAndEditors=v,this._textDocuments=t,this._extensionStoragePaths=f,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const n=r.notebookEditor?.notebookUri,d=r.cell.handle,c=this._documents.get(n)?.getCell(d);if(c)return c.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const o=this._editors.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(s){for(const[o,v]of this._editors)if(v.apiEditor===s)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,o){const v=this._documents.get(s);if(!v&&!o)throw new Error(`NO notebook document for '${s}'`);return v}_getProviderData(s){const o=this._notebookContentProviders.get(s);if(!o)throw new Error(`NO provider for '${s}'`);return o}registerNotebookContentProvider(s,o,v,t,f){if((0,D.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:s,provider:v});let r;return v.onDidChangeNotebookContentOptions&&(r=v.onDidChangeNotebookContentOptions(()=>{const n=l.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(o,n)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},o,l.NotebookDocumentContentOptions.from(t),T._convertNotebookRegistrationData(s,f)),new p.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(s,o){if(!o)return;const v=o.filenamePattern.map(t=>l.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(o.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:v,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,v){const t=T._notebookStatusBarItemProviderHandlePool++,f=typeof v.onDidChangeCellStatusBarItems=="function"?T._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,f,o);let r;return f!==void 0&&(r=v.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(f))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,f),r&&r.dispose()})}async createNotebookDocument(s){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&l.NotebookData.from(s.content)});return k.URI.revive(o)}async openNotebookDocument(s){const o=this._documents.get(s);if(o)return o.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(s),t=this._documents.get(k.URI.revive(v));return(0,C.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(s,o){k.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let v;typeof o=="object"?v={position:l.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(l.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:v={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,v),f=t&&this._editors.get(t)?.apiEditor;if(f)return f;throw t?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,v,t){const f=this._notebookStatusBarItemProviders.get(s),r=k.URI.revive(o),n=this._documents.get(r);if(!n||!f)return;const d=n.getCellFromIndex(v);if(!d)return;const a=await f.provideCellStatusBarItems(d.apiCell,t);if(!a)return;const c=new _.DisposableStore,m=this._statusBarCache.add([c]),E=(Array.isArray(a)?a:[a]).map(A=>l.NotebookStatusBarItem.from(A,this._commandsConverter,c));return{cacheId:m,items:E}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,o,v,t,f){if((0,D.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,v),this._notebookProxy.$registerNotebookSerializer(r,{id:s.identifier,location:s.extensionLocation},o,l.NotebookDocumentContentOptions.from(t),T._convertNotebookRegistrationData(s,f)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(s,o,v){const t=this._notebookSerializer.get(s);if(!t)throw new Error("NO serializer found");const f=await t.deserializeNotebook(o.buffer,v);return new h.SerializableObjectWithBuffers(l.NotebookData.from(f))}async $notebookToData(s,o,v){const t=this._notebookSerializer.get(s);if(!t)throw new Error("NO serializer found");const f=await t.serializeNotebook(l.NotebookData.to(o.value),v);return g.VSBuffer.wrap(f)}async $openNotebook(s,o,v,t,f){const{provider:r}=this._getProviderData(s),n=await r.openNotebook(k.URI.revive(o),{backupId:v,untitledDocumentData:t?.buffer},f);return new h.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(l.NotebookCellData.from)})}async $saveNotebook(s,o,v){const t=this.getNotebookDocument(k.URI.revive(o)),{provider:f}=this._getProviderData(s);return await f.saveNotebook(t.apiNotebook,v),!0}async $saveNotebookAs(s,o,v,t){const f=this.getNotebookDocument(k.URI.revive(o)),{provider:r}=this._getProviderData(s);return await r.saveNotebookAs(k.URI.revive(v),f.apiNotebook,t),!0}async $backupNotebook(s,o,v){const t=this.getNotebookDocument(k.URI.revive(o)),f=this._getProviderData(s),r=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension),n=String((0,y.hash)([t.uri.toString(),this._backupIdPool++])),d=k.URI.joinPath(r,n),a=await f.provider.backupNotebook(t.apiNotebook,{destination:d},v);return t.updateBackup(a),a.id}_createExtHostEditor(s,o,v){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const t=new S.ExtHostNotebookEditor(o,this._notebookEditorsProxy,s,v.visibleRanges.map(l.NotebookRange.to),v.selections.map(l.NotebookRange.to),typeof v.viewColumn=="number"?l.ViewColumn.to(v.viewColumn):void 0);this._editors.set(o,t)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const v of s.value.removedDocuments){const t=k.URI.revive(v),f=this._documents.get(t);f&&(f.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(s.value.addedDocuments){const v=[];for(const t of s.value.addedDocuments){const f=k.URI.revive(t.uri);if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const r=this,n=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(d){r._onDidChangeNotebookCells.fire(d)},emitCellOutputsChange(d){r._onDidChangeCellOutputs.fire(d)},emitCellMetadataChange(d){r._onDidChangeCellMetadata.fire(d)},emitCellExecutionStateChange(d){r._onDidChangeCellExecutionState.fire(d)}},f,t);v.push(...t.cells.map(d=>w.ExtHostCell.asModelAddData(n.apiNotebook,d))),this._documents.get(f)?.dispose(),this._documents.set(f,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(s.value.addedEditors)for(const v of s.value.addedEditors){if(this._editors.has(v.id))return;const t=k.URI.revive(v.documentUri),f=this._documents.get(t);f&&this._createExtHostEditor(f,v.id,v)}const o=[];if(s.value.removedEditors)for(const v of s.value.removedEditors){const t=this._editors.get(v);t&&(this._editors.delete(v),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),o.push(t))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const v=new Set;this._visibleNotebookEditors.forEach(t=>v.add(t.id));for(const t of this._editors.values()){const f=v.has(t.id);t._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=T,T._notebookStatusBarItemProviderHandlePool=0}),define(fe[246],me([0,1,3,77,13,5,14,16]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(I,l){const p=C._Keys.nextId();I.$registerNotebookEditorDecorationType(p,D.NotebookDecorationRenderOptions.from(l)),this.value={key:p,dispose(){I.$removeNotebookEditorDecorationType(p)}}}}C._Keys=new L.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(I,l,p){this._logService=I,this._extHostRpc=l,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new C(this._extHostRpc.getProxy(_.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,l);const p=this._notebooksAndEditors.getEditorById(I);l.visibleRanges&&p._acceptVisibleRanges(l.visibleRanges.ranges.map(D.NotebookRange.to)),l.selections&&p._acceptSelections(l.selections.selections.map(D.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const l in I)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(D.ViewColumn.to(I[l]))}};k=Ve([We(0,y.ILogService),We(1,P.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(fe[247],me([0,1,18,15,21,3,6,24,2,27,13,5,41,16,7,89,213,35,55]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(r,n,d,a,c){this._initData=n,this._extHostNotebook=d,this._commands=a,this._logService=c,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(I.MainContext.MainThreadNotebookKernels);const m=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",u=>!0,u=>{if(u&&"notebookEditor"in u&&"id"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);return{id:u.id,extension:u.extension,notebookEditorId:E}}else if(u&&"notebookEditor"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${u.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return u})],l.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(r,n,d,a,c,m){for(let W of this._kernelData.values())if(W.controller.id===n&&k.ExtensionIdentifier.equals(r.identifier,W.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const u=this._handlePool++,E=this;this._logService.trace(`NotebookController[${u}], CREATED by ${r.identifier.value}, ${n}`);const A=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${r.identifier}'`);let R=!1;const B=new P.DisposableStore,N=new _.Emitter,F=new _.Emitter,$={id:`${r.identifier.value}/${n}`,notebookType:d,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:a||r.identifier.value,preloads:m?m.map(p.NotebookRendererScript.from):[]};let M=c??A,z;this._proxy.$addKernel(u,$).catch(W=>{console.log(W),R=!0});let U=0;const x=()=>{if(R)return;const W=++U;Promise.resolve().then(()=>{W===U&&this._proxy.$updateKernel(u,$)})},j=new D.ResourceMap,O={get id(){return n},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return $.label},set label(W){$.label=W??r.displayName??r.name,x()},get detail(){return $.detail??""},set detail(W){$.detail=W,x()},get description(){return $.description??""},set description(W){$.description=W,x()},get kind(){return(0,T.checkProposedApiEnabled)(r),$.kind??""},set kind(W){(0,T.checkProposedApiEnabled)(r),$.kind=W,x()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(W){$.supportedLanguages=W,x()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(W){$.supportsExecutionOrder=W,x()},get rendererScripts(){return $.preloads?$.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(W){M=W??A},get interruptHandler(){return z},set interruptHandler(W){z=W,$.supportsInterrupt=Boolean(W),x()},createNotebookCellExecution(W){if(R)throw new Error("notebook controller is DISPOSED");if(!j.has(W.notebook.uri))throw E._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${W.notebook.uri.toString()}`);return E._createNotebookCellExecution(W)},dispose:()=>{R||(this._logService.trace(`NotebookController[${u}], DISPOSED`),R=!0,this._kernelData.delete(u),B.dispose(),N.dispose(),F.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(W,H){E._proxy.$updateNotebookPriority(u,W.uri,H)},onDidReceiveMessage:F.event,postMessage(W,H){return(0,T.checkProposedApiEnabled)(r),E._proxy.$postMessage(u,H&&E._extHostNotebook.getIdByEditor(H),W)},asWebviewUri(W){return(0,T.checkProposedApiEnabled)(r),(0,w.asWebviewUri)(W,E._initData.remote)}};return this._kernelData.set(u,{extensionId:r.identifier,controller:O,onDidReceiveMessage:F,onDidChangeSelection:N,associatedNotebooks:j}),O}$acceptNotebookAssociation(r,n,d){const a=this._kernelData.get(r);if(a){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n));d?a.associatedNotebooks.set(c.uri,!0):a.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,c.uri.toString(),d),a.onDidChangeSelection.fire({selected:d,notebook:c.apiNotebook})}}async $executeCells(r,n,d){const a=this._kernelData.get(r);if(!a)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n)),m=[];for(let u of d){const E=c.getCell(u);E&&m.push(E.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,c.uri.toString(),m.length),await a.controller.executeHandler.call(a.controller,m,c.apiNotebook,a.controller)}catch(u){this._logService.error(`NotebookController[${r}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(r,n,d){const a=this._kernelData.get(r);if(!a)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(n));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,c.apiNotebook);else for(let m of d){const u=c.getCell(m);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,n,d){const a=this._kernelData.get(r);if(!a)return;const c=this._extHostNotebook.getEditorById(n);a.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:d}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!d)throw new Error("invalid cell");if(this._activeExecutions.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const a=new v(d.notebook,d,this._proxy);this._activeExecutions.set(d.uri,a);const c=a.onDidChangeState(()=>{a.state===o.Resolved&&(a.dispose(),c.dispose(),this._activeExecutions.delete(d.uri))});return a.asApiObject()}};s=Ve([We(4,i.ILogService)],s),e.ExtHostNotebookKernels=s;var o;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(o||(o={}));class v extends P.Disposable{constructor(r,n,d){super();this._document=r,this._cell=n,this._proxy=d,this._handle=v.HANDLE++,this._onDidChangeState=new _.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new t(10,a=>this.update(a)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const n=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let n=this._cell;if(r&&(n=this._document.getCellFromApiCell(r)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(r){return r.map(n=>{const d=h.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return d===n.items?p.NotebookCellOutput.from(n):p.NotebookCellOutput.from({items:d,id:n.id,metadata:n.metadata})})}async updateOutputs(r,n,d){const a=this.cellIndexToHandle(n),c=this.validateAndConvertOutputs((0,g.asArray)(r));return this.updateSoon({editType:S.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:a,append:d,outputs:c})}async updateOutputItems(r,n,d){return r=h.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(r),!0),this.updateSoon({editType:S.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(p.NotebookCellOutputItem.from),outputId:n.id,append:d})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(d){r._executionOrder=d,r.update([{editType:S.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(d){if(r._state===o.Resolved||r._state===o.Started)throw new Error("Cannot call start again");r._state=o.Started,r._onDidChangeState.fire(),r.update({editType:S.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:d})},end(d,a){if(r._state===o.Resolved)throw new Error("Cannot call resolve twice");r._state=o.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:S.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:a,lastRunSuccess:d}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(d){return r.verifyStateForOutput(),r.updateOutputs([],d,!1)},appendOutput(d,a){return r.verifyStateForOutput(),r.updateOutputs(d,a,!0)},replaceOutput(d,a){return r.verifyStateForOutput(),r.updateOutputs(d,a,!1)},appendOutputItems(d,a){return r.verifyStateForOutput(),r.updateOutputItems(d,a,!0)},replaceOutputItems(d,a){return r.verifyStateForOutput(),r.updateOutputItems(d,a,!1)}})}}v.HANDLE=0;class t{constructor(r,n){this.delay=r,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>r.complete())}}}),define(fe[248],me([0,1,3,5,131]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class _{constructor(D,C){this._extHostNotebook=C,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,C,k){const i=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(C)?.fire({editor:i.apiEditor,message:k})}createRendererMessaging(D,C){if(!D.contributes?.notebookRenderer?.some(l=>l.id===C))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${C})`);const k=!!D.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(l,p,h)=>{const w=k?l:S=>{const T={};i.set(T,S.editor),l({editor:T,message:S.message})};return this.getOrCreateEmitterFor(C).event(w,p,h)},postMessage:(l,p)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(l)&&([l,p]=[p,l]);const h=k?p:i.get(p),w=h&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(w?.id,C,l)}}}getOrCreateEmitterFor(D){let C=this._rendererMessageEmitters.get(D);return C||(C=new g.Emitter({onLastListenerRemove:()=>{C?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,C),C)}}e.ExtHostNotebookRenderers=_}),define(fe[69],me([0,1,5,3,6,22,4,14]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class C extends y.Disposable{constructor(h,w,S,T,b){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=h,this._proxy=b,this._id=b.$register(this.name,w,S,T),this._disposed=!1,this._offset=0}get name(){return this._name}append(h){this.validate(),this._offset+=h?_.VSBuffer.fromString(h).byteLength:0}update(){this._id.then(h=>this._proxy.$update(h))}appendLine(h){this.validate(),this.append(h+`
`)}clear(){this.validate();const h=this._offset;this._id.then(w=>this._proxy.$clear(w,h))}show(h,w){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof h=="boolean"?h:w)))}hide(){this.validate(),this._id.then(h=>this._proxy.$close(h))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(h=>this._proxy.$dispose(h)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=C;class k extends C{constructor(h,w,S){super(h,!1,void 0,w,S)}append(h){super.append(h),this._id.then(w=>this._proxy.$append(w,h)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends C{constructor(h,w,S){super(h,!0,w,void 0,S)}append(h){throw new Error("Not supported")}}class I{constructor(h,w){this.name=h,this._channel=w}append(h){this._channel.then(w=>w.append(h))}appendLine(h){this._channel.then(w=>w.appendLine(h))}clear(){this._channel.then(h=>h.clear())}show(h,w){this._channel.then(S=>S.show(h,w))}hide(){this._channel.then(h=>h.hide())}dispose(){this._channel.then(h=>h.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(h){this._proxy=h.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(h){}createOutputChannel(h,w){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");return new k(h,w.identifier.value,this._proxy)}createOutputChannelFromLogFile(h,w){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");if(!w)throw new Error("illegal argument `file`. must not be falsy");return new i(h,w,this._proxy)}};l=Ve([We(0,D.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(fe[249],me([0,1,15,21,3,6,5,2,7,17,18,49,65]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(h,w,S){const T=h.getProxy(P.MainContext.MainThreadQuickOpen);class b{constructor(a,c){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=c}showQuickPick(a,c,m,u=L.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(a),A=++this._instances,R=T.$show(A,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},u),B={},N=R.then(()=>B);return Promise.race([N,E]).then(F=>{if(F!==B)return E.then($=>{const M=[];for(let z=0;z<$.length;z++){const U=$[z];let x,j,O,W,H;typeof U=="string"?x=U:(x=U.label,j=U.description,O=U.detail,W=U.picked,H=U.alwaysShow),M.push({label:x,description:j,handle:z,detail:O,picked:W,alwaysShow:H})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{m.onDidSelectItem($[z])}),T.$setItems(A,M),R.then(z=>{if(typeof z=="number")return $[z];if(Array.isArray(z))return z.map(U=>$[U])})})}).then(void 0,F=>{if(!(0,k.isPromiseCanceledError)(F))return T.$setError(A,F),Promise.reject(F)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,c=L.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,T.$input(a,typeof this._validateInput=="function",c).then(void 0,m=>{if(!(0,k.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(a){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,c=L.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!m)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(E=>E.uri.toString()===m.uri.toString())}createQuickPick(a,c){const m=new r(a,c,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(a){const c=new n(a,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(a,c){const m=this._sessions.get(a);m&&m._fireDidChangeValue(c)}$onDidAccept(a){const c=this._sessions.get(a);c&&c._fireDidAccept()}$onDidChangeActive(a,c){const m=this._sessions.get(a);m instanceof r&&m._fireDidChangeActive(c)}$onDidChangeSelection(a,c){const m=this._sessions.get(a);m instanceof r&&m._fireDidChangeSelection(c)}$onDidTriggerButton(a,c){const m=this._sessions.get(a);m&&m._fireDidTriggerButton(c)}$onDidTriggerItemButton(a,c,m){const u=this._sessions.get(a);u instanceof r&&u._fireDidTriggerItemButton(c,m)}$onDidHide(a){const c=this._sessions.get(a);c&&c._fireDidHide()}}class s{constructor(a,c){this._extensionId=a,this._onDidDispose=c,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((c,m)=>{const u=c===C.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(u,c)}),this.update({buttons:a.map((c,m)=>({...f(c),tooltip:c.tooltip,handle:c===C.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const c=this._handlesToButtons.get(a);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,_.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),T.$dispose(this._id))}update(a){if(!this._disposed){for(const c of Object.keys(a)){const m=a[c];this._pendingUpdate[c]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){T.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function o(d){if(d instanceof C.ThemeIcon)return{id:d.id};const a=t(d),c=v(d);return{dark:typeof a=="string"?D.URI.file(a):a,light:typeof c=="string"?D.URI.file(c):c}}function v(d){return typeof d=="object"&&"light"in d?d.light:d}function t(d){return typeof d=="object"&&"dark"in d?d.dark:d}function f(d){const a=o(d.iconPath);let c,m;return"id"in a?m=l.ThemeIcon.asClassName(a):c=a,{iconPath:c,iconClass:m}}class r extends s{constructor(a,c,m){super(a,m);this.enableProposedApi=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((c,m)=>{this._handlesToItems.set(m,c),this._itemsToHandles.set(c,m)}),this.update({items:a.map((c,m)=>({label:c.label,description:c.description,handle:m,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons&&this.enableProposedApi?c.buttons.map((u,E)=>({...f(u),tooltip:u.tooltip,handle:E})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(a){const c=(0,i.coalesce)(a.map(m=>this._handlesToItems.get(m)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(a){const c=(0,i.coalesce)(a.map(m=>this._handlesToItems.get(m)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}_fireDidTriggerItemButton(a,c){const m=this._handlesToItems.get(a);if(!m||!m.buttons||!m.buttons.length)return;const u=m.buttons[c];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:m})}}class n extends s{constructor(a,c){super(a,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?I.default.Error:I.default.Ignore})}}return new b(w,S)}e.createExtHostQuickOpen=p}),define(fe[250],me([0,1,2,3,60,6,15,5,18,101,13,27,35,65,16]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(a){if(a)return typeof a.iconPath=="string"?g.URI.file(a.iconPath):g.URI.isUri(a.iconPath)||p.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function S(a,c){if(!a.iconPath&&!c.iconPath)return 0;if(a.iconPath){if(!c.iconPath)return 1}else return-1;const m=typeof a.iconPath=="string"?a.iconPath:g.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,u=typeof c.iconPath=="string"?c.iconPath:g.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id;return(0,k.comparePaths)(m,u)}function T(a,c){let m=0;if(a.strikeThrough!==c.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==c.faded)return a.faded?1:-1;if(a.tooltip!==c.tooltip)return(a.tooltip||"").localeCompare(c.tooltip||"");if(m=S(a,c),m!==0)return m;if(a.light&&c.light)m=S(a.light,c.light);else{if(a.light)return 1;if(c.light)return-1}if(m!==0)return m;if(a.dark&&c.dark)m=S(a.dark,c.dark);else{if(a.dark)return 1;if(c.dark)return-1}return m}function b(a,c){if(a.command!==c.command)return a.command<c.command?-1:1;if(a.title!==c.title)return a.title<c.title?-1:1;if(a.tooltip!==c.tooltip){if(a.tooltip!==void 0&&c.tooltip!==void 0)return a.tooltip<c.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(c.tooltip!==void 0)return-1}if(a.arguments===c.arguments)return 0;if(a.arguments)if(c.arguments){if(a.arguments.length!==c.arguments.length)return a.arguments.length-c.arguments.length}else return 1;else return-1;for(let m=0;m<a.arguments.length;m++){const u=a.arguments[m],E=c.arguments[m];if(u!==E)return u<E?-1:1}return 0}function s(a,c){let m=(0,k.comparePaths)(a.resourceUri.fsPath,c.resourceUri.fsPath,!0);if(m!==0)return m;if(a.command&&c.command)m=b(a.command,c.command);else{if(a.command)return 1;if(c.command)return-1}if(m!==0)return m;if(a.decorations&&c.decorations)m=T(a.decorations,c.decorations);else{if(a.decorations)return 1;if(c.decorations)return-1}return m}function o(a,c){for(let m=0;m<a.length;m++)if(a[m]!==c[m])return!1;return!0}function v(a,c){return a.command===c.command&&a.title===c.title&&a.tooltip===c.tooltip&&(a.arguments&&c.arguments?o(a.arguments,c.arguments):a.arguments===c.arguments)}function t(a,c){return(0,C.equals)(a,c,v)}class f{constructor(c,m,u){this._extension=c,this._proxy=m,this._sourceControlHandle=u,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(c){this._proxy.$setInputBoxValue(this._sourceControlHandle,c),this.updateValue(c)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(c){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,c),this._placeholder=c}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(c){if((0,l.checkProposedApiEnabled)(this._extension),c&&typeof c!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=c,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!c)}get visible(){return this._visible}set visible(c){c=!!c,this._visible!==c&&(this._visible=c,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,c))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(c,m){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,c,m)}$onInputBoxValueChange(c){this.updateValue(c)}updateValue(c){this._value=c,this._onDidChange.fire(c)}}e.ExtHostSCMInputBox=f;class r{constructor(c,m,u,E,A){this._proxy=c,this._commands=m,this._sourceControlHandle=u,this._id=E,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(c){this._label=c,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,c)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(c){this._hideWhenEmpty=c,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(c){this._resourceStates=[...c],this._onDidUpdateResourceStates.fire()}getResourceState(c){return this._resourceStatesMap.get(c)}$executeResourceCommand(c,m){const u=this._resourceStatesCommandsMap.get(c);return u?(0,P.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const c=[...this._resourceStates].sort(s),u=(0,C.sortedDiff)(this._resourceSnapshot,c,s).map(R=>{const B=R.toInsert.map(N=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,N);const $=N.resourceUri;let M;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const de=new _.DisposableStore;M=this._commands.converter.toInternal(N.command,de),this._resourceStatesDisposablesMap.set(F,de)}else this._resourceStatesCommandsMap.set(F,N.command);const z=w(N.decorations),U=N.decorations&&w(N.decorations.light)||z,x=N.decorations&&w(N.decorations.dark)||z,j=[U,x],O=N.decorations&&N.decorations.tooltip||"",W=N.decorations&&!!N.decorations.strikeThrough,H=N.decorations&&!!N.decorations.faded,X=N.contextValue||"";return{rawResource:[F,$,j,O,W,H,X,M],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:B}}),E=u.map(({start:R,deleteCount:B,toInsert:N})=>[R,B,N.map(F=>F.rawResource)]),A=u.reverse();for(const{start:R,deleteCount:B,toInsert:N}of A){const F=N.map(M=>M.handle),$=this._handlesSnapshot.splice(R,B,...F);for(const M of $)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=c,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class n{constructor(c,m,u,E,A,R){this._extension=c,this._proxy=m,this._commands=u,this._id=E,this._label=A,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new _.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new _.MutableDisposable,this._statusBarDisposables=new _.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(c,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,A,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(c){this._count!==c&&(this._count=c,this._proxy.$updateSourceControl(this.handle,{count:c}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(c){this._quickDiffProvider=c,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!c})}get commitTemplate(){return this._commitTemplate}set commitTemplate(c){c!==this._commitTemplate&&(this._commitTemplate=c,this._proxy.$updateSourceControl(this.handle,{commitTemplate:c}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(c){this._acceptInputDisposables.value=new _.DisposableStore,this._acceptInputCommand=c;const m=this._commands.converter.toInternal(c,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get actionButton(){return(0,l.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(c){(0,l.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new _.DisposableStore,this._actionButton=c;const m=c!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:m??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(c){if(this._statusBarCommands&&c&&t(this._statusBarCommands,c))return;this._statusBarDisposables.value=new _.DisposableStore,this._statusBarCommands=c;const m=(c||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(c,m){const u=new r(this._proxy,this._commands,this.handle,c,m),E=L.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const c=[],m=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const A=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});L.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),A.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),c.push([u.handle,u.id,u.label,u.features]);const R=u._takeResourceStateSnapshot();R.length>0&&m.push([u.handle,R]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,c,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const c=[];this.updatedResourceGroups.forEach(m=>{const u=m._takeResourceStateSnapshot();u.length!==0&&c.push([m.handle,u])}),c.length>0&&this._proxy.$spliceResourceStates(this.handle,c),this.updatedResourceGroups.clear()}getResourceGroup(c){return this._groups.get(c)}setSelectionState(c){this._selected=c,this._onDidChangeSelection.fire(c)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(c=>c.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,y.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,y.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let d=class $n{constructor(c,m,u){this._commands=m,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=c.getProxy(D.MainContext.MainThreadSCM),this._telemetry=c.getProxy(D.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const A=this._sourceControls.get(E.sourceControlHandle);if(!A)return E;const R=A.getResourceGroup(E.groupHandle);return R?R.getResourceState(E.handle):E}else if(E&&E.$mid===4){const A=this._sourceControls.get(E.sourceControlHandle);return A?A.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const A=this._sourceControls.get(E.handle);return A||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(c,m,u,E){this.logService.trace("ExtHostSCM#createSourceControl",c.identifier.value,m,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:c.identifier.value});const A=$n._handlePool++,R=new n(c,this._proxy,this._commands,m,u,E);this._sourceControls.set(A,R);const B=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier))||[];return B.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(c.identifier),B),R}getLastInputBox(c){this.logService.trace("ExtHostSCM#getLastInputBox",c.identifier.value);const m=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(c.identifier)),u=m&&m[m.length-1];return u&&u.inputBox}$provideOriginalResource(c,m,u){const E=g.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",c,E.toString());const A=this._sourceControls.get(c);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(E,u)).then(R=>R||null)}$onInputBoxValueChange(c,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",c);const u=this._sourceControls.get(c);return u&&u.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(c,m,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",c,m,u);const A=this._sourceControls.get(c);if(!A)return Promise.resolve(void 0);const R=A.getResourceGroup(m);return R?R.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(c,m,u){this.logService.trace("ExtHostSCM#$validateInput",c);const E=this._sourceControls.get(c);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>E.inputBox.validateInput(m,u)).then(A=>{if(!A)return Promise.resolve(void 0);const R=h.MarkdownString.fromStrict(A.message);return R?Promise.resolve([R,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(c){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",c),c!==void 0&&this._sourceControls.get(c)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=c,Promise.resolve(void 0)}};d._handlePool=0,d=Ve([We(2,i.ILogService)],d),e.ExtHostSCM=d});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[251],me([0,1,7,5,167,6,16,12]),function(Y,e,g,L,y,_,P,D){"use strict";var C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class i{constructor(h,w,S,T,b=g.StatusBarAlignment.Left,s){C.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new _.DisposableStore,st(this,C,h,"f"),st(this,k,w,"f"),this._entryId=i.ID_GEN++,this._extension=S,this._id=T,this._alignment=b,this._priority=this.validatePriority(s)}validatePriority(h){if(!!(0,D.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!i.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Ne(this,k,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Ne(this,k,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let w;this._name?w=this._name:w=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let S=this._color;this._backgroundColor&&(S=i.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const T=this._tooltip?P.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,C,"f").$setEntry(this._entryId,h,w,this._text,T,this._command?.internal,S,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=i,C=new WeakMap,k=new WeakMap,i.ID_GEN=0,i.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const w={message:h};return this._messages.unshift(w),this._update(),new g.Disposable(()=>{const S=this._messages.indexOf(w);S>=0&&(this._messages.splice(S,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(h,w){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(h,w,S,T){return new i(this._proxy,this._commands,h,w,S,T)}setStatusBarMessage(h,w){const S=this._statusMessage.setMessage(h);let T;return typeof w=="number"?T=setTimeout(()=>S.dispose(),w):typeof w!="undefined"&&w.then(()=>S.dispose(),()=>S.dispose()),new g.Disposable(()=>{S.dispose(),clearTimeout(T)})}}e.ExtHostStatusBar=l}),define(fe[93],me([0,1,5,3,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class _{constructor(D){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,C){this._proxy.$registerExtensionStorageKeysToSync(D,C)}getValue(D,C,k){return this._proxy.$getValue(D,C).then(i=>i||k)}setValue(D,C,k){return this._proxy.$setValue(D,C,k)}$acceptValue(D,C,k){this._onDidChangeStorage.fire({shared:D,key:C,value:k})}}e.ExtHostStorage=_,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(fe[70],me([0,1,4,28,13,92,2]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let D=class{constructor(k,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(k){return P.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,i=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(P.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:P.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this._value)return P.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return P.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=Ve([We(0,L.IExtHostInitDataService),We(1,y.ILogService),We(2,_.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(fe[33],me([0,1,3,5,4,2,14,6,7,168,17,215,21,32,196,65,12,15]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(a,c,m,u){this._proxy=a,this._id=c,this._creationOptions=m,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(A,R=!0){E._checkDisposed(),E._proxy.$sendText(E._id,A,R)},show(A){E._checkDisposed(),E._proxy.$show(E._id,A)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(a,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:a.name,shellPath:(0,S.withNullAsUndefined)(a.shellPath),shellArgs:(0,S.withNullAsUndefined)(a.shellArgs),cwd:(0,S.withNullAsUndefined)(a.cwd),env:(0,S.withNullAsUndefined)(a.env),icon:(0,S.withNullAsUndefined)(r(a.iconPath)),color:w.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,S.withNullAsUndefined)(a.message),strictEnv:(0,S.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,S.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,S.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,S.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(a.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(a,c,m,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(a,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(a,c){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in a?{viewColumn:a.viewColumn,preserveFocus:a.preserveFocus}:void 0:a}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(a){this._name=a}setExitCode(a){this._exitStatus=Object.freeze({code:a})}setDimensions(a,c){return a===this._cols&&c===this._rows||a===0||c===0?!1:(this._cols=a,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(a){this._pidPromiseComplete?(this._pidPromiseComplete(a),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==a&&(this._pidPromise=Promise.resolve(a))})}}e.ExtHostTerminal=b;class s{constructor(a){this._pty=a,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(a){return Promise.resolve("")}async updateProperty(a,c){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(a){this._pty.handleInput&&this._pty.handleInput(a)}resize(a,c){this._pty.setDimensions&&this._pty.setDimensions({columns:a,rows:c})}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>this._onProcessOverrideDimensions.fire(c&&{cols:c.columns,rows:c.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>this._onProcessTitleChanged.fire(c)),this._pty.open(a||void 0),this._pty.setDimensions&&a&&this._pty.setDimensions(a),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let o=1,v=class extends D.Disposable{constructor(a,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(a),this._register({dispose:()=>{for(const[m,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(a=>a.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(a,c){const m=new b(this._proxy,(0,p.generateUuid)(),a,a.name),u=new s(a.pty);return m.createExtensionTerminal(a.location,this._serializeParentTerminal(a,c).resolvedExtHostIdentifier,r(a.iconPath),n(a.color)).then(E=>{const A=this._setupExtHostProcessListeners(E,u);this._terminalProcessDisposables[E]=A}),this._terminals.push(m),m.value}_serializeParentTerminal(a,c){if(c=c||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const m=a.location.parentTerminal;if(m){const u=this._terminals.find(E=>E.value===m);u&&(c.resolvedExtHostIdentifier=u._id)}}else a.location&&typeof a.location!="object"?c.location=a.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(a,c){if(!this._getTerminalById(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const u=new s(c),E=this._setupExtHostProcessListeners(a,u);this._terminalProcessDisposables[a]=E}async $acceptActiveTerminalChanged(a){const c=this._activeTerminal;if(a===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(a);m&&(this._activeTerminal=m,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(a,c){const m=this._getTerminalById(a);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:c})}async $acceptTerminalDimensions(a,c,m){const u=this._getTerminalById(a);u&&u.setDimensions(c,m)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(a,c,m){this._terminalProcesses.get(a)?.resize(c,m)}async $acceptTerminalTitleChange(a,c){const m=this._getTerminalById(a);m&&(m.name=c)}async $acceptTerminalClosed(a,c){const m=this._getTerminalObjectIndexById(this._terminals,a);if(m!==null){const u=this._terminals.splice(m,1)[0];u.setExitCode(c),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(a,c,m,u){if(c){const R=this._getTerminalObjectIndexById(this._terminals,c);if(R!==null){this._terminals[R]._id=a,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const E={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:_.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},A=new b(this._proxy,a,E,m);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(a,c){const m=this._getTerminalById(a);m&&m._setProcessId(c)}async $startExtensionTerminal(a,c){const m=this._getTerminalById(a);if(!m)return{message:(0,k.localize)(0,null,a)};m.isOpen||await new Promise(E=>{const A=this.onDidOpenTerminal(async R=>{R===m.value&&(A.dispose(),E())})});const u=this._terminalProcesses.get(a);u?u.startSendingEvents(c):this._extensionTerminalAwaitingStart[a]={initialDimensions:c}}_setupExtHostProcessListeners(a,c){const m=new D.DisposableStore;m.add(c.onProcessReady(E=>this._proxy.$sendProcessReady(a,E.pid,E.cwd))),m.add(c.onProcessTitleChanged(E=>this._proxy.$sendProcessTitle(a,E))),this._bufferer.startBuffering(a,c.onProcessData),m.add(c.onProcessExit(E=>this._onProcessExit(a,E))),c.onProcessOverrideDimensions&&m.add(c.onProcessOverrideDimensions(E=>this._proxy.$sendOverrideDimensions(a,E))),this._terminalProcesses.set(a,c);const u=this._extensionTerminalAwaitingStart[a];return u&&c instanceof s&&(c.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[a]),m}$acceptProcessAckDataEvent(a,c){this._terminalProcesses.get(a)?.acknowledgeDataEvent(c)}$acceptProcessInput(a,c){this._terminalProcesses.get(a)?.input(c)}$acceptTerminalInteraction(a){const c=this._getTerminalById(a);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(a,c,m){try{this._terminalProcesses.get(a)?.resize(c,m)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(a,c){this._terminalProcesses.get(a)?.shutdown(c)}$acceptProcessRequestInitialCwd(a){this._terminalProcesses.get(a)?.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(a,c))}$acceptProcessRequestCwd(a){this._terminalProcesses.get(a)?.getCwd().then(c=>this._proxy.$sendProcessCwd(a,c))}$acceptProcessRequestLatency(a){return a}registerLinkProvider(a){return this._linkProviders.add(a),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(a),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(a,c,m){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,m),this._proxy.$registerProfileProvider(c,a.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(a,c){const m=new l.CancellationTokenSource().token,u=await this._profileProviders.get(a)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,c);return}this.createTerminalFromOptions(u.options,c)}}async $provideLinks(a,c){const m=this._getTerminalById(a);if(!m)return[];this._terminalLinkCache.delete(a);const u=this._terminalLinkCancellationSource.get(a);u&&u.dispose(!0);const E=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(a,E);const A=[],R={terminal:m.value,line:c},B=[];for(const $ of this._linkProviders)B.push(T.Promises.withAsyncBody(async M=>{E.token.onCancellationRequested(()=>M({provider:$,links:[]}));const z=await $.provideTerminalLinks(R,E.token)||[];E.token.isCancellationRequested||M({provider:$,links:z})}));const N=await Promise.all(B);if(E.token.isCancellationRequested)return[];const F=new Map;for(const $ of N)$&&$.links.length>0&&A.push(...$.links.map(M=>{const z={id:o++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(z.id,{provider:$.provider,link:M}),z}));return this._terminalLinkCache.set(a,F),A}$activateLink(a,c){const m=this._terminalLinkCache.get(a)?.get(c);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(a,c){this._bufferer.stopBuffering(a),this._terminalProcesses.delete(a),delete this._extensionTerminalAwaitingStart[a];const m=this._terminalProcessDisposables[a];m&&(m.dispose(),delete this._terminalProcessDisposables[a]),this._proxy.$sendProcessExit(a,c)}_getTerminalById(a){return this._getTerminalObjectById(this._terminals,a)}_getTerminalObjectById(a,c){const m=this._getTerminalObjectIndexById(a,c);return m!==null?a[m]:null}_getTerminalObjectIndexById(a,c){let m=null;return a.some((u,E)=>u._id===c?(m=E,!0):!1),m}getEnvironmentVariableCollection(a){let c=this._environmentVariableCollections.get(a.identifier.value);return c||(c=new t,this._setEnvironmentVariableCollection(a.identifier.value,c)),c}_syncEnvironmentVariableCollection(a,c){const m=(0,I.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(a,c.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(a){a.forEach(c=>{const m=c[0],u=new t(c[1]);this._setEnvironmentVariableCollection(m,u)})}$acceptDefaultProfile(a,c){this._defaultProfile=a,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(a,c){this._environmentVariableCollections.set(a,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(a,c)})}};v=Ve([We(1,P.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class t{constructor(a){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(a)}get persistent(){return this._persistent}set persistent(a){this._persistent=a,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(a,c){this._setIfDiffers(a,{value:c,type:C.EnvironmentVariableMutatorType.Replace})}append(a,c){this._setIfDiffers(a,{value:c,type:C.EnvironmentVariableMutatorType.Append})}prepend(a,c){this._setIfDiffers(a,{value:c,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(a,c){const m=this.map.get(a);(!m||m.value!==c.value||m.type!==c.type)&&(this.map.set(a,c),this._onDidChangeCollection.fire())}get(a){return this.map.get(a)}forEach(a,c){this.map.forEach((m,u)=>a.call(c,u,m,this))}delete(a){this.map.delete(a),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=t;let f=class extends v{constructor(a){super(!1,a)}createTerminal(a,c,m){throw new i.NotSupportedError}createTerminalFromOptions(a,c){throw new i.NotSupportedError}};f=Ve([We(0,P.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f;function r(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function n(d){return w.ThemeColor.isThemeColor(d)?d:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[252],me([0,1,18,22,21,3,76,48,6,25,12,32,5,14,66,16,7,223,129,90]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(R,B){this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(l.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new f(this.proxy),B.registerArgumentProcessor({processArgument:N=>N?.$mid===13?w.TestItem.toItemFromContext(N):N})}createTestController(R,B){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const N=new C.DisposableStore,F=N.add(new T.SingleUseTestCollection(R));F.root.label=B;const $=new Map,M=this.proxy,z={items:F.root.children,get label(){return B},set label(x){B=x,F.root.label=x,M.$updateControllerLabel(R,B)},get id(){return R},createRunProfile:(x,j,O,W,H)=>{let X=(0,D.hash)(x);for(;$.has(X);)X++;const K=new u(this.proxy,R,X,x,j,O,W,H);return $.set(X,K),K},createTestItem(x,j,O){return new h.TestItemImpl(R,x,j,O)},createTestRun:(x,j,O=!0)=>this.runTracker.createTestRun(R,F,x,j,O),set resolveHandler(x){F.resolveHandler=x},get resolveHandler(){return F.resolveHandler},dispose:()=>{N.dispose()}};z.createRunConfiguration=z.createRunProfile,M.$registerTestController(R,B),N.add((0,C.toDisposable)(()=>M.$unregisterTestController(R)));const U={controller:z,collection:F,profiles:$};return this.controllers.set(R,U),N.add((0,C.toDisposable)(()=>this.controllers.delete(R))),N.add(F.onDidGenerateDiff(x=>M.$publishDiff(R,x))),z}createTestObserver(){return this.observer.checkout()}async runTests(R,B=y.CancellationToken.None){const N=r(R);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(N.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[F.collection.root.id],profileGroup:E[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:R.exclude?.map($=>$.id)},B)}$provideFileCoverage(R,B,N){return(0,g.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(B):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(R,B,N,F){return(0,g.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage(B):void 0)?.resolveFileCoverage(N,F)??Promise.resolve([])}$configureRunProfile(R,B){this.controllers.get(R)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(B=>(0,k.deepFreeze)(w.TestResults.to(B))).concat(this.results).sort((B,N)=>N.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,B){const N=this.controllers.get(s.TestId.fromString(R).controllerId)?.collection;N&&(await N.expand(R,B<0?Infinity:B),N.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,B){const N=this.controllers.get(R.controllerId);if(!N)return;const{collection:F,profiles:$}=N,M=$.get(R.profileId);if(!M)return;const z=R.testIds.map(O=>F.tree.get(O)).filter(i.isDefined),U=R.excludeExtIds.map(O=>N.collection.tree.get(O)).filter(i.isDefined).filter(O=>z.some(W=>W.fullId.compare(O.fullId)===2));if(!z.length)return;const x=new S.TestRunRequest(z.some(O=>O.actual instanceof h.TestItemRootImpl)?void 0:z.map(O=>O.actual),U.map(O=>O.actual),M),j=this.runTracker.prepareForMainThreadTestRun(x,n.fromInternal(R,N.collection),B);try{await M.runHandler(x,B)}finally{j.isRunning&&!B.isCancellationRequested&&await _.Event.toPromise(j.onEnd),j.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};v=Ve([We(0,p.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends C.Disposable{constructor(R,B,N){super();this.dto=R,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new _.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const B=this.dto.id,N=this.dto.controllerId,F=(0,I.generateUuid)(),$=new d(this.proxy,B,F),M=j=>(O,...W)=>{if(U){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),j(O,...W))},z=(j,O)=>{const W=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(j.uri&&j.range){const H={range:w.Range.from(j.range),uri:j.uri};for(const X of W)X.location=X.location||H}this.proxy.$appendTestMessagesInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),W)};let U=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(j){$.coverageProvider=j},enqueued:M(j=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),1)}),skipped:M(j=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),5)}),started:M(j=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),2)}),errored:M((j,O,W)=>{z(j,O),this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),6,W)}),failed:M((j,O,W)=>{z(j,O),this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,N).toString(),4,W)}),passed:M((j,O)=>{this.proxy.$updateTestStateInRun(B,F,s.TestId.fromExtHostTestItem(j,this.dto.controllerId).toString(),3,O)}),appendOutput:(j,O,W)=>{U||(W&&(this.dto.isIncluded(W)?this.ensureTestIsKnown(W):W=void 0),this.proxy.$appendOutputToRun(B,F,L.VSBuffer.fromString(j),O&&w.location.from(O),W&&s.TestId.fromExtHostTestItem(W,N).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(B,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:x,coverage:$}),this.proxy.$startedTestRunTask(B,{id:F,name:R,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof h.TestItemImpl))throw new h.InvalidTestItemError(R.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const B=[],N=this.dto.colllection.root;for(;;){const F=w.TestItem.from(R);if(B.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===N))break;R=R.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class f{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,B,N){return this.getTracker(R,B,N)}cancelRunById(R){for(const B of this.tracked.values())if(B.id===R){B.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,B,N,F,$){const M=this.tracked.get(N);if(M)return M.createRun(F);const z=n.fromPublic(R,B,N,$),U=r(N);this.proxy.$startedExtensionTestRun({controllerId:R,profile:U&&{group:E[U.kind],id:U.profileId},exclude:N.exclude?.map(j=>j.id)??[],id:z.id,include:N.include?.map(j=>j.id)??[B.root.id],persist:$});const x=this.getTracker(N,z);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),x.createRun(F)}getTracker(R,B,N){const F=new t(B,this.proxy,N);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=f;const r=A=>{if(!!A.profile){if(!(A.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class n{constructor(R,B,N,F,$,M){this.controllerId=R,this.id=B,this.isPersisted=$,this.colllection=M,this.includePrefix=N.map(z=>z+"\0"),this.excludePrefix=F.map(z=>z+"\0")}static fromPublic(R,B,N,F){return new n(R,(0,I.generateUuid)(),N.include?.map($=>s.TestId.fromExtHostTestItem($,R).toString())??[R],N.exclude?.map($=>s.TestId.fromExtHostTestItem($,R).toString())??[],F,B)}static fromInternal(R,B){return new n(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,B)}isIncluded(R){const B=s.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(B===N||B.startsWith(N))return!1;for(const N of this.includePrefix)if(B===N||B.startsWith(N))return!0;return!1}}e.TestRunDto=n;class d{constructor(R,B,N){this.proxy=R,this.runId=B,this.taskId=N}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(R,B){const N=await this.fileCoverage;let F=N?.[R];return!this._coverageProvider||!N||!F?[]:(F.detailedCoverage||(F=N[R]=await this._coverageProvider.resolveFileCoverage?.(F,B)??F),F.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class a extends b.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:N}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...B].map(F=>F.revived)},get removed(){return[...N].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return{...R,revived:w.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=c;class m{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(B=>B.revived)},dispose:(0,P.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class u{constructor(R,B,N,F,$,M,z=!1,U=void 0){this.controllerId=B,this.profileId=N,this._label=F,this.kind=$,this.runHandler=M,this._isDefault=z,this._tag=U,o.set(this,void 0),st(this,o,R,"f");const x=E[$];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Ne(this,o,"f").$publishTestRunProfile({profileId:N,controllerId:B,tag:U?w.TestTag.namespace(this.controllerId,U.id):null,label:F,group:x,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?w.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ne(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,o=new WeakMap;const E={[S.TestRunProfileKind.Coverage]:8,[S.TestRunProfileKind.Debug]:4,[S.TestRunProfileKind.Run]:2}}),define(fe[253],me([0,1,3,18,5,132,16,7]),function(Y,e,g,L,y,_,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(l=>l.value)}async showTextDocument(i,I,l){let p;typeof I=="number"?p={position:P.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?p={position:P.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?P.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:p={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(i.uri,p),w=h&&this._extHostDocumentsAndEditors.getEditor(h);if(w)return w.value;throw h?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new _.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const l=this._extHostDocumentsAndEditors.getEditor(i);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const p=I.selections.selections.map(P.Selection.to);l._acceptSelections(p)}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(P.Range.to));l._acceptVisibleRanges(p)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...I.options,lineNumbers:P.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const p=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:h,kind:p})}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const I in i){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const p=P.ViewColumn.to(i[I]);l.value.viewColumn!==p&&(l._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=C}),define(fe[254],me([0,1,2,4,5,6,7]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class D{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(y.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const p=l.uri===void 0?void 0:g.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(C(p))?.get(l.handle)}return l}})}async $getTimeline(i,I,l,p,h){return this._providers.get(i)?.provideTimeline(g.URI.revive(I),l,p,h)}registerTimelineProvider(i,I,l,p){const h=new _.DisposableStore,w=this.convertTimelineItem(I.id,p,h).bind(this);let S;I.onDidChange&&(S=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:I.id}),this));const T=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(b,s,o,v){v?.resetCache&&(h.clear(),T.get(I.id)?.clear());const t=await I.provideTimeline(b,s,o);if(t==null)return;const f=w(b,v);return{...t,source:I.id,items:t.items.map(f)}},dispose(){for(const b of T.values())b.get(I.id)?.clear();S?.dispose(),h.dispose()}})}convertTimelineItem(i,I,l){return(p,h)=>{let w;if(h?.cacheResults){let S=this._itemsBySourceAndUriMap.get(i);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(i,S));const T=C(p);w=S.get(T),w===void 0&&(w=new Map,S.set(T,w))}return S=>{const{iconPath:T,...b}=S,s=`${i}|${S.id??S.timestamp}`;w?.set(s,S);let o,v,t;return S.iconPath&&(T instanceof P.ThemeIcon?t={id:T.id,color:T.color}:g.URI.isUri(T)?(o=T,v=T):{light:o,dark:v}=T),{...b,id:b.id??void 0,handle:s,source:i,command:S.command?I.toInternal(S.command,l):void 0,icon:o,iconDark:v,themeIcon:t,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,_.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function C(k){return k?.toString()}}),define(fe[255],me([0,1,6,10,2,5]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(C){this._openers=new Map,this._proxy=C.getProxy(_.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,k,i,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=I.schemes.find(p=>!P.supportedSchemes.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,I.schemes,C,I.label),(0,g.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(C,k,i){const I=this._openers.get(C);if(!I)throw new Error(`Unknown opener with id: ${C}`);const l=y.URI.revive(k);return I.canOpenExternalUri(l,i)}async $openUri(C,k,i){const I=this._openers.get(C);if(!I)throw new Error(`Unknown opener id: '${C}'`);return I.openExternalUri(y.URI.revive(k.resolvedUri),{sourceUri:y.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(fe[256],me([0,1,5,2,6,17,27]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(P.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=D.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(k)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,k),(0,y.toDisposable)(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,i){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(i))}catch(l){(0,_.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(k){return L.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=D,D.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[71],me([0,1,3,10,2,181,205,89,5]),function(Y,e,g,L,y,_,P,D,C){"use strict";var k,i,I,l,p,h,w,S,T,b,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class v{constructor(m,u,E,A,R,B,N){k.set(this,void 0),i.set(this,void 0),I.set(this,void 0),l.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,""),S.set(this,void 0),T.set(this,!1),b.set(this,!1),s.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new g.Emitter),this._onDidDispose=Ne(this,o,"f").event,st(this,k,m,"f"),st(this,i,u,"f"),st(this,S,E,"f"),st(this,l,A,"f"),st(this,p,R,"f"),st(this,h,B,"f"),st(this,s,t(B),"f"),st(this,I,N,"f")}dispose(){st(this,T,!0,"f"),Ne(this,o,"f").fire(),Ne(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return st(this,b,!0,"f"),(0,D.asWebviewUri)(m,Ne(this,l,"f").remote)}get cspSource(){const m=Ne(this,h,"f").extensionLocation;if(m.scheme===L.Schemas.https||m.scheme===L.Schemas.http){let u=m.toString();return u.endsWith("/")||(u+="/"),u+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,w,"f")}set html(m){this.assertNotDisposed(),Ne(this,w,"f")!==m&&(st(this,w,m,"f"),!Ne(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(st(this,b,!0,"f"),Ne(this,I,"f").report("Webview vscode-resource: uris",Ne(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,i,"f").$setHtml(Ne(this,k,"f"),m))}get options(){return this.assertNotDisposed(),Ne(this,S,"f")}set options(m){this.assertNotDisposed(),Ne(this,i,"f").$setOptions(Ne(this,k,"f"),n(Ne(this,h,"f"),Ne(this,p,"f"),m)),st(this,S,m,"f")}async postMessage(m){if(Ne(this,T,"f"))return!1;const u=(0,P.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Ne(this,s,"f")});return Ne(this,i,"f").$postMessage(Ne(this,k,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Ne(this,T,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,k=new WeakMap,i=new WeakMap,I=new WeakMap,l=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,S=new WeakMap,T=new WeakMap,b=new WeakMap,s=new WeakMap,o=new WeakMap;function t(c){try{const m=(0,_.normalizeVersion)((0,_.parseVersion)(c.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=t;class f{constructor(m,u,E,A,R){this.initData=u,this.workspace=E,this._logService=A,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=m.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(m,u,...E){const A=this.getWebview(m);if(A){const{message:R}=(0,P.deserializeWebviewMessage)(u,E);A._onMessageEmitter.fire(R)}}$onMissingCsp(m,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,u,E){const A=new v(m,this._webviewProxy,d(u),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(m,A),A._onDidDispose(()=>{this._webviews.delete(m)}),A}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=f;function r(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=r;function n(c,m,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||a(c,m)}}e.serializeWebviewOptions=n;function d(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(m=>y.URI.from(m))}}e.reviveOptions=d;function a(c,m){return[...(m?.getWorkspaceFolders()||[]).map(u=>u.uri),c.extensionLocation]}}),define(fe[257],me([0,1,21,48,6,10,23,2,16,71,88,5,7]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(t,f){this.document=t,this._storagePath=f,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,f){await this.getEdit(t).undo(),f||this.disposeBackup()}async redo(t,f){await this.getEdit(t).redo(),f||this.disposeBackup()}disposeEdits(t){for(const f of t)this._edits.delete(f)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=o(this.document.uri)+this._backupCounter++;return(0,P.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const f=this._edits.get(t,0);if(!f)throw new Error("No edit found");return f}}class h{constructor(){this._documents=new Map}get(t,f){return this._documents.get(this.key(t,f))}add(t,f,r){const n=this.key(t,f.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${f.uri}`);const d=new p(f,r);return this._documents.set(n,d),d}delete(t,f){const r=this.key(t,f.uri);this._documents.delete(r)}key(t,f){return`${t}@@@${f}`}}var w;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(w||(w={}));class S{constructor(){this._providers=new Map}addTextProvider(t,f,r){return this.add(0,t,f,r)}addCustomProvider(t,f,r){return this.add(1,t,f,r)}get(t){return this._providers.get(t)}add(t,f,r,n){if(this._providers.has(f))throw new Error(`Provider for viewType:${f} already registered`);return this._providers.set(f,{type:t,extension:r,provider:n}),new l.Disposable(()=>this._providers.delete(f))}}class T{constructor(t,f,r,n,d){this._extHostDocuments=f,this._extensionStoragePaths=r,this._extHostWebview=n,this._extHostWebviewPanels=d,this._editorProviders=new S,this._documents=new h,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,f,r,n){const d=new y.DisposableStore;return b(r)?(d.add(this._editorProviders.addTextProvider(f,t,r)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),f,n.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(d.add(this._editorProviders.addCustomProvider(f,t,r)),this.supportEditing(r)&&d.add(r.onDidChangeCustomDocument(a=>{const c=this.getCustomDocumentEntry(f,a.document.uri);if(s(a)){const m=c.addEdit(a);this._proxy.$onDidEdit(a.document.uri,f,m,a.label)}else this._proxy.$onContentChange(a.document.uri,f)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),f,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(d,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(f)}))}async $createCustomDocument(t,f,r,n,d){const a=this._editorProviders.get(f);if(!a)throw new Error(`No provider found for '${f}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${f}'`);const c=D.URI.revive(t),m=await a.provider.openCustomDocument(c,{backupId:r,untitledDocumentData:n?.buffer},d);let u;return this.supportEditing(a.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension)),this._documents.add(f,m,u),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(t,f){const r=this._editorProviders.get(f);if(!r)throw new Error(`No provider found for '${f}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${f}'`);const n=D.URI.revive(t),{document:d}=this.getCustomDocumentEntry(f,n);this._documents.delete(f,d),d.dispose()}async $resolveWebviewEditor(t,f,r,n,d,a){const c=this._editorProviders.get(r);if(!c)throw new Error(`No provider found for '${r}'`);const m=C.ViewColumn.to(d),u=this._extHostWebview.createNewWebview(f,n.webviewOptions,c.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(f,r,n.title,m,n.panelOptions,u),A=D.URI.revive(t);switch(c.type){case 1:{const{document:R}=this.getCustomDocumentEntry(r,A);return c.provider.resolveCustomEditor(R,E,a)}case 0:{const R=this._extHostDocuments.getDocument(A);return c.provider.resolveCustomTextEditor(R,E,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,f,r){this.getCustomDocumentEntry(f,t).disposeEdits(r)}async $onMoveCustomEditor(t,f,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const d=this._extHostWebviewPanels.getWebviewPanel(t);if(!d)throw new Error("No webview found");const a=D.URI.revive(f),c=this._extHostDocuments.getDocument(a);await n.provider.moveCustomTextEditor(c,d,g.CancellationToken.None)}async $undo(t,f,r,n){return this.getCustomDocumentEntry(f,t).undo(r,n)}async $redo(t,f,r,n){return this.getCustomDocumentEntry(f,t).redo(r,n)}async $revert(t,f,r){const n=this.getCustomDocumentEntry(f,t);await this.getCustomEditorProvider(f).revertCustomDocument(n.document,r),n.disposeBackup()}async $onSave(t,f,r){const n=this.getCustomDocumentEntry(f,t);await this.getCustomEditorProvider(f).saveCustomDocument(n.document,r),n.disposeBackup()}async $onSaveAs(t,f,r,n){const d=this.getCustomDocumentEntry(f,t);return this.getCustomEditorProvider(f).saveCustomDocumentAs(d.document,D.URI.revive(r),n)}async $backup(t,f,r){const n=this.getCustomDocumentEntry(f,t),a=await this.getCustomEditorProvider(f).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},r);return n.updateBackup(a),a.id}getCustomDocumentEntry(t,f){const r=this._documents.get(t,D.URI.revive(f));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=T;function b(v){return typeof v.resolveCustomTextEditor=="function"}function s(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function o(v){const t=v.scheme===_.Schemas.file||v.scheme===_.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(t)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[258],me([0,1,3,6,2,32,16,71,5,7]),function(Y,e,g,L,y,_,P,D,C,k){"use strict";var i,I,l,p,h,w,S,T,b,s,o,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class f extends L.Disposable{constructor(a,c,m,u,E,A,R){super();i.set(this,void 0),I.set(this,void 0),l.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,void 0),S.set(this,void 0),T.set(this,void 0),b.set(this,!0),s.set(this,!0),o.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=Ne(this,v,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Ne(this,t,"f").event,st(this,i,a,"f"),st(this,I,c,"f"),st(this,l,m,"f"),st(this,h,A,"f"),st(this,T,E,"f"),st(this,w,u,"f"),st(this,p,R,"f")}dispose(){Ne(this,o,"f")||(st(this,o,!0,"f"),Ne(this,v,"f").fire(),Ne(this,I,"f").$disposeWebview(Ne(this,i,"f")),Ne(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,p,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,l,"f")}get title(){return this.assertNotDisposed(),Ne(this,w,"f")}set title(a){this.assertNotDisposed(),Ne(this,w,"f")!==a&&(st(this,w,a,"f"),Ne(this,I,"f").$setTitle(Ne(this,i,"f"),a))}get iconPath(){return this.assertNotDisposed(),Ne(this,S,"f")}set iconPath(a){this.assertNotDisposed(),Ne(this,S,"f")!==a&&(st(this,S,a,"f"),Ne(this,I,"f").$setIconPath(Ne(this,i,"f"),y.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Ne(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,T,"f")=="number"&&Ne(this,T,"f")<0))return Ne(this,T,"f")}get active(){return this.assertNotDisposed(),Ne(this,s,"f")}get visible(){return this.assertNotDisposed(),Ne(this,b,"f")}_updateViewState(a){Ne(this,o,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(st(this,s,a.active,"f"),st(this,b,a.visible,"f"),st(this,T,a.viewColumn,"f"),Ne(this,t,"f").fire({webviewPanel:this}))}reveal(a,c){this.assertNotDisposed(),Ne(this,I,"f").$reveal(Ne(this,i,"f"),{viewColumn:a?P.ViewColumn.from(a):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ne(this,o,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,l=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,S=new WeakMap,T=new WeakMap,b=new WeakMap,s=new WeakMap,o=new WeakMap,v=new WeakMap,t=new WeakMap;class r{constructor(a,c,m){this.webviews=c,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,_.generateUuid)()}createWebviewPanel(a,c,m,u,E={}){const A=typeof u=="object"?u.viewColumn:u,R={viewColumn:P.ViewColumn.from(A),preserveFocus:typeof u=="object"&&!!u.preserveFocus},B=(0,D.shouldSerializeBuffersForPostMessage)(a),N=r.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(a),N,c,{title:m,panelOptions:n(E),webviewOptions:(0,D.serializeWebviewOptions)(a,this.workspace,E),serializeBuffersForPostMessage:B},R);const F=this.webviews.createNewWebview(N,E,a);return this.createNewWebviewPanel(N,c,m,A,E,F)}$onDidChangeWebviewPanelViewStates(a){const c=Object.keys(a);c.sort((m,u)=>{const E=a[m],A=a[u];return E.active?1:A.active?-1:+E.visible-+A.visible});for(const m of c){const u=this.getWebviewPanel(m);if(!u)continue;const E=a[m];u._updateViewState({active:E.active,visible:E.visible,viewColumn:P.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,c,m){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:m,extension:a}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(a)}),new k.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(a,c,m,u){const E=this._serializers.get(c);if(!E)throw new Error(`No serializer found for '${c}'`);const{serializer:A,extension:R}=E,B=this.webviews.createNewWebview(a,m.webviewOptions,R),N=this.createNewWebviewPanel(a,c,m.title,u,m.panelOptions,B);await A.deserializeWebviewPanel(N,m.state)}createNewWebviewPanel(a,c,m,u,E,A){const R=new f(a,this._proxy,c,m,u,E,A);return this._webviewPanels.set(a,R),R}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=r;function n(d){return{enableFindWidget:d.enableFindWidget,retainContextWhenHidden:d.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[259],me([0,1,3,6,71,5,7]),function(Y,e,g,L,y,_,P){"use strict";var D,C,k,i,I,l,p,h,w,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class T extends L.Disposable{constructor(o,v,t,f,r,n){super();D.set(this,void 0),C.set(this,void 0),k.set(this,void 0),i.set(this,void 0),I.set(this,!1),l.set(this,void 0),p.set(this,void 0),h.set(this,void 0),w.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Ne(this,w,"f").event,S.set(this,this._register(new g.Emitter)),this.onDidDispose=Ne(this,S,"f").event,st(this,k,t,"f"),st(this,p,f,"f"),st(this,D,o,"f"),st(this,C,v,"f"),st(this,i,r,"f"),st(this,l,n,"f")}dispose(){Ne(this,I,"f")||(st(this,I,!0,"f"),Ne(this,S,"f").fire(),Ne(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,p,"f")}set title(o){this.assertNotDisposed(),Ne(this,p,"f")!==o&&(st(this,p,o,"f"),Ne(this,C,"f").$setWebviewViewTitle(Ne(this,D,"f"),o))}get description(){return this.assertNotDisposed(),Ne(this,h,"f")}set description(o){this.assertNotDisposed(),Ne(this,h,"f")!==o&&(st(this,h,o,"f"),Ne(this,C,"f").$setWebviewViewDescription(Ne(this,D,"f"),o))}get visible(){return Ne(this,l,"f")}get webview(){return Ne(this,i,"f")}get viewType(){return Ne(this,k,"f")}_setVisible(o){o===Ne(this,l,"f")||Ne(this,I,"f")||(st(this,l,o,"f"),Ne(this,w,"f").fire())}show(o){this.assertNotDisposed(),Ne(this,C,"f").$show(Ne(this,D,"f"),!!o)}assertNotDisposed(){if(Ne(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,C=new WeakMap,k=new WeakMap,i=new WeakMap,I=new WeakMap,l=new WeakMap,p=new WeakMap,h=new WeakMap,w=new WeakMap,S=new WeakMap;class b{constructor(o,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,v,t,f){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:o}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(o),v,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new P.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(o,v,t,f,r){const n=this._viewProviders.get(v);if(!n)throw new Error(`No view provider found for '${v}'`);const{provider:d,extension:a}=n,c=this._extHostWebview.createNewWebview(o,{},a),m=new T(o,this._proxy,v,t,c,!0);this._webviewViews.set(o,m),await d.resolveWebviewView(m,{state:f},r)}async $onDidChangeWebviewViewVisibility(o,v){this.getWebviewView(o)._setVisible(v)}async $disposeWebviewView(o){const v=this.getWebviewView(o);this._webviewViews.delete(o),v.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const v=this._webviewViews.get(o);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(fe[134],me([0,1,3,5,2,10,9,4,14]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Wn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wn.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let p;if(typeof I=="string"){p=I;try{I=y.URI.parse(I)}catch(h){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,P.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===_.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,p,l)}async asExternalUri(I,l){if((0,P.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(I,l);return y.URI.from(p)}};k.InitialState={focused:!0},k=Ve([We(0,C.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(fe[260],me([0,1,8,82,32,41,6,5,2,14]),function(Y,e,g,L,y,_,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends P.Disposable{constructor(l,p){super();const h=l.getProxy(D.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async w=>{const S=C.URI.file((0,g.join)((0,L.tmpdir)(),(0,y.generateUuid)()));return await h.$download(w,S),S})}};i=Ve([We(0,k.IExtHostRpcService),We(1,_.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(fe[261],me([0,1,2,8,152,26,69,28,14,6,13,117,40]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class p{constructor(T,b,s){this.name=T,this.file=b,this.appender=s}static async create(T,b){const s=await(0,I.createRotatingLogger)(T,b,30*l.ByteSize.MB,1);return s.clearFormatters(),new p(T,b,s)}append(T){this.appender.critical(T)}flush(){this.appender.flush()}}class h extends P.AbstractExtHostOutputChannel{constructor(T,b,s,o){super(T,!1,g.URI.file(b.file),s,o);this._appender=b}append(T){super.append(T),this._appender.append(T),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(T,b){this._appender.flush(),super.show(T,b)}clear(){this._appender.flush(),super.clear()}}let w=class extends P.ExtHostOutputService{constructor(T,b,s){super(T);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new k.MutableDisposable,this._logsLocation=s.logsLocation}$setVisibleChannel(T){if(T){const b=this._channels.get(T);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(T,b){if(T=T.trim(),!T)throw new Error("illegal argument `name`. must not be falsy");const s=this._doCreateOutChannel(T,b);return s.then(o=>o._id.then(v=>this._channels.set(v,o))),new P.LazyOutputChannel(T,s)}async _doCreateOutChannel(T,b){try{const s=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await _.SymlinkSupport.existsDirectory(s)||await _.Promises.mkdir(s,{recursive:!0});const v=`${this._namePool++}-${T.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,L.join)(s,`${v}.log`)),f=await p.create(v,t.fsPath);return new h(T,f,b.identifier.value,this._proxy)}catch(s){return this.logService.error(s),new P.ExtHostPushOutputChannel(T,b.identifier.value,this._proxy)}}};w=Ve([We(0,C.IExtHostRpcService),We(1,i.ILogService),We(2,D.IExtHostInitDataService)],w),e.ExtHostOutputService2=w}),define(fe[262],me([0,1,50,8,2,70,6,10,15,26]),function(Y,e,g,L,y,_,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class i extends _.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const f=await super._getWorkspaceStorageURI(t);if(f.scheme!==D.Schemas.file)return f;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const r=f.fsPath;let n=0;do{let d;n===0?d=r:d=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${n}`:`${r}-${n}`,await I(d);const a=L.join(d,"vscode.lock"),c=await w(this._logService,a,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),y.URI.file(d);n++}while(n<10);return f}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=i;async function I(v){try{await k.Promises.stat(v);return}catch{}try{await k.Promises.mkdir(v,{recursive:!0})}catch{}}const l=1e3,p=10*60*1e3;class h extends P.Disposable{constructor(t,f){super();this.logService=t,this.filename=f,this._timer=this._register(new C.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await S(t,f);(!r||r.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this._timer.cancel());try{await k.Promises.utimes(f,new Date,new Date)}catch(n){t.error(n),t.info(`Lock '${f}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(t){}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.filename,JSON.stringify(f),{flag:"w"})}catch(f){this.logService.error(f)}}}async function w(v,t,f){try{const n={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(n),{flag:"wx"})}catch(n){v.error(n)}const r=await S(v,t);return!r||r.pid!==process.pid?f?(v.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(v.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),s(v,t)):(v.info(`Lock '${t}': Lock acquired.`),new h(v,t))}async function S(v,t){let f;try{f=await k.Promises.readFile(t)}catch(r){return v.error(r),null}try{return JSON.parse(String(f))}catch(r){return v.error(r),null}}async function T(v,t){let f;try{f=await k.Promises.stat(t)}catch(r){return v.error(r),0}return f.mtime.getTime()}function b(v){try{return process.kill(v,0),!0}catch(t){return!1}}async function s(v,t){const f=await S(v,t);if(!f)return v.info(`Lock '${t}': Could not read pid of lock holder.`),o(v,t);if(f.willReleaseAt){let c=f.willReleaseAt-Date.now();if(c<5e3){for(c>0?v.info(`Lock '${t}': The lockfile is scheduled to be released in ${c} ms.`):v.info(`Lock '${t}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,C.timeout)(Math.min(100,c)),await T(v,t)===0)return o(v,t);c=f.willReleaseAt-Date.now()}return o(v,t)}}if(!b(f.pid))return v.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),o(v,t);const r=await T(v,t),n=Date.now()-r;if(n<=p)return v.info(`Lock '${t}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;v.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,C.timeout)(2e3);const d=await T(v,t),a=Date.now()-d;return a<=p?(v.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(v.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(v,t))}async function o(v,t){v.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch(f){}return w(v,t,!0)}}),define(fe[263],me([0,1,32,14,33]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let _=class extends y.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,C,k){return this.createTerminalFromOptions({name:D,shellPath:C,shellArgs:k})}createTerminalFromOptions(D,C){const k=new y.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),D,D.name);return this._terminals.push(k),k.create(D,this._serializeParentTerminal(D,C)),k.value}};_=Ve([We(0,L.IExtHostRpcService)],_),e.ExtHostTerminalService=_}),define(fe[264],me([0,1,5,14,172,6,28,2,39,23,26,7,11,54,3,123,79,13]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(m,u,E){this.remoteAddress=m,this.localAddress=u,this._dispose=E,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(c){const m=c.trim().split(`
`),u=[];return m.forEach(A=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(A);R&&R.length>=3&&u.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),u.reduce((A,R)=>(A[R.socket]=R,A),{})}e.getSockets=s;function o(...c){const m=[].concat(...c.map(t));return[...new Map(m.filter(u=>u.st==="0A").map(u=>{const E=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:v(E[0]),port:parseInt(E[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=o;function v(c){let m="";if(c.length===8)for(let u=c.length-2;u>=0;u-=2)m+=parseInt(c.substr(u,2),16),u!==0&&(m+=".");else for(let u=c.length-4;u>=0;u-=4)m+=parseInt(c.substr(u,4),16).toString(16),u!==0&&(m+=":");return m}e.parseIpAddress=v;function t(c){const m=c.trim().split(`
`),u=m.shift().trim().split(/\s+/).filter(A=>A!=="rx_queue"&&A!=="tm->when");return m.map(A=>A.trim().split(/\s+/).reduce((R,B,N)=>(R[u[N]||N]=B,R),{}))}e.loadConnectionTable=t;function f(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const m=c.trim().split(`
`),u=[];return m.forEach(E=>{const A=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);A&&A.length>=4&&u.push({pid:parseInt(A[1],10),ppid:parseInt(A[2]),cmd:A[3]})}),u}e.getRootProcesses=r;async function n(c,m,u){const E=u.reduce((R,B)=>(R[B.pid]=B,R),{}),A=[];return c.forEach(({socket:R,ip:B,port:N})=>{const F=m[R]?m[R].pid:void 0,$=F?E[F]?.cmd:void 0;F&&$&&!f($)&&A.push({host:B,port:N,detail:$,pid:F})}),A}e.findPorts=n;function d(c,m,u){const E=new Map,A=r(m);for(const R of c){const B=u.get(R.port);if(B){E.set(R.port,B);continue}const N=A.find(F=>F.cmd.includes(`${R.port}`));if(N){let F=N,$;do $=A.find(M=>M.ppid===F.pid),$&&(F=$);while($);E.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=d;let a=class extends _.Disposable{constructor(m,u,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTunnelService),l.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(u,m.displayName);if(E){const A=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(A),A}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,u){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:m,provider:u}),this._proxy.$registerPortsAttributesProvider(m,E),new I.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(m,u,E,A,R){const B=[];for(const F of m){const $=this._portAttributesProviders.get(F);if(!$)return[];B.push(...await Promise.all(u.map(async M=>$.provider.providePortAttributes(M,E,A,R))))}const N=B.filter(F=>!!F);return N.length>0?N.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let u=new S.MovingAverage,E;for(;this._candidateFindingEnabled;){const A=new Date().getTime(),R=(await this.findCandidatePorts()).filter(N=>(0,w.isLocalhost)(N.host)||(0,w.isAllInterfaces)(N.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(N=>N.port).join(", ")}`);const B=new Date().getTime()-A;u.update(B),(!E||JSON.stringify(E)!==JSON.stringify(R))&&(E=R,await this._proxy.$onFoundNewCandidates(E)),await new Promise(N=>setTimeout(()=>N(),this.calculateDelay(u.value)))}}async setTunnelExtensionFunctions(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let u=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:u})}}else this._forwardPortProvider=void 0;return(0,_.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,u){if(this._extensionTunnels.has(m.host)){const E=this._extensionTunnels.get(m.host);E.has(m.port)&&(u&&E.get(m.port).disposeListener.dispose(),await E.get(m.port).tunnel.dispose(),E.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(m,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const A=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const R=this._register(A.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(A.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:A,disposeListener:R}),p.TunnelDto.fromApiTunnel(A)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const u=await Promise.all(m.map(A=>this._showCandidatePort(A.host,A.port,A.detail??""))),E=m.filter((A,R)=>u[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(A=>A.port).join(", ")} to ${E.map(A=>A.port).join(", ")}`),E}async findCandidatePorts(){let m="",u="";try{m=await i.Promises.readFile("/proc/net/tcp","utf8"),u=await i.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const E=o(m,u),A=await new Promise(U=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,j,O)=>{U(j)})}),R=s(A),B=await i.Promises.readdir("/proc"),N=[];for(let U of B)try{const x=Number(U),j=k.joinPath(D.URI.file("/proc"),U);if((await i.Promises.stat(j.fsPath)).isDirectory()&&!isNaN(x)){const W=await i.Promises.readlink(k.joinPath(j,"cwd").fsPath),H=await i.Promises.readFile(k.joinPath(j,"cmdline").fsPath,"utf8");N.push({pid:x,cwd:W,cmd:H})}}catch(x){}const F=[],$=E.filter(U=>{const x=R[U.socket];return x||F.push(U),x}),M=n($,R,N);let z;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const U=await new Promise(x=>{(0,C.exec)("ps -F -A -l | grep root",(j,O,W)=>{x(O)})});this._foundRootPorts=d(F,U,this._foundRootPorts),z=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.join(", ")}`)}return M.then(U=>z?U.concat(z):U)}};a=Ve([We(0,L.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,T.ILogService)],a),e.ExtHostTunnelService=a}),define(fe[265],me([0,1,15,22,21,17,3,6,104,229,55]),function(Y,e,g,L,y,_,P,D,C,k,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(E,A){try{return JSON.stringify(E,A)}catch(R){return"null"}}const p="$$ref$$",h={[p]:-1};class w{constructor(A,R){this.jsonString=A,this.referencedBuffers=R}}function S(E,A=null,R=!1){const B=[];return{jsonString:(R?l:JSON.stringify)(E,(F,$)=>{if(typeof $=="undefined")return h;if(typeof $=="object"){if($ instanceof L.VSBuffer){const M=B.push($)-1;return{[p]:M}}if(A)return A(F,$)}return $}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=S;function T(E,A,R){return JSON.parse(E,(B,N)=>{if(N){const F=N[p];if(typeof F=="number")return A[F];if(R&&N.$mid===1)return R.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=T;function b(E,A){return JSON.stringify(E,A)}function s(E){return E?(A,R)=>R&&R.$mid===1?E.transformOutgoing(R):R:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},f=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class n extends D.Disposable{constructor(A,R=null,B=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=R,this._uriTransformer=B,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,F=i.ProxyIdentifier.count;N<F;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(_.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,C.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:R,sid:B}=A;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,B)),this._proxies[R]}_createProxy(A,R){let B={get:(N,F)=>(typeof F=="string"&&!N[F]&&F.charCodeAt(0)===36&&(N[F]=(...$)=>this._remoteCall(A,F,$)),F===r?R:N[F])};return new Proxy(Object.create(null),B)}set(A,R){return this._locals[A.nid]=R,R}assertRegistered(A){for(let R=0,B=A.length;R<B;R++){const N=A[R];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(A){if(this._isDisposed)return;const R=A.byteLength,B=d.read(A,0),N=B.readUInt8(),F=B.readUInt32();switch(N){case 1:case 2:{let{rpcId:$,method:M,args:z}=c.deserializeRequestJSONArgs(B);this._uriTransformer&&(z=(0,C.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(R,F,$,M,z,N===2);break}case 3:case 4:{let{rpcId:$,method:M,args:z}=c.deserializeRequestMixedArgs(B);this._uriTransformer&&(z=(0,C.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(R,F,$,M,z,N===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(B);this._uriTransformer&&($=(0,C.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,F,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(R,F,$);break}case 8:{let $=c.deserializeReplyOKVSBuffer(B);this._receiveReply(R,F,$);break}case 11:{let $=c.deserializeReplyErrError(B);this._uriTransformer&&($=(0,C.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,F,$);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,R,B,N,F,$){this._logger&&this._logger.logIncoming(A,R,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(B)}.${N}(`,F);const M=String(R);let z,U;if($){const j=new y.CancellationTokenSource;F.push(j.token),z=this._invokeHandler(B,N,F),U=()=>j.cancel()}else z=this._invokeHandler(B,N,F),U=t;this._cancelInvokedHandlers[M]=U;const x=c.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(x.byteLength,R,1,"ack"),this._protocol.send(x),z.then(j=>{delete this._cancelInvokedHandlers[M];const O=c.serializeReplyOK(R,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",j),this._protocol.send(O)},j=>{delete this._cancelInvokedHandlers[M];const O=c.serializeReplyErr(R,j);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",j),this._protocol.send(O)})}_receiveCancel(A,R){this._logger&&this._logger.logIncoming(A,R,1,"receiveCancel");const B=String(R);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(A,R,B){this._logger&&this._logger.logIncoming(A,R,0,"receiveReply:",B);const N=String(R);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],F.resolveOk(B)}_receiveReplyErr(A,R,B){this._logger&&this._logger.logIncoming(A,R,0,"receiveReplyErr:",B);const N=String(R);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const F=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let $;B&&(B.$isError?($=new Error,$.name=B.name,$.message=B.message,$.stack=B.stack):$=B),F.resolveErr($)}_invokeHandler(A,R,B){try{return Promise.resolve(this._doInvokeHandler(A,R,B))}catch(N){return Promise.reject(N)}}_doInvokeHandler(A,R,B){const N=this._locals[A];if(!N)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(A));let F=N[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,i.getStringIdentifierForProxy)(A));return F.apply(N,B)}_remoteCall(A,R,B){if(this._isDisposed)return Promise.reject(_.canceled());let N=null;if(B.length>0&&y.CancellationToken.isCancellationToken(B[B.length-1])&&(N=B.pop()),N&&N.isCancellationRequested)return Promise.reject(_.canceled());const F=c.serializeRequestArguments(B,this._uriReplacer),$=++this._lastMessageId,M=String($),z=new k.LazyPromise;N&&N.onCancellationRequested(()=>{const x=c.serializeCancel($);this._logger&&this._logger.logOutgoing(x.byteLength,$,0,"cancel"),this._protocol.send(c.serializeCancel($))}),this._pendingRPCReplies[M]=z,this._onWillSendRequest($);const U=c.serializeRequest($,A,R,F,!!N);return this._logger&&this._logger.logOutgoing(U.byteLength,$,0,`request: ${(0,i.getStringIdentifierForProxy)(A)}.${R}(`,B),this._protocol.send(U),z}}e.RPCProtocol=n,I=f,n.UNRESPONSIVE_TIME=3*1e3;class d{constructor(A,R){this._buff=A,this._offset=R}static alloc(A,R,B){let N=new d(L.VSBuffer.alloc(B+1+4),0);return N.writeUInt8(A),N.writeUInt32(R),N}static read(A,R){return new d(A,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,R}static sizeMixedArray(A){let R=0;R+=1;for(let B=0,N=A.length;B<N;B++){const F=A[B];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)R+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return R}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let R=0,B=A.length;R<B;R++){const N=A[R];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let F=0;F<N.buffers.length;++F)this.writeBuffer(N.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(A);for(let B=0;B<A;B++)switch(this.readUInt8()){case 1:R[B]=this.readLongString();break;case 2:R[B]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),$=this.readLongString(),M=[];for(let z=0;z<F;++z)M.push(this.readVSBuffer());R[B]=new i.SerializableObjectWithBuffers(T($,M,null));break;case 4:R[B]=void 0;break}return R}}d.sizeUInt32=4;var a;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(a||(a={}));class c{static _useMixedArgSerialization(A){for(let R=0,B=A.length;R<B;R++)if(A[R]instanceof L.VSBuffer||A[R]instanceof i.SerializableObjectWithBuffers||typeof A[R]=="undefined")return!0;return!1}static serializeRequestArguments(A,R){if(this._useMixedArgSerialization(A)){const B=[];for(let N=0,F=A.length;N<F;N++){const $=A[N];if($ instanceof L.VSBuffer)B[N]={type:2,value:$};else if(typeof $=="undefined")B[N]={type:4};else if($ instanceof i.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:z}=S($.value,R);B[N]={type:3,value:L.VSBuffer.fromString(M),buffers:z}}else B[N]={type:1,value:L.VSBuffer.fromString(b($,R))}}return{type:1,args:B}}return{type:0,args:b(A,R)}}static serializeRequest(A,R,B,N,F){switch(N.type){case 0:return this._requestJSONArgs(A,R,B,N.args,F);case 1:return this._requestMixedArgs(A,R,B,N.args,F)}}static _requestJSONArgs(A,R,B,N,F){const $=L.VSBuffer.fromString(B),M=L.VSBuffer.fromString(N);let z=0;z+=d.sizeUInt8(),z+=d.sizeShortString($),z+=d.sizeLongString(M);let U=d.alloc(F?2:1,A,z);return U.writeUInt8(R),U.writeShortString($),U.writeLongString(M),U.buffer}static deserializeRequestJSONArgs(A){const R=A.readUInt8(),B=A.readShortString(),N=A.readLongString();return{rpcId:R,method:B,args:JSON.parse(N)}}static _requestMixedArgs(A,R,B,N,F){const $=L.VSBuffer.fromString(B);let M=0;M+=d.sizeUInt8(),M+=d.sizeShortString($),M+=d.sizeMixedArray(N);let z=d.alloc(F?4:3,A,M);return z.writeUInt8(R),z.writeShortString($),z.writeMixedArray(N),z.buffer}static deserializeRequestMixedArgs(A){const R=A.readUInt8(),B=A.readShortString(),N=A.readMixedArray(),F=new Array(N.length);for(let $=0,M=N.length;$<M;$++){const z=N[$];typeof z=="string"?F[$]=JSON.parse(z):F[$]=z}return{rpcId:R,method:B,args:F}}static serializeAcknowledged(A){return d.alloc(5,A,0).buffer}static serializeCancel(A){return d.alloc(6,A,0).buffer}static serializeReplyOK(A,R,B){if(typeof R=="undefined")return this._serializeReplyOKEmpty(A);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(A,R);if(R instanceof i.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:F}=S(R.value,B,!0);return this._serializeReplyOKJSONWithBuffers(A,N,F)}else return this._serializeReplyOKJSON(A,l(R,B))}static _serializeReplyOKEmpty(A){return d.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,R){let B=0;B+=d.sizeVSBuffer(R);let N=d.alloc(8,A,B);return N.writeVSBuffer(R),N.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,R){const B=L.VSBuffer.fromString(R);let N=0;N+=d.sizeLongString(B);let F=d.alloc(9,A,N);return F.writeLongString(B),F.buffer}static _serializeReplyOKJSONWithBuffers(A,R,B){const N=L.VSBuffer.fromString(R);let F=0;F+=d.sizeUInt32,F+=d.sizeLongString(N);for(const M of B)F+=d.sizeVSBuffer(M);let $=d.alloc(10,A,F);$.writeUInt32(B.length),$.writeLongString(N);for(const M of B)$.writeBuffer(M);return $.buffer}static deserializeReplyOKJSON(A){const R=A.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(A,R){const B=A.readUInt32(),N=A.readLongString(),F=[];for(let $=0;$<B;++$)F.push(A.readVSBuffer());return new i.SerializableObjectWithBuffers(T(N,F,R))}static serializeReplyErr(A,R){return R?this._serializeReplyErrEror(A,R):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,R){const B=L.VSBuffer.fromString(l(_.transformErrorForSerialization(R),null));let N=0;N+=d.sizeLongString(B);let F=d.alloc(11,A,N);return F.writeLongString(B),F.buffer}static deserializeReplyErrError(A){const R=A.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(A){return d.alloc(12,A,0).buffer}}var m;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var u;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(u||(u={}))}),define(fe[266],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(fe[267],me([0,1,10,8,11,2,4,64,44,224,266]),function(Y,e,g,L,y,_,P,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,P.createDecorator)("pathService");let I=class Hn{constructor(p,h,w,S){this.localUserHome=p,this.remoteAgentService=h,this.environmentService=w,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const T=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=T?.userHome||p})()}get defaultUriScheme(){return Hn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,h){if(p.remoteAuthority)return g.Schemas.vscodeRemote;const w=(0,D.getVirtualWorkspaceScheme)(h.getWorkspace());if(w)return w;const S=h.getWorkspace().folders[0];if(S)return S.uri.scheme;const T=h.getWorkspace().configuration;return T?T.scheme:g.Schemas.file}async userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?L.win32:L.posix)}async fileURI(p){let h="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const S=p.indexOf("/",2);S===-1?(h=p.substring(2),p="/"):(h=p.substring(2,S),p=p.substring(S)||"/")}return _.URI.from({scheme:g.Schemas.file,authority:h,path:p,query:"",fragment:""})}};I=Ve([We(1,i.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,C.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[72],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(P,D){this.line=P,this.character=D}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,D){return new g(0,0)}with(P){return new g(0,0)}}e.Position=g;class L{constructor(P,D,C,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(P,D),this.end=new g(C,k)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new L(0,0,0,0)}with(P){return new L(0,0,0,0)}}e.Range=L;var y;(function(_){_[_.Information=1]="Information",_[_.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[31],me([0,1,18,30,25,29,9,4,8,17,72,12]),function(Y,e,g,L,y,_,P,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",h=(l.length+p.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var w;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var S;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(S=e.QueryType||(e.QueryType={}));function T(x){return!!x.preview}e.resultIsMatch=T;function b(x){return!!x.resource}e.isFileMatch=b;function s(x){return!!x.message}e.isProgressMessage=s;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(j){this.resource=j,this.results=[]}}e.FileMatch=v;class t{constructor(j,O,W){this.ranges=O;const H=Array.isArray(O)?O:[O];if(W&&W.matchLines===1&&f(H)){j=(0,P.getNLines)(j,W.matchLines);let X="",K=0,de=0;const _e=Math.floor(W.charsPerLine/5),Ce=[];for(const Pe of H){const Be=Math.max(Pe.startColumn-_e,0),$e=Pe.startColumn+W.charsPerLine;if(Be>de+_e+h){const He=l+(Be-de)+p;X+=He+j.slice(Be,$e),K+=Be-(de+He.length)}else X+=j.slice(de,$e);Ce.push(new n(0,Pe.startColumn-K,Pe.endColumn-K)),de=$e}this.preview={text:X,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:j,matches:(0,g.mapArrayOrNot)(O,K=>new r(K.startLineNumber-X,K.startColumn,K.endLineNumber-X,K.endColumn))}}}}e.TextSearchMatch=t;function f(x){const j=x[0].startLineNumber;for(const O of x)if(O.startLineNumber!==j||O.endLineNumber!==j)return!1;return!0}class r{constructor(j,O,W,H){this.startLineNumber=j,this.startColumn=O,this.endLineNumber=W,this.endColumn=H}}e.SearchRange=r;class n extends r{constructor(j,O,W){super(j,O,j,W)}}e.OneLineRange=n;var d;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function a(x,j=!0){const O=x&&x.files&&x.files.exclude,W=j&&x&&x.search&&x.search.exclude;if(!O&&!W)return;if(!O||!W)return O||W;let H=Object.create(null);return H=y.mixin(H,y.deepClone(O)),H=y.mixin(H,y.deepClone(W),!0),H}e.getExcludes=a;function c(x,j){return x.excludePattern&&L.match(x.excludePattern,j)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.match(x.includePattern,j)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(O=>{const W=O.folder.fsPath;if(_.isEqualOrParent(j,W)){const H=C.relative(W,j);return!O.includePattern||!!L.match(O.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(j,O){super(j);this.code=O}}e.SearchError=u;function E(x){const j=x.message;if((0,k.isPromiseCanceledError)(x))return new u(j,m.canceled);try{const O=JSON.parse(j);return new u(O.message,O.code)}catch(O){return new u(j,m.other)}}e.deserializeSearchError=E;function A(x){const j={message:x.message,code:x.code};return new Error(JSON.stringify(j))}e.serializeSearchError=A;function R(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=R;function B(x){return x.type==="success"}e.isSerializedSearchSuccess=B;function N(x){return!!x.path}e.isSerializedFileMatch=N;function F(x,j){const O=x.searchPath?x.searchPath:x.relativePath;return(0,P.fuzzyContains)(O,j)}e.isFilePatternMatch=F;class ${constructor(j){this.path=j,this.results=[]}addMatch(j){this.results.push(j)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function M(x,j){const O={...x||{},...j||{}};return Object.keys(O).filter(W=>{const H=O[W];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class z{constructor(j,O){this._parsedIncludeExpression=null,this._excludeExpression={...j.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let W=j.includePattern;O.includePattern&&(W?W={...W,...O.includePattern}:W=O.includePattern),W&&(this._parsedIncludeExpression=L.parse(W))}matchesExcludesSync(j,O,W){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,O,W))}includedInQuerySync(j,O,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,O,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(j,O,W))}includedInQuery(j,O,W){const H=this._parsedExcludeExpression(j,O,W),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(j,O,W):!0;return(0,I.isPromise)(H)?H.then(K=>K?!1:X()):X()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=z;function U(x){for(const j in x)if(typeof x[j]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,18,15,21,3,24,10,79,23,9,12,2,170,4,13,190,44,53,28,14,7,31,5]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s,o,v,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(A,R,B){return new k.ExtUri(N=>c(N,B)).isEqual(A,R)}function n(A,R,B){return r(A.uri,R.uri,B)?0:(0,i.compare)(A.uri.toString(),R.uri.toString())}function d(A,R,B){return A.index!==R.index?A.index<R.index?-1:1:r(A.uri,R.uri,B)?(0,i.compare)(A.name,R.name):(0,i.compare)(A.uri.toString(),R.uri.toString())}function a(A,R,B,N){const F=A.slice(0).sort((M,z)=>B(M,z,N)),$=R.slice(0).sort((M,z)=>B(M,z,N));return(0,g.delta)(F,$,(M,z)=>B(M,z,N))}function c(A,R){const B=R.getCapabilities(A.scheme);return!(B&&B&1024)}class m extends T.Workspace{constructor(R,B,N,F,$,M,z){super(R,N.map(U=>new T.WorkspaceFolder(U)),F,$,z);this._name=B,this._isUntitled=M,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(z),N.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(R,B,N,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:M,folders:z,configuration:U,transient:x,isUntitled:j}=R,O=[],W=B;B?z.forEach((de,_e)=>{const Ce=l.URI.revive(de.uri),Pe=m._findFolder(N||B,Ce,F);Pe?(Pe.name=de.name,Pe.index=de.index,O.push(Pe)):O.push({uri:Ce,name:de.name,index:_e})}):O.push(...z.map(({uri:de,name:_e,index:Ce})=>({uri:l.URI.revive(de),name:_e,index:Ce}))),O.sort((de,_e)=>de.index<_e.index?-1:1);const H=new m($,M,O,!!x,U?l.URI.revive(U):null,!!j,de=>c(de,F)),{added:X,removed:K}=a(W?W.workspaceFolders:[],H.workspaceFolders,n,F);return{workspace:H,added:X,removed:K}}static _findFolder(R,B,N){for(let F=0;F<R.folders.length;F++){const $=R.workspaceFolders[F];if(r($.uri,B,N))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,B){return B&&this._structure.get(R)&&(R=(0,k.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let u=class{constructor(R,B,N,F){this._onDidChangeWorkspace=new _.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new _.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=N,this._requestIdProvider=new C.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(f.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(f.MainContext.MainThreadMessageService);const $=B.workspace;this._confirmedWorkspace=$?new m($.id,$.name,[],!!$.transient,$.configuration?l.URI.revive($.configuration):null,!!$.isUntitled,M=>c(M,N)):void 0}$initializeWorkspace(R,B){this._trusted=B,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:D.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,B,N,...F){const $=[];if(Array.isArray(F)&&F.forEach(j=>{l.URI.isUri(j.uri)&&!$.some(O=>r(O.uri,j.uri,this._extHostFileSystemInfo))&&$.push({uri:j.uri,name:j.name||(0,k.basenameOrAuthority)(j.uri)})}),this._unconfirmedWorkspace||[B,N].some(j=>typeof j!="number"||j<0)||N===0&&$.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+N>M.length)return!1;const z=M.slice(0);z.splice(B,N,...$.map(j=>({uri:j.uri,name:j.name||(0,k.basenameOrAuthority)(j.uri),index:void 0})));for(let j=0;j<z.length;j++){const O=z[j];if(z.some((W,H)=>H!==j&&r(O.uri,W.uri,this._extHostFileSystemInfo)))return!1}z.forEach((j,O)=>j.index=O);const{added:U,removed:x}=a(M,z,d,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const j=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(j,B,N,$).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,p.localize)(0,null,j,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(R,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async getWorkspaceFolder2(R,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,B){let N,F="";if(typeof R=="string"?(N=l.URI.file(R),F=R):typeof R!="undefined"&&(N=R,F=R.fsPath),!N)return F;const $=this.getWorkspaceFolder(N,!0);if(!$)return F;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let M=(0,k.relativePath)($.uri,N);return B&&$.name&&(M=`${$.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:B,added:N,removed:F}=m.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:F}))}findFiles(R,B,N,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(B===null?M=!1:B&&(typeof B=="string"?M=B:M=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:U}=E(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(U),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(N),$).then(x=>Array.isArray(x)?x.map(j=>l.URI.revive(j)):[])}async findTextInFiles(R,B,N,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),z=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:U,folder:x}=E(B.include),j=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:U,excludePattern:j},W=!1;if(this._activeSearchCallbacks[M]=H=>{if(W)return;const X=l.URI.revive(H.resource);H.results.forEach(K=>{(0,t.resultIsMatch)(K)?N({uri:X,preview:{text:K.preview.text,matches:(0,g.mapArrayOrNot)(K.preview.matches,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,g.mapArrayOrNot)(K.ranges,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):N({uri:X,text:K.text,lineNumber:K.lineNumber})})},$.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(x),O,M,$);return delete this._activeSearchCallbacks[M],H||{}}catch(H){throw delete this._activeSearchCallbacks[M],H}}$handleTextSearchResult(R,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([We(0,o.IExtHostRpcService),We(1,s.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,w.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function E(A){let R,B;return A&&(typeof A=="string"?R=A:(R=A.pattern,B=A.baseFolder||l.URI.file(A.base))),{includePattern:R,folder:B}}}),define(fe[37],me([0,1,25,3,36,5,7,193,87,12,15,4,14,13,2]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(f,r){if(r){const n=r.split(".");let d=f;for(let a=0;d&&a<n.length;a++)d=d[n[a]];return d}}function S(f){return f instanceof h.URI}function T(f){return f&&f.uri instanceof h.URI&&f.languageId&&typeof f.languageId=="string"}function b(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof h.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function o(f){if(S(f))return{resource:f};if(T(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(b(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let v=class{constructor(r,n,d){this._proxy=r.getProxy(_.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=d,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(d=>d.$acceptConfigurationChanged(r,n))}};v=Ve([We(0,l.IExtHostRpcService),We(1,y.IExtHostWorkspace),We(2,p.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,n,d,a){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=a,this._extHostWorkspace=n,this._configuration=D.Configuration.parse(d),this._configurationScopes=this._toMap(d.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const d={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,d))}getConfiguration(r,n,d){const a=o(n)||{},c=this._toReadonlyValue(r?w(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,a,d?.identifier);function m(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(E){return typeof w(c,E)!="undefined"},get:(E,A)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,a,d?.identifier);let R=w(c,E);if(typeof R=="undefined")R=A;else{let B;const N=(F,$)=>{let M;const z=()=>{B=B||(0,g.deepClone)(c),M=M||w(B,$)};return(0,k.isObject)(F)?new Proxy(F,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return z(),()=>M;if(B)return M=M||w(B,$),M[x];const j=U[x];return typeof x=="string"?N(j,`${$}.${x}`):j},set:(U,x,j)=>(z(),M&&(M[x]=j),!0),deleteProperty:(U,x)=>(z(),M&&delete M[x],!0),defineProperty:(U,x,j)=>(z(),M&&Object.defineProperty(M,x,j),!0)}):F};R=N(R,E)}return R},update:(E,A,R,B)=>{E=r?`${r}.${E}`:E;const N=m(R);return A!==void 0?this._proxy.$updateConfigurationOption(N,E,A,a,B):this._proxy.$removeConfigurationOption(N,E,a,B)},inspect:E=>{E=r?`${r}.${E}`:E;const A=(0,g.deepClone)(this._configuration.inspect(E,a,this._extHostWorkspace.workspace));if(A)return{key:E,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof c=="object"&&(0,g.mixin)(u,c,!1),Object.freeze(u)}_toReadonlyValue(r){const n=d=>(0,k.isObject)(d)?new Proxy(d,{get:(a,c)=>n(a[c]),set:(a,c,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(a,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(a,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):d;return n(r)}_validateConfigurationAccess(r,n,d){const a=C.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),c=d?`[${d.value}] `:"";if(a===4){typeof n?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){n?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const d=new D.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,c)=>d.affectsConfiguration(a,o(c))})}_toMap(r){return r.reduce((n,d)=>(n.set(d[0],d[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[73],me([0,1,2,15,3,5,7,36,45,37,21,33,14,28,4,10,11,13,68,214,17]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function($){function M(U){if(U!=null)return U}$.from=M;function z(U){if(U!=null)return U}$.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var f;(function($){function M(U){if(U!=null)return U}$.from=M;function z(U){if(U!=null)return U}$.to=z})(f=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function($){function M(U){if(U!=null)return U}$.from=M;function z(U){if(U!=null)return U}$.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function($){function M(x){if(x){const j=x;return j&&!!j.process}else return!1}$.is=M;function z(x){if(x==null)return;const j={process:x.process,args:x.args};return x.options&&(j.options=r.from(x.options)),j}$.from=z;function U(x){if(x!=null)return new P.ProcessExecution(x.process,x.args,x.options)}$.to=U})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var d;(function($){function M(U){if(U!=null)return U}$.from=M;function z(U){if(U!=null)return U}$.to=z})(d=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function($){function M(x){if(x){const j=x;return j&&(!!j.commandLine||!!j.command)}else return!1}$.is=M;function z(x){if(x==null)return;const j={};return x.commandLine!==void 0?j.commandLine=x.commandLine:(j.command=x.command,j.args=x.args),x.options&&(j.options=d.from(x.options)),j}$.from=z;function U(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new P.ShellExecution(x.commandLine,x.options):new P.ShellExecution(x.command,x.args?x.args:[],x.options)}$.to=U})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function($){function M(x){if(x){let j=x;return j&&j.customExecution==="customExecution"}else return!1}$.is=M;function z(x){return{customExecution:"customExecution"}}$.from=z;function U(x,j){return j.get(x)}$.to=U})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function($){function M(z,U){let x;return z.scope!==void 0&&typeof z.scope!="number"?x=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===P.TaskScope.Workspace&&U&&U.workspaceFile?x=U.workspaceFile:x=s.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:x}}$.from=M})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function($){function M(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}$.from=M})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function($){function M(x,j){if(x==null)return[];const O=[];for(let W of x){const H=z(W,j);H&&O.push(H)}return O}$.fromMany=M;function z(x,j){if(x==null)return;let O;x.execution instanceof P.ProcessExecution?O=n.from(x.execution):x.execution instanceof P.ShellExecution?O=a.from(x.execution):x.execution&&x.execution instanceof P.CustomExecution&&(O=c.from(x.execution));const W=t.from(x.definition);let H;return x.scope?typeof x.scope=="number"?H=x.scope:H=x.scope.uri:H=P.TaskScope.Workspace,!W||!H?void 0:{_id:x._id,definition:W,name:x.name,source:{extensionId:j.identifier.value,label:x.source,scope:H},execution:O,isBackground:x.isBackground,group:u.from(x.group),presentationOptions:f.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}$.from=z;async function U(x,j,O){if(x==null)return;let W;n.is(x.execution)?W=n.to(x.execution):a.is(x.execution)?W=a.to(x.execution):c.is(x.execution)&&(W=c.to(x._id,O));const H=t.to(x.definition);let X;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?X=x.source.scope:X=await j.resolveWorkspaceFolder(g.URI.revive(x.source.scope)):X=P.TaskScope.Workspace),!H||!X)return;const K=new P.Task(H,X,x.name,x.source.label,W,x.problemMatchers);return x.isBackground!==void 0&&(K.isBackground=x.isBackground),x.group!==void 0&&(K.group=P.TaskGroup.from(x.group._id),K.group&&x.group.isDefault&&(K.group=new P.TaskGroup(K.group.id,K.group.label),x.group.isDefault&&(K.group.isDefault=x.group.isDefault))),x.presentationOptions&&(K.presentationOptions=f.to(x.presentationOptions)),x._id&&(K._id=x._id),x.detail&&(K.detail=x.detail),K}$.to=U})(E=e.TaskDTO||(e.TaskDTO={}));var A;(function($){function M(U){return U}$.from=M;function z(U){if(!!U)return Object.assign(Object.create(null),U)}$.to=z})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,z,U){this._id=z,this._task=U,v.set(this,void 0),st(this,v,M,"f")}get task(){return this._task}terminate(){Ne(this,v,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}v=new WeakMap;var B;(function($){function M(z){return{id:z._id,task:void 0}}$.from=M})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(M,z,U,x,j,O,W,H){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=M.getProxy(_.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=x,this._configurationService=j,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,z,U){if(!U)return new P.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:z,provider:U,extension:M}),this._proxy.$registerTaskProvider(x,z),new P.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(M,z){this._proxy.$registerTaskSystem(M,z)}fetchTasks(M){return this._proxy.$fetchTasks(A.from(M)).then(async z=>{const U=[];for(let x of z){const j=await E.to(x,this._workspaceProvider,this._providedCustomExecutions2);j&&U.push(j)}return U})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(z=>M.push(z)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,z,U){const x=this._providedCustomExecutions2.get(M.id);if(x){if(this._activeCustomExecutions2.get(M.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(M.id,x),this._terminalService.attachPtyToTerminal(z,await x.callback(U))}this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const z=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const z=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:z,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const z=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:M.exitCode})}$provideTasks(M,z){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));const x=[],j=(0,L.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(O=>this.provideTasksInternal(z,x,U,O));return new Promise(O=>{j.then(W=>{Promise.all(x).then(()=>{O(W)})})})}async $resolveTask(M,z){const U=this._handlers.get(M);if(!U)return Promise.reject(new Error("no handler found"));if(z.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${U.type}].`);const x=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask(x,i.CancellationToken.None);if(!j)return;this.checkDeprecation(j,U);const O=E.from(j,U.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(O.execution)&&await this.addCustomExecution(O,j,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,z,U){const x=await this._proxy.$createTaskId(M);!U&&!this._providedCustomExecutions2.has(x)&&this._notProvidedCustomExecutions.add(x),this._providedCustomExecutions2.set(x,z.execution)}async getTaskExecution(M,z){if(typeof M=="string"){const j=this._taskExecutionPromises.get(M);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let U=this._taskExecutionPromises.get(M.id);if(U)return U;const x=new Promise(async(j,O)=>{const W=z||await E.to(M.task,this._workspaceProvider,this._providedCustomExecutions2);W?j(new R(this,M.id,W)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(M.id,x),x.then(j=>(this._taskExecutions.set(M.id,j),j),j=>Promise.reject(j))}checkDeprecation(M,z){M._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let U=this._notProvidedCustomExecutions.values(),x=U.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=U.next()}};N=Ve([We(0,l.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,D.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,T.ILogService),We(7,b.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let F=class extends N{constructor(M,z,U,x,j,O,W,H){super(M,z,U,x,j,O,W,H);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(M,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const U=E.from(z,M);if(U===void 0)throw new Error("Task is not valid");if(c.is(U.execution))await this.addCustomExecution(U,z,!1);else throw new o.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),z);return this._proxy.$executeTask(U).catch(j=>{throw new Error(j)}),x}provideTasksInternal(M,z,U,x){const j=[];if(x)for(let O of x){this.checkDeprecation(O,U),(!O.definition||!M[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const W=E.from(O,U.extension);W&&c.is(W.execution)?(j.push(W),z.push(this.addCustomExecution(W,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async resolveTaskInternal(M){if(c.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,z,U){}};F=Ve([We(0,l.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,D.IExtHostWorkspace),We(3,C.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,I.IExtHostTerminalService),We(6,T.ILogService),We(7,b.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(fe[268],me([0,1,18,59,30,81,24,10,8,23,9,12,2,146,177,121,44,130,267,31]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(m,u,E,A){this.configurationService=m,this.workspaceContextService=u,this.editorGroupsService=E,this.pathService=A}text(m,u,E={}){m=this.getContentPattern(m,E);const A=this.configurationService.getValue(),R=u&&u.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(u?.map(S.toWorkspaceFolder),E),type:2,contentPattern:m,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:A.search.usePCRE2||R||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(m,u){const E=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const A={...m,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(m,u)&&(A.isCaseSensitive=!0),this.isMultiline(m)&&(A.isMultiline=!0),A}file(m,u={}){return{...this.commonQuery(m,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(m,u){return m?(m=Array.isArray(m)?m.map(n):n(m),u?this.parseSearchPaths(m):{pattern:t(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],u={}){const E=this.handleIncludeExclude(u.includePattern,u.expandPatterns),A=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),R=m.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map($=>this.getFolderQueryForSearchPath($,u,A)):m.map($=>this.getFolderQueryForRoot($,u,A,R))).filter($=>!!$),N={_reason:u._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:A.pattern,includePattern:E.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const M=g.coalesce(g.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,s.pathIncludedInQuery)(N,U.fsPath)),z=this.commonQueryFromFileList(M);return{...N,...z}}const F=u.extraFileResources&&u.extraFileResources.filter($=>(0,s.pathIncludedInQuery)(N,$.fsPath));return N.extraFileResources=F&&F.length?F:void 0,N}commonQueryFromFileList(m){const u=[],E=new P.ResourceMap,A={};let R=!1;return m.forEach(B=>{if(B.scheme===D.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(B)){const F=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:C.dirname(B.fsPath)});let $=E.get(F);$||(R=!0,$={folder:F,includePattern:{}},u.push($),E.set(F,$));const M=C.relative(F.fsPath,B.fsPath);(0,I.assertIsDefined)($.includePattern)[M.replace(/\\/g,"/")]=!0}else B.fsPath&&(R=!0,A[B.fsPath]=!0)}),{folderQueries:u,includePattern:A,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(m,u){if(u.isSmartCase){if(m.isRegExp){if(i.containsUppercaseCharacter(m.pattern,!0))return!0}else if(i.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,p.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const u=z=>C.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),A=(Array.isArray(m)?m:f(m)).map(z=>{const U=this.pathService.resolvedUserHome;return U?(0,_.untildify)(z,U.scheme===D.Schemas.file?U.fsPath:U.path):z}),R=L.groupBy(A,z=>u(z)?"searchPaths":"exprSegments"),B=(R.exprSegments||[]).map(z=>i.rtrim(z,"/")).map(z=>i.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),N={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(N.searchPaths=F);const $=g.flatten(B),M=t(...$);return M&&(N.pattern=M),N}getExcludesForFolder(m,u){return u.disregardExcludeSettings?void 0:(0,s.getExcludes)(m,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const u=g.flatten(m.map(A=>{let{pathPortion:R,globPortion:B}=v(A);B&&(B=d(B));const N=this.expandOneSearchPath(R);return g.flatten(N.map(F=>this.resolveOneSearchPathPattern(F,B)))})),E=new Map;return u.forEach(A=>{const R=A.searchPath.toString(),B=E.get(R);B?A.pattern&&(B.pattern=B.pattern||{},B.pattern[A.pattern]=!0):E.set(R,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(m){if(C.isAbsolute(m)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==D.Schemas.file?[{searchPath:u[0].uri.with({path:m})}]:[{searchPath:l.URI.file(C.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=n(m),m.startsWith("../")||m===".."){const A=C.posix.resolve(u.path,m);return[{searchPath:u.with({path:A})}]}const E=d(m);return[{searchPath:u,pattern:E}]}else{if(m==="./"||m===".\\")return[];{const u=m.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(R=>{const B=u.match(new RegExp(`^${i.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return B?{match:B,folder:R}:null}).filter(I.isDefined);if(A.length)return A.map(R=>{const B=R.match[1];return{searchPath:R.folder.uri,pattern:B&&d(B)}});{const R=m.match(/\.[\/\\](.+)[\/\\]?/),B=R?R[1]:m,N=h.localize(0,null,B);throw new Error(N)}}}}resolveOneSearchPathPattern(m,u){const E=m.pattern&&u?`${m.pattern}/${u}`:m.pattern||u,A=[{searchPath:m.searchPath,pattern:E}];return E&&!E.endsWith("**")&&A.push({searchPath:m.searchPath,pattern:E+"/**"}),A}getFolderQueryForSearchPath(m,u,E){const A=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(m.searchPath),u,E,!1);return A?{...A,includePattern:m.pattern}:null}getFolderQueryForRoot(m,u,E,A){let R;const B=l.URI.isUri(m)?m:m.uri;if(E.searchPaths){const z=E.searchPaths.filter(U=>(0,k.isEqual)(U.searchPath,B))[0];if(z&&!z.pattern)return null;z&&(R=z.pattern)}const N=this.configurationService.getValue({resource:B}),$={...this.getExcludesForFolder(N,u)||{},...R||{}},M=l.URI.isUri(m)?(0,k.basename)(m):m.name;return{folder:B,folderName:A?M:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!N.search.followSymlinks}}};o=Ve([We(0,w.IConfigurationService),We(1,S.IWorkspaceContextService),We(2,T.IEditorGroupsService),We(3,b.IPathService)],o),e.QueryBuilder=o;function v(c){const m=c.match(/[\*\{\}\(\)\[\]\?]/);if(m){const u=m.index,E=c.substr(0,u).match(/[/|\\][^/\\]*$/);if(E){let A=c.substr(0,E.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:c.substr((E.index||0)+1)}}}return{pathPortion:c}}function t(...c){return c.length?c.reduce((m,u)=>(m[u]=!0,m),Object.create(null)):void 0}function f(c){return y.splitGlobAware(c,",").map(m=>m.trim()).filter(m=>!!m.length)}function r(c){return[`**/${c}/**`,`**/${c}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function n(c){return c.replace(/\\/g,"/")}function d(c){return n(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(c,m){c=g.distinct(c,A=>A.toString());const u=[],E=m.getWorkspace();return c&&c.forEach(A=>{let R;if(m.getWorkbenchState()===2)R=(0,k.relativePath)(E.folders[0].uri,A),R&&R!=="."&&(R="./"+R);else{const B=m.getWorkspaceFolder(A);if(B){const N=B.name;if(E.folders.filter($=>$.name===N).length===1){const $=(0,k.relativePath)(B.uri,A);$===""?R=`./${B.name}`:R=`./${B.name}/${$}`}else R=A.fsPath}}R&&u.push(R)}),u}e.resolveResourcesForSearchIncludes=a}),define(fe[269],me([0,1,23,2,21,17,4,268,31,44]),function(Y,e,g,L,y,_,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(w,S){const T=S.activationEvents;if(!T)return Promise.resolve(void 0);const b=[],s=[];for(const n of T)if(/^workspaceContains:/.test(n)){const d=n.substr("workspaceContains:".length);d.indexOf("*")>=0||d.indexOf("?")>=0||w.forceUsingSearch?s.push(d):b.push(d)}if(b.length===0&&s.length===0)return Promise.resolve(void 0);let o;const v=new Promise((n,d)=>{o=n}),t=n=>o({activationEvent:n}),f=Promise.all(b.map(n=>l(w,n,t))).then(()=>{}),r=p(w,S.identifier,s,t);return Promise.all([f,r]).then(()=>{o(void 0)}),v}e.checkActivateWorkspaceContainsExtension=I;async function l(w,S,T){for(const b of w.folders)if(await w.exists(g.joinPath(L.URI.revive(b),S))){T(`workspaceContains:${S}`);return}}async function p(w,S,T,b){if(T.length===0)return Promise.resolve(void 0);const s=new y.CancellationTokenSource,o=w.checkExists(w.folders,T,s.token),v=setTimeout(async()=>{s.cancel(),b(`workspaceContainsTimeout:${T.join(",")}`)},i);let t=!1;try{t=await o}catch(f){_.isPromiseCanceledError(f)||_.onUnexpectedError(f)}s.dispose(),clearTimeout(v),t&&b(`workspaceContains:${T.join(",")}`)}function h(w,S,T,b){const s=w.get(P.IInstantiationService),o=w.get(C.ISearchService),t=s.createInstance(D.QueryBuilder).file(S.map(f=>(0,k.toWorkspaceFolder)(L.URI.revive(f))),{_reason:"checkExists",includePattern:T,exists:!0});return o.fileSearch(t,b).then(f=>!!f.limitHit,f=>_.isPromiseCanceledError(f)?!1:Promise.reject(f))}e.checkGlobFileExists=h});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Ne=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[42],me([0,1,165,8,74,23,15,6,24,2,13,5,37,227,93,36,35,225,17,27,22,200,7,122,4,28,70,14,86,54,33,3,269,91,202,10]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s,o,v,t,f,r,n,d,a,c,m,u,E,A,R,B,N){"use strict";var F,$,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class zn extends D.Disposable{constructor(O,W,H,X,K,de,_e,Ce,Pe,Be){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=H,this._initData=_e,this._extHostWorkspace=X,this._extHostConfiguration=K,this._logService=de,this._extHostTunnelService=Pe,this._extHostTerminalService=Be,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._eagerExtensionsActivated=new P.Barrier,this._registry=new T.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=O.createChild(new c.ServiceCollection([h.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const $e=new Set;this._initData.hostExtensions.forEach(He=>$e.add(s.ExtensionIdentifier.toKey(He))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,G,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(G),ee)},actualActivateExtension:async(He,G)=>{if($e.has(s.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,G),new p.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,G)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(W){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,W){return this._activator.activateByEvent(O,W)}_activateById(O,W){return this._activator.activateById(O,W)}activateByIdWithErrors(O,W){return this._activateById(O,W).then(()=>{const H=this._activator.getActivatedExtension(O);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==N.Schemas.file)return O;const W=await this._hostUtils.realpath(O.fsPath);return k.URI.file(W)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=C.TernarySearchTree.forUris(W=>_.extUriBiasedIgnorePathCase.ignorePathCasing(W));for(const W of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(W)){const H=await this._realPathExtensionUri(W.extensionLocation);O.set(H,W)}return O})()),this._extensionPathIndex}_deactivate(O){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return W;const H=this._activator.getActivatedExtension(O);if(!H)return W;try{typeof H.module.deactivate=="function"&&(W=Promise.resolve(H.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,D.dispose)(H.subscriptions)}catch(X){this._logService.error(X)}return W}async _activateExtension(O,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,W).then(H=>{const X=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,W),this._logExtensionActivationTimes(O,W,"success",X),H},H=>{throw this._logExtensionActivationTimes(O,W,"failure"),H})}_logExtensionActivationTimes(O,W,H,X){const K=U(O,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...X||{},outcome:H})}_doActivateExtension(O,W){const H=U(O,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${O.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const K=new p.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,_.joinPath)(O.extensionLocation,X),K),this._loadExtensionContext(O)]).then(de=>(y.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),zn._callActivate(this._logService,O.identifier,de[0],de[1],K))).then(de=>(y.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const W=new v.ExtensionGlobalMemento(O,this._storage),H=new v.ExtensionMemento(O.identifier.value,!1,this._storage),X=new B.ExtensionSecrets(O,this._secretState),K=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([W.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const _e=this;let Ce;return Object.freeze({globalState:W,workspaceState:H,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Pe){return L.join(O.extensionLocation.fsPath,Pe)},get storagePath(){return _e._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return _e._storagePath.globalValue(O).fsPath},get logPath(){return L.join(_e._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return k.URI.joinPath(_e._initData.logsLocation,O.identifier.value)},get storageUri(){return _e._storagePath.workspaceValue(O)},get globalStorageUri(){return _e._storagePath.globalValue(O)},get extensionMode(){return K},get extension(){return Ce===void 0&&(Ce=new x(_e,O.identifier,O,de)),Ce},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O),_e.extensionRuntime},get environmentVariableCollection(){return _e._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,W,H,X,K){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,W,H,X,K).then(de=>new p.ActivatedExtension(!1,null,K.build(),H,de,X.subscriptions))}static _callActivateOptional(O,W,H,X,K){if(typeof H.activate=="function")try{K.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${W.value}`);const de=typeof global=="object"?global:self,_e=H.activate.apply(de,[X]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(_e).then(Ce=>(K.activateResolveStop(),Ce))}catch(de){return Promise.reject(de)}else return Promise.resolve(H)}_activateOneStartupFinished(O,W){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:W}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const W of O.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(O,W)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(W),X=Promise.all([O,H]).then(()=>{});return Promise.race([X,(0,P.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(O,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,W){if(this.isActivated(W.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:H,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,_e,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(de,_e,Ce)},K=await(0,A.checkActivateWorkspaceContainsExtension)(X,W);if(!!K)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:K.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:W}=this._initData.environment;if(!O||!W)throw new Error(g.localize(0,null));const H=await this._loadCommonJSModule(null,W,new p.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(g.localize(1,null,W.toString()));return new Promise((X,K)=>{const de=(Pe,Be)=>{Pe?K(Pe):X(typeof Be=="number"&&Be>0?1:0)},_e=(0,_.originalFSPath)(W),Ce=H.run(_e,de);Ce&&Ce.then&&Ce.then(()=>{X(0)}).catch(Pe=>{K(Pe.toString())})})}async $extensionTestsExit(O){this._logService.info(`Extension host terminating: test runner requested exit with code ${O}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,W){return this._resolvers[O]=W,(0,D.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const W=O.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const H=O.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(O,W){const{authorityPrefix:H,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:f.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),y.mark(`code/extHost/willResolveAuthority/${H}`);const K=await X.resolve(O,{resolveAttempt:W});y.mark(`code/extHost/didResolveAuthorityOK/${H}`);const de={authority:O,host:K.host,port:K.port,connectionToken:K.connectionToken},_e={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:de,options:_e,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(y.mark(`code/extHost/didResolveAuthorityError/${H}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(O,W){const{authorityPrefix:H,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const K=k.URI.revive(W);if(typeof X.getCanonicalURI=="undefined")return K;const de=await(0,P.asPromise)(()=>X.getCanonicalURI(K));return de||K}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,W){return W===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(O,!1))}async $activate(O,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,W),!0):!1}async $deltaExtensions(O,W){O.forEach(X=>X.extensionLocation=k.URI.revive(X.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(W.map(async X=>{const K=this._registry.getExtensionDescription(X);K&&H.delete(await this._realPathExtensionUri(K.extensionLocation))})),await Promise.all(O.map(async X=>{const K=await this._realPathExtensionUri(X.extensionLocation);H.set(K,X)})),this._registry.deltaExtensions(O,W),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let W=o.VSBuffer.alloc(O),H=Math.random()%256;for(let X=0;X<O;X++)W.writeUInt8(H,X);return W}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};z=Ve([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,a.IExtHostRpcService),We(3,w.IExtHostWorkspace),We(4,l.IExtHostConfiguration),We(5,i.ILogService),We(6,n.IExtHostInitDataService),We(7,d.IExtensionStoragePaths),We(8,m.IExtHostTunnelService),We(9,u.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function U(j,O){return{id:j.identifier.value,name:j.name,extensionVersion:j.version,publisherDisplayName:j.publisher,activationEvents:j.activationEvents?j.activationEvents.join(","):null,isBuiltin:j.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class x{constructor(O,W,H,X){F.set(this,void 0),$.set(this,void 0),M.set(this,void 0),st(this,F,O,"f"),st(this,$,W,"f"),st(this,M,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,_.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=X}get isActive(){return Ne(this,F,"f").isActivated(Ne(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,F,"f").getExtensionExports(Ne(this,M,"f"))}activate(){return Ne(this,F,"f").activateByIdWithErrors(Ne(this,M,"f"),{startup:!1,extensionId:Ne(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,F=new WeakMap,$=new WeakMap,M=new WeakMap}),define(fe[57],me([0,1,8,2,3,15,5,7,126,36,42,45,216,37,210,14,4,12,38,56]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let o=class{constructor(c,m,u,E,A,R){this._workspaceService=m,this._extensionService=u,this._editorsService=E,this._configurationService=A,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=c.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(N=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,m){const u=c;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let E=`debug:${encodeURIComponent(u.path||"")}`,A="?";return m&&(E+=`${A}session=${encodeURIComponent(m.id)}`,A="&"),E+=`${A}ref=${u.sourceReference}`,L.URI.parse(E)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const m=[];for(const u of c.getAllExtensionDescriptions())if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0)for(const A of E)(0,h.isDebuggerMainContribution)(A)&&m.push(A.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(m=>c.push(m)),c}addBreakpoints(c){this.startBreakpoints();const m=c.filter(A=>{const R=A.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,A),!0)});this.fireBreakpointChanges(m,[],[]);const u=[],E=new Map;for(const A of m)if(A instanceof D.SourceBreakpoint){let R=E.get(A.location.uri.toString());R||(R={type:"sourceMulti",uri:A.location.uri,lines:[]},E.set(A.location.uri.toString(),R),u.push(R)),R.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof D.FunctionBreakpoint&&u.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(c){this.startBreakpoints();const m=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],m,[]);const u=m.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),E=m.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),A=m.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(u,E,A)}startDebugging(c,m,u){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,m,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,m,u){if(!m)return new D.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:E,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,u,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,E),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(c,m,u){if(!u)return new D.Disposable(()=>{});if(!this.definesDebugType(c,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:E,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,E),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(c,m){if(!m)return new D.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:u,factory:m}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==m)})}async $runInTerminal(c,m){return Promise.resolve(void 0)}async $substituteVariables(c,m){if(!this._variableResolver){const[A,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,R)}let u;const E=await this.getFolder(c);return E&&(u={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,m)}createDebugAdapter(c,m){if(c.type==="implementation")return new n(c.implementation)}createSignService(){}async $startDASession(c,m){const u=this,E=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const R=this.convertToDto(A),B=this.createDebugAdapter(R,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const N=B;return this._debugAdapters.set(c,N),this.getDebugAdapterTrackers(E).then(F=>(F&&this._debugAdaptersTrackers.set(c,F),N.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const M=$,z={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(M.arguments.value);z.body={signature:U},N.sendResponse(z)}else throw new Error("no signer")}catch(U){z.success=!1,z.message=U.message,N.sendResponse(z)}}else F&&F.onDidSendMessage&&F.onDidSendMessage($),$=(0,h.convertToVSCPaths)($,!0),u._debugServiceProxy.$acceptDAMessage(c,$)}),N.onError($=>{F&&F.onError&&F.onError($),this._debugServiceProxy.$acceptDAError(c,$.name,$.message,$.stack)}),N.onExit($=>{F&&F.onExit&&F.onExit((0,T.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,T.withNullAsUndefined)($),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),N.startSession()))})}$sendDAMessage(c,m){m=(0,h.convertToDAPaths)(m,!1);const u=this._debugAdaptersTrackers.get(c);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(m);const E=this._debugAdapters.get(c);E&&E.sendMessage(m)}$stopDASession(c){const m=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),m&&m.onWillStopSession&&m.onWillStopSession();const u=this._debugAdapters.get(c);return this._debugAdapters.delete(c),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const m=[],u=[],E=[];if(c.added)for(const A of c.added){const R=A.id;if(R&&!this._breakpoints.has(R)){let B;if(A.type==="function")B=new D.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")B=new D.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const N=L.URI.revive(A.uri);B=new D.SourceBreakpoint(new D.Location(N,new D.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}B._id=R,this._breakpoints.set(R,B),m.push(B)}}if(c.removed)for(const A of c.removed){const R=this._breakpoints.get(A);R&&(this._breakpoints.delete(A),u.push(R))}if(c.changed){for(const A of c.changed)if(A.id){const R=this._breakpoints.get(A.id);if(R){if(R instanceof D.FunctionBreakpoint&&A.type==="function"){const B=R;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.functionName=A.functionName}else if(R instanceof D.SourceBreakpoint&&A.type==="source"){const B=R;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.location=new D.Location(L.URI.revive(A.uri),new D.Position(A.line,A.character))}E.push(R)}}}this.fireBreakpointChanges(m,u,E)}$provideDebugConfigurations(c,m,u){return(0,_.asPromise)(async()=>{const E=this.getConfigProviderByHandle(c);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(m);return E.provideDebugConfigurations(A,u)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(c,m,u,E){return(0,_.asPromise)(async()=>{const A=this.getConfigProviderByHandle(c);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(m);return A.resolveDebugConfiguration(R,u,E)})}$resolveDebugConfigurationWithSubstitutedVariables(c,m,u,E){return(0,_.asPromise)(async()=>{const A=this.getConfigProviderByHandle(c);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(m);return A.resolveDebugConfigurationWithSubstitutedVariables(R,u,E)})}async $provideDebugAdapter(c,m){const u=this.getAdapterDescriptorFactoryByHandle(c);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(m);return this.getAdapterDescriptor(u,E).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(c){const m=await this.getSession(c);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(c){const m=await this.getSession(c);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,m){const u=await this.getSession(c);u&&u._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(c,m){const E={session:await this.getSession(c),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(c){if(c instanceof D.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof D.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const m=this._adapterFactories.filter(u=>u.type===c);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(c){const m=this._adapterFactories.filter(u=>u.handle===c);if(m.length>0)return m[0].factory}getConfigProviderByHandle(c){const m=this._configProviders.filter(u=>u.handle===c);if(m.length>0)return m[0].provider}definesDebugType(c,m){if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0){for(const E of u)if(E.label&&E.type&&E.type===m)return!0}}return!1}getDebugAdapterTrackers(c){const u=c.configuration.type,E=this._trackerFactories.filter(A=>A.type===u||A.type==="*").map(A=>(0,_.asPromise)(()=>A.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(E).then(A=>{const R=A.filter(B=>!!B);if(R.length>0)return new r(R)}),new Promise((A,R)=>{const B=setTimeout(()=>{clearTimeout(B),R(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(c,m){const u=m.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new D.DebugAdapterServer(u));if(c){const A=await this._extensionService.getExtensionRegistry();return(0,_.asPromise)(()=>c.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,A))).then(R=>{if(R)return R})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,E))}daExecutableFromPackage(c,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,m,u){(c.length>0||m.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:m,changed:u}))}async getSession(c){if(c)if(typeof c=="string"){const m=this._debugSessions.get(c);if(m)return m}else{let m=this._debugSessions.get(c.id);if(!m){const u=await this.getFolder(c.folderUri),E=c.parent?this._debugSessions.get(c.parent):void 0;m=new v(this._debugServiceProxy,c.id,c.type,c.name,u,c.configuration,E),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(c){if(c){const m=L.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};o=Ve([We(0,w.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,s.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class v{constructor(c,m,u,E,A,R,B){this._debugServiceProxy=c,this._id=m,this._type=u,this._name=E,this._workspaceFolder=A,this._configuration=R,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,m)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=v;class t{constructor(c){this.value=Object.freeze({append(m){c.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=t;class f extends l.AbstractVariableResolverService{constructor(c,m,u,E,A){function R(){if(m){const B=m.activeEditor();if(B)return B.document.uri;const N=E.tabs.filter(F=>F.isActive);if(N.length>0){const F=N[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:N[0].resource}}}super({getFolderUri:B=>{const N=c.filter(F=>F.name===B);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(B,N)=>u.getConfiguration(void 0,B).get(N),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=R();if(B)return g.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const B=R();if(B){const N=A.getWorkspaceFolder(B);if(N)return g.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(m){const B=m.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(m){const B=m.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=f;class r{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(m=>m.onError?m.onError(c):void 0)}onExit(c,m){this.trackers.forEach(u=>u.onExit?u.onExit(c,m):void 0)}}class n extends C.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let d=class extends o{constructor(c,m,u,E,A,R){super(c,m,u,E,A,R)}createVariableResolver(c,m,u){return new f(c,m,u,this._editorTabs)}};d=Ve([We(0,w.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,i.IExtHostExtensionService),We(3,I.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,s.IExtHostEditorTabs)],d),e.WorkerExtHostDebugService=d}),define(fe[270],me([0,1,74,2,5,37,35,27,14,28,4,42,38,13]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(s,o,v,t,f,r,n){this._apiFactory=s,this._extensionRegistry=o,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=f,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,o,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(S,o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(T,o,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let o of s.nodeModuleName)this._factories.set(o,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(o=>s.alternativeModuleName(o))}};h=Ve([We(2,i.IInstantiationService),We(3,_.IExtHostConfiguration),We(4,I.IExtHostExtensionService),We(5,k.IExtHostInitDataService),We(6,p.ILogService)],h),e.RequireInterceptor=h;class w{constructor(s,o,v,t,f){this._apiFactory=s,this._extensionPaths=o,this._extensionRegistry=v,this._configProvider=t,this._logService=f,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,o){const v=this._extensionPaths.findSubstr(o);if(v){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((f,r)=>t+=`	${r} -> ${f.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(s,o,v){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=o.getProxy(y.MainContext.MainThreadTelemetry);const{environment:t}=v,f=o.getProxy(y.MainContext.MainThreadKeytar);if(t.appRoot){let r=t.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,n)=>f.$getPassword(r,n),setPassword:(r,n,d)=>f.$setPassword(r,n,d),deletePassword:(r,n)=>f.$deletePassword(r,n),findPassword:r=>f.$findPassword(r),findCredentials(r){return f.$findCredentials(r)}}}load(s,o){const v=this._extensionPaths.findSubstr(o);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:v?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const o=s.length;if(o<=7||!this.alternativeNames)return;const v=o-7;if((s.charAt(v)==="/"||s.charAt(v)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};S=Ve([We(1,C.IExtHostRpcService),We(2,k.IExtHostInitDataService)],S);let T=class{constructor(s,o,v){this._extensionPaths=s,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(y.MainContext.MainThreadTelemetry);const t=v.getProxy(y.MainContext.MainThreadWindow);this._impl=(f,r)=>{const n=L.URI.parse(f);return r?this.callOriginal(f,r):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,f,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,f,{}):this.callOriginal(f,r)}}load(s,o,v){const t=this._extensionPaths.findSubstr(o);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(s),this._impl}callOriginal(s,o){return this.sendNoForwardTelemetry(),this._original(s,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};T=Ve([We(2,C.IExtHostRpcService)],T)}),define(fe[271],me([0,1,171,11,7,211,36,42,45,37,33,14,57,195,15,212,56]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let T=class extends l.ExtHostDebugServiceBase{constructor(o,v,t,f,r,n,d){super(o,v,t,f,r,d);this._terminalService=n,this._integratedTerminalInstances=new b}createDebugAdapter(o,v){switch(o.type){case"server":return new _.SocketDebugAdapter(o);case"pipeServer":return new _.NamedPipeDebugAdapter(o);case"executable":return new _.ExecutableDebugAdapter(o,v.type)}return super.createDebugAdapter(o,v)}daExecutableFromPackage(o,v){const t=_.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),o.type);if(t)return new y.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new p.SignService}async $runInTerminal(o,v){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const t=await this._configurationService.getConfigProvider(),f=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),n=o.title||g.localize(0,null),d=JSON.stringify({shell:f,shellArgs:r});let a=await this._integratedTerminalInstances.checkout(d,n),c,m=!1;if(a)c=o.cwd;else{const R={shellPath:f,shellArgs:r,cwd:o.cwd,name:n,iconPath:new y.ThemeIcon("debug")};m=!0,a=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(a,d)}a.show(!0);const u=await a.processId;m?await new Promise(R=>setTimeout(R,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0||f.indexOf("cmd.exe")>=0?a.sendText("cls"):f.indexOf("bash")>=0?a.sendText("clear"):L.isWindows?a.sendText("cls"):a.sendText("clear"));const E=(0,w.prepareCommand)(f,o.args,c,o.env);a.sendText(E);const A=this.onDidTerminateDebugSession(R=>{R.id===v&&(this._integratedTerminalInstances.free(a),A.dispose())});return u}else if(o.kind==="external")return(0,w.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,v)}createVariableResolver(o,v,t){return new l.ExtHostVariableResolverService(o,v,t,this._editorTabs,this._workspaceService)}};T=Ve([We(0,I.IExtHostRpcService),We(1,P.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,C.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,i.IExtHostTerminalService),We(6,S.IExtHostEditorTabs)],T),e.ExtHostDebugService=T;class b{constructor(){this._terminalInstances=new Map}async checkout(o,v){const f=[...this._terminalInstances.entries()].map(([r,n])=>(0,h.createCancelablePromise)(async d=>{if(r.name!==v||n.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await r.processId))return null;const a=Date.now();return n.lastUsedAt+b.minUseDelay>a||d.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=a,r)}));return await(0,h.firstParallel)(f,r=>!!r)}insert(o,v){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:v})}free(o){const v=this._terminalInstances.get(o);v&&(v.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}b.minUseDelay=1e3}),define(fe[272],me([0,1,8,2,114,36,57,45,37,44,33,14,28,73,10,13,68,56,23,82]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends p.ExtHostTaskBase{constructor(t,f,r,n,d,a,c,m,u){super(t,f,r,n,d,a,c,m);this.workspaceService=r,this.editorTabs=u,f.remote.isRemote&&f.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:f.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,f){const r=f;if(!f.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const n=p.TaskHandleDTO.from(r,this.workspaceService),d=await this._proxy.$getTaskExecution(n);if(d.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.getTaskExecution(d,f);return this._proxy.$executeTask(n).catch(()=>{}),a}else{const n=p.TaskDTO.from(f,t);if(n===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,f,!1);const d=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),f);return this._proxy.$executeTask(n).catch(()=>{}),d}}provideTasksInternal(t,f,r,n){const d=[];if(n)for(let a of n){this.checkDeprecation(a,r),(!a.definition||!t[a.definition.type])&&this._logService.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const c=p.TaskDTO.from(a,r.extension);c&&(d.push(c),p.CustomExecutionDTO.is(c.execution)&&f.push(this.addCustomExecution(c,a,!0)))}return{tasks:d,extension:r.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const f=await this._configurationService.getConfigProvider();this._variableResolver=new P.ExtHostVariableResolverService(t,this._editorService,f,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let f=t&&t.length>0?t[0]:void 0;if(!f){const r=L.URI.file((0,s.homedir)());f=new k.WorkspaceFolder({uri:r,name:b.basename(r),index:0})}return{uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,f){const r=L.URI.revive(t),n={process:void 0,variables:Object.create(null)},d=await this._workspaceProvider.resolveWorkspaceFolder(r),a=await this._workspaceProvider.getWorkspaceFolders2()??[],c=await this.getVariableResolver(a),m=d?{uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(a);for(let u of f.variables)n.variables[u]=await c.resolveAsync(m,u);if(f.process!==void 0){let u;if(f.process.path!==void 0){u=f.process.path.split(g.delimiter);for(let E=0;E<u.length;E++)u[E]=await c.resolveAsync(m,u[E])}n.process=await y.win32.findExecutable(await c.resolveAsync(m,f.process.name),f.process.cwd!==void 0?await c.resolveAsync(m,f.process.cwd):void 0,u)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(t,f,r){return y.win32.findExecutable(t,f,r)}};o=Ve([We(0,I.IExtHostRpcService),We(1,l.IExtHostInitDataService),We(2,_.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,i.IExtHostTerminalService),We(6,w.ILogService),We(7,S.IExtHostApiDeprecationService),We(8,T.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(fe[273],me([0,1,15,17,74,6,2,5,265,13,84,86,28,189,14,67,42,33]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(o,v,t,f){this._disposables=new _.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new C.RPCProtocol(o,null,f),v=b._transform(v,this._rpcProtocol);const r=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...v}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),r.set(w.IURITransformerService,new w.URITransformerService(f)),r.set(S.IHostUtils,t);const n=new p.InstantiationService(r,!0),d=n.invokeFunction(u=>u.get(T.IExtHostTerminalService));this._disposables.add(d),this._logService=n.invokeFunction(u=>u.get(k.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=n.invokeFunction(u=>u.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const a=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(E,A)=>{let R="",B,N;for(const F of A)R+=`
	at ${F.toString()}`,N=F.getFileName(),!B&&N&&(B=u.findSubstr(P.URI.file(N)));return a.set(E,B),`${E.name||"Error"}: ${E.message||""}${R}`}});const c=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(u=>{const E=L.transformErrorForSerialization(u),A=a.get(u);A?c.$onExtensionRuntimeError(A.identifier,E):m.$onUnexpectedError(E)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(o,v){o.extensions.forEach(f=>f.extensionLocation=P.URI.revive(v.transformIncomingURIs(f.extensionLocation))),o.environment.appRoot=P.URI.revive(v.transformIncomingURIs(o.environment.appRoot));const t=o.environment.extensionDevelopmentLocationURI;return t&&(o.environment.extensionDevelopmentLocationURI=t.map(f=>P.URI.revive(v.transformIncomingURIs(f)))),o.environment.extensionTestsLocationURI=P.URI.revive(v.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=P.URI.revive(v.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=P.URI.revive(v.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=P.URI.revive(v.transformIncomingURIs(o.logsLocation)),o.logFile=P.URI.revive(v.transformIncomingURIs(o.logFile)),o.workspace=v.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=b}),define(fe[274],me([0,1,8,21,52,30,23,46,31]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(l,p,h){this.config=l,this.provider=p,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&_.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&_.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const p=this.config.folderQueries||[];return new Promise((h,w)=>{const S=T=>{this.resultCount++,l(T)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(T=>{const b=T.toString(),s=g.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,s)||this.matchFile(S,{base:T,basename:s})}),Promise.all(p.map(T=>this.searchInFolder(T,S))).then(T=>{h({limitHit:this.isLimitHit,stats:T[0]||void 0})},T=>{w(new Error((0,y.toErrorMessage)(T)))})})}async searchInFolder(l,p){const h=new L.CancellationTokenSource,w=this.getSearchOptionsForFolder(l),S=this.initDirectoryTree(),T=new C.QueryGlobTester(this.config,l),b=!T.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(h),s=D.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,h.token),v=s.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(f=>{const r=g.posix.relative(l.folder.path,f.path);if(b){const n=g.basename(f.path);this.matchFile(p,{base:l.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(S,l.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,T,p),{providerTime:v,postProcessTime:t.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(l){const p=(0,C.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),h=(0,C.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:h,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},p,h,w){if(h===this.filePattern){const T=g.basename(this.filePattern);this.matchFile(w,{base:p,relativePath:this.filePattern,basename:T})}function S(T){const b=g.basename(T),s=g.dirname(T);let o=l[s];o||(o=l[s]=[],S(s)),o.push({base:p,relativePath:T,basename:b})}S(h)}matchDirectoryTree({rootEntries:l,pathToEntries:p},h,w){const S=this,T=this.filePattern;function b(s){const o=_.hasSiblingFn(()=>s.map(v=>v.basename));for(let v=0,t=s.length;v<t;v++){const f=s[v],{relativePath:r,basename:n}=f;if(h.matchesExcludesSync(r,n,T!==n?o:void 0))continue;const d=p[r];if(d)b(d);else{if(r===T)continue;S.matchFile(w,f)}if(S.isLimitHit)break}}b(l)}matchFile(l,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(p))}}class i{constructor(){this.sessions=new Map}fileSearch(l,p,h,w){const S=this.getSessionTokenSource(l.cacheKey),T=new k(l,p,S&&S.token);let b=0;const s=o=>{b+=o.length,h(o.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(T,i.BATCH_SIZE,s,w).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:o.stats}}))}clearCache(l){const p=this.getSessionTokenSource(l);p&&p.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new L.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:P.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,p,h,w){w.onCancellationRequested(()=>{l.cancel()});const S=b=>{b&&(T.push(b),p>0&&T.length>=p&&(h(T),T=[]))};let T=[];return l.search(S).then(b=>(T.length&&h(T),b),b=>(T.length&&h(T),Promise.reject(b)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(fe[135],me([0,1,18,21,52,30,10,8,23,12,2,31]),function(Y,e,g,L,y,_,P,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(s,o,v,t){this.query=s,this.provider=o,this.fileUtils=v,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,o){const v=this.query.folderQueries||[],t=new L.CancellationTokenSource;return o.onCancellationRequested(()=>t.cancel()),new Promise((f,r)=>{this.collector=new h(s);let n=!1;const d=(a,c)=>{if(!n&&!this.isLimitHit){const m=this.resultSize(a);S(a)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const u=this.resultSize(a);this.resultCount+=u,(u>0||!S(a))&&this.collector.add(a,c)}};Promise.all(v.map((a,c)=>this.searchInFolder(a,m=>d(m,c),t.token))).then(a=>{t.dispose(),this.collector.flush();const c=a.some(m=>!!m&&!!m.limitHit);f({limitHit:this.isLimitHit||c,messages:(0,g.flatten)(a.map(m=>m?.message?(0,k.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},a=>{t.dispose();const c=(0,y.toErrorMessage)(a);r(new Error(c))})})}resultSize(s){return S(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,o){const v=Array.isArray(s.ranges)?s.ranges:[s.ranges],t=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:v.slice(0,o),preview:{matches:t.slice(0,o),text:s.preview.text},uri:s.uri}}async searchInFolder(s,o,v){const t=new I.QueryGlobTester(this.query,s),f=[],r={report:a=>{if(!this.validateProviderResult(a))return;const c=s.folder.scheme===P.Schemas.file?_.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(a.uri))):void 0,m=C.relativePath(s.folder,a.uri);if(m){const u=t.includedInQuery(m,D.basename(m),c);(0,k.isPromise)(u)?f.push(u.then(E=>{E&&o(a)})):u&&o(a)}}},n=this.getSearchOptionsForFolder(s),d=await this.provider.provideTextSearchResults(p(this.query.contentPattern),n,r,v);return f.length&&await Promise.all(f),d}validateProviderResult(s){if(S(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const o=(0,I.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),v=(0,I.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),t={folder:i.URI.from(s.folder),excludes:v,includes:o,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function p(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class h{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new T(512,o=>this.sendItems(o))}add(s,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!C.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(w(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=h;function w(b){return S(b)?{preview:{matches:(0,g.mapArrayOrNot)(b.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:b.preview.text},ranges:(0,g.mapArrayOrNot)(b.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function S(b){return!!b.preview}e.extensionResultIsMatch=S;class T{constructor(s,o){this.maxBatchSize=s,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,o){!s||this.addItemToBatch(s,o)}addItems(s,o){!s||this.addItemsToBatch(s,o)}addItemToBatch(s,o){this.batch.push(s),this.batchSize+=o,this.onUpdate()}addItemsToBatch(s,o){this.batch=this.batch.concat(s),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<T.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},T.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=T,T.TIMEOUT=4e3,T.START_BATCH_AFTER_COUNT=50}),define(fe[75],me([0,1,6,5,4,274,14,67,13,2,135]),function(Y,e,g,L,y,_,P,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let I=class{constructor(w,S,T){this.extHostRpc=w,this._uriTransformer=S,this._logService=T,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new _.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,S){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const T=this._handlePool++;return this._textSearchProvider.set(T,S),this._proxy.$registerTextSearchProvider(T,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}registerFileSearchProvider(w,S){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const T=this._handlePool++;return this._fileSearchProvider.set(T,S),this._proxy.$registerFileSearchProvider(T,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}$provideFileSearchResults(w,S,T,b){const s=l(T),o=this._fileSearchProvider.get(w);if(o)return this._fileSearchManager.fileSearch(s,o,v=>{this._proxy.$handleFileMatch(w,S,v.map(t=>t.resource))},b);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,S,T,b){const s=this._textSearchProvider.get(w);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const o=l(T);return this.createTextSearchManager(o,s).search(t=>this._proxy.$handleTextMatch(w,S,t),b)}$enableExtensionHostSearch(){}createTextSearchManager(w,S){return new i.TextSearchManager(w,S,{readdir:T=>Promise.resolve([]),toCanonicalName:T=>T},"textSearchProvider")}};I=Ve([We(0,P.IExtHostRpcService),We(1,D.IURITransformerService),We(2,C.ILogService)],I),e.ExtHostSearch=I;function l(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(p),extraFileResources:h.extraFileResources&&h.extraFileResources.map(w=>k.URI.revive(w))}}e.reviveQuery=l;function p(h){return{...h,folder:k.URI.revive(h.folder)}}}),define(fe[275],me([0,1,21,17,3,49,2,115,110,147,83,40,5,233,232,41,234,37,235,236,237,218,238,45,42,239,219,242,243,244,69,221,249,250,251,93,33,253,222,16,7,256,71,134,36,35,59,207,241,64,133,73,57,75,13,67,14,28,245,204,54,68,230,254,203,70,92,259,257,258,231,53,252,255,91,56,124,247,72,248,10,191,246,201,240]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s,o,v,t,f,r,n,d,a,c,m,u,E,A,R,B,N,F,$,M,z,U,x,j,O,W,H,X,K,de,_e,Ce,Pe,Be,$e,He,G,ee,te,ce,Z,se,pe,Me,je,Ke,Ze,rt,ct,ye,at,J,ie,Ee,Qe,et,le,Ie,Ue,Xe,it,ft,tt,ut,Re,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Te(oe){const ue=oe.get(te.IExtHostInitDataService),we=oe.get(ie.IExtHostFileSystemInfo),ve=oe.get(rt.IExtHostConsumerFileSystem),Fe=oe.get(r.IExtHostExtensionService),Ge=oe.get(W.IExtHostWorkspace),ze=oe.get(Ie.IExtHostTelemetry),Ye=oe.get(T.IExtHostConfiguration),lt=oe.get(G.IURITransformerService),xe=oe.get(ee.IExtHostRpcService),ge=oe.get(N.IExtHostStorage),be=oe.get(Ze.IExtensionStoragePaths),re=oe.get(He.ILogService),Q=oe.get(se.IExtHostTunnelService),Se=oe.get(pe.IExtHostApiDeprecationService),Le=oe.get(O.IExtHostWindow),nt=oe.get(et.IExtHostSecretState),qe=oe.get(le.IExtHostEditorTabs);xe.set(l.ExtHostContext.ExtHostFileSystemInfo,we),xe.set(l.ExtHostContext.ExtHostLogService,re),xe.set(l.ExtHostContext.ExtHostWorkspace,Ge),xe.set(l.ExtHostContext.ExtHostConfiguration,Ye),xe.set(l.ExtHostContext.ExtHostExtensionService,Fe),xe.set(l.ExtHostContext.ExtHostStorage,ge),xe.set(l.ExtHostContext.ExtHostTunnelService,Q),xe.set(l.ExtHostContext.ExtHostWindow,Le),xe.set(l.ExtHostContext.ExtHostSecretState,nt),xe.set(l.ExtHostContext.ExtHostTelemetry,ze),xe.set(l.ExtHostContext.ExtHostEditorTabs,qe);const gt=xe.set(l.ExtHostContext.ExtHostDecorations,oe.get(Ce.IExtHostDecorations)),Et=xe.set(l.ExtHostContext.ExtHostDocumentsAndEditors,oe.get(f.IExtHostDocumentsAndEditors)),pt=xe.set(l.ExtHostContext.ExtHostCommands,oe.get(w.IExtHostCommands)),vt=xe.set(l.ExtHostContext.ExtHostTerminalService,oe.get(F.IExtHostTerminalService)),wt=xe.set(l.ExtHostContext.ExtHostDebugService,oe.get(Be.IExtHostDebugService)),Dt=xe.set(l.ExtHostContext.ExtHostSearch,oe.get($e.IExtHostSearch)),Ct=xe.set(l.ExtHostContext.ExtHostTask,oe.get(Pe.IExtHostTask)),Tt=xe.set(l.ExtHostContext.ExtHostOutputService,oe.get(u.IExtHostOutputService)),Nt=xe.set(l.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(xe)),It=xe.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(xe,Et)),Ut=xe.set(l.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(xe,Et,re)),$t=xe.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(re,It,xe.getProxy(l.MainContext.MainThreadBulkEdits))),St=xe.set(l.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(xe,pt,Et,It,be)),Qt=xe.set(l.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(re,St)),zt=xe.set(l.ExtHostContext.ExtHostNotebookEditors,new ut.ExtHostNotebookEditors(re,xe,St)),nn=xe.set(l.ExtHostContext.ExtHostNotebookKernels,new Ue.ExtHostNotebookKernels(xe,ue,St,pt,re)),rn=xe.set(l.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(xe,St)),At=xe.set(l.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(xe,Et)),Xt=xe.set(l.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(xe.getProxy(l.MainContext.MainThreadTreeViews),pt,re)),sn=xe.set(l.ExtHostContext.ExtHostEditorInsets,new K.ExtHostEditorInsets(xe.getProxy(l.MainContext.MainThreadEditorInsets),At,ue)),Yt=xe.set(l.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,re,we)),Wt=xe.set(l.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(xe,It,pt.converter,lt)),bt=xe.set(l.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(xe,lt,It,pt,Yt,re,Se)),on=xe.set(l.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(xe,bt)),Ft=xe.set(l.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(xe,re,Et)),Vt=xe.set(l.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(xe,Ge,pt)),Jt=xe.set(l.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(xe,pt,re)),an=xe.set(l.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(xe,pt,It)),hn=xe.set(l.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(xe.getProxy(l.MainContext.MainThreadProgress))),bn=xe.set(l.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(xe)),fn=xe.set(l.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(xe)),Zt=xe.set(l.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(xe)),En=xe.set(l.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(xe,pt)),jt=xe.set(l.ExtHostContext.ExtHostWebviews,new j.ExtHostWebviews(xe,{remote:ue.remote},Ge,re,Se)),qt=xe.set(l.ExtHostContext.ExtHostWebviewPanels,new at.ExtHostWebviewPanels(xe,jt,Ge)),_n=xe.set(l.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(xe,It,be,jt,qt)),Sn=xe.set(l.ExtHostContext.ExtHostWebviewViews,new ct.ExtHostWebviewViews(xe,jt)),Gt=xe.set(l.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(xe,pt)),yn=xe.set(l.ExtHostContext.ExtHostUriOpeners,new Qe.ExtHostUriOpeners(xe));xe.set(l.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(xe,St,Et,pt));const en=(0,X.values)(l.ExtHostContext);xe.assertRegistered(en);const Dn=new J.ExtHostBulkEdits(xe,Et),Cn=new h.ExtHostClipboard(xe),Kt=new m.ExtHostMessageService(xe,re),mn=new s.ExtHostDialogs(xe),Ht=new B.ExtHostStatusBar(xe,pt.converter);return p.ExtHostApiCommands.register(pt),function(Oe,ln,Lt){const _t=function(){let ne=!Oe.isUnderDevelopment;function he(Ae){ne||(re.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ae(ht){if(Array.isArray(ht))ht.forEach(Ae);else if(typeof ht=="string")he(ht);else{const yt=ht;typeof yt.scheme=="undefined"&&he(ht),!Oe.enableProposedApi&&typeof yt.exclusive=="boolean"&&(0,H.throwProposedApiError)(Oe)}return ht}}(),kn={getSession(ne,he,Ae){return(Ae?.forceNewSession||Ae?.silent)&&(0,H.checkProposedApiEnabled)(Oe),Zt.getSession(Oe,ne,he,Ae)},async hasSession(ne,he){return(0,H.checkProposedApiEnabled)(Oe),!!await Zt.getSession(Oe,ne,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(ne,he,Ae,ht){return Zt.registerAuthenticationProvider(ne,he,Ae,ht)}},In={registerCommand(ne,he,Ae){return pt.registerCommand(!0,ne,he,Ae,void 0,Oe)},registerTextEditorCommand(ne,he,Ae){return pt.registerCommand(!0,ne,(...ht)=>{const yt=At.getActiveTextEditor();if(!yt){re.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Pt=>{he.apply(Ae,[yt,Pt,...ht])}).then(Pt=>{Pt||re.warn("Edits from command "+ne+" were not applied.")},Pt=>{re.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(ne,he,Ae)=>((0,H.checkProposedApiEnabled)(Oe),pt.registerCommand(!0,ne,async(...ht)=>{const yt=Et.activeEditor(!0);if(!yt){re.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await At.getDiffInformation(yt.id);he.apply(Ae,[Pt,...ht])},void 0,void 0,Oe)),executeCommand(ne,...he){return pt.executeCommand(ne,...he)},getCommands(ne=!1){return pt.getCommands(ne)}},gn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Cn.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,he){return Le.openUri(ne,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ue.environment.appUriScheme)return Nt.createAppUri(ne);try{return await Le.asExternalUri(ne,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,tt.matchesScheme)(ne,ft.Schemas.http)||(0,tt.matchesScheme)(ne,ft.Schemas.https))return ne;throw he}},get remoteName(){return(0,_e.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,H.checkProposedApiEnabled)(Oe),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=ue.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pn={createTestController(ne,he){return Gt.createTestController(ne,he)},createTestObserver(){return(0,H.checkProposedApiEnabled)(Oe),Gt.createTestObserver()},runTests(ne){return(0,H.checkProposedApiEnabled)(Oe),Gt.runTests(ne)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Oe),Gt.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Oe),Gt.results}},Tn={getExtension(ne){const he=ln.getExtensionDescription(ne);if(he)return new r.Extension(Fe,Oe.identifier,he,pn)},get all(){return ln.getAllExtensionDescriptions().map(ne=>new r.Extension(Fe,Oe.identifier,ne,pn))},get onDidChange(){return ln.onDidChange}},An={createDiagnosticCollection(ne){return Yt.createDiagnosticCollection(Oe.identifier,ne)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:ne=>Yt.getDiagnostics(ne),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(ne,he){return Wt.changeLanguage(ne.uri,he)},match(ne,he){return(0,i.score)(z.LanguageSelector.from(ne),he.uri,he.languageId,!0)},registerCodeActionsProvider(ne,he,Ae){return bt.registerCodeActionProvider(Oe,_t(ne),he,Ae)},registerCodeLensProvider(ne,he){return bt.registerCodeLensProvider(Oe,_t(ne),he)},registerDefinitionProvider(ne,he){return bt.registerDefinitionProvider(Oe,_t(ne),he)},registerDeclarationProvider(ne,he){return bt.registerDeclarationProvider(Oe,_t(ne),he)},registerImplementationProvider(ne,he){return bt.registerImplementationProvider(Oe,_t(ne),he)},registerTypeDefinitionProvider(ne,he){return bt.registerTypeDefinitionProvider(Oe,_t(ne),he)},registerHoverProvider(ne,he){return bt.registerHoverProvider(Oe,_t(ne),he,Oe.identifier)},registerEvaluatableExpressionProvider(ne,he){return bt.registerEvaluatableExpressionProvider(Oe,_t(ne),he,Oe.identifier)},registerInlineValuesProvider(ne,he){return bt.registerInlineValuesProvider(Oe,_t(ne),he,Oe.identifier)},registerDocumentHighlightProvider(ne,he){return bt.registerDocumentHighlightProvider(Oe,_t(ne),he)},registerLinkedEditingRangeProvider(ne,he){return bt.registerLinkedEditingRangeProvider(Oe,_t(ne),he)},registerReferenceProvider(ne,he){return bt.registerReferenceProvider(Oe,_t(ne),he)},registerRenameProvider(ne,he){return bt.registerRenameProvider(Oe,_t(ne),he)},registerDocumentSymbolProvider(ne,he,Ae){return bt.registerDocumentSymbolProvider(Oe,_t(ne),he,Ae)},registerWorkspaceSymbolProvider(ne){return bt.registerWorkspaceSymbolProvider(Oe,ne)},registerDocumentFormattingEditProvider(ne,he){return bt.registerDocumentFormattingEditProvider(Oe,_t(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return bt.registerDocumentRangeFormattingEditProvider(Oe,_t(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Ae,...ht){return bt.registerOnTypeFormattingEditProvider(Oe,_t(ne),he,[Ae].concat(ht))},registerDocumentSemanticTokensProvider(ne,he,Ae){return bt.registerDocumentSemanticTokensProvider(Oe,_t(ne),he,Ae)},registerDocumentRangeSemanticTokensProvider(ne,he,Ae){return bt.registerDocumentRangeSemanticTokensProvider(Oe,_t(ne),he,Ae)},registerSignatureHelpProvider(ne,he,Ae,...ht){return typeof Ae=="object"?bt.registerSignatureHelpProvider(Oe,_t(ne),he,Ae):bt.registerSignatureHelpProvider(Oe,_t(ne),he,typeof Ae=="undefined"?[]:[Ae,...ht])},registerCompletionItemProvider(ne,he,...Ae){return bt.registerCompletionItemProvider(Oe,_t(ne),he,Ae)},registerInlineCompletionItemProvider(ne,he){return(0,H.checkProposedApiEnabled)(Oe),bt.registerInlineCompletionsProvider(Oe,_t(ne),he)},registerDocumentLinkProvider(ne,he){return bt.registerDocumentLinkProvider(Oe,_t(ne),he)},registerColorProvider(ne,he){return bt.registerColorProvider(Oe,_t(ne),he)},registerFoldingRangeProvider(ne,he){return bt.registerFoldingRangeProvider(Oe,_t(ne),he)},registerSelectionRangeProvider(ne,he){return bt.registerSelectionRangeProvider(Oe,ne,he)},registerCallHierarchyProvider(ne,he){return bt.registerCallHierarchyProvider(Oe,ne,he)},registerTypeHierarchyProvider(ne,he){return bt.registerTypeHierarchyProvider(Oe,ne,he)},setLanguageConfiguration:(ne,he)=>bt.setLanguageConfiguration(Oe,ne,he),getTokenInformationAtPosition(ne,he){return(0,H.checkProposedApiEnabled)(Oe),Wt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return(0,H.checkProposedApiEnabled)(Oe),bt.registerInlayHintsProvider(Oe,ne,he)},createLanguageStatusItem(ne,he){return(0,H.checkProposedApiEnabled)(Oe),Wt.createLanguageStatusItem(Oe,ne,he)}},cn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(ne,he,Ae){const ht=await(P.URI.isUri(ne)?Promise.resolve(vn.openTextDocument(ne)):Promise.resolve(ne));return At.showTextDocument(ht,he,Ae)},createTextEditorDecorationType(ne){return At.createTextEditorDecorationType(Oe,ne)},onDidChangeActiveTextEditor(ne,he,Ae){return At.onDidChangeActiveTextEditor(ne,he,Ae)},onDidChangeVisibleTextEditors(ne,he,Ae){return At.onDidChangeVisibleTextEditors(ne,he,Ae)},onDidChangeTextEditorSelection(ne,he,Ae){return At.onDidChangeTextEditorSelection(ne,he,Ae)},onDidChangeTextEditorOptions(ne,he,Ae){return At.onDidChangeTextEditorOptions(ne,he,Ae)},onDidChangeTextEditorVisibleRanges(ne,he,Ae){return At.onDidChangeTextEditorVisibleRanges(ne,he,Ae)},onDidChangeTextEditorViewColumn(ne,he,Ae){return At.onDidChangeTextEditorViewColumn(ne,he,Ae)},onDidCloseTerminal(ne,he,Ae){return vt.onDidCloseTerminal(ne,he,Ae)},onDidOpenTerminal(ne,he,Ae){return vt.onDidOpenTerminal(ne,he,Ae)},onDidChangeActiveTerminal(ne,he,Ae){return vt.onDidChangeActiveTerminal(ne,he,Ae)},onDidChangeTerminalDimensions(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),vt.onDidChangeTerminalDimensions(ne,he,Ae)},onDidChangeTerminalState(ne,he,Ae){return vt.onDidChangeTerminalState(ne,he,Ae)},onDidWriteTerminalData(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),vt.onDidWriteTerminalData(ne,he,Ae)},get state(){return Le.state},onDidChangeWindowState(ne,he,Ae){return Le.onDidChangeWindowState(ne,he,Ae)},showInformationMessage(ne,...he){return Kt.showMessage(Oe,_.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return Kt.showMessage(Oe,_.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return Kt.showMessage(Oe,_.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Ae){return Vt.showQuickPick(ne,!!Oe.enableProposedApi,he,Ae)},showWorkspaceFolderPick(ne){return Vt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Vt.showInput(ne,he)},showOpenDialog(ne){return mn.showOpenDialog(ne)},showSaveDialog(ne){return mn.showSaveDialog(ne)},createStatusBarItem(ne,he,Ae){let ht,yt,Pt;return typeof ne=="string"?(ht=ne,yt=he,Pt=Ae):(yt=ne,Pt=he),Ht.createStatusBarEntry(Oe,ht,yt,Pt)},setStatusBarMessage(ne,he){return Ht.setStatusBarMessage(ne,he)},withScmProgress(ne){return Se.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:U.ProgressLocation.SourceControl},(he,Ae)=>ne({report(ht){}}))},withProgress(ne,he){return hn.withProgress(Oe,ne,he)},createOutputChannel(ne){return Tt.createOutputChannel(ne,Oe)},createWebviewPanel(ne,he,Ae,ht){return qt.createWebviewPanel(Oe,ne,he,Ae,ht)},createWebviewTextEditorInset(ne,he,Ae,ht){return(0,H.checkProposedApiEnabled)(Oe),sn.createWebviewEditorInset(ne,he,Ae,ht,Oe)},createTerminal(ne,he,Ae){return typeof ne=="object"?("location"in ne&&(0,H.checkProposedApiEnabled)(Oe),"pty"in ne?vt.createExtensionTerminal(ne):vt.createTerminalFromOptions(ne)):vt.createTerminal(ne,he,Ae)},registerTerminalLinkProvider(ne){return vt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return vt.registerProfileProvider(Oe,ne,he)},registerTreeDataProvider(ne,he){return Xt.registerTreeDataProvider(ne,he,Oe)},createTreeView(ne,he){return Xt.createTreeView(ne,he,Oe)},registerWebviewPanelSerializer:(ne,he)=>qt.registerWebviewPanelSerializer(Oe,ne,he),registerCustomEditorProvider:(ne,he,Ae={})=>_n.registerCustomEditorProvider(Oe,ne,he,Ae),registerFileDecorationProvider(ne){return gt.registerFileDecorationProvider(ne,Oe.identifier)},registerUriHandler(ne){return Nt.registerUriHandler(Oe.identifier,ne)},createQuickPick(){return Vt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return Vt.createInputBox(Oe.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Ae){return fn.onDidChangeActiveColorTheme(ne,he,Ae)},registerWebviewViewProvider(ne,he,Ae){return Sn.registerWebviewViewProvider(Oe,ne,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Oe),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),St.onDidChangeActiveNotebookEditor(ne,he,Ae)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Oe),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Oe),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorSelection(ne,he,Ae)},onDidChangeNotebookEditorVisibleRanges(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),zt.onDidChangeNotebookEditorVisibleRanges(ne,he,Ae)},showNotebookDocument(ne,he){return(0,H.checkProposedApiEnabled)(Oe),St.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),yn.registerExternalUriOpener(Oe.identifier,ne,he,Ae)},get tabs(){return(0,H.checkProposedApiEnabled)(Oe),qe.tabs},get activeTab(){return(0,H.checkProposedApiEnabled)(Oe),qe.activeTab},get onDidChangeTabs(){return(0,H.checkProposedApiEnabled)(Oe),qe.onDidChangeTabs},get onDidChangeActiveTab(){return(0,H.checkProposedApiEnabled)(Oe),qe.onDidChangeActiveTab},getInlineCompletionItemController(ne){return(0,H.checkProposedApiEnabled)(Oe),a.InlineCompletionController.get(ne)}},vn={get rootPath(){return Se.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ne){throw L.readonly()},getWorkspaceFolder(ne){return Ge.getWorkspaceFolder(ne)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ne){throw L.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ne){throw L.readonly()},updateWorkspaceFolders:(ne,he,...Ae)=>Ge.updateWorkspaceFolders(Oe,ne,he||0,...Ae),onDidChangeWorkspaceFolders:function(ne,he,Ae){return Ge.onDidChangeWorkspace(ne,he,Ae)},asRelativePath:(ne,he)=>Ge.getRelativePath(ne,he),findFiles:(ne,he,Ae,ht)=>Ge.findFiles(z.GlobPattern.from(ne),z.GlobPattern.from(he),Ae,Oe.identifier,ht),findTextInFiles:(ne,he,Ae,ht)=>{let yt,Pt;return typeof he=="object"?(yt=he,Pt=Ae):(yt={},Pt=he,ht=Ae),Ge.findTextInFiles(ne,yt||{},Pt,Oe.identifier,ht)},saveAll:ne=>Ge.saveAll(ne),applyEdit(ne){return Dn.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,he,Ae,ht)=>Ft.createFileSystemWatcher(z.GlobPattern.from(ne),he,Ae,ht),get textDocuments(){return It.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw L.readonly()},openTextDocument(ne){let he;const Ae=ne;if(typeof ne=="string")he=Promise.resolve(P.URI.file(ne));else if(P.URI.isUri(ne))he=Promise.resolve(ne);else if(!Ae||typeof Ae=="object")he=It.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ht=>It.ensureDocumentData(ht).then(yt=>yt.document))},onDidOpenTextDocument:(ne,he,Ae)=>It.onDidAddDocument(ne,he,Ae),onDidCloseTextDocument:(ne,he,Ae)=>It.onDidRemoveDocument(ne,he,Ae),onDidChangeTextDocument:(ne,he,Ae)=>It.onDidChangeDocument(ne,he,Ae),onDidSaveTextDocument:(ne,he,Ae)=>It.onDidSaveDocument(ne,he,Ae),onWillSaveTextDocument:(ne,he,Ae)=>$t.getOnWillSaveTextDocumentEvent(Oe)(ne,he,Ae),get notebookDocuments(){return St.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Ae;if(P.URI.isUri(ne))Ae=ne,await St.openNotebookDocument(ne);else if(typeof ne=="string")Ae=P.URI.revive(await St.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Ae,ht){return St.registerNotebookSerializer(Oe,ne,he,Ae,Oe.enableProposedApi?ht:void 0)},registerNotebookContentProvider:(ne,he,Ae,ht)=>((0,H.checkProposedApiEnabled)(Oe),St.registerNotebookContentProvider(Oe,ne,he,Ae,Oe.enableProposedApi?ht:void 0)),onDidChangeConfiguration:(ne,he,Ae)=>Lt.onDidChangeConfiguration(ne,he,Ae),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Lt.getConfiguration(ne,he,Oe)},registerTextDocumentContentProvider(ne,he){return Ut.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(Se.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Oe,ne,he)),registerFileSystemProvider(ne,he,Ae){return on.registerFileSystemProvider(Oe.identifier,ne,he,Ae)},get fs(){return ve.value},registerFileSearchProvider:(ne,he)=>((0,H.checkProposedApiEnabled)(Oe),Dt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,H.checkProposedApiEnabled)(Oe),Dt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,H.checkProposedApiEnabled)(Oe),Fe.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,H.checkProposedApiEnabled)(Oe),bn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Ae)=>Ft.onDidCreateFile(ne,he,Ae),onDidDeleteFiles:(ne,he,Ae)=>Ft.onDidDeleteFile(ne,he,Ae),onDidRenameFiles:(ne,he,Ae)=>Ft.onDidRenameFile(ne,he,Ae),onWillCreateFiles:(ne,he,Ae)=>Ft.getOnWillCreateFileEvent(Oe)(ne,he,Ae),onWillDeleteFiles:(ne,he,Ae)=>Ft.getOnWillDeleteFileEvent(Oe)(ne,he,Ae),onWillRenameFiles:(ne,he,Ae)=>Ft.getOnWillRenameFileEvent(Oe)(ne,he,Ae),openTunnel:ne=>((0,H.checkProposedApiEnabled)(Oe),Q.openTunnel(Oe,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,H.checkProposedApiEnabled)(Oe),Q.getTunnels()},onDidChangeTunnels:(ne,he,Ae)=>((0,H.checkProposedApiEnabled)(Oe),Q.onDidChangeTunnels(ne,he,Ae)),registerPortAttributesProvider:(ne,he)=>((0,H.checkProposedApiEnabled)(Oe),Q.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,H.checkProposedApiEnabled)(Oe),En.registerTimelineProvider(ne,he,Oe.identifier,pt.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ne=>((0,H.checkProposedApiEnabled)(Oe),Ge.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Ae)=>Ge.onDidGrantWorkspaceTrust(ne,he,Ae)},Rn={get inputBox(){return Se.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Oe)},createSourceControl(ne,he,Ae){return Jt.createSourceControl(Oe,ne,he,Ae)}},Ln={createCommentController(ne,he){return an.createCommentController(Oe,ne,he)}},Fn={get activeDebugSession(){return wt.activeDebugSession},get activeDebugConsole(){return wt.activeDebugConsole},get breakpoints(){return wt.breakpoints},onDidStartDebugSession(ne,he,Ae){return wt.onDidStartDebugSession(ne,he,Ae)},onDidTerminateDebugSession(ne,he,Ae){return wt.onDidTerminateDebugSession(ne,he,Ae)},onDidChangeActiveDebugSession(ne,he,Ae){return wt.onDidChangeActiveDebugSession(ne,he,Ae)},onDidReceiveDebugSessionCustomEvent(ne,he,Ae){return wt.onDidReceiveDebugSessionCustomEvent(ne,he,Ae)},onDidChangeBreakpoints(ne,he,Ae){return wt.onDidChangeBreakpoints(ne,he,Ae)},registerDebugConfigurationProvider(ne,he,Ae){return wt.registerDebugConfigurationProvider(ne,he,Ae||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return wt.registerDebugAdapterDescriptorFactory(Oe,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return wt.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?wt.startDebugging(ne,he,{parentSession:Ae}):wt.startDebugging(ne,he,Ae||{})},stopDebugging(ne){return wt.stopDebugging(ne)},addBreakpoints(ne){return wt.addBreakpoints(ne)},removeBreakpoints(ne){return wt.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return wt.asDebugSourceUri(ne,he)}},Mn={registerTaskProvider:(ne,he)=>Ct.registerTaskProvider(Oe,ne,he),fetchTasks:ne=>Ct.fetchTasks(ne),executeTask:ne=>Ct.executeTask(Oe,ne),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(ne,he,Ae)=>Ct.onDidStartTask(ne,he,Ae),onDidEndTask:(ne,he,Ae)=>Ct.onDidEndTask(ne,he,Ae),onDidStartTaskProcess:(ne,he,Ae)=>Ct.onDidStartTaskProcess(ne,he,Ae),onDidEndTaskProcess:(ne,he,Ae)=>Ct.onDidEndTaskProcess(ne,he,Ae)},On={createNotebookController(ne,he,Ae,ht,yt){return nn.createNotebookController(Oe,ne,he,Ae,ht,Oe.enableProposedApi?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>St.registerNotebookCellStatusBarItemProvider(Oe,ne,he),get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Oe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return(0,H.checkProposedApiEnabled)(Oe),zt.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return rn.createRendererMessaging(Oe,ne)},onDidChangeNotebookDocumentMetadata(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),Qt.onDidChangeNotebookDocumentMetadata(ne,he,Ae)},onDidChangeNotebookCells(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),St.onDidChangeNotebookCells(ne,he,Ae)},onDidChangeNotebookCellExecutionState(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),St.onDidChangeNotebookCellExecutionState(ne,he,Ae)},onDidChangeCellOutputs(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),St.onDidChangeCellOutputs(ne,he,Ae)},onDidChangeCellMetadata(ne,he,Ae){return(0,H.checkProposedApiEnabled)(Oe),St.onDidChangeCellMetadata(ne,he,Ae)},createConcatTextDocument(ne,he){return(0,H.checkProposedApiEnabled)(Oe),new Ke.ExtHostNotebookConcatDocument(St,It,ne,he)}};return{version:ue.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:Tn,languages:An,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:cn,workspace:vn,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:k.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:l.UIKind,Uri:P.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:Xe.TextSearchCompleteMessageType,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Te}),define(fe[276],me([0,1,84,69,36,133,37,41,45,33,73,57,75,93,54,68,134,92,53,91,124,56]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,g.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,g.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration),(0,g.registerSingleton)(T.IExtHostConsumerFileSystem,T.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(_.IExtHostDecorations,_.ExtHostDecorations),(0,g.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,g.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,g.registerSingleton)(S.IExtHostWindow,S.ExtHostWindow),(0,g.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,g.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,g.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(fe[94],me([0,1,18,13,31,72]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=P;function D(I,l,p,h){const w=(0,g.mapArrayOrNot)(p,C),S=new y.TextSearchMatch(l,w,h),T=S.preview.matches;return{ranges:(0,g.mapArrayOrNot)(w,k),uri:I,preview:{text:S.preview.text,matches:(0,g.mapArrayOrNot)(T,k)}}}e.createTextSearchResult=D;function C(I){return new y.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function k(I){return new _.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(l,p){this.prefix=l,this.logService=p}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};i=Ve([We(1,L.ILogService)],i),e.OutputChannel=i}),define(fe[277],me([0,1,97,22]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(f=>f===t)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const _=512,P=512,D=512*8,C=512*128;class k{constructor(f){this.iconvLiteDecoder=f}static async create(f){let r;if(f!==e.UTF8)r=(await new Promise((d,a)=>{Y(["iconv-lite-umd"],d,a)})).getDecoder(p(f));else{const n=new TextDecoder;r={write(d){return n.decode(d,{stream:!0})},end(){return n.decode()}}}return new k(r)}write(f){return this.iconvLiteDecoder.write(f)}end(){return this.iconvLiteDecoder.end()}}function i(t,f){const r=f.minBytesRequiredForDetection??f.guessEncoding?D:P;return new Promise((n,d)=>{const a=(0,g.newWriteableStream)(A=>A.join("")),c=[];let m=0,u;const E=async()=>{try{const A=await v({buffer:L.VSBuffer.concat(c),bytesRead:m},f.guessEncoding);A.encoding=await f.overwriteEncoding(A.encoding),u=await k.create(A.encoding);const R=u.write(L.VSBuffer.concat(c).buffer);a.write(R),c.length=0,m=0,n({stream:a,detected:A})}catch(A){d(A)}};(0,g.listenStream)(t,{onData:async A=>{u?a.write(u.write(A.buffer)):(c.push(A),m+=A.byteLength,m>=r&&(t.pause(),await E(),setTimeout(()=>t.resume())))},onError:A=>a.error(A),onEnd:async()=>{u||await E(),a.end(u?.end())}})})}e.toDecodeStream=i;async function I(t,f,r){const d=(await new Promise((m,u)=>{Y(["iconv-lite-umd"],m,u)})).getEncoder(p(f),r);let a=!1,c=!1;return{read(){if(c)return null;const m=t.read();if(typeof m!="string"){if(c=!0,!a&&r?.addBOM)switch(f){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=d.end();return u&&u.length>0?(a=!0,L.VSBuffer.wrap(u)):null}return a=!0,L.VSBuffer.wrap(d.write(m))}}}e.toEncodeReadable=I;async function l(t){return(await new Promise((r,n)=>{Y(["iconv-lite-umd"],r,n)})).encodingExists(p(t))}e.encodingExists=l;function p(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=p;function h(t,f){if(!t||f<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),n=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(f<e.UTF8_BOM.length)return null;const d=t.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&d===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const w=["ascii","utf-16","utf-32"];async function S(t){const f=await new Promise((c,m)=>{Y(["jschardet"],c,m)}),r=t.slice(0,C),n=s(r.buffer),d=f.detect(n);if(!d||!d.encoding)return null;const a=d.encoding.toLowerCase();return 0<=w.indexOf(a)?null:b(d.encoding)}const T={ibm866:"cp866",big5:"cp950"};function b(t){const f=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return T[f]||f}function s(t){let f="";for(let r=0;r<t.length;r++)f+=String.fromCharCode(t[r]);return f}function o(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const f=t.match(/windows(\d+)/);return f?"windows-"+f[1]:t}}e.toCanonicalName=o;function v({buffer:t,bytesRead:f},r){let n=h(t,f),d=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let a=!0,c=!0,m=!1;for(let u=0;u<f&&u<_;u++){const E=u%2==1,A=t.readUInt8(u)===0;if(A&&(m=!0),a&&(E&&!A||!E&&A)&&(a=!1),c&&(E&&A||!E&&!A)&&(c=!1),A&&!a&&!c)break}m&&(a?n=e.UTF16le:c?n=e.UTF16be:d=!0)}return r&&!d&&!n&&t?S(t.slice(0,f)).then(a=>({seemsBinary:!1,encoding:a})):{seemsBinary:d,encoding:n}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,277,26,135]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class _ extends y.TextSearchManager{constructor(D,C,k=L,i="searchProcess"){super(D,C,{readdir:I=>k.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,g.toCanonicalName)(I)},i)}}e.NativeTextSearchManager=_}),define(fe[278],me([0,1,279,293,294,2,295]),function(Y,e,g,L,y,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(I,l,p,h,w,S){const T=S.environment.useHostProxy,b=typeof T=="boolean"?T:!S.remote.isRemote,s=(0,P.createProxyResolver)({resolveProxy:v=>I.resolveProxy(v),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(v,t,...f)=>{switch(v){case P.LogLevel.Trace:h.trace(t,...f);break;case P.LogLevel.Debug:h.debug(t,...f);break;case P.LogLevel.Info:h.info(t,...f);break;case P.LogLevel.Warning:h.warn(t,...f);break;case P.LogLevel.Error:h.error(t,...f);break;case P.LogLevel.Critical:h.critical(t,...f);break;case P.LogLevel.Off:break;default:r(v,t,f);break}function r(n,d,...a){h.error("Unknown log level",n),h.error(d,...a)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:v=>{w.$publicLog2("resolveProxy",v)},useHostProxy:b,env:process.env}),o=C(l,s);return i(p,o)}e.connectProxyResolver=D;function C(I,l){const p={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(w=>{p.config=I.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(w=>{h.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,P.createHttpPatch)(g,l,{config:"off"},h,!0)),on:Object.assign({},g,(0,P.createHttpPatch)(g,l,{config:"on"},h,!0)),override:Object.assign({},g,(0,P.createHttpPatch)(g,l,{config:"override"},h,!0)),onRequest:Object.assign({},g,(0,P.createHttpPatch)(g,l,p,h,!0)),default:Object.assign(g,(0,P.createHttpPatch)(g,l,p,h,!1))},https:{off:Object.assign({},L,(0,P.createHttpPatch)(L,l,{config:"off"},h,!0)),on:Object.assign({},L,(0,P.createHttpPatch)(L,l,{config:"on"},h,!0)),override:Object.assign({},L,(0,P.createHttpPatch)(L,l,{config:"override"},h,!0)),onRequest:Object.assign({},L,(0,P.createHttpPatch)(L,l,p,h,!0)),default:Object.assign(L,(0,P.createHttpPatch)(L,l,p,h,!1))},tls:Object.assign(y,(0,P.createTlsPatch)(y))}}const k=new Map;function i(I,l){return I.getExtensionPathIndex().then(p=>{const h=Y.__$__nodeRequire("module"),w=h._load;h._load=function(T,b,s){if(T==="tls")return l.tls;if(T!=="http"&&T!=="https")return w.apply(this,arguments);const o=l[T],v=p.findSubstr(_.URI.file(b.filename));let t=k.get(v);if(t||k.set(v,t={}),!t[T]){let f=o.default;v&&v.enableProposedApi&&(f=o[v.proxySupport]||o.onRequest),t[T]={...f}}return t[T]}})}}),define(fe[280],me([0,1,39,8,80,29,11,9,94,281]),function(Y,e,g,L,y,_,P,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(s,o,v,t){const f=l(s,o,v,t),r=o.folder.fsPath;return{cmd:g.spawn(i,f.args,{cwd:r}),rgDiskPath:i,siblingClauses:f.siblingClauses,rgArgs:f,cwd:r}}e.spawnRipgrepCmd=I;function l(s,o,v,t){const f=["--files","--hidden","--case-sensitive"];h([o],v,!1).forEach(n=>{const d=(0,C.anchorGlob)(n);if(f.push("-g",d),P.isMacintosh){const a=(0,y.normalizeNFD)(d);a!==d&&f.push("-g",a)}});const r=p([o],t,void 0,!1);return r.globArgs.forEach(n=>{const d=`!${(0,C.anchorGlob)(n)}`;if(f.push("-g",d),P.isMacintosh){const a=(0,y.normalizeNFD)(d);a!==d&&f.push("-g",a)}}),o.disregardIgnoreFiles!==!1?f.push("--no-ignore"):f.push("--no-ignore-parent"),o.ignoreSymlinks||f.push("--follow"),s.exists&&f.push("--quiet"),f.push("--no-config"),o.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:r.siblingClauses}}function p(s,o,v,t=!0){const f=[];let r={};return s.forEach(n=>{const d=Object.assign({},n.excludePattern||{},o||{}),a=w(d,t?n.folder.fsPath:void 0,v);f.push(...a.globArgs),a.siblingClauses&&(r=Object.assign(r,a.siblingClauses))}),{globArgs:f,siblingClauses:r}}e.foldersToRgExcludeGlobs=p;function h(s,o,v=!0){const t=[];return s.forEach(f=>{const r=Object.assign({},o||{},f.includePattern||{}),n=w(r,v?f.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=h;function w(s,o,v){const t=[],f={};return Object.keys(s).forEach(r=>{if(v&&v.has(r)||!r)return;const n=s[r];r=T(o?S(o,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof n=="boolean"&&n?(r.startsWith("\\\\")&&(r+="**"),t.push(b(r))):n&&n.when&&(f[r]=n)}),{globArgs:t,siblingClauses:f}}function S(s,o){return L.isAbsolute(o)?o:L.join(s,o)}e.getAbsoluteGlob=S;function T(s){return s=D.rtrim(s,"\\"),D.rtrim(s,"/")}function b(s){return _.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=b}),define(fe[282],me([0,1,39,50,8,105,18,52,30,80,29,11,46,9,12,26,31,280,102]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(r=>r())});class o{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&C.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&C.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(d=>{const a=Object.assign({},d.excludePattern||{},this.config.excludePattern||{}),c=d.folder.fsPath;n.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==c).forEach(m=>{(0,i.isEqualOrParent)(m,c)&&(a[y.relative(c,m)]=!0)}),this.folderExcludePatterns.set(c,new t(a,c))})}cancel(){this.isCanceled=!0}walk(n,d,a,c,m){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);d.forEach(u=>{const E=y.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,E)||this.matchFile(a,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(n,(u,E)=>{this.call(this.cmdTraversal,this,u,a,c,A=>{if(A){const R=(0,D.toErrorMessage)(A);console.error(R),this.errors.push(R),E(A,void 0)}else E(null,void 0)})},(u,E)=>{this.fileWalkSW.stop();const A=u?P.coalesce(u)[0]:null;m(A,this.isLimitHit)})}parallel(n,d,a){const c=new Array(n.length),m=new Array(n.length);let u=!1,E=0;if(n.length===0)return a(null,[]);n.forEach((A,R)=>{d(A,(B,N)=>{if(B?(u=!0,c[R]=null,m[R]=B):(c[R]=N,m[R]=null),++E===n.length)return a(u?m:null,c)})})}call(n,d,...a){try{n.apply(d,a)}catch(c){a[a.length-1](c)}}cmdTraversal(n,d,a,c){const m=n.folder.fsPath,u=I.isMacintosh;let E;const A=()=>E&&E.kill();s.add(A);let R=U=>{s.delete(A),R=()=>{},c(U)},B="";const N=this.initDirectoryTree();let F;const $=(0,T.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);E=$.cmd,F=!Object.keys($.siblingClauses).length;const M=$.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let z=`${$.rgDiskPath} ${M}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),a({message:z}),this.cmdResultCount=0,this.collectStdout(E,"utf8",a,(U,x,j)=>{if(U){R(U);return}if(this.isLimitHit){R();return}const W=(B+(u?k.normalizeNFC(x||""):x)).split(`
`);if(j){const H=W.length;W[H-1]=W[H-1].trim(),W[H-1]||W.pop()}else B=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,F){for(const H of W)if(this.matchFile(d,{base:m,relativePath:H,searchPath:this.getSearchPath(n,H)}),this.isLimitHit){A();break}(j||this.isLimitHit)&&R();return}this.addDirectoryEntries(n,N,m,W,d),j&&(this.matchDirectoryTree(N,m,d),R())})}spawnFindCmd(n){const d=this.folderExcludePatterns.get(n.folder.fsPath),a=d.getBasenameTerms(),c=d.getPathTerms(),m=["-L","."];if(a.length||c.length){m.push("-not","(","(");for(const u of a)m.push("-name",u),m.push("-o");for(const u of c)m.push("-path",u),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),g.spawn("find",m,{cwd:n.folder.fsPath})}readStdout(n,d,a){let c="";this.collectStdout(n,d,()=>{},(m,u,E)=>{if(m){a(m);return}c+=u,E&&a(null,c)})}collectStdout(n,d,a,c){let m=(A,R,B)=>{(A||B)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),c(A,R,B)},u=!1;n.stdout?(this.forwardData(n.stdout,d,m),n.stdout.once("data",()=>u=!0)):a({message:"stdout is null"});let E;n.stderr?E=this.collectData(n.stderr):a({message:"stderr is null"}),n.on("error",A=>{m(A)}),n.on("close",A=>{let R;!u&&(R=this.decodeData(E,d))&&f(R)?m(new Error(`command failed with error code ${A}: ${this.decodeData(E,d)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(n,d,a){const c=new _.StringDecoder(d);return n.on("data",m=>{a(null,c.write(m))}),c}collectData(n){const d=[];return n.on("data",a=>{d.push(a)}),d}decodeData(n,d){const a=new _.StringDecoder(d);return n.map(c=>a.write(c)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:d},a,c,m){c.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:a,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const u=E=>{const A=y.basename(E),R=y.dirname(E);let B=d[R];B||(B=d[R]=[],u(R)),B.push({base:a,relativePath:E,basename:A,searchPath:this.getSearchPath(n,E)})};c.forEach(u)}matchDirectoryTree({rootEntries:n,pathToEntries:d},a,c){const m=this,u=this.folderExcludePatterns.get(a),E=this.filePattern;function A(R){m.directoriesWalked++;const B=C.hasSiblingFn(()=>R.map(N=>N.basename));for(let N=0,F=R.length;N<F;N++){const $=R[N],{relativePath:M,basename:z}=$;if(u.test(M,z,E!==z?B:void 0))continue;const U=d[M];if(U)A(U);else{if(m.filesWalked++,M===E)continue;m.matchFile(c,$)}if(m.isLimitHit)break}}A(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,d,a,c,m){const u=n.folder,E=C.hasSiblingFn(()=>a);this.parallel(a,(A,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const B=d?[d,A].join(y.sep):A;if(this.folderExcludePatterns.get(n.folder.fsPath).test(B,A,this.config.filePattern!==A?E:void 0))return R(null);const N=[u.fsPath,B].join(y.sep);L.lstat(N,(F,$)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(N,$,(M,z)=>M||this.isCanceled||this.isLimitHit?R(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(N,$,(U,x)=>U||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?R(null):(this.walkedPaths[x]=!0,w.Promises.readdir(N).then(j=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(n,B,j,c,O=>R(O||null))},j=>{R(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&h.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(c,{base:u.fsPath,relativePath:B,searchPath:this.getSearchPath(n,B)}),R(null,void 0)))})},A=>{const R=A&&P.coalesce(A);return m(R&&R.length>0?R[0]:void 0)})}matchFile(n,d){this.isFileMatch(d)&&(!this.includePattern||this.includePattern(d.relativePath,y.basename(d.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(d))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,d,a){return d.isSymbolicLink()?L.stat(n,a):a(null,d)}realPathIfNeeded(n,d,a){return d.isSymbolicLink()?L.realpath(n,(c,m)=>c?a(c):a(null,m)):a(null,n)}getSearchPath(n,d){return n.folderName?y.join(n.folderName,d):d}}e.FileWalker=o;class v{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new o(n)}search(n,d,a){this.walker.walk(this.folderQueries,this.extraFiles,n,d,(c,m)=>{a(c,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(n,d){this.expression=n,this.root=d,this.init(n)}init(n){let d,a;Object.keys(n).filter(c=>n[c]).forEach(c=>{y.isAbsolute(c)?(d=d||C.getEmptyExpression(),d[c]=n[c]):(a=a||C.getEmptyExpression(),a[c]=n[c])}),this.absoluteParsedExpr=d&&C.parse(d,{trimForExclusions:!0}),this.relativeParsedExpr=a&&C.parse(a,{trimForExclusions:!0})}test(n,d,a){return this.relativeParsedExpr&&this.relativeParsedExpr(n,d,a)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,n),d,a)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...C.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...C.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...C.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...C.getPathTerms(this.relativeParsedExpr)),n}}function f(r){const n=r.trim().split(`
`),d=n[0].trim();if(d.startsWith("Error parsing regex"))return d;if(d.startsWith("regex parse error"))return p.uppercaseFirstLetter(n[n.length-1].trim());if(d.startsWith("error parsing glob")||d.startsWith("unsupported encoding"))return d.charAt(0).toUpperCase()+d.substr(1);if(d==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(d.startsWith("Literal "))return d}e.rgErrorMsgForDisplay=f}),define(fe[137],me([0,1,39,296,105,18,59,30,8,9,2,31,72,297,281,94]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class T{constructor(u){this.outputChannel=u}provideTextSearchResults(u,E,A,R){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((B,N)=>{R.onCancellationRequested(()=>O());const F=f(u,E),$=E.folder.fsPath,M=F.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${S} ${M}
 - cwd: ${$}`);let z=g.spawn(S,F,{cwd:$});z.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),N((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let U=!1;const x=new o(E.maxResults,$,E.previewOptions);x.on("result",de=>{U=!0,H="",A.report(de)});let j=!1;const O=()=>{j=!0,z&&z.kill(),x&&x.cancel()};let W=!1;x.on("hitLimit",()=>{W=!0,O()});let H="";z.stdout.on("data",de=>{x.handleData(de),U||(H+=de)});let X=!1;z.stdout.once("data",()=>X=!0);let K="";z.stderr.on("data",de=>{const _e=de.toString();this.outputChannel.appendLine(_e),K+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),j)B({limitHit:W});else{x.flush(),z=null;let de;K&&!X&&(de=b(K))?N((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):B({limitHit:W})}})})}}e.RipgrepTextSearchEngine=T;function b(m){const u=m.split(`
`),E=u[0].trim();if(u.some(R=>R.startsWith("regex parse error")))return new I.SearchError(s(u),I.SearchErrorCode.regexParseError);const A=E.match(/grep config error: unknown encoding: (.*)/);if(A)return new I.SearchError(`Unknown encoding: ${A[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function s(m){const u=["Regex parse error"],E=m.filter(A=>A.startsWith("PCRE2:"));if(E.length>=1){const A=E[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const R=A.split(":")[1];u.push(":"+R)}}return u.join("")}e.buildRegexParseError=s;class o extends L.EventEmitter{constructor(u,E,A){super();this.maxResults=u,this.rootFolder=E,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,E){return super.on(u,E),this}handleData(u){if(this.isDone)return;const E=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(E)}handleDecodedData(u){let E=u.indexOf(`
`);const A=this.remainder+u;if(E>=0)E+=this.remainder.length;else{this.remainder=A;return}let R=0;for(;E>=0;)this.handleLine(A.substring(R,E).trim()),R=E+1,E=A.indexOf(`
`,R);this.remainder=A.substring(R)}handleLine(u){if(this.isDone||!u)return;let E;try{E=JSON.parse(u)}catch(A){throw new Error(`malformed line from rg: ${u}`)}if(E.type==="match"){const A=v(E.data.path),R=i.URI.file(C.join(this.rootFolder,A)),B=this.createTextSearchMatch(E.data,R);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const A=v(E.data.path),R=i.URI.file(C.join(this.rootFolder,A));this.createTextSearchContext(E.data,R).forEach(N=>this.onResult(N))}}createTextSearchMatch(u,E){const A=u.line_number-1,R=v(u.lines),B=Buffer.from(R);let N=0,F=0,$=A;u.submatches.length===0&&u.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,_.coalesce)(u.submatches.map((z,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=v(z.match),j=B.slice(N,z.start).toString().length,O=F+j,W=t(x),H=$,X=W.numLines+H,K=W.numLines>0?W.lastLineLength:W.lastLineLength+O;return N=z.end,F=K,$=X,new l.Range(H,O,X,K)}));return(0,w.createTextSearchResult)(E,R,M,this.previewOptions)}createTextSearchContext(u,E){const A=v(u.lines),R=u.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((B,N)=>({text:B,uri:E,lineNumber:R+N}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=o;function v(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function t(m){const u=/\n/g;let E=0,A=-1,R;for(;R=u.exec(m);)E++,A=R.index;const B=A>=0?m.length-A-1:m.length;return{numLines:E,lastLineLength:B}}function f(m,u){const E=["--hidden"];E.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:R}=(0,P.groupBy)(u.includes,N=>N.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const N=new Set;R.forEach(F=>{N.add(F)}),E.push("-g","!*"),N.forEach(F=>{r(F).map(w.anchorGlob).forEach($=>{E.push("-g",$)})})}A&&A.length&&A.forEach(N=>{E.push("-g",N)}),u.excludes.map(w.anchorGlob).forEach(N=>E.push("-g",`!${N}`)),u.maxFileSize&&E.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?E.push("--no-ignore-parent"):E.push("--no-ignore"),u.followSymlinks&&E.push("--follow"),u.encoding&&u.encoding!=="utf8"&&E.push("--encoding",u.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,k.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),u.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),m.isRegExp&&(m.pattern=n(m.pattern),E.push("--auto-hybrid-regex"));let B;if(m.isWordMatch){const F=(0,k.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",F)}else if(m.isRegExp){let N=a(m.pattern);N=c(N),E.push("--regexp",N)}else B=m.pattern,E.push("--fixed-strings");return E.push("--no-config"),u.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),m.isMultiline&&E.push("--multiline"),u.beforeContext&&E.push("--before-context",u.beforeContext+""),u.afterContext&&E.push("--after-context",u.afterContext+""),E.push("--"),B&&E.push(B),E.push("."),E}function r(m){const u=(0,D.splitGlobAware)(m,"/");return u.map((E,A)=>u.slice(0,A+1).join("/"))}e.spreadGlobComponents=r;function n(m){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(u);)m=m.replace(u,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(E);)m=m.replace(E,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=n;const d=m=>m.type==="Assertion"&&m.kind==="lookbehind";function a(m){let u;try{u=new p.RegExpParser().parsePattern(m)}catch{return m}let E="",A=0;const R=(F,$,M)=>{E+=m.slice(A,F)+M,A=$},B=[];return new p.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const $=B[0];if(!$)R(F.start,F.end,"\\r?\\n");else if(!B.some(d))if($.type==="CharacterClass")if($.negate){const M=m.slice($.start+2,F.start)+m.slice(F.end,$.end-1);if($.parent?.type==="Quantifier"){const z=$.parent;R(z.start,z.end,(M?`[^${M}]`:".")+(z.greedy?"+":"*"))}else R($.start,$.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=m.slice($.start+1,F.start)+m.slice(F.end,$.end-1);R($.start,$.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else $.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){B.unshift(F)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(F){B.unshift(F)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(F){B.unshift(F)},onCharacterClassLeave(){B.shift()},onAssertionEnter(F){d(F)&&B.push(F)},onAssertionLeave(F){B[0]===F&&B.shift()}}).visit(u),E+=m.slice(A),E}e.fixRegexNewline=a;function c(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(fe[283],me([0,1,21,137,119,10]),function(Y,e,g,L,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,i,I,l){const p=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===_.Schemas.userData){const h={...i,folder:i.folder.with({scheme:_.Schemas.file})},w=new y.Progress(S=>I.report({...S,uri:S.uri.with({scheme:i.folder.scheme})}));return this.withToken(l,S=>p.provideTextSearchResults(k,h,w,S))}else return this.withToken(l,h=>p.provideTextSearchResults(k,i,I,h))}async withToken(k,i){const I=D(k);this.inProgress.add(I);const l=await i(I.token);return this.inProgress.delete(I),l}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=P;function D(C){const k=new g.CancellationTokenSource;return C.onCancellationRequested(()=>k.cancel()),k}}),define(fe[284],me([0,1,26,137,136]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class _{constructor(C){this.query=C}search(C,k,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(p){i({message:p})}},l=new y.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((p,h)=>l.search(w=>{k(w.map(P))},C).then(w=>p({limitHit:w.limitHit,type:"success",stats:w.stats}),h))}}e.TextSearchEngineAdapter=_;function P(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((C,k)=>{if(k.ranges){const i=k;return C+(Array.isArray(i.ranges)?i.ranges.length:1)}else return C+1},0)}}}),define(fe[285],me([0,1,50,298,18,15,17,3,102,8,46,2,40,31,282,284]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class S{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let f;const r=s(t),n=new D.Emitter({onFirstListenerDidAdd:()=>{f=(0,_.createCancelablePromise)(d=>this.doFileSearchWithEngine(h.Engine,r,a=>n.fire(a),d)),f.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return n.event}textSearch(t){let f;const r=s(t),n=new D.Emitter({onFirstListenerDidAdd:()=>{f=(0,_.createCancelablePromise)(d=>this.ripgrepTextSearch(r,a=>n.fire(a),d)),f.then(d=>n.fire(d),d=>n.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onLastListenerRemove:()=>{f.cancel()}});return n.event}ripgrepTextSearch(t,f,r){return t.maxFileSize=(0,l.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(t).search(r,f,f)}doFileSearch(t,f,r){return this.doFileSearchWithEngine(h.Engine,t,f,r)}doFileSearchWithEngine(t,f,r,n,d=S.BATCH_SIZE){let a=0;const c=u=>{Array.isArray(u)?(a+=u.length,r(u.map(E=>this.rawMatchToSearchItem(E)))):u.relativePath?(a++,r(this.rawMatchToSearchItem(u))):r(u)};if(f.sortByScore){let u=this.trySortedSearchFromCache(f,c,n);if(!u){const E=f.maxResults?Object.assign({},f,{maxResults:null}):f,A=new t(E);u=this.doSortedSearch(A,f,r,c,n)}return new Promise((E,A)=>{u.then(([R,B])=>{const N=B.map(F=>this.rawMatchToSearchItem(F));this.sendProgress(N,r,d),E(R)},A)})}const m=new t(f);return this.doSearch(m,c,d,n).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:this.processType,fromCache:!1,resultCount:a,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,k.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,f,r,n,d){const a=new D.Emitter;let c=(0,_.createCancelablePromise)(u=>{let E=[];const A=R=>{Array.isArray(R)?E=R:(n(R),a.fire(R))};return this.doSearch(t,A,-1,u).then(R=>[R,E])}),m;if(f.cacheKey){m=this.getOrCreateCache(f.cacheKey);const u={promise:c,event:a.event,resolved:!1};m.resultsToSearchCache[f.filePattern||""]=u,c.then(()=>{u.resolved=!0},E=>{delete m.resultsToSearchCache[f.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([u,E])=>{const A=m?m.scorerCache:Object.create(null),R=(typeof f.maxResults!="number"||f.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(f,E,A,d).then(B=>{const N=R?R.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:f.folderQueries.length,resultCount:B.length},messages:u.messages,limitHit:u.limitHit||typeof f.maxResults=="number"&&E.length>f.maxResults},B]})})}getOrCreateCache(t){const f=this.caches[t];return f||(this.caches[t]=new T)}trySortedSearchFromCache(t,f,r){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const d=this.getResultsFromCache(n,t.filePattern||"",f,r);if(d)return d.then(([a,c,m])=>{const u=i.StopWatch.create(!1);return this.sortResults(t,c,n.scorerCache,r).then(E=>{const A=u.elapsed(),R={fromCache:!0,detailStats:m,type:this.processType,resultCount:c.length,sortingTime:A};return[{type:"success",limitHit:a.limitHit||typeof t.maxResults=="number"&&c.length>t.maxResults,stats:R},E]})})}sortResults(t,f,r,n){const d=(0,C.prepareQuery)(t.filePattern||""),a=(m,u)=>(0,C.compareItemsByFuzzyScore)(m,u,d,!0,b,r),c=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return y.topAsync(f,a,c,1e4,n)}sendProgress(t,f,r){if(r&&r>0)for(let n=0;n<t.length;n+=r)f(t.slice(n,n+r));else f(t)}getResultsFromCache(t,f,r,n){const d=i.StopWatch.create(!1),a=f.indexOf(k.sep)>=0;let c;for(const A in t.resultsToSearchCache)if(f.startsWith(A)){if(a&&A.indexOf(k.sep)<0&&A!=="")continue;const R=t.resultsToSearchCache[A];c={promise:this.preventCancellation(R.promise),event:R.event,resolved:R.resolved};break}if(!c)return null;const m=d.elapsed(),u=i.StopWatch.create(!1),E=c.event(r);return n&&n.onCancellationRequested(()=>{E.dispose()}),c.promise.then(([A,R])=>{if(n&&n.isCancellationRequested)throw(0,P.canceled)();const B=[],N=(0,C.prepareQuery)(f).normalizedLowercase;for(const F of R)!(0,p.isFilePatternMatch)(F,N)||B.push(F);return[A,B,{cacheWasResolved:c.resolved,cacheLookupTime:m,cacheFilterTime:u.elapsed(),cacheEntryCount:R.length}]})}doSearch(t,f,r,n){return new Promise((d,a)=>{let c=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(m=>{m&&(r?(c.push(m),r>0&&c.length>=r&&(f(c),c=[])):f(m))},m=>{f(m)},(m,u)=>{c.length&&f(c),m?a(m):d(u)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(f,r){return t.then(f,r)}catch(f){return this.then(void 0,f)}finally(f){return t.finally(f)}}}}e.SearchService=S,S.BATCH_SIZE=512;class T{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(v){return(0,k.basename)(v.relativePath)}getItemDescription(v){return(0,k.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function s(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(o),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>I.URI.revive(t))}}function o(v){return{...v,folder:I.URI.revive(v.folder)}}}),define(fe[286],me([0,1,6,10,2,26,13,28,14,75,67,31,285,283,94,136]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends k.ExtHostSearch{constructor(b,s,o,v){super(b,o,v);this._pfs=_,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new p.RipgrepSearchProvider(t)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new p.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(L.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,s){const o=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(b)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(b,s,o,v){const t=(0,k.reviveQuery)(o);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,s,t,v):super.$provideFileSearchResults(b,s,o,v)}doInternalFileSearch(b,s,o,v){const t=f=>{if((0,I.isSerializedFileMatch)(f)&&(f=[f]),Array.isArray(f)){this._proxy.$handleFileMatch(b,s,f.map(r=>y.URI.file(r.path)));return}f.message&&this._logService.debug("ExtHostSearch",f.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,t,v)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,s){return new w.NativeTextSearchManager(b,s,void 0,"textSearchProvider")}};S=Ve([We(0,C.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,i.IURITransformerService),We(3,P.ILogService)],S),e.NativeExtHostSearch=S}),define(fe[138],me([0,1,299,127,82,22,17,3,6,8,11,32,107,108,300]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(c){this.socket=c,this._errorListener=m=>{if(m){if(m.code==="EPIPE")return;(0,P.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const m=u=>c(_.VSBuffer.wrap(u));return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(c){const m=u=>{c({type:0,hadError:u,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(c){return this.socket.on("end",c),{dispose:()=>this.socket.off("end",c)}}write(c){if(!this.socket.destroyed)try{this.socket.write(c.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,P.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,P.onUnexpectedError)(m)}}end(){this.socket.end()}drain(){return new Promise((c,m)=>{if(this.socket.bufferSize===0){c();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),c()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=w;var S;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var T;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(T||(T={}));class b extends C.Disposable{constructor(c,m,u,E){super();this._onDidZlibFlush=this._register(new D.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=m,this._recordInflateBytes=E,m?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,P.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,P.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):_.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._totalOutgoingDataBytes+=c.byteLength,this._zlibDeflate?(this._zlibDeflate.write(c.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let m=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.length-4),this._isEnded||this._write(_.VSBuffer.wrap(m),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(c,!1)}_write(c,m){let u=2;c.byteLength<126?u+=0:c.byteLength<2**16?u+=2:u+=8;const E=_.VSBuffer.alloc(u);if(m?E.writeUInt8(194,0):E.writeUInt8(130,0),c.byteLength<126)E.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){E.writeUInt8(126,1);let A=1;E.writeUInt8(c.byteLength>>>8&255,++A),E.writeUInt8(c.byteLength>>>0&255,++A)}else{E.writeUInt8(127,1);let A=1;E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(0,++A),E.writeUInt8(c.byteLength>>>24&255,++A),E.writeUInt8(c.byteLength>>>16&255,++A),E.writeUInt8(c.byteLength>>>8&255,++A),E.writeUInt8(c.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=E.byteLength+c.byteLength,this.socket.write(_.VSBuffer.concat([E,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._totalIncomingWireBytes+=c.byteLength,this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),u=m.readUInt8(0),E=(u&128)>>>7,A=(u&64)>>>6,R=m.readUInt8(1),B=(R&128)>>>7,N=R&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(A)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),u=m.readUInt8(1),E=(u&128)>>>7;let A=u&127,R=1;A===126?A=m.readUInt8(++R)*2**8+m.readUInt8(++R):A===127&&(A=m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*2**24+m.readUInt8(++R)*2**16+m.readUInt8(++R)*2**8+m.readUInt8(++R));let B=0;E&&(B=m.readUInt8(++R)*2**24+m.readUInt8(++R)*2**16+m.readUInt8(++R)*2**8+m.readUInt8(++R)),this._state.state=3,this._state.readLen=A,this._state.mask=B}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);s(m,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(m.buffer)),this._zlibInflate.write(m.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(_.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=m.byteLength,this._onData.fire(m))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await D.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function s(a,c){if(c===0)return;let m=a.byteLength>>>2;for(let N=0;N<m;N++){const F=a.readUInt32BE(N*4);a.writeUInt32BE(F^c,N*4)}let u=m*4,E=a.byteLength-u;const A=c>>>24&255,R=c>>>16&255,B=c>>>8&255;E>=1&&a.writeUInt8(a.readUInt8(u)^A,u),E>=2&&a.writeUInt8(a.readUInt8(u+1)^R,u+1),E>=3&&a.writeUInt8(a.readUInt8(u+2)^B,u+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function v(){const a=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):c=(0,k.join)((0,y.tmpdir)(),`vscode-ipc-${a}.sock`),f(c),c}e.createRandomIPCHandle=v;function t(a,c,m){const u=(0,g.createHash)("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${m}-${c}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${m}-${c}.sock`):E=(0,k.join)(a,`${m}-${c}.sock`),f(E),E}e.createStaticIPCHandle=t;function f(a){const c=o[i.platform];typeof c=="number"&&a.length>=c&&console.warn(`WARNING: IPC handle "${a}" is longer than ${c} chars, try a shorter --user-data-dir`)}class r extends l.IPCServer{constructor(c){super(r.toClientConnectionEvent(c));this.server=c}static toClientConnectionEvent(c){const m=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(m,u=>({protocol:new p.Protocol(new w(u)),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(a){return new Promise((c,m)=>{const u=(0,L.createServer)();u.on("error",m),u.listen(a,()=>{u.removeListener("error",m),c(new r(u))})})}e.serve=n;function d(a,c){return new Promise((m,u)=>{const E=(0,L.createConnection)(a,()=>{E.removeListener("error",u),m(p.Client.fromSocket(new w(E),c))});E.once("error",u)})}e.connect=d}),define(fe[287],me([0,1,138,279,50,41,2,199,13]),function(Y,e,g,L,y,_,P,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(l,p,h){this._commands=l,this.logService=p,this._ipcHandlePath=h,this._server=L.createServer((w,S)=>this.onRequest(w,S)),this.setup().catch(w=>(p.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,p){const h=[];l.setEncoding("utf8"),l.on("data",w=>h.push(w)),l.on("end",()=>{const w=JSON.parse(h.join(""));switch(w.type){case"open":this.open(w,p);break;case"openExternal":this.openExternal(w,p);break;case"status":this.getStatus(w,p);break;case"extensionManagement":this.manageExtensions(w,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${w.type}`,S=>{S&&this.logService.error(S)}),p.end();break}})}open(l,p){let{fileURIs:h,folderURIs:w,forceNewWindow:S,diffMode:T,addMode:b,forceReuseWindow:s,gotoLineMode:o,waitMarkerFilePath:v}=l;const t=[];if(Array.isArray(w))for(const f of w)try{t.push({folderUri:P.URI.parse(f)})}catch(r){}if(Array.isArray(h))for(const f of h)try{(0,D.hasWorkspaceFileExtension)(f)?t.push({workspaceUri:P.URI.parse(f)}):t.push({fileUri:P.URI.parse(f)})}catch(r){}if(t.length){const f=v?P.URI.file(v):void 0,n={forceNewWindow:S,diffMode:T,addMode:b,gotoLineMode:o,forceReuseWindow:s,preferNewWindow:!s&&!f&&!b,waitMarkerFileURI:f};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}p.writeHead(200),p.end()}async openExternal(l,p){for(const h of l.uris){const w=P.URI.parse(h),S=w.scheme==="file"?w:h;await this._commands.executeCommand("_remoteCLI.openExternal",S)}p.writeHead(200),p.end()}async manageExtensions(l,p){try{const h=T=>T?.map(b=>/\.vsix$/i.test(b)?P.URI.parse(b):b),w={list:l.list,install:h(l.install),uninstall:h(l.uninstall),force:l.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);p.writeHead(200),p.write(S)}catch(h){p.writeHead(500),p.write(String(h),w=>{w&&this.logService.error(w)})}p.end()}async getStatus(l,p){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(h),p.end()}catch(h){p.writeHead(500),p.write(String(h),w=>{w&&this.logService.error(w)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let i=class extends k{constructor(l,p){super(l,p,(0,g.createRandomIPCHandle)())}};i=Ve([We(0,_.IExtHostCommands),We(1,C.ILogService)],i),e.CLIServer=i}),define(fe[288],me([0,1,74,275,270,5,278,42,260,2,10,7,287,106]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends y.RequireInterceptor{_installInterceptor(){const T=this,b=Y.__$__nodeRequire("module"),s=b._load;b._load=function(v,t,f){for(let r of T._alternatives){let n=r(v);if(n){v=n;break}}return T._factories.has(v)?T._factories.get(v).load(v,k.URI.file((0,p.realpathSync)(t.filename)),r=>s.apply(this,[r,t,f])):s.apply(this,arguments)}}}class w extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const T=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(C.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(h,T,this._registry).install(),g.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const o=process.send,v=this._extHostContext.getProxy(_.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?o.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(T){return T.main}_loadCommonJSModule(T,b,s){if(b.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let o=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{T&&g.mark(`code/extHost/willLoadExtensionCode/${T.value}`),o=Y.__$__nodeRequire(b.fsPath)}catch(v){return Promise.reject(v)}finally{T&&g.mark(`code/extHost/didLoadExtensionCode/${T.value}`),s.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(T){if(!!this._initData.remote.isRemote)for(const b in T){const s=T[b];s===null?delete process.env[b]:process.env[b]=s}}}e.ExtHostExtensionService=w}),define(fe[289],me([0,1,84,261,263,272,271,286,288,228,264,57,42,69,75,73,33,54,13,70,262]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S,T,b,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(l.IExtHostExtensionService,C.ExtHostExtensionService),(0,g.registerSingleton)(b.ILogService,k.ExtHostLogService),(0,g.registerSingleton)(s.IExtensionStoragePaths,o.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,P.ExtHostDebugService),(0,g.registerSingleton)(p.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(h.IExtHostSearch,D.NativeExtHostSearch),(0,g.registerSingleton)(w.IExtHostTask,_.ExtHostTask),(0,g.registerSingleton)(S.IExtHostTerminalService,y.ExtHostTerminalService),(0,g.registerSingleton)(T.IExtHostTunnelService,i.ExtHostTunnelService)}),define(fe[290],me([0,1,127,301,74,17,108,138,192,226,273,22,104,26,106,15,115,276,289]),function(Y,e,g,L,y,_,P,D,C,k,i,I,l,p,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const T=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=Y.__$__nodeRequire("module"),d=n._load;n._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return d.apply(this,arguments)}})();const b=process.exit.bind(process);function s(n){process.exit=function(d){if(n)b(d);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)}}let o=function(n){b()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,d)=>{let a=null,c=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,u=3e5,E=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),m),A=new w.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),u);process.on("message",(B,N)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let $;if(B.skipWebSocketFrames)$=new D.NodeSocket(N);else{const M=I.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));$=new D.WebSocketNodeSocket(new D.NodeSocket(N),B.permessageDeflate,M,!1)}a?(E.cancel(),A.cancel(),a.beginAcceptReconnection($,F),a.endAcceptReconnection()):(clearTimeout(c),a=new P.PersistentProtocol($,F),a.onDidDispose(()=>o("renderer disconnected")),n(a),a.onSocketClose(()=>{E.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;E.isScheduled()&&A.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((d,a)=>{const c=g.createConnection(n,()=>{c.removeListener("error",a),d(new P.PersistentProtocol(new D.NodeSocket(c)))});c.once("error",a),c.on("close",()=>{o("renderer closed the socket")})})}}async function t(){const n=await v();return new class{constructor(){this._onMessage=new P.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(d=>{(0,k.isMessageOfType)(d,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||n.send(d)}drain(){return n.drain()}}}function f(n){return new Promise(d=>{const a=n.onMessage(c=>{a.dispose();const m=JSON.parse(c.toString()),u=m.commit,E=C.default.commit;u&&E&&u!==E&&b(55);const A=[];process.on("unhandledRejection",(N,F)=>{A.push(F),setTimeout(()=>{const $=A.indexOf(F);$>=0&&F.catch(M=>{A.splice($,1),(0,_.isPromiseCanceledError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),(0,_.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const F=A.indexOf(N);F>=0&&A.splice(F,1)}),process.on("uncaughtException",function(N){(0,_.onUnexpectedError)(N)});let R=0;setInterval(function(){try{process.kill(m.parentPid,0),R=0}catch(N){N&&N.code==="EPERM"?(R++,R>=3&&o(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):o(`parent process ${m.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let B;try{B=Y.__$__nodeRequire("native-watchdog"),B.start(m.parentPid)}catch(N){(0,_.onUnexpectedError)(N)}n.send((0,k.createMessageOfType)(0)),d({protocol:n,initData:m})});n.send((0,k.createMessageOfType)(1))})}async function r(){y.mark("code/extHost/willConnectToRenderer");const n=await t();y.mark("code/extHost/didConnectToRenderer");const d=await f(n);y.mark("code/extHost/didWaitForInitData");const{initData:a}=d;s(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=T.useHostProxy!==void 0?T.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,S.boolean)(T.skipWorkspaceStorageLock,!1);const c=new class{constructor(){this.pid=process.pid}exit(A){b(A)}exists(A){return p.Promises.exists(A)}realpath(A){return(0,h.realpath)(A)}};let m=null;if(a.remote.authority&&T.uriTransformerPath)try{const A=Y.__$__nodeRequire(T.uriTransformerPath)(a.remote.authority);m=new l.URITransformer(A)}catch(E){console.error(E)}const u=new i.ExtensionHostMain(d.protocol,a,c,m);o=E=>u.terminate(E)}e.startExtensionHostProcess=r}),define(fe[302],me([0,1,290]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ccbaa2d27e38e5afa3e5c21c1c7bef4657064247/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
